/* cli.c generated by valac 0.56.9, the Vala compiler
 * generated from cli.vala, do not modify */

/* -*- Mode: vala; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*-

   This file is part of GNOME Tetravex.

   Copyright (C) 2019 Arnaud Bonatti

   GNOME Tetravex is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 2 of the License, or
   (at your option) any later version.

   GNOME Tetravex is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License along
   with this GNOME Tetravex.  If not, see <https://www.gnu.org/licenses/>.
*/

#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gio/gio.h>
#include <glib-object.h>
#include <glib/gi18n-lib.h>
#include <stdio.h>
#include <errno.h>

#define KEY_GRID_SIZE "grid-size"
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TYPE_PUZZLE (puzzle_get_type ())
#define PUZZLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PUZZLE, Puzzle))
#define PUZZLE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PUZZLE, PuzzleClass))
#define IS_PUZZLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PUZZLE))
#define IS_PUZZLE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PUZZLE))
#define PUZZLE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PUZZLE, PuzzleClass))

typedef struct _Puzzle Puzzle;
typedef struct _PuzzleClass PuzzleClass;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
typedef enum  {
	DIRECTION_NONE,
	DIRECTION_UP,
	DIRECTION_DOWN,
	DIRECTION_LEFT,
	DIRECTION_RIGHT
} Direction;

#define TYPE_DIRECTION (direction_get_type ())

#define TYPE_TILE (tile_get_type ())
#define TILE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_TILE, Tile))
#define TILE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_TILE, TileClass))
#define IS_TILE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_TILE))
#define IS_TILE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_TILE))
#define TILE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_TILE, TileClass))

typedef struct _Tile Tile;
typedef struct _TileClass TileClass;
typedef struct _TilePrivate TilePrivate;

struct _Tile {
	GObject parent_instance;
	TilePrivate * priv;
	guint8 north;
	guint8 west;
	guint8 east;
	guint8 south;
};

struct _TileClass {
	GObjectClass parent_class;
};

VALA_EXTERN GType puzzle_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Puzzle, g_object_unref)
VALA_EXTERN gint cli_play_cli (const gchar* cli,
                   const gchar* schema_name,
                   GSettings** settings,
                   GVariant** saved_game,
                   gboolean* can_restore,
                   Puzzle** puzzle,
                   gint* colors,
                   gint* game_size);
VALA_EXTERN gboolean puzzle_is_valid_saved_game (GVariant* maybe_variant,
                                     gboolean restore_finished_game);
VALA_EXTERN Puzzle* puzzle_new (guint8 size,
                    guint8 colors);
VALA_EXTERN Puzzle* puzzle_construct (GType object_type,
                          guint8 size,
                          guint8 colors);
VALA_EXTERN Puzzle* puzzle_new_restore (GVariant* maybe_variant);
VALA_EXTERN Puzzle* puzzle_construct_restore (GType object_type,
                                  GVariant* maybe_variant);
VALA_EXTERN guint8 puzzle_get_size (Puzzle* self);
VALA_EXTERN void cli_print_board (Puzzle* puzzle,
                      guint8 size);
VALA_EXTERN GType direction_get_type (void) G_GNUC_CONST ;
VALA_EXTERN gboolean cli_cli_move_tiles (Puzzle* puzzle,
                             gboolean new_puzzle,
                             gboolean left_board,
                             Direction direction,
                             const gchar* warning_string);
VALA_EXTERN gboolean puzzle_get_is_solved (Puzzle* self);
VALA_EXTERN void cli_puzzle_is_solved_message (gboolean alternative_message);
VALA_EXTERN gboolean puzzle_get_is_solved_right (Puzzle* self);
VALA_EXTERN void puzzle_finish (Puzzle* self,
                    guint duration);
VALA_EXTERN gboolean puzzle_move_last_tile_if_possible (Puzzle* self);
VALA_EXTERN void puzzle_solve (Puzzle* self);
VALA_EXTERN gboolean cli_parse_cli (const gchar* cli,
                        guint8 size,
                        guint8* tile_1_x,
                        guint8* tile_1_y,
                        guint8* tile_2_x,
                        guint8* tile_2_y);
VALA_EXTERN GType tile_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Tile, g_object_unref)
VALA_EXTERN Tile* puzzle_get_tile (Puzzle* self,
                       guint8 x,
                       guint8 y);
VALA_EXTERN gboolean puzzle_can_switch (Puzzle* self,
                            guint8 x0,
                            guint8 y0,
                            guint8 x1,
                            guint8 y1);
VALA_EXTERN void puzzle_switch_tiles (Puzzle* self,
                          guint8 x0,
                          guint8 y0,
                          guint8 x1,
                          guint8 y1,
                          guint delay_if_finished);
VALA_EXTERN GVariant* puzzle_to_variant (Puzzle* self,
                             gboolean save_time);
VALA_EXTERN gboolean puzzle_move_up (Puzzle* self,
                         gboolean left_board);
VALA_EXTERN gboolean puzzle_move_down (Puzzle* self,
                           gboolean left_board);
VALA_EXTERN gboolean puzzle_move_left (Puzzle* self,
                           gboolean left_board);
VALA_EXTERN gboolean puzzle_move_right (Puzzle* self,
                            gboolean left_board);
VALA_EXTERN gboolean cli_is_valid_column (gchar column_char,
                              guint8 size,
                              guint8* column);

gint
cli_play_cli (const gchar* cli,
              const gchar* schema_name,
              GSettings** settings,
              GVariant** saved_game,
              gboolean* can_restore,
              Puzzle** puzzle,
              gint* colors,
              gint* game_size)
{
	GSettings* _vala_settings = NULL;
	GVariant* _vala_saved_game = NULL;
	gboolean _vala_can_restore = FALSE;
	Puzzle* _vala_puzzle = NULL;
	GSettings* _tmp0_;
	GSettings* _tmp1_;
	GVariant* _tmp2_;
	GVariant* _tmp3_;
	gboolean _tmp4_ = FALSE;
	gboolean _tmp5_ = FALSE;
	guint8 size = 0U;
	gboolean new_puzzle = FALSE;
	const gchar* _tmp21_;
	GQuark _tmp23_ = 0U;
#line 68 "../src/cli.vala"
	static GQuark _tmp22_label0 = 0;
#line 68 "../src/cli.vala"
	static GQuark _tmp22_label1 = 0;
#line 68 "../src/cli.vala"
	static GQuark _tmp22_label2 = 0;
#line 68 "../src/cli.vala"
	static GQuark _tmp22_label3 = 0;
#line 68 "../src/cli.vala"
	static GQuark _tmp22_label4 = 0;
#line 68 "../src/cli.vala"
	static GQuark _tmp22_label5 = 0;
#line 68 "../src/cli.vala"
	static GQuark _tmp22_label6 = 0;
#line 68 "../src/cli.vala"
	static GQuark _tmp22_label7 = 0;
#line 68 "../src/cli.vala"
	static GQuark _tmp22_label8 = 0;
#line 68 "../src/cli.vala"
	static GQuark _tmp22_label9 = 0;
#line 68 "../src/cli.vala"
	static GQuark _tmp22_label10 = 0;
#line 68 "../src/cli.vala"
	static GQuark _tmp22_label11 = 0;
#line 68 "../src/cli.vala"
	static GQuark _tmp22_label12 = 0;
#line 68 "../src/cli.vala"
	static GQuark _tmp22_label13 = 0;
#line 68 "../src/cli.vala"
	static GQuark _tmp22_label14 = 0;
#line 68 "../src/cli.vala"
	static GQuark _tmp22_label15 = 0;
#line 68 "../src/cli.vala"
	static GQuark _tmp22_label16 = 0;
#line 68 "../src/cli.vala"
	static GQuark _tmp22_label17 = 0;
#line 68 "../src/cli.vala"
	static GQuark _tmp22_label18 = 0;
#line 68 "../src/cli.vala"
	static GQuark _tmp22_label19 = 0;
#line 68 "../src/cli.vala"
	static GQuark _tmp22_label20 = 0;
#line 229 "cli.c"
	Puzzle* _tmp75_;
	GSettings* _tmp76_;
	Puzzle* _tmp77_;
	GVariant* _tmp78_;
	GVariant* _tmp79_;
	gint result;
#line 25 "../src/cli.vala"
	g_return_val_if_fail (cli != NULL, 0);
#line 25 "../src/cli.vala"
	g_return_val_if_fail (schema_name != NULL, 0);
#line 27 "../src/cli.vala"
	_tmp0_ = g_settings_new (schema_name);
#line 27 "../src/cli.vala"
	_g_object_unref0 (_vala_settings);
#line 27 "../src/cli.vala"
	_vala_settings = _tmp0_;
#line 29 "../src/cli.vala"
	_tmp1_ = _vala_settings;
#line 29 "../src/cli.vala"
	_tmp2_ = g_settings_get_value (_tmp1_, "saved-game");
#line 29 "../src/cli.vala"
	_g_variant_unref0 (_vala_saved_game);
#line 29 "../src/cli.vala"
	_vala_saved_game = _tmp2_;
#line 30 "../src/cli.vala"
	_tmp3_ = _vala_saved_game;
#line 30 "../src/cli.vala"
	_vala_can_restore = puzzle_is_valid_saved_game (_tmp3_, TRUE);
#line 32 "../src/cli.vala"
	if ((*game_size) != G_MININT) {
#line 32 "../src/cli.vala"
		_tmp5_ = TRUE;
#line 262 "cli.c"
	} else {
#line 32 "../src/cli.vala"
		_tmp5_ = (*colors) != 10;
#line 266 "cli.c"
	}
#line 32 "../src/cli.vala"
	if (_tmp5_) {
#line 32 "../src/cli.vala"
		_tmp4_ = g_strcmp0 (cli, "new") != 0;
#line 272 "cli.c"
	} else {
#line 32 "../src/cli.vala"
		_tmp4_ = FALSE;
#line 276 "cli.c"
	}
#line 32 "../src/cli.vala"
	if (_tmp4_) {
#line 280 "cli.c"
		gchar* _tmp6_;
		gchar* _tmp7_;
		Puzzle* _tmp8_;
#line 35 "../src/cli.vala"
		_tmp6_ = g_strconcat (_ ("Game size and colors number can only be given for new puzzles."), "\n", NULL);
#line 35 "../src/cli.vala"
		_tmp7_ = _tmp6_;
#line 35 "../src/cli.vala"
		g_warning ("cli.vala:35: %s", _tmp7_);
#line 35 "../src/cli.vala"
		_g_free0 (_tmp7_);
#line 36 "../src/cli.vala"
		_tmp8_ = puzzle_new ((guint8) 2, (guint8) 10);
#line 36 "../src/cli.vala"
		_g_object_unref0 (_vala_puzzle);
#line 36 "../src/cli.vala"
		_vala_puzzle = _tmp8_;
#line 37 "../src/cli.vala"
		result = EXIT_FAILURE;
#line 37 "../src/cli.vala"
		if (settings) {
#line 37 "../src/cli.vala"
			*settings = _vala_settings;
#line 304 "cli.c"
		} else {
#line 37 "../src/cli.vala"
			_g_object_unref0 (_vala_settings);
#line 308 "cli.c"
		}
#line 37 "../src/cli.vala"
		if (saved_game) {
#line 37 "../src/cli.vala"
			*saved_game = _vala_saved_game;
#line 314 "cli.c"
		} else {
#line 37 "../src/cli.vala"
			_g_variant_unref0 (_vala_saved_game);
#line 318 "cli.c"
		}
#line 37 "../src/cli.vala"
		if (can_restore) {
#line 37 "../src/cli.vala"
			*can_restore = _vala_can_restore;
#line 324 "cli.c"
		}
#line 37 "../src/cli.vala"
		if (puzzle) {
#line 37 "../src/cli.vala"
			*puzzle = _vala_puzzle;
#line 330 "cli.c"
		} else {
#line 37 "../src/cli.vala"
			_g_object_unref0 (_vala_puzzle);
#line 334 "cli.c"
		}
#line 37 "../src/cli.vala"
		return result;
#line 338 "cli.c"
	}
#line 42 "../src/cli.vala"
	if ((*game_size) != G_MININT) {
#line 342 "cli.c"
		GSettings* _tmp9_;
		Puzzle* _tmp10_;
#line 44 "../src/cli.vala"
		_tmp9_ = _vala_settings;
#line 44 "../src/cli.vala"
		g_settings_set_int (_tmp9_, KEY_GRID_SIZE, *game_size);
#line 45 "../src/cli.vala"
		size = (guint8) (*game_size);
#line 46 "../src/cli.vala"
		_tmp10_ = puzzle_new (size, (guint8) (*colors));
#line 46 "../src/cli.vala"
		_g_object_unref0 (_vala_puzzle);
#line 46 "../src/cli.vala"
		_vala_puzzle = _tmp10_;
#line 47 "../src/cli.vala"
		new_puzzle = TRUE;
#line 359 "cli.c"
	} else {
		gboolean _tmp11_ = FALSE;
#line 49 "../src/cli.vala"
		if ((*colors) != 10) {
#line 49 "../src/cli.vala"
			_tmp11_ = TRUE;
#line 366 "cli.c"
		} else {
#line 49 "../src/cli.vala"
			_tmp11_ = g_strcmp0 (cli, "new") == 0;
#line 370 "cli.c"
		}
#line 49 "../src/cli.vala"
		if (_tmp11_) {
#line 374 "cli.c"
			GSettings* _tmp12_;
			Puzzle* _tmp13_;
#line 51 "../src/cli.vala"
			_tmp12_ = _vala_settings;
#line 51 "../src/cli.vala"
			size = (guint8) g_settings_get_int (_tmp12_, KEY_GRID_SIZE);
#line 52 "../src/cli.vala"
			_tmp13_ = puzzle_new (size, (guint8) (*colors));
#line 52 "../src/cli.vala"
			_g_object_unref0 (_vala_puzzle);
#line 52 "../src/cli.vala"
			_vala_puzzle = _tmp13_;
#line 53 "../src/cli.vala"
			new_puzzle = TRUE;
#line 389 "cli.c"
		} else {
#line 55 "../src/cli.vala"
			if (_vala_can_restore) {
#line 393 "cli.c"
				GVariant* _tmp14_;
				Puzzle* _tmp15_;
				Puzzle* _tmp16_;
				guint8 _tmp17_;
				guint8 _tmp18_;
#line 57 "../src/cli.vala"
				_tmp14_ = _vala_saved_game;
#line 57 "../src/cli.vala"
				_tmp15_ = puzzle_new_restore ((GVariant*) _tmp14_);
#line 57 "../src/cli.vala"
				_g_object_unref0 (_vala_puzzle);
#line 57 "../src/cli.vala"
				_vala_puzzle = _tmp15_;
#line 58 "../src/cli.vala"
				_tmp16_ = _vala_puzzle;
#line 58 "../src/cli.vala"
				_tmp17_ = puzzle_get_size (_tmp16_);
#line 58 "../src/cli.vala"
				_tmp18_ = _tmp17_;
#line 58 "../src/cli.vala"
				size = _tmp18_;
#line 59 "../src/cli.vala"
				new_puzzle = FALSE;
#line 417 "cli.c"
			} else {
				GSettings* _tmp19_;
				Puzzle* _tmp20_;
#line 63 "../src/cli.vala"
				_tmp19_ = _vala_settings;
#line 63 "../src/cli.vala"
				size = (guint8) g_settings_get_int (_tmp19_, KEY_GRID_SIZE);
#line 64 "../src/cli.vala"
				_tmp20_ = puzzle_new (size, (guint8) 10);
#line 64 "../src/cli.vala"
				_g_object_unref0 (_vala_puzzle);
#line 64 "../src/cli.vala"
				_vala_puzzle = _tmp20_;
#line 65 "../src/cli.vala"
				new_puzzle = TRUE;
#line 433 "cli.c"
			}
		}
	}
#line 68 "../src/cli.vala"
	_tmp21_ = cli;
#line 68 "../src/cli.vala"
	_tmp23_ = (NULL == _tmp21_) ? 0 : g_quark_from_string (_tmp21_);
#line 68 "../src/cli.vala"
	if ((_tmp23_ == ((0 != _tmp22_label0) ? _tmp22_label0 : (_tmp22_label0 = g_quark_from_static_string ("help")))) || (_tmp23_ == ((0 != _tmp22_label1) ? _tmp22_label1 : (_tmp22_label1 = g_quark_from_static_string ("HELP"))))) {
#line 68 "../src/cli.vala"
		switch (0) {
#line 445 "cli.c"
			default:
			{
#line 72 "../src/cli.vala"
				g_assert_not_reached ();
#line 450 "cli.c"
			}
		}
	} else if (((_tmp23_ == ((0 != _tmp22_label2) ? _tmp22_label2 : (_tmp22_label2 = g_quark_from_static_string ("")))) || (_tmp23_ == ((0 != _tmp22_label3) ? _tmp22_label3 : (_tmp22_label3 = g_quark_from_static_string ("show"))))) || (_tmp23_ == ((0 != _tmp22_label4) ? _tmp22_label4 : (_tmp22_label4 = g_quark_from_static_string ("status"))))) {
#line 68 "../src/cli.vala"
		switch (0) {
#line 456 "cli.c"
			default:
			{
				Puzzle* _tmp24_;
#line 77 "../src/cli.vala"
				if (new_puzzle) {
#line 78 "../src/cli.vala"
					break;
#line 464 "cli.c"
				}
#line 80 "../src/cli.vala"
				_tmp24_ = _vala_puzzle;
#line 80 "../src/cli.vala"
				cli_print_board (_tmp24_, size);
#line 81 "../src/cli.vala"
				result = EXIT_SUCCESS;
#line 81 "../src/cli.vala"
				if (settings) {
#line 81 "../src/cli.vala"
					*settings = _vala_settings;
#line 476 "cli.c"
				} else {
#line 81 "../src/cli.vala"
					_g_object_unref0 (_vala_settings);
#line 480 "cli.c"
				}
#line 81 "../src/cli.vala"
				if (saved_game) {
#line 81 "../src/cli.vala"
					*saved_game = _vala_saved_game;
#line 486 "cli.c"
				} else {
#line 81 "../src/cli.vala"
					_g_variant_unref0 (_vala_saved_game);
#line 490 "cli.c"
				}
#line 81 "../src/cli.vala"
				if (can_restore) {
#line 81 "../src/cli.vala"
					*can_restore = _vala_can_restore;
#line 496 "cli.c"
				}
#line 81 "../src/cli.vala"
				if (puzzle) {
#line 81 "../src/cli.vala"
					*puzzle = _vala_puzzle;
#line 502 "cli.c"
				} else {
#line 81 "../src/cli.vala"
					_g_object_unref0 (_vala_puzzle);
#line 506 "cli.c"
				}
#line 81 "../src/cli.vala"
				return result;
#line 510 "cli.c"
			}
		}
	} else if (_tmp23_ == ((0 != _tmp22_label5) ? _tmp22_label5 : (_tmp22_label5 = g_quark_from_static_string ("new")))) {
#line 68 "../src/cli.vala"
		switch (0) {
#line 516 "cli.c"
			default:
			{
#line 84 "../src/cli.vala"
				break;
#line 521 "cli.c"
			}
		}
	} else if ((_tmp23_ == ((0 != _tmp22_label6) ? _tmp22_label6 : (_tmp22_label6 = g_quark_from_static_string ("up")))) || (_tmp23_ == ((0 != _tmp22_label7) ? _tmp22_label7 : (_tmp22_label7 = g_quark_from_static_string ("l-up"))))) {
#line 68 "../src/cli.vala"
		switch (0) {
#line 527 "cli.c"
			default:
			{
				Puzzle* _tmp25_;
#line 89 "../src/cli.vala"
				_tmp25_ = _vala_puzzle;
#line 89 "../src/cli.vala"
				if (!cli_cli_move_tiles (_tmp25_, new_puzzle, TRUE, DIRECTION_UP, _ ("Cannot move up left-board tiles."))) {
#line 90 "../src/cli.vala"
					result = EXIT_FAILURE;
#line 90 "../src/cli.vala"
					if (settings) {
#line 90 "../src/cli.vala"
						*settings = _vala_settings;
#line 541 "cli.c"
					} else {
#line 90 "../src/cli.vala"
						_g_object_unref0 (_vala_settings);
#line 545 "cli.c"
					}
#line 90 "../src/cli.vala"
					if (saved_game) {
#line 90 "../src/cli.vala"
						*saved_game = _vala_saved_game;
#line 551 "cli.c"
					} else {
#line 90 "../src/cli.vala"
						_g_variant_unref0 (_vala_saved_game);
#line 555 "cli.c"
					}
#line 90 "../src/cli.vala"
					if (can_restore) {
#line 90 "../src/cli.vala"
						*can_restore = _vala_can_restore;
#line 561 "cli.c"
					}
#line 90 "../src/cli.vala"
					if (puzzle) {
#line 90 "../src/cli.vala"
						*puzzle = _vala_puzzle;
#line 567 "cli.c"
					} else {
#line 90 "../src/cli.vala"
						_g_object_unref0 (_vala_puzzle);
#line 571 "cli.c"
					}
#line 90 "../src/cli.vala"
					return result;
#line 575 "cli.c"
				}
#line 91 "../src/cli.vala"
				break;
#line 579 "cli.c"
			}
		}
	} else if ((_tmp23_ == ((0 != _tmp22_label8) ? _tmp22_label8 : (_tmp22_label8 = g_quark_from_static_string ("down")))) || (_tmp23_ == ((0 != _tmp22_label9) ? _tmp22_label9 : (_tmp22_label9 = g_quark_from_static_string ("l-down"))))) {
#line 68 "../src/cli.vala"
		switch (0) {
#line 585 "cli.c"
			default:
			{
				Puzzle* _tmp26_;
#line 95 "../src/cli.vala"
				_tmp26_ = _vala_puzzle;
#line 95 "../src/cli.vala"
				if (!cli_cli_move_tiles (_tmp26_, new_puzzle, TRUE, DIRECTION_DOWN, _ ("Cannot move down left-board tiles."))) {
#line 96 "../src/cli.vala"
					result = EXIT_FAILURE;
#line 96 "../src/cli.vala"
					if (settings) {
#line 96 "../src/cli.vala"
						*settings = _vala_settings;
#line 599 "cli.c"
					} else {
#line 96 "../src/cli.vala"
						_g_object_unref0 (_vala_settings);
#line 603 "cli.c"
					}
#line 96 "../src/cli.vala"
					if (saved_game) {
#line 96 "../src/cli.vala"
						*saved_game = _vala_saved_game;
#line 609 "cli.c"
					} else {
#line 96 "../src/cli.vala"
						_g_variant_unref0 (_vala_saved_game);
#line 613 "cli.c"
					}
#line 96 "../src/cli.vala"
					if (can_restore) {
#line 96 "../src/cli.vala"
						*can_restore = _vala_can_restore;
#line 619 "cli.c"
					}
#line 96 "../src/cli.vala"
					if (puzzle) {
#line 96 "../src/cli.vala"
						*puzzle = _vala_puzzle;
#line 625 "cli.c"
					} else {
#line 96 "../src/cli.vala"
						_g_object_unref0 (_vala_puzzle);
#line 629 "cli.c"
					}
#line 96 "../src/cli.vala"
					return result;
#line 633 "cli.c"
				}
#line 97 "../src/cli.vala"
				break;
#line 637 "cli.c"
			}
		}
	} else if ((_tmp23_ == ((0 != _tmp22_label10) ? _tmp22_label10 : (_tmp22_label10 = g_quark_from_static_string ("left")))) || (_tmp23_ == ((0 != _tmp22_label11) ? _tmp22_label11 : (_tmp22_label11 = g_quark_from_static_string ("l-left"))))) {
#line 68 "../src/cli.vala"
		switch (0) {
#line 643 "cli.c"
			default:
			{
				Puzzle* _tmp27_;
#line 101 "../src/cli.vala"
				_tmp27_ = _vala_puzzle;
#line 101 "../src/cli.vala"
				if (!cli_cli_move_tiles (_tmp27_, new_puzzle, TRUE, DIRECTION_LEFT, _ ("Cannot move left left-board tiles."))) {
#line 102 "../src/cli.vala"
					result = EXIT_FAILURE;
#line 102 "../src/cli.vala"
					if (settings) {
#line 102 "../src/cli.vala"
						*settings = _vala_settings;
#line 657 "cli.c"
					} else {
#line 102 "../src/cli.vala"
						_g_object_unref0 (_vala_settings);
#line 661 "cli.c"
					}
#line 102 "../src/cli.vala"
					if (saved_game) {
#line 102 "../src/cli.vala"
						*saved_game = _vala_saved_game;
#line 667 "cli.c"
					} else {
#line 102 "../src/cli.vala"
						_g_variant_unref0 (_vala_saved_game);
#line 671 "cli.c"
					}
#line 102 "../src/cli.vala"
					if (can_restore) {
#line 102 "../src/cli.vala"
						*can_restore = _vala_can_restore;
#line 677 "cli.c"
					}
#line 102 "../src/cli.vala"
					if (puzzle) {
#line 102 "../src/cli.vala"
						*puzzle = _vala_puzzle;
#line 683 "cli.c"
					} else {
#line 102 "../src/cli.vala"
						_g_object_unref0 (_vala_puzzle);
#line 687 "cli.c"
					}
#line 102 "../src/cli.vala"
					return result;
#line 691 "cli.c"
				}
#line 103 "../src/cli.vala"
				break;
#line 695 "cli.c"
			}
		}
	} else if ((_tmp23_ == ((0 != _tmp22_label12) ? _tmp22_label12 : (_tmp22_label12 = g_quark_from_static_string ("right")))) || (_tmp23_ == ((0 != _tmp22_label13) ? _tmp22_label13 : (_tmp22_label13 = g_quark_from_static_string ("l-right"))))) {
#line 68 "../src/cli.vala"
		switch (0) {
#line 701 "cli.c"
			default:
			{
				Puzzle* _tmp28_;
#line 107 "../src/cli.vala"
				_tmp28_ = _vala_puzzle;
#line 107 "../src/cli.vala"
				if (!cli_cli_move_tiles (_tmp28_, new_puzzle, TRUE, DIRECTION_RIGHT, _ ("Cannot move right left-board tiles."))) {
#line 108 "../src/cli.vala"
					result = EXIT_FAILURE;
#line 108 "../src/cli.vala"
					if (settings) {
#line 108 "../src/cli.vala"
						*settings = _vala_settings;
#line 715 "cli.c"
					} else {
#line 108 "../src/cli.vala"
						_g_object_unref0 (_vala_settings);
#line 719 "cli.c"
					}
#line 108 "../src/cli.vala"
					if (saved_game) {
#line 108 "../src/cli.vala"
						*saved_game = _vala_saved_game;
#line 725 "cli.c"
					} else {
#line 108 "../src/cli.vala"
						_g_variant_unref0 (_vala_saved_game);
#line 729 "cli.c"
					}
#line 108 "../src/cli.vala"
					if (can_restore) {
#line 108 "../src/cli.vala"
						*can_restore = _vala_can_restore;
#line 735 "cli.c"
					}
#line 108 "../src/cli.vala"
					if (puzzle) {
#line 108 "../src/cli.vala"
						*puzzle = _vala_puzzle;
#line 741 "cli.c"
					} else {
#line 108 "../src/cli.vala"
						_g_object_unref0 (_vala_puzzle);
#line 745 "cli.c"
					}
#line 108 "../src/cli.vala"
					return result;
#line 749 "cli.c"
				}
#line 109 "../src/cli.vala"
				break;
#line 753 "cli.c"
			}
		}
	} else if (_tmp23_ == ((0 != _tmp22_label14) ? _tmp22_label14 : (_tmp22_label14 = g_quark_from_static_string ("r-up")))) {
#line 68 "../src/cli.vala"
		switch (0) {
#line 759 "cli.c"
			default:
			{
				Puzzle* _tmp29_;
#line 113 "../src/cli.vala"
				_tmp29_ = _vala_puzzle;
#line 113 "../src/cli.vala"
				if (!cli_cli_move_tiles (_tmp29_, new_puzzle, FALSE, DIRECTION_UP, _ ("Cannot move up right-board tiles."))) {
#line 114 "../src/cli.vala"
					result = EXIT_FAILURE;
#line 114 "../src/cli.vala"
					if (settings) {
#line 114 "../src/cli.vala"
						*settings = _vala_settings;
#line 773 "cli.c"
					} else {
#line 114 "../src/cli.vala"
						_g_object_unref0 (_vala_settings);
#line 777 "cli.c"
					}
#line 114 "../src/cli.vala"
					if (saved_game) {
#line 114 "../src/cli.vala"
						*saved_game = _vala_saved_game;
#line 783 "cli.c"
					} else {
#line 114 "../src/cli.vala"
						_g_variant_unref0 (_vala_saved_game);
#line 787 "cli.c"
					}
#line 114 "../src/cli.vala"
					if (can_restore) {
#line 114 "../src/cli.vala"
						*can_restore = _vala_can_restore;
#line 793 "cli.c"
					}
#line 114 "../src/cli.vala"
					if (puzzle) {
#line 114 "../src/cli.vala"
						*puzzle = _vala_puzzle;
#line 799 "cli.c"
					} else {
#line 114 "../src/cli.vala"
						_g_object_unref0 (_vala_puzzle);
#line 803 "cli.c"
					}
#line 114 "../src/cli.vala"
					return result;
#line 807 "cli.c"
				}
#line 115 "../src/cli.vala"
				break;
#line 811 "cli.c"
			}
		}
	} else if (_tmp23_ == ((0 != _tmp22_label15) ? _tmp22_label15 : (_tmp22_label15 = g_quark_from_static_string ("r-down")))) {
#line 68 "../src/cli.vala"
		switch (0) {
#line 817 "cli.c"
			default:
			{
				Puzzle* _tmp30_;
#line 118 "../src/cli.vala"
				_tmp30_ = _vala_puzzle;
#line 118 "../src/cli.vala"
				if (!cli_cli_move_tiles (_tmp30_, new_puzzle, FALSE, DIRECTION_DOWN, _ ("Cannot move down right-board tiles."))) {
#line 119 "../src/cli.vala"
					result = EXIT_FAILURE;
#line 119 "../src/cli.vala"
					if (settings) {
#line 119 "../src/cli.vala"
						*settings = _vala_settings;
#line 831 "cli.c"
					} else {
#line 119 "../src/cli.vala"
						_g_object_unref0 (_vala_settings);
#line 835 "cli.c"
					}
#line 119 "../src/cli.vala"
					if (saved_game) {
#line 119 "../src/cli.vala"
						*saved_game = _vala_saved_game;
#line 841 "cli.c"
					} else {
#line 119 "../src/cli.vala"
						_g_variant_unref0 (_vala_saved_game);
#line 845 "cli.c"
					}
#line 119 "../src/cli.vala"
					if (can_restore) {
#line 119 "../src/cli.vala"
						*can_restore = _vala_can_restore;
#line 851 "cli.c"
					}
#line 119 "../src/cli.vala"
					if (puzzle) {
#line 119 "../src/cli.vala"
						*puzzle = _vala_puzzle;
#line 857 "cli.c"
					} else {
#line 119 "../src/cli.vala"
						_g_object_unref0 (_vala_puzzle);
#line 861 "cli.c"
					}
#line 119 "../src/cli.vala"
					return result;
#line 865 "cli.c"
				}
#line 120 "../src/cli.vala"
				break;
#line 869 "cli.c"
			}
		}
	} else if (_tmp23_ == ((0 != _tmp22_label16) ? _tmp22_label16 : (_tmp22_label16 = g_quark_from_static_string ("r-left")))) {
#line 68 "../src/cli.vala"
		switch (0) {
#line 875 "cli.c"
			default:
			{
				Puzzle* _tmp31_;
#line 123 "../src/cli.vala"
				_tmp31_ = _vala_puzzle;
#line 123 "../src/cli.vala"
				if (!cli_cli_move_tiles (_tmp31_, new_puzzle, FALSE, DIRECTION_LEFT, _ ("Cannot move left right-board tiles."))) {
#line 124 "../src/cli.vala"
					result = EXIT_FAILURE;
#line 124 "../src/cli.vala"
					if (settings) {
#line 124 "../src/cli.vala"
						*settings = _vala_settings;
#line 889 "cli.c"
					} else {
#line 124 "../src/cli.vala"
						_g_object_unref0 (_vala_settings);
#line 893 "cli.c"
					}
#line 124 "../src/cli.vala"
					if (saved_game) {
#line 124 "../src/cli.vala"
						*saved_game = _vala_saved_game;
#line 899 "cli.c"
					} else {
#line 124 "../src/cli.vala"
						_g_variant_unref0 (_vala_saved_game);
#line 903 "cli.c"
					}
#line 124 "../src/cli.vala"
					if (can_restore) {
#line 124 "../src/cli.vala"
						*can_restore = _vala_can_restore;
#line 909 "cli.c"
					}
#line 124 "../src/cli.vala"
					if (puzzle) {
#line 124 "../src/cli.vala"
						*puzzle = _vala_puzzle;
#line 915 "cli.c"
					} else {
#line 124 "../src/cli.vala"
						_g_object_unref0 (_vala_puzzle);
#line 919 "cli.c"
					}
#line 124 "../src/cli.vala"
					return result;
#line 923 "cli.c"
				}
#line 125 "../src/cli.vala"
				break;
#line 927 "cli.c"
			}
		}
	} else if (_tmp23_ == ((0 != _tmp22_label17) ? _tmp22_label17 : (_tmp22_label17 = g_quark_from_static_string ("r-right")))) {
#line 68 "../src/cli.vala"
		switch (0) {
#line 933 "cli.c"
			default:
			{
				Puzzle* _tmp32_;
#line 128 "../src/cli.vala"
				_tmp32_ = _vala_puzzle;
#line 128 "../src/cli.vala"
				if (!cli_cli_move_tiles (_tmp32_, new_puzzle, FALSE, DIRECTION_RIGHT, _ ("Cannot move right right-board tiles."))) {
#line 129 "../src/cli.vala"
					result = EXIT_FAILURE;
#line 129 "../src/cli.vala"
					if (settings) {
#line 129 "../src/cli.vala"
						*settings = _vala_settings;
#line 947 "cli.c"
					} else {
#line 129 "../src/cli.vala"
						_g_object_unref0 (_vala_settings);
#line 951 "cli.c"
					}
#line 129 "../src/cli.vala"
					if (saved_game) {
#line 129 "../src/cli.vala"
						*saved_game = _vala_saved_game;
#line 957 "cli.c"
					} else {
#line 129 "../src/cli.vala"
						_g_variant_unref0 (_vala_saved_game);
#line 961 "cli.c"
					}
#line 129 "../src/cli.vala"
					if (can_restore) {
#line 129 "../src/cli.vala"
						*can_restore = _vala_can_restore;
#line 967 "cli.c"
					}
#line 129 "../src/cli.vala"
					if (puzzle) {
#line 129 "../src/cli.vala"
						*puzzle = _vala_puzzle;
#line 973 "cli.c"
					} else {
#line 129 "../src/cli.vala"
						_g_object_unref0 (_vala_puzzle);
#line 977 "cli.c"
					}
#line 129 "../src/cli.vala"
					return result;
#line 981 "cli.c"
				}
#line 130 "../src/cli.vala"
				break;
#line 985 "cli.c"
			}
		}
	} else if ((_tmp23_ == ((0 != _tmp22_label18) ? _tmp22_label18 : (_tmp22_label18 = g_quark_from_static_string ("end")))) || (_tmp23_ == ((0 != _tmp22_label19) ? _tmp22_label19 : (_tmp22_label19 = g_quark_from_static_string ("finish"))))) {
#line 68 "../src/cli.vala"
		switch (0) {
#line 991 "cli.c"
			default:
			{
				gboolean _tmp33_ = FALSE;
				Puzzle* _tmp37_;
				gboolean _tmp38_;
				gboolean _tmp39_;
#line 134 "../src/cli.vala"
				if (new_puzzle) {
#line 134 "../src/cli.vala"
					_tmp33_ = TRUE;
#line 1002 "cli.c"
				} else {
					Puzzle* _tmp34_;
					gboolean _tmp35_;
					gboolean _tmp36_;
#line 134 "../src/cli.vala"
					_tmp34_ = _vala_puzzle;
#line 134 "../src/cli.vala"
					_tmp35_ = puzzle_get_is_solved (_tmp34_);
#line 134 "../src/cli.vala"
					_tmp36_ = _tmp35_;
#line 134 "../src/cli.vala"
					_tmp33_ = _tmp36_;
#line 1015 "cli.c"
				}
#line 134 "../src/cli.vala"
				if (_tmp33_) {
#line 136 "../src/cli.vala"
					cli_puzzle_is_solved_message (TRUE);
#line 137 "../src/cli.vala"
					result = EXIT_FAILURE;
#line 137 "../src/cli.vala"
					if (settings) {
#line 137 "../src/cli.vala"
						*settings = _vala_settings;
#line 1027 "cli.c"
					} else {
#line 137 "../src/cli.vala"
						_g_object_unref0 (_vala_settings);
#line 1031 "cli.c"
					}
#line 137 "../src/cli.vala"
					if (saved_game) {
#line 137 "../src/cli.vala"
						*saved_game = _vala_saved_game;
#line 1037 "cli.c"
					} else {
#line 137 "../src/cli.vala"
						_g_variant_unref0 (_vala_saved_game);
#line 1041 "cli.c"
					}
#line 137 "../src/cli.vala"
					if (can_restore) {
#line 137 "../src/cli.vala"
						*can_restore = _vala_can_restore;
#line 1047 "cli.c"
					}
#line 137 "../src/cli.vala"
					if (puzzle) {
#line 137 "../src/cli.vala"
						*puzzle = _vala_puzzle;
#line 1053 "cli.c"
					} else {
#line 137 "../src/cli.vala"
						_g_object_unref0 (_vala_puzzle);
#line 1057 "cli.c"
					}
#line 137 "../src/cli.vala"
					return result;
#line 1061 "cli.c"
				}
#line 140 "../src/cli.vala"
				_tmp37_ = _vala_puzzle;
#line 140 "../src/cli.vala"
				_tmp38_ = puzzle_get_is_solved_right (_tmp37_);
#line 140 "../src/cli.vala"
				_tmp39_ = _tmp38_;
#line 140 "../src/cli.vala"
				if (_tmp39_) {
#line 1071 "cli.c"
					Puzzle* _tmp40_;
#line 141 "../src/cli.vala"
					_tmp40_ = _vala_puzzle;
#line 141 "../src/cli.vala"
					puzzle_finish (_tmp40_, (guint) 0);
#line 1077 "cli.c"
				} else {
					Puzzle* _tmp41_;
#line 142 "../src/cli.vala"
					_tmp41_ = _vala_puzzle;
#line 142 "../src/cli.vala"
					if (!puzzle_move_last_tile_if_possible (_tmp41_)) {
#line 1084 "cli.c"
						gchar* _tmp42_;
						gchar* _tmp43_;
#line 145 "../src/cli.vala"
						_tmp42_ = g_strconcat (_ ("Cannot finish automatically. If you want to give up and view the solut" \
"ion, use “solve”."), "\n", NULL);
#line 145 "../src/cli.vala"
						_tmp43_ = _tmp42_;
#line 145 "../src/cli.vala"
						g_warning ("cli.vala:145: %s", _tmp43_);
#line 145 "../src/cli.vala"
						_g_free0 (_tmp43_);
#line 146 "../src/cli.vala"
						result = EXIT_FAILURE;
#line 146 "../src/cli.vala"
						if (settings) {
#line 146 "../src/cli.vala"
							*settings = _vala_settings;
#line 1101 "cli.c"
						} else {
#line 146 "../src/cli.vala"
							_g_object_unref0 (_vala_settings);
#line 1105 "cli.c"
						}
#line 146 "../src/cli.vala"
						if (saved_game) {
#line 146 "../src/cli.vala"
							*saved_game = _vala_saved_game;
#line 1111 "cli.c"
						} else {
#line 146 "../src/cli.vala"
							_g_variant_unref0 (_vala_saved_game);
#line 1115 "cli.c"
						}
#line 146 "../src/cli.vala"
						if (can_restore) {
#line 146 "../src/cli.vala"
							*can_restore = _vala_can_restore;
#line 1121 "cli.c"
						}
#line 146 "../src/cli.vala"
						if (puzzle) {
#line 146 "../src/cli.vala"
							*puzzle = _vala_puzzle;
#line 1127 "cli.c"
						} else {
#line 146 "../src/cli.vala"
							_g_object_unref0 (_vala_puzzle);
#line 1131 "cli.c"
						}
#line 146 "../src/cli.vala"
						return result;
#line 1135 "cli.c"
					}
				}
#line 148 "../src/cli.vala"
				break;
#line 1140 "cli.c"
			}
		}
	} else if (_tmp23_ == ((0 != _tmp22_label20) ? _tmp22_label20 : (_tmp22_label20 = g_quark_from_static_string ("solve")))) {
#line 68 "../src/cli.vala"
		switch (0) {
#line 1146 "cli.c"
			default:
			{
				gboolean _tmp44_ = FALSE;
				Puzzle* _tmp48_;
#line 151 "../src/cli.vala"
				if (new_puzzle) {
#line 151 "../src/cli.vala"
					_tmp44_ = TRUE;
#line 1155 "cli.c"
				} else {
					Puzzle* _tmp45_;
					gboolean _tmp46_;
					gboolean _tmp47_;
#line 151 "../src/cli.vala"
					_tmp45_ = _vala_puzzle;
#line 151 "../src/cli.vala"
					_tmp46_ = puzzle_get_is_solved (_tmp45_);
#line 151 "../src/cli.vala"
					_tmp47_ = _tmp46_;
#line 151 "../src/cli.vala"
					_tmp44_ = _tmp47_;
#line 1168 "cli.c"
				}
#line 151 "../src/cli.vala"
				if (_tmp44_) {
#line 153 "../src/cli.vala"
					cli_puzzle_is_solved_message (TRUE);
#line 154 "../src/cli.vala"
					result = EXIT_FAILURE;
#line 154 "../src/cli.vala"
					if (settings) {
#line 154 "../src/cli.vala"
						*settings = _vala_settings;
#line 1180 "cli.c"
					} else {
#line 154 "../src/cli.vala"
						_g_object_unref0 (_vala_settings);
#line 1184 "cli.c"
					}
#line 154 "../src/cli.vala"
					if (saved_game) {
#line 154 "../src/cli.vala"
						*saved_game = _vala_saved_game;
#line 1190 "cli.c"
					} else {
#line 154 "../src/cli.vala"
						_g_variant_unref0 (_vala_saved_game);
#line 1194 "cli.c"
					}
#line 154 "../src/cli.vala"
					if (can_restore) {
#line 154 "../src/cli.vala"
						*can_restore = _vala_can_restore;
#line 1200 "cli.c"
					}
#line 154 "../src/cli.vala"
					if (puzzle) {
#line 154 "../src/cli.vala"
						*puzzle = _vala_puzzle;
#line 1206 "cli.c"
					} else {
#line 154 "../src/cli.vala"
						_g_object_unref0 (_vala_puzzle);
#line 1210 "cli.c"
					}
#line 154 "../src/cli.vala"
					return result;
#line 1214 "cli.c"
				}
#line 157 "../src/cli.vala"
				_tmp48_ = _vala_puzzle;
#line 157 "../src/cli.vala"
				puzzle_solve (_tmp48_);
#line 158 "../src/cli.vala"
				break;
#line 1222 "cli.c"
			}
		}
	} else {
#line 68 "../src/cli.vala"
		switch (0) {
#line 1228 "cli.c"
			default:
			{
				gboolean _tmp49_ = FALSE;
				guint8 tile_1_x = 0U;
				guint8 tile_1_y = 0U;
				guint8 tile_2_x = 0U;
				guint8 tile_2_y = 0U;
				guint8 _tmp53_ = 0U;
				guint8 _tmp54_ = 0U;
				guint8 _tmp55_ = 0U;
				guint8 _tmp56_ = 0U;
				gboolean _tmp57_;
				gboolean _tmp60_ = FALSE;
				Puzzle* _tmp61_;
				Tile* _tmp62_;
				Tile* _tmp63_;
				gboolean _tmp64_;
				Puzzle* _tmp70_;
				Puzzle* _tmp74_;
#line 161 "../src/cli.vala"
				if (new_puzzle) {
#line 161 "../src/cli.vala"
					_tmp49_ = TRUE;
#line 1252 "cli.c"
				} else {
					Puzzle* _tmp50_;
					gboolean _tmp51_;
					gboolean _tmp52_;
#line 161 "../src/cli.vala"
					_tmp50_ = _vala_puzzle;
#line 161 "../src/cli.vala"
					_tmp51_ = puzzle_get_is_solved (_tmp50_);
#line 161 "../src/cli.vala"
					_tmp52_ = _tmp51_;
#line 161 "../src/cli.vala"
					_tmp49_ = _tmp52_;
#line 1265 "cli.c"
				}
#line 161 "../src/cli.vala"
				if (_tmp49_) {
#line 163 "../src/cli.vala"
					cli_puzzle_is_solved_message (FALSE);
#line 164 "../src/cli.vala"
					result = EXIT_FAILURE;
#line 164 "../src/cli.vala"
					if (settings) {
#line 164 "../src/cli.vala"
						*settings = _vala_settings;
#line 1277 "cli.c"
					} else {
#line 164 "../src/cli.vala"
						_g_object_unref0 (_vala_settings);
#line 1281 "cli.c"
					}
#line 164 "../src/cli.vala"
					if (saved_game) {
#line 164 "../src/cli.vala"
						*saved_game = _vala_saved_game;
#line 1287 "cli.c"
					} else {
#line 164 "../src/cli.vala"
						_g_variant_unref0 (_vala_saved_game);
#line 1291 "cli.c"
					}
#line 164 "../src/cli.vala"
					if (can_restore) {
#line 164 "../src/cli.vala"
						*can_restore = _vala_can_restore;
#line 1297 "cli.c"
					}
#line 164 "../src/cli.vala"
					if (puzzle) {
#line 164 "../src/cli.vala"
						*puzzle = _vala_puzzle;
#line 1303 "cli.c"
					} else {
#line 164 "../src/cli.vala"
						_g_object_unref0 (_vala_puzzle);
#line 1307 "cli.c"
					}
#line 164 "../src/cli.vala"
					return result;
#line 1311 "cli.c"
				}
#line 171 "../src/cli.vala"
				_tmp57_ = cli_parse_cli (cli, size, &_tmp53_, &_tmp54_, &_tmp55_, &_tmp56_);
#line 171 "../src/cli.vala"
				tile_1_x = _tmp53_;
#line 171 "../src/cli.vala"
				tile_1_y = _tmp54_;
#line 171 "../src/cli.vala"
				tile_2_x = _tmp55_;
#line 171 "../src/cli.vala"
				tile_2_y = _tmp56_;
#line 171 "../src/cli.vala"
				if (!_tmp57_) {
#line 1325 "cli.c"
					gchar* _tmp58_;
					gchar* _tmp59_;
#line 174 "../src/cli.vala"
					_tmp58_ = g_strconcat (_ ("Cannot parse instruction, aborting."), "\n", NULL);
#line 174 "../src/cli.vala"
					_tmp59_ = _tmp58_;
#line 174 "../src/cli.vala"
					g_warning ("cli.vala:174: %s", _tmp59_);
#line 174 "../src/cli.vala"
					_g_free0 (_tmp59_);
#line 175 "../src/cli.vala"
					result = EXIT_FAILURE;
#line 175 "../src/cli.vala"
					if (settings) {
#line 175 "../src/cli.vala"
						*settings = _vala_settings;
#line 1342 "cli.c"
					} else {
#line 175 "../src/cli.vala"
						_g_object_unref0 (_vala_settings);
#line 1346 "cli.c"
					}
#line 175 "../src/cli.vala"
					if (saved_game) {
#line 175 "../src/cli.vala"
						*saved_game = _vala_saved_game;
#line 1352 "cli.c"
					} else {
#line 175 "../src/cli.vala"
						_g_variant_unref0 (_vala_saved_game);
#line 1356 "cli.c"
					}
#line 175 "../src/cli.vala"
					if (can_restore) {
#line 175 "../src/cli.vala"
						*can_restore = _vala_can_restore;
#line 1362 "cli.c"
					}
#line 175 "../src/cli.vala"
					if (puzzle) {
#line 175 "../src/cli.vala"
						*puzzle = _vala_puzzle;
#line 1368 "cli.c"
					} else {
#line 175 "../src/cli.vala"
						_g_object_unref0 (_vala_puzzle);
#line 1372 "cli.c"
					}
#line 175 "../src/cli.vala"
					return result;
#line 1376 "cli.c"
				}
#line 177 "../src/cli.vala"
				_tmp61_ = _vala_puzzle;
#line 177 "../src/cli.vala"
				_tmp62_ = puzzle_get_tile (_tmp61_, tile_1_x, tile_1_y);
#line 177 "../src/cli.vala"
				_tmp63_ = _tmp62_;
#line 177 "../src/cli.vala"
				_tmp64_ = _tmp63_ == NULL;
#line 177 "../src/cli.vala"
				_g_object_unref0 (_tmp63_);
#line 177 "../src/cli.vala"
				if (_tmp64_) {
#line 1390 "cli.c"
					Puzzle* _tmp65_;
					Tile* _tmp66_;
					Tile* _tmp67_;
#line 178 "../src/cli.vala"
					_tmp65_ = _vala_puzzle;
#line 178 "../src/cli.vala"
					_tmp66_ = puzzle_get_tile (_tmp65_, tile_2_x, tile_2_y);
#line 178 "../src/cli.vala"
					_tmp67_ = _tmp66_;
#line 178 "../src/cli.vala"
					_tmp60_ = _tmp67_ == NULL;
#line 178 "../src/cli.vala"
					_g_object_unref0 (_tmp67_);
#line 1404 "cli.c"
				} else {
#line 177 "../src/cli.vala"
					_tmp60_ = FALSE;
#line 1408 "cli.c"
				}
#line 177 "../src/cli.vala"
				if (_tmp60_) {
#line 1412 "cli.c"
					gchar* _tmp68_;
					gchar* _tmp69_;
#line 181 "../src/cli.vala"
					_tmp68_ = g_strconcat (_ ("Both given tiles are empty, aborting."), "\n", NULL);
#line 181 "../src/cli.vala"
					_tmp69_ = _tmp68_;
#line 181 "../src/cli.vala"
					g_warning ("cli.vala:181: %s", _tmp69_);
#line 181 "../src/cli.vala"
					_g_free0 (_tmp69_);
#line 182 "../src/cli.vala"
					result = EXIT_FAILURE;
#line 182 "../src/cli.vala"
					if (settings) {
#line 182 "../src/cli.vala"
						*settings = _vala_settings;
#line 1429 "cli.c"
					} else {
#line 182 "../src/cli.vala"
						_g_object_unref0 (_vala_settings);
#line 1433 "cli.c"
					}
#line 182 "../src/cli.vala"
					if (saved_game) {
#line 182 "../src/cli.vala"
						*saved_game = _vala_saved_game;
#line 1439 "cli.c"
					} else {
#line 182 "../src/cli.vala"
						_g_variant_unref0 (_vala_saved_game);
#line 1443 "cli.c"
					}
#line 182 "../src/cli.vala"
					if (can_restore) {
#line 182 "../src/cli.vala"
						*can_restore = _vala_can_restore;
#line 1449 "cli.c"
					}
#line 182 "../src/cli.vala"
					if (puzzle) {
#line 182 "../src/cli.vala"
						*puzzle = _vala_puzzle;
#line 1455 "cli.c"
					} else {
#line 182 "../src/cli.vala"
						_g_object_unref0 (_vala_puzzle);
#line 1459 "cli.c"
					}
#line 182 "../src/cli.vala"
					return result;
#line 1463 "cli.c"
				}
#line 184 "../src/cli.vala"
				_tmp70_ = _vala_puzzle;
#line 184 "../src/cli.vala"
				if (!puzzle_can_switch (_tmp70_, tile_1_x, tile_1_y, tile_2_x, tile_2_y)) {
#line 1469 "cli.c"
					gchar* _tmp71_;
					gchar* _tmp72_;
					Puzzle* _tmp73_;
#line 187 "../src/cli.vala"
					_tmp71_ = g_strconcat (_ ("Cannot swap the given tiles, aborting."), "\n", NULL);
#line 187 "../src/cli.vala"
					_tmp72_ = _tmp71_;
#line 187 "../src/cli.vala"
					g_warning ("cli.vala:187: %s", _tmp72_);
#line 187 "../src/cli.vala"
					_g_free0 (_tmp72_);
#line 188 "../src/cli.vala"
					_tmp73_ = _vala_puzzle;
#line 188 "../src/cli.vala"
					cli_print_board (_tmp73_, size);
#line 189 "../src/cli.vala"
					result = EXIT_FAILURE;
#line 189 "../src/cli.vala"
					if (settings) {
#line 189 "../src/cli.vala"
						*settings = _vala_settings;
#line 1491 "cli.c"
					} else {
#line 189 "../src/cli.vala"
						_g_object_unref0 (_vala_settings);
#line 1495 "cli.c"
					}
#line 189 "../src/cli.vala"
					if (saved_game) {
#line 189 "../src/cli.vala"
						*saved_game = _vala_saved_game;
#line 1501 "cli.c"
					} else {
#line 189 "../src/cli.vala"
						_g_variant_unref0 (_vala_saved_game);
#line 1505 "cli.c"
					}
#line 189 "../src/cli.vala"
					if (can_restore) {
#line 189 "../src/cli.vala"
						*can_restore = _vala_can_restore;
#line 1511 "cli.c"
					}
#line 189 "../src/cli.vala"
					if (puzzle) {
#line 189 "../src/cli.vala"
						*puzzle = _vala_puzzle;
#line 1517 "cli.c"
					} else {
#line 189 "../src/cli.vala"
						_g_object_unref0 (_vala_puzzle);
#line 1521 "cli.c"
					}
#line 189 "../src/cli.vala"
					return result;
#line 1525 "cli.c"
				}
#line 191 "../src/cli.vala"
				_tmp74_ = _vala_puzzle;
#line 191 "../src/cli.vala"
				puzzle_switch_tiles (_tmp74_, tile_1_x, tile_1_y, tile_2_x, tile_2_y, (guint) 0);
#line 192 "../src/cli.vala"
				break;
#line 1533 "cli.c"
			}
		}
	}
#line 195 "../src/cli.vala"
	_tmp75_ = _vala_puzzle;
#line 195 "../src/cli.vala"
	cli_print_board (_tmp75_, size);
#line 197 "../src/cli.vala"
	_tmp76_ = _vala_settings;
#line 197 "../src/cli.vala"
	_tmp77_ = _vala_puzzle;
#line 197 "../src/cli.vala"
	_tmp78_ = puzzle_to_variant (_tmp77_, FALSE);
#line 197 "../src/cli.vala"
	_tmp79_ = _tmp78_;
#line 197 "../src/cli.vala"
	g_settings_set_value (_tmp76_, "saved-game", _tmp79_);
#line 197 "../src/cli.vala"
	_g_variant_unref0 (_tmp79_);
#line 199 "../src/cli.vala"
	result = EXIT_SUCCESS;
#line 199 "../src/cli.vala"
	if (settings) {
#line 199 "../src/cli.vala"
		*settings = _vala_settings;
#line 1559 "cli.c"
	} else {
#line 199 "../src/cli.vala"
		_g_object_unref0 (_vala_settings);
#line 1563 "cli.c"
	}
#line 199 "../src/cli.vala"
	if (saved_game) {
#line 199 "../src/cli.vala"
		*saved_game = _vala_saved_game;
#line 1569 "cli.c"
	} else {
#line 199 "../src/cli.vala"
		_g_variant_unref0 (_vala_saved_game);
#line 1573 "cli.c"
	}
#line 199 "../src/cli.vala"
	if (can_restore) {
#line 199 "../src/cli.vala"
		*can_restore = _vala_can_restore;
#line 1579 "cli.c"
	}
#line 199 "../src/cli.vala"
	if (puzzle) {
#line 199 "../src/cli.vala"
		*puzzle = _vala_puzzle;
#line 1585 "cli.c"
	} else {
#line 199 "../src/cli.vala"
		_g_object_unref0 (_vala_puzzle);
#line 1589 "cli.c"
	}
#line 199 "../src/cli.vala"
	return result;
#line 1593 "cli.c"
}

static const gchar*
string_to_string (const gchar* self)
{
	const gchar* result;
#line 1578 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1579 "glib-2.0.vapi"
	result = self;
#line 1579 "glib-2.0.vapi"
	return result;
#line 1606 "cli.c"
}

gboolean
cli_cli_move_tiles (Puzzle* puzzle,
                    gboolean new_puzzle,
                    gboolean left_board,
                    Direction direction,
                    const gchar* warning_string)
{
	gboolean _tmp0_ = FALSE;
	gboolean success = FALSE;
	gboolean result;
#line 202 "../src/cli.vala"
	g_return_val_if_fail (puzzle != NULL, FALSE);
#line 202 "../src/cli.vala"
	g_return_val_if_fail (warning_string != NULL, FALSE);
#line 204 "../src/cli.vala"
	if (new_puzzle) {
#line 204 "../src/cli.vala"
		_tmp0_ = TRUE;
#line 1627 "cli.c"
	} else {
		gboolean _tmp1_;
		gboolean _tmp2_;
#line 204 "../src/cli.vala"
		_tmp1_ = puzzle_get_is_solved (puzzle);
#line 204 "../src/cli.vala"
		_tmp2_ = _tmp1_;
#line 204 "../src/cli.vala"
		_tmp0_ = _tmp2_;
#line 1637 "cli.c"
	}
#line 204 "../src/cli.vala"
	if (_tmp0_) {
#line 206 "../src/cli.vala"
		cli_puzzle_is_solved_message (FALSE);
#line 207 "../src/cli.vala"
		result = FALSE;
#line 207 "../src/cli.vala"
		return result;
#line 1647 "cli.c"
	}
#line 210 "../src/cli.vala"
	switch (direction) {
#line 210 "../src/cli.vala"
		case DIRECTION_UP:
#line 1653 "cli.c"
		{
#line 212 "../src/cli.vala"
			success = puzzle_move_up (puzzle, left_board);
#line 212 "../src/cli.vala"
			break;
#line 1659 "cli.c"
		}
#line 210 "../src/cli.vala"
		case DIRECTION_DOWN:
#line 1663 "cli.c"
		{
#line 213 "../src/cli.vala"
			success = puzzle_move_down (puzzle, left_board);
#line 213 "../src/cli.vala"
			break;
#line 1669 "cli.c"
		}
#line 210 "../src/cli.vala"
		case DIRECTION_LEFT:
#line 1673 "cli.c"
		{
#line 214 "../src/cli.vala"
			success = puzzle_move_left (puzzle, left_board);
#line 214 "../src/cli.vala"
			break;
#line 1679 "cli.c"
		}
#line 210 "../src/cli.vala"
		case DIRECTION_RIGHT:
#line 1683 "cli.c"
		{
#line 215 "../src/cli.vala"
			success = puzzle_move_right (puzzle, left_board);
#line 215 "../src/cli.vala"
			break;
#line 1689 "cli.c"
		}
		default:
		{
#line 216 "../src/cli.vala"
			g_assert_not_reached ();
#line 1695 "cli.c"
		}
	}
#line 218 "../src/cli.vala"
	if (!success) {
#line 1700 "cli.c"
		const gchar* _tmp3_;
		gchar* _tmp4_;
		gchar* _tmp5_;
#line 220 "../src/cli.vala"
		_tmp3_ = string_to_string (warning_string);
#line 220 "../src/cli.vala"
		_tmp4_ = g_strconcat (_tmp3_, "\n", NULL);
#line 220 "../src/cli.vala"
		_tmp5_ = _tmp4_;
#line 220 "../src/cli.vala"
		g_warning ("cli.vala:220: %s", _tmp5_);
#line 220 "../src/cli.vala"
		_g_free0 (_tmp5_);
#line 221 "../src/cli.vala"
		result = FALSE;
#line 221 "../src/cli.vala"
		return result;
#line 1718 "cli.c"
	}
#line 223 "../src/cli.vala"
	result = TRUE;
#line 223 "../src/cli.vala"
	return result;
#line 1724 "cli.c"
}

void
cli_puzzle_is_solved_message (gboolean alternative_message)
{
#line 228 "../src/cli.vala"
	if (alternative_message) {
#line 1732 "cli.c"
		gchar* _tmp0_;
		gchar* _tmp1_;
#line 230 "../src/cli.vala"
		_tmp0_ = g_strconcat (_ ("Puzzle is already solved! If you want to start a new one, use “new”."), "\n", NULL);
#line 230 "../src/cli.vala"
		_tmp1_ = _tmp0_;
#line 230 "../src/cli.vala"
		g_warning ("cli.vala:230: %s", _tmp1_);
#line 230 "../src/cli.vala"
		_g_free0 (_tmp1_);
#line 1743 "cli.c"
	} else {
		gchar* _tmp2_;
		gchar* _tmp3_;
#line 233 "../src/cli.vala"
		_tmp2_ = g_strconcat (_ ("Puzzle is solved! If you want to start a new one, use “new”."), "\n", NULL);
#line 233 "../src/cli.vala"
		_tmp3_ = _tmp2_;
#line 233 "../src/cli.vala"
		g_warning ("cli.vala:233: %s", _tmp3_);
#line 233 "../src/cli.vala"
		_g_free0 (_tmp3_);
#line 1755 "cli.c"
	}
}

void
cli_print_board (Puzzle* puzzle,
                 guint8 size)
{
	FILE* _tmp0_;
	FILE* _tmp45_;
	gboolean _tmp46_;
	gboolean _tmp47_;
#line 236 "../src/cli.vala"
	g_return_if_fail (puzzle != NULL);
#line 238 "../src/cli.vala"
	_tmp0_ = stdout;
#line 238 "../src/cli.vala"
	fprintf (_tmp0_, "\n");
#line 1773 "cli.c"
	{
		guint8 y = 0U;
#line 239 "../src/cli.vala"
		y = (guint8) 0;
#line 1778 "cli.c"
		{
			gboolean _tmp1_ = FALSE;
#line 239 "../src/cli.vala"
			_tmp1_ = TRUE;
#line 239 "../src/cli.vala"
			while (TRUE) {
#line 1785 "cli.c"
				FILE* _tmp15_;
				FILE* _tmp31_;
				FILE* _tmp44_;
#line 239 "../src/cli.vala"
				if (!_tmp1_) {
#line 1791 "cli.c"
					guint8 _tmp2_;
#line 239 "../src/cli.vala"
					_tmp2_ = y;
#line 239 "../src/cli.vala"
					y = _tmp2_ + 1;
#line 1797 "cli.c"
				}
#line 239 "../src/cli.vala"
				_tmp1_ = FALSE;
#line 239 "../src/cli.vala"
				if (!(y < size)) {
#line 239 "../src/cli.vala"
					break;
#line 1805 "cli.c"
				}
				{
					guint8 x = 0U;
#line 241 "../src/cli.vala"
					x = (guint8) 0;
#line 1811 "cli.c"
					{
						gboolean _tmp3_ = FALSE;
#line 241 "../src/cli.vala"
						_tmp3_ = TRUE;
#line 241 "../src/cli.vala"
						while (TRUE) {
#line 1818 "cli.c"
							Tile* tile = NULL;
							Tile* _tmp5_;
							Tile* _tmp6_;
#line 241 "../src/cli.vala"
							if (!_tmp3_) {
#line 1824 "cli.c"
								guint8 _tmp4_;
#line 241 "../src/cli.vala"
								_tmp4_ = x;
#line 241 "../src/cli.vala"
								x = _tmp4_ + 1;
#line 1830 "cli.c"
							}
#line 241 "../src/cli.vala"
							_tmp3_ = FALSE;
#line 241 "../src/cli.vala"
							if (!(((gint) x) < (2 * size))) {
#line 241 "../src/cli.vala"
								break;
#line 1838 "cli.c"
							}
#line 243 "../src/cli.vala"
							_tmp5_ = puzzle_get_tile (puzzle, x, y);
#line 243 "../src/cli.vala"
							tile = _tmp5_;
#line 244 "../src/cli.vala"
							_tmp6_ = tile;
#line 244 "../src/cli.vala"
							if (_tmp6_ == NULL) {
#line 1848 "cli.c"
								FILE* _tmp7_;
#line 245 "../src/cli.vala"
								_tmp7_ = stdout;
#line 245 "../src/cli.vala"
								fprintf (_tmp7_, " ╭╴ ╶╮");
#line 1854 "cli.c"
							} else {
								FILE* _tmp8_;
								Tile* _tmp9_;
								gchar* _tmp10_;
								gchar* _tmp11_;
								gchar* _tmp12_;
								gchar* _tmp13_;
#line 247 "../src/cli.vala"
								_tmp8_ = stdout;
#line 247 "../src/cli.vala"
								_tmp9_ = tile;
#line 247 "../src/cli.vala"
								_tmp10_ = g_strdup_printf ("%hhu", G_TYPE_CHECK_INSTANCE_CAST (_tmp9_, TYPE_TILE, Tile)->north);
#line 247 "../src/cli.vala"
								_tmp11_ = _tmp10_;
#line 247 "../src/cli.vala"
								_tmp12_ = g_strconcat (" ┌╴", _tmp11_, "╶┐", NULL);
#line 247 "../src/cli.vala"
								_tmp13_ = _tmp12_;
#line 247 "../src/cli.vala"
								fprintf (_tmp8_, "%s", _tmp13_);
#line 247 "../src/cli.vala"
								_g_free0 (_tmp13_);
#line 247 "../src/cli.vala"
								_g_free0 (_tmp11_);
#line 1880 "cli.c"
							}
#line 248 "../src/cli.vala"
							if (((gint) x) == (size - 1)) {
#line 1884 "cli.c"
								FILE* _tmp14_;
#line 249 "../src/cli.vala"
								_tmp14_ = stdout;
#line 249 "../src/cli.vala"
								fprintf (_tmp14_, "  ");
#line 1890 "cli.c"
							}
#line 241 "../src/cli.vala"
							_g_object_unref0 (tile);
#line 1894 "cli.c"
						}
					}
				}
#line 251 "../src/cli.vala"
				_tmp15_ = stdout;
#line 251 "../src/cli.vala"
				fprintf (_tmp15_, "\n");
#line 1902 "cli.c"
				{
					guint8 x = 0U;
#line 252 "../src/cli.vala"
					x = (guint8) 0;
#line 1907 "cli.c"
					{
						gboolean _tmp16_ = FALSE;
#line 252 "../src/cli.vala"
						_tmp16_ = TRUE;
#line 252 "../src/cli.vala"
						while (TRUE) {
#line 1914 "cli.c"
							Tile* tile = NULL;
							Tile* _tmp18_;
							Tile* _tmp19_;
#line 252 "../src/cli.vala"
							if (!_tmp16_) {
#line 1920 "cli.c"
								guint8 _tmp17_;
#line 252 "../src/cli.vala"
								_tmp17_ = x;
#line 252 "../src/cli.vala"
								x = _tmp17_ + 1;
#line 1926 "cli.c"
							}
#line 252 "../src/cli.vala"
							_tmp16_ = FALSE;
#line 252 "../src/cli.vala"
							if (!(((gint) x) < (2 * size))) {
#line 252 "../src/cli.vala"
								break;
#line 1934 "cli.c"
							}
#line 254 "../src/cli.vala"
							_tmp18_ = puzzle_get_tile (puzzle, x, y);
#line 254 "../src/cli.vala"
							tile = _tmp18_;
#line 255 "../src/cli.vala"
							_tmp19_ = tile;
#line 255 "../src/cli.vala"
							if (_tmp19_ == NULL) {
#line 1944 "cli.c"
								FILE* _tmp20_;
#line 256 "../src/cli.vala"
								_tmp20_ = stdout;
#line 256 "../src/cli.vala"
								fprintf (_tmp20_, "      ");
#line 1950 "cli.c"
							} else {
								FILE* _tmp21_;
								Tile* _tmp22_;
								gchar* _tmp23_;
								gchar* _tmp24_;
								Tile* _tmp25_;
								gchar* _tmp26_;
								gchar* _tmp27_;
								gchar* _tmp28_;
								gchar* _tmp29_;
#line 258 "../src/cli.vala"
								_tmp21_ = stdout;
#line 258 "../src/cli.vala"
								_tmp22_ = tile;
#line 258 "../src/cli.vala"
								_tmp23_ = g_strdup_printf ("%hhu", G_TYPE_CHECK_INSTANCE_CAST (_tmp22_, TYPE_TILE, Tile)->west);
#line 258 "../src/cli.vala"
								_tmp24_ = _tmp23_;
#line 258 "../src/cli.vala"
								_tmp25_ = tile;
#line 258 "../src/cli.vala"
								_tmp26_ = g_strdup_printf ("%hhu", G_TYPE_CHECK_INSTANCE_CAST (_tmp25_, TYPE_TILE, Tile)->east);
#line 258 "../src/cli.vala"
								_tmp27_ = _tmp26_;
#line 258 "../src/cli.vala"
								_tmp28_ = g_strconcat (" ", _tmp24_, " · ", _tmp27_, NULL);
#line 258 "../src/cli.vala"
								_tmp29_ = _tmp28_;
#line 258 "../src/cli.vala"
								fprintf (_tmp21_, "%s", _tmp29_);
#line 258 "../src/cli.vala"
								_g_free0 (_tmp29_);
#line 258 "../src/cli.vala"
								_g_free0 (_tmp27_);
#line 258 "../src/cli.vala"
								_g_free0 (_tmp24_);
#line 1987 "cli.c"
							}
#line 259 "../src/cli.vala"
							if (((gint) x) == (size - 1)) {
#line 1991 "cli.c"
								FILE* _tmp30_;
#line 260 "../src/cli.vala"
								_tmp30_ = stdout;
#line 260 "../src/cli.vala"
								fprintf (_tmp30_, "  ");
#line 1997 "cli.c"
							}
#line 252 "../src/cli.vala"
							_g_object_unref0 (tile);
#line 2001 "cli.c"
						}
					}
				}
#line 262 "../src/cli.vala"
				_tmp31_ = stdout;
#line 262 "../src/cli.vala"
				fprintf (_tmp31_, "\n");
#line 2009 "cli.c"
				{
					guint8 x = 0U;
#line 263 "../src/cli.vala"
					x = (guint8) 0;
#line 2014 "cli.c"
					{
						gboolean _tmp32_ = FALSE;
#line 263 "../src/cli.vala"
						_tmp32_ = TRUE;
#line 263 "../src/cli.vala"
						while (TRUE) {
#line 2021 "cli.c"
							Tile* tile = NULL;
							Tile* _tmp34_;
							Tile* _tmp35_;
#line 263 "../src/cli.vala"
							if (!_tmp32_) {
#line 2027 "cli.c"
								guint8 _tmp33_;
#line 263 "../src/cli.vala"
								_tmp33_ = x;
#line 263 "../src/cli.vala"
								x = _tmp33_ + 1;
#line 2033 "cli.c"
							}
#line 263 "../src/cli.vala"
							_tmp32_ = FALSE;
#line 263 "../src/cli.vala"
							if (!(((gint) x) < (2 * size))) {
#line 263 "../src/cli.vala"
								break;
#line 2041 "cli.c"
							}
#line 265 "../src/cli.vala"
							_tmp34_ = puzzle_get_tile (puzzle, x, y);
#line 265 "../src/cli.vala"
							tile = _tmp34_;
#line 266 "../src/cli.vala"
							_tmp35_ = tile;
#line 266 "../src/cli.vala"
							if (_tmp35_ == NULL) {
#line 2051 "cli.c"
								FILE* _tmp36_;
#line 267 "../src/cli.vala"
								_tmp36_ = stdout;
#line 267 "../src/cli.vala"
								fprintf (_tmp36_, " ╰╴ ╶╯");
#line 2057 "cli.c"
							} else {
								FILE* _tmp37_;
								Tile* _tmp38_;
								gchar* _tmp39_;
								gchar* _tmp40_;
								gchar* _tmp41_;
								gchar* _tmp42_;
#line 269 "../src/cli.vala"
								_tmp37_ = stdout;
#line 269 "../src/cli.vala"
								_tmp38_ = tile;
#line 269 "../src/cli.vala"
								_tmp39_ = g_strdup_printf ("%hhu", G_TYPE_CHECK_INSTANCE_CAST (_tmp38_, TYPE_TILE, Tile)->south);
#line 269 "../src/cli.vala"
								_tmp40_ = _tmp39_;
#line 269 "../src/cli.vala"
								_tmp41_ = g_strconcat (" └╴", _tmp40_, "╶┘", NULL);
#line 269 "../src/cli.vala"
								_tmp42_ = _tmp41_;
#line 269 "../src/cli.vala"
								fprintf (_tmp37_, "%s", _tmp42_);
#line 269 "../src/cli.vala"
								_g_free0 (_tmp42_);
#line 269 "../src/cli.vala"
								_g_free0 (_tmp40_);
#line 2083 "cli.c"
							}
#line 270 "../src/cli.vala"
							if (((gint) x) == (size - 1)) {
#line 2087 "cli.c"
								FILE* _tmp43_;
#line 271 "../src/cli.vala"
								_tmp43_ = stdout;
#line 271 "../src/cli.vala"
								fprintf (_tmp43_, "  ");
#line 2093 "cli.c"
							}
#line 263 "../src/cli.vala"
							_g_object_unref0 (tile);
#line 2097 "cli.c"
						}
					}
				}
#line 273 "../src/cli.vala"
				_tmp44_ = stdout;
#line 273 "../src/cli.vala"
				fprintf (_tmp44_, "\n");
#line 2105 "cli.c"
			}
		}
	}
#line 275 "../src/cli.vala"
	_tmp45_ = stdout;
#line 275 "../src/cli.vala"
	fprintf (_tmp45_, "\n");
#line 276 "../src/cli.vala"
	_tmp46_ = puzzle_get_is_solved (puzzle);
#line 276 "../src/cli.vala"
	_tmp47_ = _tmp46_;
#line 276 "../src/cli.vala"
	if (_tmp47_) {
#line 2119 "cli.c"
		FILE* _tmp48_;
		gchar* _tmp49_;
		gchar* _tmp50_;
#line 278 "../src/cli.vala"
		_tmp48_ = stdout;
#line 278 "../src/cli.vala"
		_tmp49_ = g_strconcat (_ ("Puzzle is solved!"), "\n\n", NULL);
#line 278 "../src/cli.vala"
		_tmp50_ = _tmp49_;
#line 278 "../src/cli.vala"
		fprintf (_tmp48_, "%s", _tmp50_);
#line 278 "../src/cli.vala"
		_g_free0 (_tmp50_);
#line 2133 "cli.c"
	}
}

static gchar
string_get (const gchar* self,
            glong index)
{
	gchar _tmp0_;
	gchar result;
#line 1240 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, '\0');
#line 1241 "glib-2.0.vapi"
	_tmp0_ = ((gchar*) self)[index];
#line 1241 "glib-2.0.vapi"
	result = _tmp0_;
#line 1241 "glib-2.0.vapi"
	return result;
#line 2151 "cli.c"
}

static gboolean
uint64_try_parse (const gchar* str,
                  guint64* _result_,
                  const gchar** unparsed,
                  guint _base)
{
	guint64 _vala__result_ = 0ULL;
	const gchar* _vala_unparsed = NULL;
	gchar* endptr = NULL;
	gchar* _tmp0_ = NULL;
	guint64 _tmp1_;
	gchar* _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
	gboolean result;
#line 843 "glib-2.0.vapi"
	g_return_val_if_fail (str != NULL, FALSE);
#line 845 "glib-2.0.vapi"
	errno = 0;
#line 846 "glib-2.0.vapi"
	_tmp1_ = g_ascii_strtoull (str, &_tmp0_, _base);
#line 846 "glib-2.0.vapi"
	endptr = _tmp0_;
#line 846 "glib-2.0.vapi"
	_vala__result_ = _tmp1_;
#line 847 "glib-2.0.vapi"
	_tmp2_ = endptr;
#line 847 "glib-2.0.vapi"
	_tmp3_ = strlen (str);
#line 847 "glib-2.0.vapi"
	_tmp4_ = _tmp3_;
#line 847 "glib-2.0.vapi"
	if (_tmp2_ == (((gchar*) str) + _tmp4_)) {
#line 2187 "cli.c"
		gboolean _tmp5_ = FALSE;
#line 848 "glib-2.0.vapi"
		_vala_unparsed = "";
#line 849 "glib-2.0.vapi"
		if (errno != ERANGE) {
#line 849 "glib-2.0.vapi"
			_tmp5_ = errno != EINVAL;
#line 2195 "cli.c"
		} else {
#line 849 "glib-2.0.vapi"
			_tmp5_ = FALSE;
#line 2199 "cli.c"
		}
#line 849 "glib-2.0.vapi"
		result = _tmp5_;
#line 849 "glib-2.0.vapi"
		if (_result_) {
#line 849 "glib-2.0.vapi"
			*_result_ = _vala__result_;
#line 2207 "cli.c"
		}
#line 849 "glib-2.0.vapi"
		if (unparsed) {
#line 849 "glib-2.0.vapi"
			*unparsed = _vala_unparsed;
#line 2213 "cli.c"
		}
#line 849 "glib-2.0.vapi"
		return result;
#line 2217 "cli.c"
	} else {
		gchar* _tmp6_;
#line 851 "glib-2.0.vapi"
		_tmp6_ = endptr;
#line 851 "glib-2.0.vapi"
		_vala_unparsed = (const gchar*) _tmp6_;
#line 852 "glib-2.0.vapi"
		result = FALSE;
#line 852 "glib-2.0.vapi"
		if (_result_) {
#line 852 "glib-2.0.vapi"
			*_result_ = _vala__result_;
#line 2230 "cli.c"
		}
#line 852 "glib-2.0.vapi"
		if (unparsed) {
#line 852 "glib-2.0.vapi"
			*unparsed = _vala_unparsed;
#line 2236 "cli.c"
		}
#line 852 "glib-2.0.vapi"
		return result;
#line 2240 "cli.c"
	}
}

gboolean
cli_parse_cli (const gchar* cli,
               guint8 size,
               guint8* tile_1_x,
               guint8* tile_1_y,
               guint8* tile_2_x,
               guint8* tile_2_y)
{
	guint8 _vala_tile_1_x = 0U;
	guint8 _vala_tile_1_y = 0U;
	guint8 _vala_tile_2_x = 0U;
	guint8 _vala_tile_2_y = 0U;
	gint _tmp0_;
	gint _tmp1_;
	gchar column_char = '\0';
	guint8 _tmp2_ = 0U;
	gboolean _tmp3_;
	guint8 _tmp4_ = 0U;
	gboolean _tmp5_;
	guint64 test = 0ULL;
	gchar* _tmp6_;
	gchar* _tmp7_;
	guint64 _tmp8_ = 0ULL;
	gboolean _tmp9_;
	gboolean _tmp10_;
	gboolean _tmp11_ = FALSE;
	gchar* _tmp12_;
	gchar* _tmp13_;
	guint64 _tmp14_ = 0ULL;
	gboolean _tmp15_;
	gboolean _tmp16_;
	gboolean _tmp17_ = FALSE;
	gboolean result;
#line 281 "../src/cli.vala"
	g_return_val_if_fail (cli != NULL, FALSE);
#line 285 "../src/cli.vala"
	_vala_tile_1_x = G_MAXUINT8;
#line 286 "../src/cli.vala"
	_vala_tile_1_y = G_MAXUINT8;
#line 287 "../src/cli.vala"
	_vala_tile_2_x = G_MAXUINT8;
#line 288 "../src/cli.vala"
	_vala_tile_2_y = G_MAXUINT8;
#line 290 "../src/cli.vala"
	_tmp0_ = strlen (cli);
#line 290 "../src/cli.vala"
	_tmp1_ = _tmp0_;
#line 290 "../src/cli.vala"
	if (_tmp1_ != 4) {
#line 291 "../src/cli.vala"
		result = FALSE;
#line 291 "../src/cli.vala"
		if (tile_1_x) {
#line 291 "../src/cli.vala"
			*tile_1_x = _vala_tile_1_x;
#line 2299 "cli.c"
		}
#line 291 "../src/cli.vala"
		if (tile_1_y) {
#line 291 "../src/cli.vala"
			*tile_1_y = _vala_tile_1_y;
#line 2305 "cli.c"
		}
#line 291 "../src/cli.vala"
		if (tile_2_x) {
#line 291 "../src/cli.vala"
			*tile_2_x = _vala_tile_2_x;
#line 2311 "cli.c"
		}
#line 291 "../src/cli.vala"
		if (tile_2_y) {
#line 291 "../src/cli.vala"
			*tile_2_y = _vala_tile_2_y;
#line 2317 "cli.c"
		}
#line 291 "../src/cli.vala"
		return result;
#line 2321 "cli.c"
	}
#line 293 "../src/cli.vala"
	column_char = string_get (cli, (glong) 0);
#line 294 "../src/cli.vala"
	_tmp3_ = cli_is_valid_column (column_char, size, &_tmp2_);
#line 294 "../src/cli.vala"
	_vala_tile_1_x = _tmp2_;
#line 294 "../src/cli.vala"
	if (!_tmp3_) {
#line 295 "../src/cli.vala"
		result = FALSE;
#line 295 "../src/cli.vala"
		if (tile_1_x) {
#line 295 "../src/cli.vala"
			*tile_1_x = _vala_tile_1_x;
#line 2337 "cli.c"
		}
#line 295 "../src/cli.vala"
		if (tile_1_y) {
#line 295 "../src/cli.vala"
			*tile_1_y = _vala_tile_1_y;
#line 2343 "cli.c"
		}
#line 295 "../src/cli.vala"
		if (tile_2_x) {
#line 295 "../src/cli.vala"
			*tile_2_x = _vala_tile_2_x;
#line 2349 "cli.c"
		}
#line 295 "../src/cli.vala"
		if (tile_2_y) {
#line 295 "../src/cli.vala"
			*tile_2_y = _vala_tile_2_y;
#line 2355 "cli.c"
		}
#line 295 "../src/cli.vala"
		return result;
#line 2359 "cli.c"
	}
#line 297 "../src/cli.vala"
	column_char = string_get (cli, (glong) 2);
#line 298 "../src/cli.vala"
	_tmp5_ = cli_is_valid_column (column_char, size, &_tmp4_);
#line 298 "../src/cli.vala"
	_vala_tile_2_x = _tmp4_;
#line 298 "../src/cli.vala"
	if (!_tmp5_) {
#line 299 "../src/cli.vala"
		result = FALSE;
#line 299 "../src/cli.vala"
		if (tile_1_x) {
#line 299 "../src/cli.vala"
			*tile_1_x = _vala_tile_1_x;
#line 2375 "cli.c"
		}
#line 299 "../src/cli.vala"
		if (tile_1_y) {
#line 299 "../src/cli.vala"
			*tile_1_y = _vala_tile_1_y;
#line 2381 "cli.c"
		}
#line 299 "../src/cli.vala"
		if (tile_2_x) {
#line 299 "../src/cli.vala"
			*tile_2_x = _vala_tile_2_x;
#line 2387 "cli.c"
		}
#line 299 "../src/cli.vala"
		if (tile_2_y) {
#line 299 "../src/cli.vala"
			*tile_2_y = _vala_tile_2_y;
#line 2393 "cli.c"
		}
#line 299 "../src/cli.vala"
		return result;
#line 2397 "cli.c"
	}
#line 302 "../src/cli.vala"
	_tmp6_ = g_strdup_printf ("%c", string_get (cli, (glong) 1));
#line 302 "../src/cli.vala"
	_tmp7_ = _tmp6_;
#line 302 "../src/cli.vala"
	_tmp9_ = uint64_try_parse (_tmp7_, &_tmp8_, NULL, (guint) 0);
#line 302 "../src/cli.vala"
	test = _tmp8_;
#line 302 "../src/cli.vala"
	_tmp10_ = !_tmp9_;
#line 302 "../src/cli.vala"
	_g_free0 (_tmp7_);
#line 302 "../src/cli.vala"
	if (_tmp10_) {
#line 303 "../src/cli.vala"
		result = FALSE;
#line 303 "../src/cli.vala"
		if (tile_1_x) {
#line 303 "../src/cli.vala"
			*tile_1_x = _vala_tile_1_x;
#line 2419 "cli.c"
		}
#line 303 "../src/cli.vala"
		if (tile_1_y) {
#line 303 "../src/cli.vala"
			*tile_1_y = _vala_tile_1_y;
#line 2425 "cli.c"
		}
#line 303 "../src/cli.vala"
		if (tile_2_x) {
#line 303 "../src/cli.vala"
			*tile_2_x = _vala_tile_2_x;
#line 2431 "cli.c"
		}
#line 303 "../src/cli.vala"
		if (tile_2_y) {
#line 303 "../src/cli.vala"
			*tile_2_y = _vala_tile_2_y;
#line 2437 "cli.c"
		}
#line 303 "../src/cli.vala"
		return result;
#line 2441 "cli.c"
	}
#line 304 "../src/cli.vala"
	if (test <= ((guint64) 0)) {
#line 304 "../src/cli.vala"
		_tmp11_ = TRUE;
#line 2447 "cli.c"
	} else {
#line 304 "../src/cli.vala"
		_tmp11_ = test > ((guint64) size);
#line 2451 "cli.c"
	}
#line 304 "../src/cli.vala"
	if (_tmp11_) {
#line 305 "../src/cli.vala"
		result = FALSE;
#line 305 "../src/cli.vala"
		if (tile_1_x) {
#line 305 "../src/cli.vala"
			*tile_1_x = _vala_tile_1_x;
#line 2461 "cli.c"
		}
#line 305 "../src/cli.vala"
		if (tile_1_y) {
#line 305 "../src/cli.vala"
			*tile_1_y = _vala_tile_1_y;
#line 2467 "cli.c"
		}
#line 305 "../src/cli.vala"
		if (tile_2_x) {
#line 305 "../src/cli.vala"
			*tile_2_x = _vala_tile_2_x;
#line 2473 "cli.c"
		}
#line 305 "../src/cli.vala"
		if (tile_2_y) {
#line 305 "../src/cli.vala"
			*tile_2_y = _vala_tile_2_y;
#line 2479 "cli.c"
		}
#line 305 "../src/cli.vala"
		return result;
#line 2483 "cli.c"
	}
#line 306 "../src/cli.vala"
	_vala_tile_1_y = (guint8) (((guint8) test) - 1);
#line 308 "../src/cli.vala"
	_tmp12_ = g_strdup_printf ("%c", string_get (cli, (glong) 3));
#line 308 "../src/cli.vala"
	_tmp13_ = _tmp12_;
#line 308 "../src/cli.vala"
	_tmp15_ = uint64_try_parse (_tmp13_, &_tmp14_, NULL, (guint) 0);
#line 308 "../src/cli.vala"
	test = _tmp14_;
#line 308 "../src/cli.vala"
	_tmp16_ = !_tmp15_;
#line 308 "../src/cli.vala"
	_g_free0 (_tmp13_);
#line 308 "../src/cli.vala"
	if (_tmp16_) {
#line 309 "../src/cli.vala"
		result = FALSE;
#line 309 "../src/cli.vala"
		if (tile_1_x) {
#line 309 "../src/cli.vala"
			*tile_1_x = _vala_tile_1_x;
#line 2507 "cli.c"
		}
#line 309 "../src/cli.vala"
		if (tile_1_y) {
#line 309 "../src/cli.vala"
			*tile_1_y = _vala_tile_1_y;
#line 2513 "cli.c"
		}
#line 309 "../src/cli.vala"
		if (tile_2_x) {
#line 309 "../src/cli.vala"
			*tile_2_x = _vala_tile_2_x;
#line 2519 "cli.c"
		}
#line 309 "../src/cli.vala"
		if (tile_2_y) {
#line 309 "../src/cli.vala"
			*tile_2_y = _vala_tile_2_y;
#line 2525 "cli.c"
		}
#line 309 "../src/cli.vala"
		return result;
#line 2529 "cli.c"
	}
#line 310 "../src/cli.vala"
	if (test <= ((guint64) 0)) {
#line 310 "../src/cli.vala"
		_tmp17_ = TRUE;
#line 2535 "cli.c"
	} else {
#line 310 "../src/cli.vala"
		_tmp17_ = test > ((guint64) size);
#line 2539 "cli.c"
	}
#line 310 "../src/cli.vala"
	if (_tmp17_) {
#line 311 "../src/cli.vala"
		result = FALSE;
#line 311 "../src/cli.vala"
		if (tile_1_x) {
#line 311 "../src/cli.vala"
			*tile_1_x = _vala_tile_1_x;
#line 2549 "cli.c"
		}
#line 311 "../src/cli.vala"
		if (tile_1_y) {
#line 311 "../src/cli.vala"
			*tile_1_y = _vala_tile_1_y;
#line 2555 "cli.c"
		}
#line 311 "../src/cli.vala"
		if (tile_2_x) {
#line 311 "../src/cli.vala"
			*tile_2_x = _vala_tile_2_x;
#line 2561 "cli.c"
		}
#line 311 "../src/cli.vala"
		if (tile_2_y) {
#line 311 "../src/cli.vala"
			*tile_2_y = _vala_tile_2_y;
#line 2567 "cli.c"
		}
#line 311 "../src/cli.vala"
		return result;
#line 2571 "cli.c"
	}
#line 312 "../src/cli.vala"
	_vala_tile_2_y = (guint8) (((guint8) test) - 1);
#line 314 "../src/cli.vala"
	result = TRUE;
#line 314 "../src/cli.vala"
	if (tile_1_x) {
#line 314 "../src/cli.vala"
		*tile_1_x = _vala_tile_1_x;
#line 2581 "cli.c"
	}
#line 314 "../src/cli.vala"
	if (tile_1_y) {
#line 314 "../src/cli.vala"
		*tile_1_y = _vala_tile_1_y;
#line 2587 "cli.c"
	}
#line 314 "../src/cli.vala"
	if (tile_2_x) {
#line 314 "../src/cli.vala"
		*tile_2_x = _vala_tile_2_x;
#line 2593 "cli.c"
	}
#line 314 "../src/cli.vala"
	if (tile_2_y) {
#line 314 "../src/cli.vala"
		*tile_2_y = _vala_tile_2_y;
#line 2599 "cli.c"
	}
#line 314 "../src/cli.vala"
	return result;
#line 2603 "cli.c"
}

gboolean
cli_is_valid_column (gchar column_char,
                     guint8 size,
                     guint8* column)
{
	guint8 _vala_column = 0U;
	gboolean result;
#line 319 "../src/cli.vala"
	switch (column_char) {
#line 319 "../src/cli.vala"
		case 'a':
#line 2617 "cli.c"
		{
#line 321 "../src/cli.vala"
			_vala_column = (guint8) 0;
#line 321 "../src/cli.vala"
			result = TRUE;
#line 321 "../src/cli.vala"
			if (column) {
#line 321 "../src/cli.vala"
				*column = _vala_column;
#line 2627 "cli.c"
			}
#line 321 "../src/cli.vala"
			return result;
#line 2631 "cli.c"
		}
#line 319 "../src/cli.vala"
		case 'b':
#line 2635 "cli.c"
		{
#line 322 "../src/cli.vala"
			_vala_column = (guint8) 1;
#line 322 "../src/cli.vala"
			result = TRUE;
#line 322 "../src/cli.vala"
			if (column) {
#line 322 "../src/cli.vala"
				*column = _vala_column;
#line 2645 "cli.c"
			}
#line 322 "../src/cli.vala"
			return result;
#line 2649 "cli.c"
		}
#line 319 "../src/cli.vala"
		case 'c':
#line 2653 "cli.c"
		{
#line 323 "../src/cli.vala"
			_vala_column = (guint8) 2;
#line 323 "../src/cli.vala"
			result = ((gint) size) >= 3;
#line 323 "../src/cli.vala"
			if (column) {
#line 323 "../src/cli.vala"
				*column = _vala_column;
#line 2663 "cli.c"
			}
#line 323 "../src/cli.vala"
			return result;
#line 2667 "cli.c"
		}
#line 319 "../src/cli.vala"
		case 'd':
#line 2671 "cli.c"
		{
#line 324 "../src/cli.vala"
			_vala_column = (guint8) 3;
#line 324 "../src/cli.vala"
			result = ((gint) size) >= 4;
#line 324 "../src/cli.vala"
			if (column) {
#line 324 "../src/cli.vala"
				*column = _vala_column;
#line 2681 "cli.c"
			}
#line 324 "../src/cli.vala"
			return result;
#line 2685 "cli.c"
		}
#line 319 "../src/cli.vala"
		case 'e':
#line 2689 "cli.c"
		{
#line 325 "../src/cli.vala"
			_vala_column = (guint8) 4;
#line 325 "../src/cli.vala"
			result = ((gint) size) >= 5;
#line 325 "../src/cli.vala"
			if (column) {
#line 325 "../src/cli.vala"
				*column = _vala_column;
#line 2699 "cli.c"
			}
#line 325 "../src/cli.vala"
			return result;
#line 2703 "cli.c"
		}
#line 319 "../src/cli.vala"
		case 'f':
#line 2707 "cli.c"
		{
#line 326 "../src/cli.vala"
			_vala_column = (guint8) 5;
#line 326 "../src/cli.vala"
			result = ((gint) size) == 6;
#line 326 "../src/cli.vala"
			if (column) {
#line 326 "../src/cli.vala"
				*column = _vala_column;
#line 2717 "cli.c"
			}
#line 326 "../src/cli.vala"
			return result;
#line 2721 "cli.c"
		}
#line 319 "../src/cli.vala"
		case 'A':
#line 2725 "cli.c"
		{
#line 327 "../src/cli.vala"
			_vala_column = size;
#line 327 "../src/cli.vala"
			result = TRUE;
#line 327 "../src/cli.vala"
			if (column) {
#line 327 "../src/cli.vala"
				*column = _vala_column;
#line 2735 "cli.c"
			}
#line 327 "../src/cli.vala"
			return result;
#line 2739 "cli.c"
		}
#line 319 "../src/cli.vala"
		case 'B':
#line 2743 "cli.c"
		{
#line 328 "../src/cli.vala"
			_vala_column = (guint8) (size + 1);
#line 328 "../src/cli.vala"
			result = TRUE;
#line 328 "../src/cli.vala"
			if (column) {
#line 328 "../src/cli.vala"
				*column = _vala_column;
#line 2753 "cli.c"
			}
#line 328 "../src/cli.vala"
			return result;
#line 2757 "cli.c"
		}
#line 319 "../src/cli.vala"
		case 'C':
#line 2761 "cli.c"
		{
#line 329 "../src/cli.vala"
			_vala_column = (guint8) (size + 2);
#line 329 "../src/cli.vala"
			result = ((gint) size) >= 3;
#line 329 "../src/cli.vala"
			if (column) {
#line 329 "../src/cli.vala"
				*column = _vala_column;
#line 2771 "cli.c"
			}
#line 329 "../src/cli.vala"
			return result;
#line 2775 "cli.c"
		}
#line 319 "../src/cli.vala"
		case 'D':
#line 2779 "cli.c"
		{
#line 330 "../src/cli.vala"
			_vala_column = (guint8) (size + 3);
#line 330 "../src/cli.vala"
			result = ((gint) size) >= 4;
#line 330 "../src/cli.vala"
			if (column) {
#line 330 "../src/cli.vala"
				*column = _vala_column;
#line 2789 "cli.c"
			}
#line 330 "../src/cli.vala"
			return result;
#line 2793 "cli.c"
		}
#line 319 "../src/cli.vala"
		case 'E':
#line 2797 "cli.c"
		{
#line 331 "../src/cli.vala"
			_vala_column = (guint8) (size + 4);
#line 331 "../src/cli.vala"
			result = ((gint) size) >= 5;
#line 331 "../src/cli.vala"
			if (column) {
#line 331 "../src/cli.vala"
				*column = _vala_column;
#line 2807 "cli.c"
			}
#line 331 "../src/cli.vala"
			return result;
#line 2811 "cli.c"
		}
#line 319 "../src/cli.vala"
		case 'F':
#line 2815 "cli.c"
		{
#line 332 "../src/cli.vala"
			_vala_column = (guint8) (size + 5);
#line 332 "../src/cli.vala"
			result = ((gint) size) == 6;
#line 332 "../src/cli.vala"
			if (column) {
#line 332 "../src/cli.vala"
				*column = _vala_column;
#line 2825 "cli.c"
			}
#line 332 "../src/cli.vala"
			return result;
#line 2829 "cli.c"
		}
		default:
		{
#line 333 "../src/cli.vala"
			_vala_column = G_MAXUINT8;
#line 333 "../src/cli.vala"
			result = FALSE;
#line 333 "../src/cli.vala"
			if (column) {
#line 333 "../src/cli.vala"
				*column = _vala_column;
#line 2841 "cli.c"
			}
#line 333 "../src/cli.vala"
			return result;
#line 2845 "cli.c"
		}
	}
}

