/* theme-nostalgia.c generated by valac 0.56.9, the Vala compiler
 * generated from theme-nostalgia.vala, do not modify */

/* -*- Mode: vala; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*-

   This file is part of GNOME Tetravex.

   Copyright (C) 2010-2013 Robert Ancell
   Copyright (C) 2019 Arnaud Bonatti

   GNOME Tetravex is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 2 of the License, or
   (at your option) any later version.

   GNOME Tetravex is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License along
   with this GNOME Tetravex.  If not, see <https://www.gnu.org/licenses/>.
*/

#include <glib-object.h>
#include <glib.h>
#include <cairo-gobject.h>
#include <float.h>
#include <math.h>
#include <stdlib.h>
#include <string.h>

#define PUZZLE_VIEW_gap_factor 0.5
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TYPE_THEME (theme_get_type ())
#define THEME(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_THEME, Theme))
#define THEME_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_THEME, ThemeClass))
#define IS_THEME(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_THEME))
#define IS_THEME_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_THEME))
#define THEME_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_THEME, ThemeClass))

typedef struct _Theme Theme;
typedef struct _ThemeClass ThemeClass;
typedef struct _ThemePrivate ThemePrivate;

#define TYPE_TILE (tile_get_type ())
#define TILE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_TILE, Tile))
#define TILE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_TILE, TileClass))
#define IS_TILE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_TILE))
#define IS_TILE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_TILE))
#define TILE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_TILE, TileClass))

typedef struct _Tile Tile;
typedef struct _TileClass TileClass;

#define TYPE_NOSTALGIA_THEME (nostalgia_theme_get_type ())
#define NOSTALGIA_THEME(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_NOSTALGIA_THEME, NostalgiaTheme))
#define NOSTALGIA_THEME_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_NOSTALGIA_THEME, NostalgiaThemeClass))
#define IS_NOSTALGIA_THEME(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_NOSTALGIA_THEME))
#define IS_NOSTALGIA_THEME_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_NOSTALGIA_THEME))
#define NOSTALGIA_THEME_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_NOSTALGIA_THEME, NostalgiaThemeClass))

typedef struct _NostalgiaTheme NostalgiaTheme;
typedef struct _NostalgiaThemeClass NostalgiaThemeClass;
typedef struct _NostalgiaThemePrivate NostalgiaThemePrivate;
enum  {
	NOSTALGIA_THEME_0_PROPERTY,
	NOSTALGIA_THEME_NUM_PROPERTIES
};
static GParamSpec* nostalgia_theme_properties[NOSTALGIA_THEME_NUM_PROPERTIES];
#define _cairo_pattern_destroy0(var) ((var == NULL) ? NULL : (var = (cairo_pattern_destroy (var), NULL)))
typedef struct _TilePrivate TilePrivate;
#define _g_free0(var) (var = (g_free (var), NULL))

struct _Theme {
	GObject parent_instance;
	ThemePrivate * priv;
};

struct _ThemeClass {
	GObjectClass parent_class;
	void (*configure) (Theme* self, guint size);
	void (*draw_arrow) (Theme* self, cairo_t* context);
	void (*draw_socket) (Theme* self, cairo_t* context);
	void (*draw_highlight) (Theme* self, cairo_t* context, gboolean has_tile);
	void (*draw_paused_tile) (Theme* self, cairo_t* context);
	void (*draw_tile) (Theme* self, cairo_t* context, Tile* tile, gboolean highlight);
	void (*set_animation_level) (Theme* self, guint8 animation_level);
};

struct _NostalgiaTheme {
	Theme parent_instance;
	NostalgiaThemePrivate * priv;
};

struct _NostalgiaThemeClass {
	ThemeClass parent_class;
};

struct _NostalgiaThemePrivate {
	cairo_pattern_t* tile_colors[10];
	cairo_pattern_t* paused_color;
	cairo_pattern_t* text_colors[10];
	cairo_pattern_t* black_text_color;
	cairo_pattern_t* white_text_color;
	guint size;
	guint8 animation_level;
	gdouble arrow_half_h;
	gdouble neg_arrow_half_h;
	gdouble arrow_depth;
	gdouble arrow_dx;
	gdouble arrow_dy;
	gdouble neg_arrow_dy;
	gdouble arrow_w;
	gdouble arrow_x;
	gdouble arrow_w_minus_depth;
	gdouble socket_depth;
	gdouble size_minus_socket_depth;
	gdouble size_minus_two_socket_depths;
	cairo_pattern_t* highlight_tile_pattern;
	gdouble tile_depth;
	gdouble size_minus_tile_depth;
	gdouble tile_dx;
	gdouble tile_dy;
	gdouble size_minus_tile_dx;
	gdouble half_tile_size;
	gdouble half_tile_size_minus_dy;
	gdouble half_tile_size_plus_dy;
	gdouble size_minus_one;
	gdouble font_size;
	gdouble north_number_y;
	gdouble south_number_y;
	gdouble east_number_x;
	gdouble west_number_x;
};

struct _Tile {
	GObject parent_instance;
	TilePrivate * priv;
	guint8 north;
	guint8 west;
	guint8 east;
	guint8 south;
};

struct _TileClass {
	GObjectClass parent_class;
};

static gint NostalgiaTheme_private_offset;
static gpointer nostalgia_theme_parent_class = NULL;

VALA_EXTERN GType theme_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Theme, g_object_unref)
VALA_EXTERN GType tile_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Tile, g_object_unref)
VALA_EXTERN GType nostalgia_theme_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (NostalgiaTheme, g_object_unref)
VALA_EXTERN void theme_configure (Theme* self,
                      guint size);
VALA_EXTERN void theme_set_animation_level (Theme* self,
                                guint8 animation_level);
VALA_EXTERN void theme_draw_arrow (Theme* self,
                       cairo_t* context);
VALA_EXTERN void theme_draw_socket (Theme* self,
                        cairo_t* context);
VALA_EXTERN void theme_draw_highlight (Theme* self,
                           cairo_t* context,
                           gboolean has_tile);
VALA_EXTERN void theme_draw_paused_tile (Theme* self,
                             cairo_t* context);
VALA_EXTERN void theme_draw_tile (Theme* self,
                      cairo_t* context,
                      Tile* tile,
                      gboolean highlight);
static cairo_pattern_t* nostalgia_theme_make_color_pattern (const gchar* color);
static gdouble nostalgia_theme_hex_value (gchar c);
static void nostalgia_theme_real_configure (Theme* base,
                                     guint new_size);
static void nostalgia_theme_configure_arrow (NostalgiaTheme* self,
                                      guint new_size);
static void nostalgia_theme_configure_socket (NostalgiaTheme* self,
                                       guint new_size);
static void nostalgia_theme_real_set_animation_level (Theme* base,
                                               guint8 new_animation_level);
static void nostalgia_theme_real_draw_arrow (Theme* base,
                                      cairo_t* context);
static void nostalgia_theme_real_draw_socket (Theme* base,
                                       cairo_t* context);
static void nostalgia_theme_real_draw_highlight (Theme* base,
                                          cairo_t* context,
                                          gboolean has_tile);
static void nostalgia_theme_real_draw_paused_tile (Theme* base,
                                            cairo_t* context);
static void nostalgia_theme_draw_tile_background (NostalgiaTheme* self,
                                           cairo_t* context,
                                           cairo_pattern_t* north_color,
                                           cairo_pattern_t* east_color,
                                           cairo_pattern_t* south_color,
                                           cairo_pattern_t* west_color);
static void nostalgia_theme_real_draw_tile (Theme* base,
                                     cairo_t* context,
                                     Tile* tile,
                                     gboolean highlight);
static void nostalgia_theme_draw_number (cairo_t* context,
                                  cairo_pattern_t* text_color,
                                  gdouble x,
                                  gdouble y,
                                  guint8 number);
VALA_EXTERN NostalgiaTheme* nostalgia_theme_new (void);
VALA_EXTERN NostalgiaTheme* nostalgia_theme_construct (GType object_type);
VALA_EXTERN Theme* theme_construct (GType object_type);
static GObject * nostalgia_theme_constructor (GType type,
                                       guint n_construct_properties,
                                       GObjectConstructParam * construct_properties);
static void nostalgia_theme_finalize (GObject * obj);
static GType nostalgia_theme_get_type_once (void);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);

static inline gpointer
nostalgia_theme_get_instance_private (NostalgiaTheme* self)
{
	return G_STRUCT_MEMBER_P (self, NostalgiaTheme_private_offset);
}

static gchar
string_get (const gchar* self,
            glong index)
{
	gchar _tmp0_;
	gchar result;
#line 1240 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, '\0');
#line 1241 "glib-2.0.vapi"
	_tmp0_ = ((gchar*) self)[index];
#line 1241 "glib-2.0.vapi"
	result = _tmp0_;
#line 1241 "glib-2.0.vapi"
	return result;
#line 255 "theme-nostalgia.c"
}

static cairo_pattern_t*
nostalgia_theme_make_color_pattern (const gchar* color)
{
	gdouble r = 0.0;
	gdouble g = 0.0;
	gdouble b = 0.0;
	cairo_pattern_t* _tmp0_;
	cairo_pattern_t* result;
#line 62 "../src/theme-nostalgia.vala"
	g_return_val_if_fail (color != NULL, NULL);
#line 64 "../src/theme-nostalgia.vala"
	r = ((nostalgia_theme_hex_value (string_get (color, (glong) 0)) * 16.0) + nostalgia_theme_hex_value (string_get (color, (glong) 1))) / 255.0;
#line 65 "../src/theme-nostalgia.vala"
	g = ((nostalgia_theme_hex_value (string_get (color, (glong) 2)) * 16.0) + nostalgia_theme_hex_value (string_get (color, (glong) 3))) / 255.0;
#line 66 "../src/theme-nostalgia.vala"
	b = ((nostalgia_theme_hex_value (string_get (color, (glong) 4)) * 16.0) + nostalgia_theme_hex_value (string_get (color, (glong) 5))) / 255.0;
#line 67 "../src/theme-nostalgia.vala"
	_tmp0_ = cairo_pattern_create_rgb (r, g, b);
#line 67 "../src/theme-nostalgia.vala"
	result = _tmp0_;
#line 67 "../src/theme-nostalgia.vala"
	return result;
#line 280 "theme-nostalgia.c"
}

static gdouble
nostalgia_theme_hex_value (gchar c)
{
	gboolean _tmp0_ = FALSE;
	gdouble result;
#line 72 "../src/theme-nostalgia.vala"
	if (c >= '0') {
#line 72 "../src/theme-nostalgia.vala"
		_tmp0_ = c <= '9';
#line 292 "theme-nostalgia.c"
	} else {
#line 72 "../src/theme-nostalgia.vala"
		_tmp0_ = FALSE;
#line 296 "theme-nostalgia.c"
	}
#line 72 "../src/theme-nostalgia.vala"
	if (_tmp0_) {
#line 73 "../src/theme-nostalgia.vala"
		result = (gdouble) (c - '0');
#line 73 "../src/theme-nostalgia.vala"
		return result;
#line 304 "theme-nostalgia.c"
	} else {
		gboolean _tmp1_ = FALSE;
#line 74 "../src/theme-nostalgia.vala"
		if (c >= 'a') {
#line 74 "../src/theme-nostalgia.vala"
			_tmp1_ = c <= 'f';
#line 311 "theme-nostalgia.c"
		} else {
#line 74 "../src/theme-nostalgia.vala"
			_tmp1_ = FALSE;
#line 315 "theme-nostalgia.c"
		}
#line 74 "../src/theme-nostalgia.vala"
		if (_tmp1_) {
#line 75 "../src/theme-nostalgia.vala"
			result = (gdouble) ((c - 'a') + 10);
#line 75 "../src/theme-nostalgia.vala"
			return result;
#line 323 "theme-nostalgia.c"
		} else {
			gboolean _tmp2_ = FALSE;
#line 76 "../src/theme-nostalgia.vala"
			if (c >= 'A') {
#line 76 "../src/theme-nostalgia.vala"
				_tmp2_ = c <= 'F';
#line 330 "theme-nostalgia.c"
			} else {
#line 76 "../src/theme-nostalgia.vala"
				_tmp2_ = FALSE;
#line 334 "theme-nostalgia.c"
			}
#line 76 "../src/theme-nostalgia.vala"
			if (_tmp2_) {
#line 77 "../src/theme-nostalgia.vala"
				result = (gdouble) ((c - 'A') + 10);
#line 77 "../src/theme-nostalgia.vala"
				return result;
#line 342 "theme-nostalgia.c"
			} else {
#line 79 "../src/theme-nostalgia.vala"
				result = 0.0;
#line 79 "../src/theme-nostalgia.vala"
				return result;
#line 348 "theme-nostalgia.c"
			}
		}
	}
}

static void
nostalgia_theme_real_configure (Theme* base,
                                guint new_size)
{
	NostalgiaTheme * self;
	gboolean _tmp0_ = FALSE;
	gdouble highlight_radius = 0.0;
	cairo_pattern_t* _tmp1_;
	cairo_pattern_t* _tmp2_;
	cairo_pattern_t* _tmp3_;
	cairo_pattern_t* _tmp4_;
	cairo_pattern_t* _tmp5_;
	cairo_pattern_t* _tmp6_;
	cairo_pattern_t* _tmp7_;
#line 126 "../src/theme-nostalgia.vala"
	self = (NostalgiaTheme*) base;
#line 128 "../src/theme-nostalgia.vala"
	if (self->priv->size != ((guint) 0)) {
#line 128 "../src/theme-nostalgia.vala"
		_tmp0_ = self->priv->size == new_size;
#line 374 "theme-nostalgia.c"
	} else {
#line 128 "../src/theme-nostalgia.vala"
		_tmp0_ = FALSE;
#line 378 "theme-nostalgia.c"
	}
#line 128 "../src/theme-nostalgia.vala"
	if (_tmp0_) {
#line 129 "../src/theme-nostalgia.vala"
		return;
#line 384 "theme-nostalgia.c"
	}
#line 131 "../src/theme-nostalgia.vala"
	nostalgia_theme_configure_arrow (self, new_size);
#line 132 "../src/theme-nostalgia.vala"
	nostalgia_theme_configure_socket (self, new_size);
#line 135 "../src/theme-nostalgia.vala"
	self->priv->half_tile_size = new_size * 0.5;
#line 136 "../src/theme-nostalgia.vala"
	highlight_radius = new_size * 0.45;
#line 137 "../src/theme-nostalgia.vala"
	_tmp1_ = cairo_pattern_create_radial (self->priv->half_tile_size, self->priv->half_tile_size, 0.0, self->priv->half_tile_size, self->priv->half_tile_size, highlight_radius);
#line 137 "../src/theme-nostalgia.vala"
	_cairo_pattern_destroy0 (self->priv->highlight_tile_pattern);
#line 137 "../src/theme-nostalgia.vala"
	self->priv->highlight_tile_pattern = _tmp1_;
#line 139 "../src/theme-nostalgia.vala"
	_tmp2_ = self->priv->highlight_tile_pattern;
#line 139 "../src/theme-nostalgia.vala"
	cairo_pattern_add_color_stop_rgba (_tmp2_, 0.0, 1.0, 1.0, 1.0, 1.0);
#line 140 "../src/theme-nostalgia.vala"
	_tmp3_ = self->priv->highlight_tile_pattern;
#line 140 "../src/theme-nostalgia.vala"
	cairo_pattern_add_color_stop_rgba (_tmp3_, 0.2, 1.0, 1.0, 1.0, 0.8);
#line 141 "../src/theme-nostalgia.vala"
	_tmp4_ = self->priv->highlight_tile_pattern;
#line 141 "../src/theme-nostalgia.vala"
	cairo_pattern_add_color_stop_rgba (_tmp4_, 0.3, 1.0, 1.0, 1.0, 0.5);
#line 142 "../src/theme-nostalgia.vala"
	_tmp5_ = self->priv->highlight_tile_pattern;
#line 142 "../src/theme-nostalgia.vala"
	cairo_pattern_add_color_stop_rgba (_tmp5_, 0.4, 1.0, 1.0, 1.0, 0.2);
#line 143 "../src/theme-nostalgia.vala"
	_tmp6_ = self->priv->highlight_tile_pattern;
#line 143 "../src/theme-nostalgia.vala"
	cairo_pattern_add_color_stop_rgba (_tmp6_, 0.5, 1.0, 1.0, 1.0, 0.1);
#line 144 "../src/theme-nostalgia.vala"
	_tmp7_ = self->priv->highlight_tile_pattern;
#line 144 "../src/theme-nostalgia.vala"
	cairo_pattern_add_color_stop_rgba (_tmp7_, 1.0, 1.0, 1.0, 1.0, 0.0);
#line 147 "../src/theme-nostalgia.vala"
	self->priv->tile_depth = MIN (new_size * 0.05, 4.0);
#line 148 "../src/theme-nostalgia.vala"
	self->priv->size_minus_tile_depth = ((gdouble) new_size) - self->priv->tile_depth;
#line 149 "../src/theme-nostalgia.vala"
	self->priv->tile_dx = (G_SQRT2 + 1.0) * self->priv->tile_depth;
#line 150 "../src/theme-nostalgia.vala"
	self->priv->tile_dy = G_SQRT2 * self->priv->tile_depth;
#line 151 "../src/theme-nostalgia.vala"
	self->priv->size_minus_tile_dx = ((gdouble) new_size) - self->priv->tile_dx;
#line 152 "../src/theme-nostalgia.vala"
	self->priv->half_tile_size_minus_dy = self->priv->half_tile_size - self->priv->tile_dy;
#line 153 "../src/theme-nostalgia.vala"
	self->priv->half_tile_size_plus_dy = self->priv->half_tile_size + self->priv->tile_dy;
#line 154 "../src/theme-nostalgia.vala"
	self->priv->size_minus_one = (gdouble) (new_size - 1);
#line 157 "../src/theme-nostalgia.vala"
	self->priv->font_size = new_size / 3.5;
#line 158 "../src/theme-nostalgia.vala"
	self->priv->north_number_y = new_size / 5.0;
#line 159 "../src/theme-nostalgia.vala"
	self->priv->south_number_y = (new_size * 4.0) / 5.0;
#line 160 "../src/theme-nostalgia.vala"
	self->priv->east_number_x = self->priv->south_number_y;
#line 161 "../src/theme-nostalgia.vala"
	self->priv->west_number_x = self->priv->north_number_y;
#line 164 "../src/theme-nostalgia.vala"
	self->priv->size = new_size;
#line 452 "theme-nostalgia.c"
}

static void
nostalgia_theme_real_set_animation_level (Theme* base,
                                          guint8 new_animation_level)
{
	NostalgiaTheme * self;
#line 167 "../src/theme-nostalgia.vala"
	self = (NostalgiaTheme*) base;
#line 169 "../src/theme-nostalgia.vala"
	self->priv->animation_level = new_animation_level;
#line 170 "../src/theme-nostalgia.vala"
	nostalgia_theme_configure_arrow (self, self->priv->size);
#line 171 "../src/theme-nostalgia.vala"
	nostalgia_theme_configure_socket (self, self->priv->size);
#line 468 "theme-nostalgia.c"
}

static void
nostalgia_theme_configure_arrow (NostalgiaTheme* self,
                                 guint new_size)
{
#line 174 "../src/theme-nostalgia.vala"
	g_return_if_fail (self != NULL);
#line 176 "../src/theme-nostalgia.vala"
	self->priv->arrow_half_h = new_size * 0.75;
#line 177 "../src/theme-nostalgia.vala"
	self->priv->neg_arrow_half_h = -self->priv->arrow_half_h;
#line 178 "../src/theme-nostalgia.vala"
	self->priv->arrow_depth = MIN (new_size * 0.025, 2.0) - (((gdouble) self->priv->animation_level) / 6.0);
#line 179 "../src/theme-nostalgia.vala"
	self->priv->arrow_depth = MAX (self->priv->arrow_depth, 0.0);
#line 180 "../src/theme-nostalgia.vala"
	self->priv->arrow_dx = G_SQRT2 * self->priv->arrow_depth;
#line 181 "../src/theme-nostalgia.vala"
	self->priv->arrow_dy = self->priv->arrow_half_h - (6.1623 * self->priv->arrow_depth);
#line 182 "../src/theme-nostalgia.vala"
	self->priv->neg_arrow_dy = -self->priv->arrow_dy;
#line 183 "../src/theme-nostalgia.vala"
	self->priv->arrow_w = (new_size * PUZZLE_VIEW_gap_factor) * 0.5;
#line 184 "../src/theme-nostalgia.vala"
	self->priv->arrow_x = ((new_size * PUZZLE_VIEW_gap_factor) - self->priv->arrow_w) * 0.5;
#line 185 "../src/theme-nostalgia.vala"
	self->priv->arrow_w_minus_depth = self->priv->arrow_w - self->priv->arrow_depth;
#line 497 "theme-nostalgia.c"
}

static void
nostalgia_theme_configure_socket (NostalgiaTheme* self,
                                  guint new_size)
{
#line 188 "../src/theme-nostalgia.vala"
	g_return_if_fail (self != NULL);
#line 190 "../src/theme-nostalgia.vala"
	self->priv->socket_depth = MIN (new_size * 0.05, 4.0) - (((gdouble) self->priv->animation_level) / 4.0);
#line 191 "../src/theme-nostalgia.vala"
	self->priv->socket_depth = MAX (self->priv->socket_depth, 0.0);
#line 192 "../src/theme-nostalgia.vala"
	self->priv->size_minus_socket_depth = ((gdouble) new_size) - self->priv->socket_depth;
#line 193 "../src/theme-nostalgia.vala"
	self->priv->size_minus_two_socket_depths = ((gdouble) new_size) - (self->priv->socket_depth * 2.0);
#line 514 "theme-nostalgia.c"
}

static void
nostalgia_theme_real_draw_arrow (Theme* base,
                                 cairo_t* context)
{
	NostalgiaTheme * self;
#line 200 "../src/theme-nostalgia.vala"
	self = (NostalgiaTheme*) base;
#line 200 "../src/theme-nostalgia.vala"
	g_return_if_fail (context != NULL);
#line 202 "../src/theme-nostalgia.vala"
	cairo_translate (context, self->priv->arrow_x, 0.0);
#line 205 "../src/theme-nostalgia.vala"
	cairo_move_to (context, 0.0, 0.0);
#line 206 "../src/theme-nostalgia.vala"
	cairo_line_to (context, self->priv->arrow_w, self->priv->arrow_half_h);
#line 207 "../src/theme-nostalgia.vala"
	cairo_line_to (context, self->priv->arrow_w, self->priv->neg_arrow_half_h);
#line 208 "../src/theme-nostalgia.vala"
	cairo_close_path (context);
#line 209 "../src/theme-nostalgia.vala"
	if (((gint) self->priv->animation_level) == 0) {
#line 210 "../src/theme-nostalgia.vala"
		cairo_set_source_rgba (context, 0.0, 0.0, 0.0, 0.125);
#line 540 "theme-nostalgia.c"
	} else {
#line 212 "../src/theme-nostalgia.vala"
		cairo_set_source_rgba (context, 0.0, 0.0, 0.0, (0.125 * (16.0 - ((gdouble) self->priv->animation_level))) / 16.0);
#line 544 "theme-nostalgia.c"
	}
#line 213 "../src/theme-nostalgia.vala"
	cairo_fill (context);
#line 216 "../src/theme-nostalgia.vala"
	cairo_move_to (context, self->priv->arrow_w, self->priv->neg_arrow_half_h);
#line 217 "../src/theme-nostalgia.vala"
	cairo_line_to (context, self->priv->arrow_w, self->priv->arrow_half_h);
#line 218 "../src/theme-nostalgia.vala"
	cairo_line_to (context, self->priv->arrow_w_minus_depth, self->priv->arrow_dy);
#line 219 "../src/theme-nostalgia.vala"
	cairo_line_to (context, self->priv->arrow_w_minus_depth, self->priv->neg_arrow_dy);
#line 220 "../src/theme-nostalgia.vala"
	cairo_close_path (context);
#line 221 "../src/theme-nostalgia.vala"
	if (((gint) self->priv->animation_level) == 0) {
#line 222 "../src/theme-nostalgia.vala"
		cairo_set_source_rgba (context, 0.6, 0.6, 0.5, 0.125);
#line 562 "theme-nostalgia.c"
	} else {
#line 224 "../src/theme-nostalgia.vala"
		cairo_set_source_rgba (context, 0.6, 0.6, 0.5, (0.125 * (16.0 - ((gdouble) self->priv->animation_level))) / 16.0);
#line 566 "theme-nostalgia.c"
	}
#line 225 "../src/theme-nostalgia.vala"
	cairo_fill (context);
#line 228 "../src/theme-nostalgia.vala"
	cairo_move_to (context, self->priv->arrow_w, self->priv->neg_arrow_half_h);
#line 229 "../src/theme-nostalgia.vala"
	cairo_line_to (context, 0.0, 0.0);
#line 230 "../src/theme-nostalgia.vala"
	cairo_line_to (context, self->priv->arrow_w, self->priv->arrow_half_h);
#line 231 "../src/theme-nostalgia.vala"
	cairo_line_to (context, self->priv->arrow_w_minus_depth, self->priv->arrow_dy);
#line 232 "../src/theme-nostalgia.vala"
	cairo_line_to (context, self->priv->arrow_dx, 0.0);
#line 233 "../src/theme-nostalgia.vala"
	cairo_line_to (context, self->priv->arrow_w_minus_depth, self->priv->neg_arrow_dy);
#line 234 "../src/theme-nostalgia.vala"
	cairo_close_path (context);
#line 235 "../src/theme-nostalgia.vala"
	if (((gint) self->priv->animation_level) == 0) {
#line 236 "../src/theme-nostalgia.vala"
		cairo_set_source_rgba (context, 0.0, 0.0, 0.0, 0.25);
#line 588 "theme-nostalgia.c"
	} else {
#line 238 "../src/theme-nostalgia.vala"
		cairo_set_source_rgba (context, 0.0, 0.0, 0.0, (0.25 * (16.0 - ((gdouble) self->priv->animation_level))) / 16.0);
#line 592 "theme-nostalgia.c"
	}
#line 239 "../src/theme-nostalgia.vala"
	cairo_fill (context);
#line 596 "theme-nostalgia.c"
}

static void
nostalgia_theme_real_draw_socket (Theme* base,
                                  cairo_t* context)
{
	NostalgiaTheme * self;
#line 246 "../src/theme-nostalgia.vala"
	self = (NostalgiaTheme*) base;
#line 246 "../src/theme-nostalgia.vala"
	g_return_if_fail (context != NULL);
#line 249 "../src/theme-nostalgia.vala"
	cairo_rectangle (context, self->priv->socket_depth, self->priv->socket_depth, self->priv->size_minus_two_socket_depths, self->priv->size_minus_two_socket_depths);
#line 250 "../src/theme-nostalgia.vala"
	if (((gint) self->priv->animation_level) == 0) {
#line 251 "../src/theme-nostalgia.vala"
		cairo_set_source_rgba (context, 0.0, 0.0, 0.0, 0.125);
#line 614 "theme-nostalgia.c"
	} else {
#line 253 "../src/theme-nostalgia.vala"
		cairo_set_source_rgba (context, 0.0, 0.0, 0.0, (0.125 * (16.0 - ((gdouble) self->priv->animation_level))) / 16.0);
#line 618 "theme-nostalgia.c"
	}
#line 254 "../src/theme-nostalgia.vala"
	cairo_fill (context);
#line 257 "../src/theme-nostalgia.vala"
	cairo_move_to (context, 0.0, (gdouble) self->priv->size);
#line 258 "../src/theme-nostalgia.vala"
	cairo_line_to (context, (gdouble) self->priv->size, (gdouble) self->priv->size);
#line 259 "../src/theme-nostalgia.vala"
	cairo_line_to (context, (gdouble) self->priv->size, 0.0);
#line 260 "../src/theme-nostalgia.vala"
	cairo_line_to (context, self->priv->size_minus_socket_depth, self->priv->socket_depth);
#line 261 "../src/theme-nostalgia.vala"
	cairo_line_to (context, self->priv->size_minus_socket_depth, self->priv->size_minus_socket_depth);
#line 262 "../src/theme-nostalgia.vala"
	cairo_line_to (context, self->priv->socket_depth, self->priv->size_minus_socket_depth);
#line 263 "../src/theme-nostalgia.vala"
	cairo_close_path (context);
#line 264 "../src/theme-nostalgia.vala"
	if (((gint) self->priv->animation_level) == 0) {
#line 265 "../src/theme-nostalgia.vala"
		cairo_set_source_rgba (context, 0.6, 0.6, 0.5, 0.125);
#line 640 "theme-nostalgia.c"
	} else {
#line 267 "../src/theme-nostalgia.vala"
		cairo_set_source_rgba (context, 0.6, 0.6, 0.5, (0.125 * (16.0 - ((gdouble) self->priv->animation_level))) / 16.0);
#line 644 "theme-nostalgia.c"
	}
#line 268 "../src/theme-nostalgia.vala"
	cairo_fill (context);
#line 271 "../src/theme-nostalgia.vala"
	cairo_move_to (context, (gdouble) self->priv->size, 0.0);
#line 272 "../src/theme-nostalgia.vala"
	cairo_line_to (context, 0.0, 0.0);
#line 273 "../src/theme-nostalgia.vala"
	cairo_line_to (context, 0.0, (gdouble) self->priv->size);
#line 274 "../src/theme-nostalgia.vala"
	cairo_line_to (context, self->priv->socket_depth, self->priv->size_minus_socket_depth);
#line 275 "../src/theme-nostalgia.vala"
	cairo_line_to (context, self->priv->socket_depth, self->priv->socket_depth);
#line 276 "../src/theme-nostalgia.vala"
	cairo_line_to (context, self->priv->size_minus_socket_depth, self->priv->socket_depth);
#line 277 "../src/theme-nostalgia.vala"
	cairo_close_path (context);
#line 278 "../src/theme-nostalgia.vala"
	if (((gint) self->priv->animation_level) == 0) {
#line 279 "../src/theme-nostalgia.vala"
		cairo_set_source_rgba (context, 0.0, 0.0, 0.0, 0.25);
#line 666 "theme-nostalgia.c"
	} else {
#line 281 "../src/theme-nostalgia.vala"
		cairo_set_source_rgba (context, 0.0, 0.0, 0.0, (0.25 * (16.0 - ((gdouble) self->priv->animation_level))) / 16.0);
#line 670 "theme-nostalgia.c"
	}
#line 282 "../src/theme-nostalgia.vala"
	cairo_fill (context);
#line 674 "theme-nostalgia.c"
}

static void
nostalgia_theme_real_draw_highlight (Theme* base,
                                     cairo_t* context,
                                     gboolean has_tile)
{
	NostalgiaTheme * self;
	cairo_pattern_t* _tmp0_;
#line 289 "../src/theme-nostalgia.vala"
	self = (NostalgiaTheme*) base;
#line 289 "../src/theme-nostalgia.vala"
	g_return_if_fail (context != NULL);
#line 291 "../src/theme-nostalgia.vala"
	_tmp0_ = self->priv->highlight_tile_pattern;
#line 291 "../src/theme-nostalgia.vala"
	cairo_set_source (context, _tmp0_);
#line 292 "../src/theme-nostalgia.vala"
	cairo_rectangle (context, 0.0, 0.0, (gdouble) self->priv->size, (gdouble) self->priv->size);
#line 293 "../src/theme-nostalgia.vala"
	cairo_fill (context);
#line 696 "theme-nostalgia.c"
}

static void
nostalgia_theme_real_draw_paused_tile (Theme* base,
                                       cairo_t* context)
{
	NostalgiaTheme * self;
	cairo_pattern_t* _tmp0_;
	cairo_pattern_t* _tmp1_;
	cairo_pattern_t* _tmp2_;
	cairo_pattern_t* _tmp3_;
#line 300 "../src/theme-nostalgia.vala"
	self = (NostalgiaTheme*) base;
#line 300 "../src/theme-nostalgia.vala"
	g_return_if_fail (context != NULL);
#line 302 "../src/theme-nostalgia.vala"
	_tmp0_ = self->priv->paused_color;
#line 302 "../src/theme-nostalgia.vala"
	_tmp1_ = self->priv->paused_color;
#line 302 "../src/theme-nostalgia.vala"
	_tmp2_ = self->priv->paused_color;
#line 302 "../src/theme-nostalgia.vala"
	_tmp3_ = self->priv->paused_color;
#line 302 "../src/theme-nostalgia.vala"
	nostalgia_theme_draw_tile_background (self, context, _tmp0_, _tmp1_, _tmp2_, _tmp3_);
#line 722 "theme-nostalgia.c"
}

static void
nostalgia_theme_real_draw_tile (Theme* base,
                                cairo_t* context,
                                Tile* tile,
                                gboolean highlight)
{
	NostalgiaTheme * self;
	cairo_pattern_t* _tmp0_;
	cairo_pattern_t* _tmp1_;
	cairo_pattern_t* _tmp2_;
	cairo_pattern_t* _tmp3_;
	cairo_pattern_t* _tmp4_;
	cairo_pattern_t* _tmp5_;
	cairo_pattern_t* _tmp6_;
	cairo_pattern_t* _tmp7_;
#line 305 "../src/theme-nostalgia.vala"
	self = (NostalgiaTheme*) base;
#line 305 "../src/theme-nostalgia.vala"
	g_return_if_fail (context != NULL);
#line 305 "../src/theme-nostalgia.vala"
	g_return_if_fail (tile != NULL);
#line 307 "../src/theme-nostalgia.vala"
	_tmp0_ = self->priv->tile_colors[tile->north];
#line 307 "../src/theme-nostalgia.vala"
	_tmp1_ = self->priv->tile_colors[tile->east];
#line 307 "../src/theme-nostalgia.vala"
	_tmp2_ = self->priv->tile_colors[tile->south];
#line 307 "../src/theme-nostalgia.vala"
	_tmp3_ = self->priv->tile_colors[tile->west];
#line 307 "../src/theme-nostalgia.vala"
	nostalgia_theme_draw_tile_background (self, context, _tmp0_, _tmp1_, _tmp2_, _tmp3_);
#line 309 "../src/theme-nostalgia.vala"
	cairo_select_font_face (context, "sans-serif", CAIRO_FONT_SLANT_NORMAL, CAIRO_FONT_WEIGHT_BOLD);
#line 310 "../src/theme-nostalgia.vala"
	cairo_set_font_size (context, self->priv->font_size);
#line 311 "../src/theme-nostalgia.vala"
	_tmp4_ = self->priv->text_colors[tile->north];
#line 311 "../src/theme-nostalgia.vala"
	nostalgia_theme_draw_number (context, _tmp4_, self->priv->half_tile_size, self->priv->north_number_y, tile->north);
#line 312 "../src/theme-nostalgia.vala"
	_tmp5_ = self->priv->text_colors[tile->south];
#line 312 "../src/theme-nostalgia.vala"
	nostalgia_theme_draw_number (context, _tmp5_, self->priv->half_tile_size, self->priv->south_number_y, tile->south);
#line 313 "../src/theme-nostalgia.vala"
	_tmp6_ = self->priv->text_colors[tile->east];
#line 313 "../src/theme-nostalgia.vala"
	nostalgia_theme_draw_number (context, _tmp6_, self->priv->east_number_x, self->priv->half_tile_size, tile->east);
#line 314 "../src/theme-nostalgia.vala"
	_tmp7_ = self->priv->text_colors[tile->west];
#line 314 "../src/theme-nostalgia.vala"
	nostalgia_theme_draw_number (context, _tmp7_, self->priv->west_number_x, self->priv->half_tile_size, tile->west);
#line 316 "../src/theme-nostalgia.vala"
	if (highlight) {
#line 318 "../src/theme-nostalgia.vala"
		cairo_set_source_rgba (context, 1.0, 1.0, 1.0, 0.3);
#line 319 "../src/theme-nostalgia.vala"
		cairo_rectangle (context, 0.0, 0.0, (gdouble) self->priv->size, (gdouble) self->priv->size);
#line 320 "../src/theme-nostalgia.vala"
		cairo_fill (context);
#line 784 "theme-nostalgia.c"
	}
}

static void
nostalgia_theme_draw_tile_background (NostalgiaTheme* self,
                                      cairo_t* context,
                                      cairo_pattern_t* north_color,
                                      cairo_pattern_t* east_color,
                                      cairo_pattern_t* south_color,
                                      cairo_pattern_t* west_color)
{
#line 324 "../src/theme-nostalgia.vala"
	g_return_if_fail (self != NULL);
#line 324 "../src/theme-nostalgia.vala"
	g_return_if_fail (context != NULL);
#line 324 "../src/theme-nostalgia.vala"
	g_return_if_fail (north_color != NULL);
#line 324 "../src/theme-nostalgia.vala"
	g_return_if_fail (east_color != NULL);
#line 324 "../src/theme-nostalgia.vala"
	g_return_if_fail (south_color != NULL);
#line 324 "../src/theme-nostalgia.vala"
	g_return_if_fail (west_color != NULL);
#line 327 "../src/theme-nostalgia.vala"
	cairo_rectangle (context, 0.0, 0.0, (gdouble) self->priv->size, self->priv->half_tile_size);
#line 328 "../src/theme-nostalgia.vala"
	cairo_set_source (context, north_color);
#line 329 "../src/theme-nostalgia.vala"
	cairo_fill (context);
#line 332 "../src/theme-nostalgia.vala"
	cairo_move_to (context, 0.0, 0.0);
#line 333 "../src/theme-nostalgia.vala"
	cairo_line_to (context, (gdouble) self->priv->size, 0.0);
#line 334 "../src/theme-nostalgia.vala"
	cairo_line_to (context, self->priv->size_minus_tile_dx, self->priv->tile_depth);
#line 335 "../src/theme-nostalgia.vala"
	cairo_line_to (context, self->priv->tile_dx, self->priv->tile_depth);
#line 336 "../src/theme-nostalgia.vala"
	cairo_line_to (context, self->priv->half_tile_size, self->priv->half_tile_size_minus_dy);
#line 337 "../src/theme-nostalgia.vala"
	cairo_line_to (context, self->priv->half_tile_size, self->priv->half_tile_size);
#line 338 "../src/theme-nostalgia.vala"
	cairo_close_path (context);
#line 339 "../src/theme-nostalgia.vala"
	cairo_set_source_rgba (context, 1.0, 1.0, 1.0, 0.125);
#line 340 "../src/theme-nostalgia.vala"
	cairo_fill (context);
#line 343 "../src/theme-nostalgia.vala"
	cairo_move_to (context, (gdouble) self->priv->size, 0.0);
#line 344 "../src/theme-nostalgia.vala"
	cairo_line_to (context, self->priv->half_tile_size, self->priv->half_tile_size);
#line 345 "../src/theme-nostalgia.vala"
	cairo_line_to (context, self->priv->half_tile_size, self->priv->half_tile_size_minus_dy);
#line 346 "../src/theme-nostalgia.vala"
	cairo_line_to (context, self->priv->size_minus_tile_dx, self->priv->tile_depth);
#line 347 "../src/theme-nostalgia.vala"
	cairo_close_path (context);
#line 348 "../src/theme-nostalgia.vala"
	cairo_set_source_rgba (context, 0.0, 0.0, 0.0, 0.25);
#line 349 "../src/theme-nostalgia.vala"
	cairo_fill (context);
#line 352 "../src/theme-nostalgia.vala"
	cairo_rectangle (context, 0.0, self->priv->half_tile_size, (gdouble) self->priv->size, self->priv->half_tile_size);
#line 353 "../src/theme-nostalgia.vala"
	cairo_set_source (context, south_color);
#line 354 "../src/theme-nostalgia.vala"
	cairo_fill (context);
#line 357 "../src/theme-nostalgia.vala"
	cairo_move_to (context, 0.0, (gdouble) self->priv->size);
#line 358 "../src/theme-nostalgia.vala"
	cairo_line_to (context, self->priv->tile_dx, self->priv->size_minus_tile_depth);
#line 359 "../src/theme-nostalgia.vala"
	cairo_line_to (context, self->priv->half_tile_size, self->priv->half_tile_size_plus_dy);
#line 360 "../src/theme-nostalgia.vala"
	cairo_line_to (context, self->priv->half_tile_size, self->priv->half_tile_size);
#line 361 "../src/theme-nostalgia.vala"
	cairo_close_path (context);
#line 362 "../src/theme-nostalgia.vala"
	cairo_set_source_rgba (context, 1.0, 1.0, 1.0, 0.125);
#line 363 "../src/theme-nostalgia.vala"
	cairo_fill (context);
#line 366 "../src/theme-nostalgia.vala"
	cairo_move_to (context, 0.0, (gdouble) self->priv->size);
#line 367 "../src/theme-nostalgia.vala"
	cairo_line_to (context, (gdouble) self->priv->size, (gdouble) self->priv->size);
#line 368 "../src/theme-nostalgia.vala"
	cairo_line_to (context, self->priv->half_tile_size, self->priv->half_tile_size);
#line 369 "../src/theme-nostalgia.vala"
	cairo_line_to (context, self->priv->half_tile_size, self->priv->half_tile_size_plus_dy);
#line 370 "../src/theme-nostalgia.vala"
	cairo_line_to (context, self->priv->size_minus_tile_dx, self->priv->size_minus_tile_depth);
#line 371 "../src/theme-nostalgia.vala"
	cairo_line_to (context, self->priv->tile_dx, self->priv->size_minus_tile_depth);
#line 372 "../src/theme-nostalgia.vala"
	cairo_close_path (context);
#line 373 "../src/theme-nostalgia.vala"
	cairo_set_source_rgba (context, 0.0, 0.0, 0.0, 0.25);
#line 374 "../src/theme-nostalgia.vala"
	cairo_fill (context);
#line 377 "../src/theme-nostalgia.vala"
	cairo_move_to (context, (gdouble) self->priv->size, 0.0);
#line 378 "../src/theme-nostalgia.vala"
	cairo_line_to (context, (gdouble) self->priv->size, (gdouble) self->priv->size);
#line 379 "../src/theme-nostalgia.vala"
	cairo_line_to (context, self->priv->half_tile_size, self->priv->half_tile_size);
#line 380 "../src/theme-nostalgia.vala"
	cairo_close_path (context);
#line 381 "../src/theme-nostalgia.vala"
	cairo_set_source (context, east_color);
#line 382 "../src/theme-nostalgia.vala"
	cairo_fill (context);
#line 385 "../src/theme-nostalgia.vala"
	cairo_move_to (context, (gdouble) self->priv->size, 0.0);
#line 386 "../src/theme-nostalgia.vala"
	cairo_line_to (context, self->priv->half_tile_size, self->priv->half_tile_size);
#line 387 "../src/theme-nostalgia.vala"
	cairo_line_to (context, (gdouble) self->priv->size, (gdouble) self->priv->size);
#line 388 "../src/theme-nostalgia.vala"
	cairo_line_to (context, self->priv->size_minus_tile_depth, self->priv->size_minus_tile_dx);
#line 389 "../src/theme-nostalgia.vala"
	cairo_line_to (context, self->priv->half_tile_size_plus_dy, self->priv->half_tile_size);
#line 390 "../src/theme-nostalgia.vala"
	cairo_line_to (context, self->priv->size_minus_tile_depth, self->priv->tile_dx);
#line 391 "../src/theme-nostalgia.vala"
	cairo_close_path (context);
#line 392 "../src/theme-nostalgia.vala"
	cairo_set_source_rgba (context, 1.0, 1.0, 1.0, 0.125);
#line 393 "../src/theme-nostalgia.vala"
	cairo_fill (context);
#line 396 "../src/theme-nostalgia.vala"
	cairo_move_to (context, (gdouble) self->priv->size, 0.0);
#line 397 "../src/theme-nostalgia.vala"
	cairo_line_to (context, (gdouble) self->priv->size, (gdouble) self->priv->size);
#line 398 "../src/theme-nostalgia.vala"
	cairo_line_to (context, self->priv->size_minus_tile_depth, self->priv->size_minus_tile_dx);
#line 399 "../src/theme-nostalgia.vala"
	cairo_line_to (context, self->priv->size_minus_tile_depth, self->priv->tile_dx);
#line 400 "../src/theme-nostalgia.vala"
	cairo_close_path (context);
#line 401 "../src/theme-nostalgia.vala"
	cairo_set_source_rgba (context, 0.0, 0.0, 0.0, 0.25);
#line 402 "../src/theme-nostalgia.vala"
	cairo_fill (context);
#line 405 "../src/theme-nostalgia.vala"
	cairo_move_to (context, 0.0, 0.0);
#line 406 "../src/theme-nostalgia.vala"
	cairo_line_to (context, 0.0, (gdouble) self->priv->size);
#line 407 "../src/theme-nostalgia.vala"
	cairo_line_to (context, self->priv->half_tile_size, self->priv->half_tile_size);
#line 408 "../src/theme-nostalgia.vala"
	cairo_close_path (context);
#line 409 "../src/theme-nostalgia.vala"
	cairo_set_source (context, west_color);
#line 410 "../src/theme-nostalgia.vala"
	cairo_fill (context);
#line 413 "../src/theme-nostalgia.vala"
	cairo_move_to (context, 0.0, 0.0);
#line 414 "../src/theme-nostalgia.vala"
	cairo_line_to (context, 0.0, (gdouble) self->priv->size);
#line 415 "../src/theme-nostalgia.vala"
	cairo_line_to (context, self->priv->tile_depth, self->priv->size_minus_tile_dx);
#line 416 "../src/theme-nostalgia.vala"
	cairo_line_to (context, self->priv->tile_depth, self->priv->tile_dx);
#line 417 "../src/theme-nostalgia.vala"
	cairo_close_path (context);
#line 418 "../src/theme-nostalgia.vala"
	cairo_set_source_rgba (context, 1.0, 1.0, 1.0, 0.125);
#line 419 "../src/theme-nostalgia.vala"
	cairo_fill (context);
#line 422 "../src/theme-nostalgia.vala"
	cairo_move_to (context, 0.0, 0.0);
#line 423 "../src/theme-nostalgia.vala"
	cairo_line_to (context, self->priv->half_tile_size, self->priv->half_tile_size);
#line 424 "../src/theme-nostalgia.vala"
	cairo_line_to (context, 0.0, (gdouble) self->priv->size);
#line 425 "../src/theme-nostalgia.vala"
	cairo_line_to (context, self->priv->tile_depth, self->priv->size_minus_tile_dx);
#line 426 "../src/theme-nostalgia.vala"
	cairo_line_to (context, self->priv->half_tile_size_minus_dy, self->priv->half_tile_size);
#line 427 "../src/theme-nostalgia.vala"
	cairo_line_to (context, self->priv->tile_depth, self->priv->tile_dx);
#line 428 "../src/theme-nostalgia.vala"
	cairo_close_path (context);
#line 429 "../src/theme-nostalgia.vala"
	cairo_set_source_rgba (context, 0.0, 0.0, 0.0, 0.25);
#line 430 "../src/theme-nostalgia.vala"
	cairo_fill (context);
#line 433 "../src/theme-nostalgia.vala"
	cairo_set_line_width (context, 1.0);
#line 434 "../src/theme-nostalgia.vala"
	cairo_set_source_rgb (context, 0.0, 0.0, 0.0);
#line 435 "../src/theme-nostalgia.vala"
	cairo_rectangle (context, 0.5, 0.5, self->priv->size_minus_one, self->priv->size_minus_one);
#line 436 "../src/theme-nostalgia.vala"
	cairo_stroke (context);
#line 980 "theme-nostalgia.c"
}

static void
nostalgia_theme_draw_number (cairo_t* context,
                             cairo_pattern_t* text_color,
                             gdouble x,
                             gdouble y,
                             guint8 number)
{
	gchar* text = NULL;
	gchar* _tmp0_;
	cairo_text_extents_t extents = {0};
	cairo_text_extents_t _tmp1_ = {0};
	cairo_text_extents_t _tmp2_;
	cairo_text_extents_t _tmp3_;
#line 439 "../src/theme-nostalgia.vala"
	g_return_if_fail (context != NULL);
#line 439 "../src/theme-nostalgia.vala"
	g_return_if_fail (text_color != NULL);
#line 441 "../src/theme-nostalgia.vala"
	cairo_set_source (context, text_color);
#line 443 "../src/theme-nostalgia.vala"
	_tmp0_ = g_strdup_printf ("%hu", (gushort) number);
#line 443 "../src/theme-nostalgia.vala"
	text = _tmp0_;
#line 445 "../src/theme-nostalgia.vala"
	cairo_text_extents (context, text, &_tmp1_);
#line 445 "../src/theme-nostalgia.vala"
	extents = _tmp1_;
#line 446 "../src/theme-nostalgia.vala"
	_tmp2_ = extents;
#line 446 "../src/theme-nostalgia.vala"
	_tmp3_ = extents;
#line 446 "../src/theme-nostalgia.vala"
	cairo_move_to (context, x - (_tmp2_.width / 2.0), y + (_tmp3_.height / 2.0));
#line 447 "../src/theme-nostalgia.vala"
	cairo_show_text (context, text);
#line 439 "../src/theme-nostalgia.vala"
	_g_free0 (text);
#line 1020 "theme-nostalgia.c"
}

NostalgiaTheme*
nostalgia_theme_construct (GType object_type)
{
	NostalgiaTheme * self = NULL;
#line 22 "../src/theme-nostalgia.vala"
	self = (NostalgiaTheme*) theme_construct (object_type);
#line 22 "../src/theme-nostalgia.vala"
	return self;
#line 1031 "theme-nostalgia.c"
}

NostalgiaTheme*
nostalgia_theme_new (void)
{
#line 22 "../src/theme-nostalgia.vala"
	return nostalgia_theme_construct (TYPE_NOSTALGIA_THEME);
#line 1039 "theme-nostalgia.c"
}

static GObject *
nostalgia_theme_constructor (GType type,
                             guint n_construct_properties,
                             GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	NostalgiaTheme * self;
	cairo_pattern_t* _tmp0_;
	cairo_pattern_t* _tmp1_;
	cairo_pattern_t* _tmp2_;
	cairo_pattern_t* _tmp3_;
	cairo_pattern_t* _tmp4_;
	cairo_pattern_t* _tmp5_;
	cairo_pattern_t* _tmp6_;
	cairo_pattern_t* _tmp7_;
	cairo_pattern_t* _tmp8_;
	cairo_pattern_t* _tmp9_;
	cairo_pattern_t* _tmp10_;
	cairo_pattern_t* _tmp11_;
	cairo_pattern_t* _tmp12_;
	cairo_pattern_t* _tmp13_;
	cairo_pattern_t* _tmp14_;
	cairo_pattern_t* _tmp15_;
	cairo_pattern_t* _tmp16_;
	cairo_pattern_t* _tmp17_;
	cairo_pattern_t* _tmp18_;
	cairo_pattern_t* _tmp19_;
	cairo_pattern_t* _tmp20_;
#line 35 "../src/theme-nostalgia.vala"
	parent_class = G_OBJECT_CLASS (nostalgia_theme_parent_class);
#line 35 "../src/theme-nostalgia.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 35 "../src/theme-nostalgia.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_NOSTALGIA_THEME, NostalgiaTheme);
#line 37 "../src/theme-nostalgia.vala"
	_tmp0_ = nostalgia_theme_make_color_pattern ("000000");
#line 37 "../src/theme-nostalgia.vala"
	_cairo_pattern_destroy0 (self->priv->tile_colors[0]);
#line 37 "../src/theme-nostalgia.vala"
	self->priv->tile_colors[0] = _tmp0_;
#line 38 "../src/theme-nostalgia.vala"
	_tmp1_ = nostalgia_theme_make_color_pattern ("C17D11");
#line 38 "../src/theme-nostalgia.vala"
	_cairo_pattern_destroy0 (self->priv->tile_colors[1]);
#line 38 "../src/theme-nostalgia.vala"
	self->priv->tile_colors[1] = _tmp1_;
#line 39 "../src/theme-nostalgia.vala"
	_tmp2_ = nostalgia_theme_make_color_pattern ("CC0000");
#line 39 "../src/theme-nostalgia.vala"
	_cairo_pattern_destroy0 (self->priv->tile_colors[2]);
#line 39 "../src/theme-nostalgia.vala"
	self->priv->tile_colors[2] = _tmp2_;
#line 40 "../src/theme-nostalgia.vala"
	_tmp3_ = nostalgia_theme_make_color_pattern ("F57900");
#line 40 "../src/theme-nostalgia.vala"
	_cairo_pattern_destroy0 (self->priv->tile_colors[3]);
#line 40 "../src/theme-nostalgia.vala"
	self->priv->tile_colors[3] = _tmp3_;
#line 41 "../src/theme-nostalgia.vala"
	_tmp4_ = nostalgia_theme_make_color_pattern ("EDD400");
#line 41 "../src/theme-nostalgia.vala"
	_cairo_pattern_destroy0 (self->priv->tile_colors[4]);
#line 41 "../src/theme-nostalgia.vala"
	self->priv->tile_colors[4] = _tmp4_;
#line 42 "../src/theme-nostalgia.vala"
	_tmp5_ = nostalgia_theme_make_color_pattern ("73D216");
#line 42 "../src/theme-nostalgia.vala"
	_cairo_pattern_destroy0 (self->priv->tile_colors[5]);
#line 42 "../src/theme-nostalgia.vala"
	self->priv->tile_colors[5] = _tmp5_;
#line 43 "../src/theme-nostalgia.vala"
	_tmp6_ = nostalgia_theme_make_color_pattern ("3465A4");
#line 43 "../src/theme-nostalgia.vala"
	_cairo_pattern_destroy0 (self->priv->tile_colors[6]);
#line 43 "../src/theme-nostalgia.vala"
	self->priv->tile_colors[6] = _tmp6_;
#line 44 "../src/theme-nostalgia.vala"
	_tmp7_ = nostalgia_theme_make_color_pattern ("75507B");
#line 44 "../src/theme-nostalgia.vala"
	_cairo_pattern_destroy0 (self->priv->tile_colors[7]);
#line 44 "../src/theme-nostalgia.vala"
	self->priv->tile_colors[7] = _tmp7_;
#line 45 "../src/theme-nostalgia.vala"
	_tmp8_ = nostalgia_theme_make_color_pattern ("BABDB6");
#line 45 "../src/theme-nostalgia.vala"
	_cairo_pattern_destroy0 (self->priv->tile_colors[8]);
#line 45 "../src/theme-nostalgia.vala"
	self->priv->tile_colors[8] = _tmp8_;
#line 46 "../src/theme-nostalgia.vala"
	_tmp9_ = nostalgia_theme_make_color_pattern ("FFFFFF");
#line 46 "../src/theme-nostalgia.vala"
	_cairo_pattern_destroy0 (self->priv->tile_colors[9]);
#line 46 "../src/theme-nostalgia.vala"
	self->priv->tile_colors[9] = _tmp9_;
#line 48 "../src/theme-nostalgia.vala"
	_tmp10_ = nostalgia_theme_make_color_pattern ("CCCCCC");
#line 48 "../src/theme-nostalgia.vala"
	_cairo_pattern_destroy0 (self->priv->paused_color);
#line 48 "../src/theme-nostalgia.vala"
	self->priv->paused_color = _tmp10_;
#line 50 "../src/theme-nostalgia.vala"
	_tmp11_ = self->priv->white_text_color;
#line 50 "../src/theme-nostalgia.vala"
	self->priv->text_colors[0] = _tmp11_;
#line 51 "../src/theme-nostalgia.vala"
	_tmp12_ = self->priv->white_text_color;
#line 51 "../src/theme-nostalgia.vala"
	self->priv->text_colors[1] = _tmp12_;
#line 52 "../src/theme-nostalgia.vala"
	_tmp13_ = self->priv->white_text_color;
#line 52 "../src/theme-nostalgia.vala"
	self->priv->text_colors[2] = _tmp13_;
#line 53 "../src/theme-nostalgia.vala"
	_tmp14_ = self->priv->white_text_color;
#line 53 "../src/theme-nostalgia.vala"
	self->priv->text_colors[3] = _tmp14_;
#line 54 "../src/theme-nostalgia.vala"
	_tmp15_ = self->priv->black_text_color;
#line 54 "../src/theme-nostalgia.vala"
	self->priv->text_colors[4] = _tmp15_;
#line 55 "../src/theme-nostalgia.vala"
	_tmp16_ = self->priv->black_text_color;
#line 55 "../src/theme-nostalgia.vala"
	self->priv->text_colors[5] = _tmp16_;
#line 56 "../src/theme-nostalgia.vala"
	_tmp17_ = self->priv->white_text_color;
#line 56 "../src/theme-nostalgia.vala"
	self->priv->text_colors[6] = _tmp17_;
#line 57 "../src/theme-nostalgia.vala"
	_tmp18_ = self->priv->white_text_color;
#line 57 "../src/theme-nostalgia.vala"
	self->priv->text_colors[7] = _tmp18_;
#line 58 "../src/theme-nostalgia.vala"
	_tmp19_ = self->priv->black_text_color;
#line 58 "../src/theme-nostalgia.vala"
	self->priv->text_colors[8] = _tmp19_;
#line 59 "../src/theme-nostalgia.vala"
	_tmp20_ = self->priv->black_text_color;
#line 59 "../src/theme-nostalgia.vala"
	self->priv->text_colors[9] = _tmp20_;
#line 35 "../src/theme-nostalgia.vala"
	return obj;
#line 1185 "theme-nostalgia.c"
}

static void
nostalgia_theme_class_init (NostalgiaThemeClass * klass,
                            gpointer klass_data)
{
#line 22 "../src/theme-nostalgia.vala"
	nostalgia_theme_parent_class = g_type_class_peek_parent (klass);
#line 22 "../src/theme-nostalgia.vala"
	g_type_class_adjust_private_offset (klass, &NostalgiaTheme_private_offset);
#line 22 "../src/theme-nostalgia.vala"
	((ThemeClass *) klass)->configure = (void (*) (Theme*, guint)) nostalgia_theme_real_configure;
#line 22 "../src/theme-nostalgia.vala"
	((ThemeClass *) klass)->set_animation_level = (void (*) (Theme*, guint8)) nostalgia_theme_real_set_animation_level;
#line 22 "../src/theme-nostalgia.vala"
	((ThemeClass *) klass)->draw_arrow = (void (*) (Theme*, cairo_t*)) nostalgia_theme_real_draw_arrow;
#line 22 "../src/theme-nostalgia.vala"
	((ThemeClass *) klass)->draw_socket = (void (*) (Theme*, cairo_t*)) nostalgia_theme_real_draw_socket;
#line 22 "../src/theme-nostalgia.vala"
	((ThemeClass *) klass)->draw_highlight = (void (*) (Theme*, cairo_t*, gboolean)) nostalgia_theme_real_draw_highlight;
#line 22 "../src/theme-nostalgia.vala"
	((ThemeClass *) klass)->draw_paused_tile = (void (*) (Theme*, cairo_t*)) nostalgia_theme_real_draw_paused_tile;
#line 22 "../src/theme-nostalgia.vala"
	((ThemeClass *) klass)->draw_tile = (void (*) (Theme*, cairo_t*, Tile*, gboolean)) nostalgia_theme_real_draw_tile;
#line 22 "../src/theme-nostalgia.vala"
	G_OBJECT_CLASS (klass)->constructor = nostalgia_theme_constructor;
#line 22 "../src/theme-nostalgia.vala"
	G_OBJECT_CLASS (klass)->finalize = nostalgia_theme_finalize;
#line 1214 "theme-nostalgia.c"
}

static void
nostalgia_theme_instance_init (NostalgiaTheme * self,
                               gpointer klass)
{
	cairo_pattern_t* _tmp0_;
	cairo_pattern_t* _tmp1_;
#line 22 "../src/theme-nostalgia.vala"
	self->priv = nostalgia_theme_get_instance_private (self);
#line 32 "../src/theme-nostalgia.vala"
	_tmp0_ = cairo_pattern_create_rgb ((gdouble) 0, (gdouble) 0, (gdouble) 0);
#line 32 "../src/theme-nostalgia.vala"
	self->priv->black_text_color = _tmp0_;
#line 33 "../src/theme-nostalgia.vala"
	_tmp1_ = cairo_pattern_create_rgb ((gdouble) 1, (gdouble) 1, (gdouble) 1);
#line 33 "../src/theme-nostalgia.vala"
	self->priv->white_text_color = _tmp1_;
#line 86 "../src/theme-nostalgia.vala"
	self->priv->size = (guint) 0;
#line 87 "../src/theme-nostalgia.vala"
	self->priv->animation_level = (guint8) 0;
#line 1237 "theme-nostalgia.c"
}

static void
nostalgia_theme_finalize (GObject * obj)
{
	NostalgiaTheme * self;
#line 22 "../src/theme-nostalgia.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_NOSTALGIA_THEME, NostalgiaTheme);
#line 28 "../src/theme-nostalgia.vala"
	_vala_array_destroy (self->priv->tile_colors, 10, (GDestroyNotify) cairo_pattern_destroy);
#line 29 "../src/theme-nostalgia.vala"
	_cairo_pattern_destroy0 (self->priv->paused_color);
#line 32 "../src/theme-nostalgia.vala"
	_cairo_pattern_destroy0 (self->priv->black_text_color);
#line 33 "../src/theme-nostalgia.vala"
	_cairo_pattern_destroy0 (self->priv->white_text_color);
#line 106 "../src/theme-nostalgia.vala"
	_cairo_pattern_destroy0 (self->priv->highlight_tile_pattern);
#line 22 "../src/theme-nostalgia.vala"
	G_OBJECT_CLASS (nostalgia_theme_parent_class)->finalize (obj);
#line 1258 "theme-nostalgia.c"
}

static GType
nostalgia_theme_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (NostalgiaThemeClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) nostalgia_theme_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NostalgiaTheme), 0, (GInstanceInitFunc) nostalgia_theme_instance_init, NULL };
	GType nostalgia_theme_type_id;
	nostalgia_theme_type_id = g_type_register_static (TYPE_THEME, "NostalgiaTheme", &g_define_type_info, 0);
	NostalgiaTheme_private_offset = g_type_add_instance_private (nostalgia_theme_type_id, sizeof (NostalgiaThemePrivate));
	return nostalgia_theme_type_id;
}

GType
nostalgia_theme_get_type (void)
{
	static volatile gsize nostalgia_theme_type_id__once = 0;
	if (g_once_init_enter (&nostalgia_theme_type_id__once)) {
		GType nostalgia_theme_type_id;
		nostalgia_theme_type_id = nostalgia_theme_get_type_once ();
		g_once_init_leave (&nostalgia_theme_type_id__once, nostalgia_theme_type_id);
	}
	return nostalgia_theme_type_id__once;
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

