/* puzzle-view.c generated by valac 0.56.9, the Vala compiler
 * generated from puzzle-view.vala, do not modify */

/* -*- Mode: vala; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*-

   This file is part of GNOME Tetravex.

   Copyright (C) 2010-2013 Robert Ancell
   Copyright (C) 2019 Arnaud Bonatti

   GNOME Tetravex is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 2 of the License, or
   (at your option) any later version.

   GNOME Tetravex is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License along
   with this GNOME Tetravex.  If not, see <https://www.gnu.org/licenses/>.
*/

#include <glib-object.h>
#include <glib.h>
#include <cairo-gobject.h>
#include <gtk/gtk.h>
#include <float.h>
#include <math.h>
#include <gdk/gdk.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gi18n-lib.h>

#define PUZZLE_VIEW_minimum_size 80
#define PUZZLE_VIEW_animation_duration 0.25
#define PUZZLE_VIEW_final_animation_duration ((guint) 250)
#define PUZZLE_VIEW_half_animation_duration 0.15
#define PUZZLE_VIEW_gap_factor 0.5
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TYPE_THEME (theme_get_type ())
#define THEME(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_THEME, Theme))
#define THEME_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_THEME, ThemeClass))
#define IS_THEME(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_THEME))
#define IS_THEME_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_THEME))
#define THEME_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_THEME, ThemeClass))

typedef struct _Theme Theme;
typedef struct _ThemeClass ThemeClass;
typedef struct _ThemePrivate ThemePrivate;

#define TYPE_TILE (tile_get_type ())
#define TILE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_TILE, Tile))
#define TILE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_TILE, TileClass))
#define IS_TILE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_TILE))
#define IS_TILE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_TILE))
#define TILE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_TILE, TileClass))

typedef struct _Tile Tile;
typedef struct _TileClass TileClass;
enum  {
	THEME_0_PROPERTY,
	THEME_OVERDRAW_TOP_PROPERTY,
	THEME_OVERDRAW_LEFT_PROPERTY,
	THEME_OVERDRAW_RIGHT_PROPERTY,
	THEME_OVERDRAW_BOTTOM_PROPERTY,
	THEME_NUM_PROPERTIES
};
static GParamSpec* theme_properties[THEME_NUM_PROPERTIES];

#define TYPE_PUZZLE_VIEW (puzzle_view_get_type ())
#define PUZZLE_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PUZZLE_VIEW, PuzzleView))
#define PUZZLE_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PUZZLE_VIEW, PuzzleViewClass))
#define IS_PUZZLE_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PUZZLE_VIEW))
#define IS_PUZZLE_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PUZZLE_VIEW))
#define PUZZLE_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PUZZLE_VIEW, PuzzleViewClass))

typedef struct _PuzzleView PuzzleView;
typedef struct _PuzzleViewClass PuzzleViewClass;
typedef struct _PuzzleViewPrivate PuzzleViewPrivate;

#define TYPE_PUZZLE (puzzle_get_type ())
#define PUZZLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PUZZLE, Puzzle))
#define PUZZLE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PUZZLE, PuzzleClass))
#define IS_PUZZLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PUZZLE))
#define IS_PUZZLE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PUZZLE))
#define PUZZLE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PUZZLE, PuzzleClass))

typedef struct _Puzzle Puzzle;
typedef struct _PuzzleClass PuzzleClass;

#define PUZZLE_VIEW_TYPE_TILE_IMAGE (puzzle_view_tile_image_get_type ())
#define PUZZLE_VIEW_TILE_IMAGE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PUZZLE_VIEW_TYPE_TILE_IMAGE, PuzzleViewTileImage))
#define PUZZLE_VIEW_TILE_IMAGE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), PUZZLE_VIEW_TYPE_TILE_IMAGE, PuzzleViewTileImageClass))
#define PUZZLE_VIEW_IS_TILE_IMAGE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PUZZLE_VIEW_TYPE_TILE_IMAGE))
#define PUZZLE_VIEW_IS_TILE_IMAGE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), PUZZLE_VIEW_TYPE_TILE_IMAGE))
#define PUZZLE_VIEW_TILE_IMAGE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), PUZZLE_VIEW_TYPE_TILE_IMAGE, PuzzleViewTileImageClass))

typedef struct _PuzzleViewTileImage PuzzleViewTileImage;
typedef struct _PuzzleViewTileImageClass PuzzleViewTileImageClass;
enum  {
	PUZZLE_VIEW_0_PROPERTY,
	PUZZLE_VIEW_PUZZLE_PROPERTY,
	PUZZLE_VIEW_THEME_ID_PROPERTY,
	PUZZLE_VIEW_TILE_SELECTED_PROPERTY,
	PUZZLE_VIEW_BOARDSIZE_PROPERTY,
	PUZZLE_VIEW_X_OFFSET_RIGHT_PROPERTY,
	PUZZLE_VIEW_Y_OFFSET_PROPERTY,
	PUZZLE_VIEW_RIGHT_MARGIN_PROPERTY,
	PUZZLE_VIEW_MOUSE_USE_EXTRA_BUTTONS_PROPERTY,
	PUZZLE_VIEW_MOUSE_BACK_BUTTON_PROPERTY,
	PUZZLE_VIEW_MOUSE_FORWARD_BUTTON_PROPERTY,
	PUZZLE_VIEW_NUM_PROPERTIES
};
static GParamSpec* puzzle_view_properties[PUZZLE_VIEW_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_hash_table_unref0(var) ((var == NULL) ? NULL : (var = (g_hash_table_unref (var), NULL)))
#define _g_timer_destroy0(var) ((var == NULL) ? NULL : (var = (g_timer_destroy (var), NULL)))
#define _cairo_pattern_destroy0(var) ((var == NULL) ? NULL : (var = (cairo_pattern_destroy (var), NULL)))
typedef struct _PuzzleViewTileImagePrivate PuzzleViewTileImagePrivate;
#define _cairo_surface_destroy0(var) ((var == NULL) ? NULL : (var = (cairo_surface_destroy (var), NULL)))
#define _cairo_destroy0(var) ((var == NULL) ? NULL : (var = (cairo_destroy (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

#define TYPE_NEO_RETRO_THEME (neo_retro_theme_get_type ())
#define NEO_RETRO_THEME(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_NEO_RETRO_THEME, NeoRetroTheme))
#define NEO_RETRO_THEME_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_NEO_RETRO_THEME, NeoRetroThemeClass))
#define IS_NEO_RETRO_THEME(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_NEO_RETRO_THEME))
#define IS_NEO_RETRO_THEME_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_NEO_RETRO_THEME))
#define NEO_RETRO_THEME_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_NEO_RETRO_THEME, NeoRetroThemeClass))

typedef struct _NeoRetroTheme NeoRetroTheme;
typedef struct _NeoRetroThemeClass NeoRetroThemeClass;

#define TYPE_NOSTALGIA_THEME (nostalgia_theme_get_type ())
#define NOSTALGIA_THEME(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_NOSTALGIA_THEME, NostalgiaTheme))
#define NOSTALGIA_THEME_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_NOSTALGIA_THEME, NostalgiaThemeClass))
#define IS_NOSTALGIA_THEME(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_NOSTALGIA_THEME))
#define IS_NOSTALGIA_THEME_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_NOSTALGIA_THEME))
#define NOSTALGIA_THEME_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_NOSTALGIA_THEME, NostalgiaThemeClass))

typedef struct _NostalgiaTheme NostalgiaTheme;
typedef struct _NostalgiaThemeClass NostalgiaThemeClass;

#define TYPE_SYNESTHESIA_THEME (synesthesia_theme_get_type ())
#define SYNESTHESIA_THEME(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SYNESTHESIA_THEME, SynesthesiaTheme))
#define SYNESTHESIA_THEME_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SYNESTHESIA_THEME, SynesthesiaThemeClass))
#define IS_SYNESTHESIA_THEME(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SYNESTHESIA_THEME))
#define IS_SYNESTHESIA_THEME_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SYNESTHESIA_THEME))
#define SYNESTHESIA_THEME_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SYNESTHESIA_THEME, SynesthesiaThemeClass))

typedef struct _SynesthesiaTheme SynesthesiaTheme;
typedef struct _SynesthesiaThemeClass SynesthesiaThemeClass;

#define TYPE_EXTRUSION_THEME (extrusion_theme_get_type ())
#define EXTRUSION_THEME(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_EXTRUSION_THEME, ExtrusionTheme))
#define EXTRUSION_THEME_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_EXTRUSION_THEME, ExtrusionThemeClass))
#define IS_EXTRUSION_THEME(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_EXTRUSION_THEME))
#define IS_EXTRUSION_THEME_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_EXTRUSION_THEME))
#define EXTRUSION_THEME_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_EXTRUSION_THEME, ExtrusionThemeClass))

typedef struct _ExtrusionTheme ExtrusionTheme;
typedef struct _ExtrusionThemeClass ExtrusionThemeClass;
enum  {
	PUZZLE_VIEW_TILE_IMAGE_0_PROPERTY,
	PUZZLE_VIEW_TILE_IMAGE_NUM_PROPERTIES
};
static GParamSpec* puzzle_view_tile_image_properties[PUZZLE_VIEW_TILE_IMAGE_NUM_PROPERTIES];

struct _Theme {
	GObject parent_instance;
	ThemePrivate * priv;
};

struct _ThemeClass {
	GObjectClass parent_class;
	void (*configure) (Theme* self, guint size);
	void (*draw_arrow) (Theme* self, cairo_t* context);
	void (*draw_socket) (Theme* self, cairo_t* context);
	void (*draw_highlight) (Theme* self, cairo_t* context, gboolean has_tile);
	void (*draw_paused_tile) (Theme* self, cairo_t* context);
	void (*draw_tile) (Theme* self, cairo_t* context, Tile* tile, gboolean highlight);
	void (*set_animation_level) (Theme* self, guint8 animation_level);
};

struct _ThemePrivate {
	gint _overdraw_top;
	gint _overdraw_left;
	gint _overdraw_right;
	gint _overdraw_bottom;
};

struct _PuzzleView {
	GtkDrawingArea parent_instance;
	PuzzleViewPrivate * priv;
};

struct _PuzzleViewClass {
	GtkDrawingAreaClass parent_class;
};

struct _PuzzleViewPrivate {
	Puzzle* _puzzle;
	gboolean puzzle_init_done;
	Theme* theme;
	PuzzleViewTileImage* selected_tile;
	PuzzleViewTileImage* last_selected_tile;
	gboolean _tile_selected;
	guint selection_timeout;
	gdouble selected_x_offset;
	gdouble selected_y_offset;
	GHashTable* tiles;
	GTimer* animation_timer;
	guint animation_timeout;
	guint _boardsize;
	gdouble _x_offset_right;
	gdouble _y_offset;
	gdouble _right_margin;
	gdouble x_offset;
	guint tilesize;
	guint gap;
	gdouble arrow_x;
	gdouble arrow_local_y;
	gdouble* sockets_xs;
	gint sockets_xs_length1;
	gint sockets_xs_length2;
	gdouble* sockets_ys;
	gint sockets_ys_length1;
	gint sockets_ys_length2;
	gint board_x_maxi;
	gint board_y_maxi;
	gdouble snap_distance;
	guint render_size;
	cairo_pattern_t* arrow_pattern;
	cairo_pattern_t* socket_pattern;
	GtkEventControllerMotion* motion_controller;
	GtkGestureMultiPress* click_controller;
	gboolean _mouse_use_extra_buttons;
	gint _mouse_back_button;
	gint _mouse_forward_button;
	guint8 socket_animation_level;
	guint socket_timeout_id;
	GtkEventControllerKey* key_controller;
	gboolean show_highlight;
	gboolean highlight_set;
	guint8 highlight_x;
	guint8 highlight_y;
	guint8 old_highlight_x;
	guint8 old_highlight_y;
	gboolean tile_selection;
	guint8 kbd_selected_x;
	guint8 kbd_selected_y;
};

struct _PuzzleViewTileImage {
	GObject parent_instance;
	PuzzleViewTileImagePrivate * priv;
	Tile* tile;
	gdouble x;
	gdouble y;
	gdouble source_x;
	gdouble source_y;
	gdouble source_time;
	gdouble target_x;
	gdouble target_y;
	gdouble duration;
	gboolean snap_to_cursor;
};

struct _PuzzleViewTileImageClass {
	GObjectClass parent_class;
};

static gint Theme_private_offset;
static gpointer theme_parent_class = NULL;
static gint PuzzleView_private_offset;
static gpointer puzzle_view_parent_class = NULL;
static gpointer puzzle_view_tile_image_parent_class = NULL;

VALA_EXTERN GType theme_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Theme, g_object_unref)
VALA_EXTERN GType tile_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Tile, g_object_unref)
VALA_EXTERN void theme_configure (Theme* self,
                      guint size);
VALA_EXTERN void theme_draw_arrow (Theme* self,
                       cairo_t* context);
VALA_EXTERN void theme_draw_socket (Theme* self,
                        cairo_t* context);
VALA_EXTERN void theme_draw_highlight (Theme* self,
                           cairo_t* context,
                           gboolean has_tile);
VALA_EXTERN void theme_draw_paused_tile (Theme* self,
                             cairo_t* context);
VALA_EXTERN void theme_draw_tile (Theme* self,
                      cairo_t* context,
                      Tile* tile,
                      gboolean highlight);
VALA_EXTERN void theme_set_animation_level (Theme* self,
                                guint8 animation_level);
static void theme_real_configure (Theme* self,
                           guint size);
static void theme_real_draw_arrow (Theme* self,
                            cairo_t* context);
static void theme_real_draw_socket (Theme* self,
                             cairo_t* context);
static void theme_real_draw_highlight (Theme* self,
                                cairo_t* context,
                                gboolean has_tile);
static void theme_real_draw_paused_tile (Theme* self,
                                  cairo_t* context);
static void theme_real_draw_tile (Theme* self,
                           cairo_t* context,
                           Tile* tile,
                           gboolean highlight);
static void theme_real_set_animation_level (Theme* self,
                                     guint8 animation_level);
VALA_EXTERN Theme* theme_construct (GType object_type);
VALA_EXTERN gint theme_get_overdraw_top (Theme* self);
VALA_EXTERN void theme_set_overdraw_top (Theme* self,
                             gint value);
VALA_EXTERN gint theme_get_overdraw_left (Theme* self);
VALA_EXTERN void theme_set_overdraw_left (Theme* self,
                              gint value);
VALA_EXTERN gint theme_get_overdraw_right (Theme* self);
VALA_EXTERN void theme_set_overdraw_right (Theme* self,
                               gint value);
VALA_EXTERN gint theme_get_overdraw_bottom (Theme* self);
VALA_EXTERN void theme_set_overdraw_bottom (Theme* self,
                                gint value);
static void theme_finalize (GObject * obj);
static GType theme_get_type_once (void);
static void _vala_theme_get_property (GObject * object,
                               guint property_id,
                               GValue * value,
                               GParamSpec * pspec);
static void _vala_theme_set_property (GObject * object,
                               guint property_id,
                               const GValue * value,
                               GParamSpec * pspec);
VALA_EXTERN GType puzzle_view_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (PuzzleView, g_object_unref)
VALA_EXTERN GType puzzle_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Puzzle, g_object_unref)
static GType puzzle_view_tile_image_get_type (void) G_GNUC_CONST  G_GNUC_UNUSED ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (PuzzleViewTileImage, g_object_unref)
static void _g_object_unref0_ (gpointer var);
static void puzzle_view_redraw_tile (PuzzleView* self,
                              PuzzleViewTileImage* image);
static void puzzle_view_queue_draw_tile (PuzzleView* self,
                                  guint8 x,
                                  guint8 y);
static void puzzle_view_move_tile_to_location (PuzzleView* self,
                                        PuzzleViewTileImage* image,
                                        guint x,
                                        guint y,
                                        gdouble duration);
static Puzzle* puzzle_view_get_puzzle (PuzzleView* self);
VALA_EXTERN guint8 puzzle_get_size (Puzzle* self);
VALA_EXTERN gdouble puzzle_view_get_y_offset (PuzzleView* self);
static void puzzle_view_move_tile (PuzzleView* self,
                            PuzzleViewTileImage* image,
                            gdouble x,
                            gdouble y,
                            gdouble duration);
static gboolean puzzle_view_animate_cb (PuzzleView* self);
static gboolean _puzzle_view_animate_cb_gsource_func (gpointer self);
static void puzzle_view_real_get_preferred_width (GtkWidget* base,
                                           gint* minimum,
                                           gint* natural);
static void puzzle_view_real_get_preferred_height (GtkWidget* base,
                                            gint* minimum,
                                            gint* natural);
static void puzzle_view_tile_moved_cb (PuzzleView* self,
                                Puzzle* puzzle,
                                Tile* tile,
                                guint8 x,
                                guint8 y);
static gboolean puzzle_view_real_configure_event (GtkWidget* base,
                                           GdkEventConfigure* event);
static void puzzle_view_set_boardsize (PuzzleView* self,
                                guint value);
VALA_EXTERN guint puzzle_view_get_boardsize (PuzzleView* self);
static void puzzle_view_set_y_offset (PuzzleView* self,
                               gdouble value);
static void puzzle_view_set_x_offset_right (PuzzleView* self,
                                     gdouble value);
VALA_EXTERN gdouble puzzle_view_get_x_offset_right (PuzzleView* self);
static void puzzle_view_set_right_margin (PuzzleView* self,
                                   gdouble value);
VALA_EXTERN void puzzle_get_tile_location (Puzzle* self,
                               Tile* tile,
                               guint8* x,
                               guint8* y);
static void puzzle_view_set_tile_selected (PuzzleView* self,
                                    gboolean value);
static inline void puzzle_view_init_patterns (PuzzleView* self,
                                cairo_t* context);
static gboolean puzzle_view_real_draw (GtkWidget* base,
                                cairo_t* context);
static void puzzle_view_draw_image (PuzzleView* self,
                             cairo_t* context,
                             PuzzleViewTileImage* image);
VALA_EXTERN gboolean puzzle_get_is_solved (Puzzle* self);
VALA_EXTERN Tile* puzzle_get_tile (Puzzle* self,
                       guint8 x,
                       guint8 y);
VALA_EXTERN gboolean puzzle_get_paused (Puzzle* self);
static inline void puzzle_view_draw_pause_overlay (PuzzleView* self,
                                     cairo_t* context);
static inline void _g_slist_free__g_object_unref0_ (GSList* self);
static void puzzle_view_pick_tile (PuzzleView* self,
                            gdouble x,
                            gdouble y);
static gboolean puzzle_view_selection_timeout_cb (PuzzleView* self);
static gboolean _puzzle_view_selection_timeout_cb_gsource_func (gpointer self);
VALA_EXTERN gboolean puzzle_view_get_tile_selected (PuzzleView* self);
static inline gboolean puzzle_view_get_tile_coords (PuzzleView* self,
                                      gdouble event_x,
                                      gdouble event_y,
                                      guint8* tile_x,
                                      guint8* tile_y);
VALA_EXTERN void puzzle_try_move (Puzzle* self,
                      guint8 x,
                      guint8 y);
static inline gboolean puzzle_view_get_tile_coord_x (PuzzleView* self,
                                       gdouble event_x,
                                       guint8* tile_x);
static inline gboolean puzzle_view_get_tile_coord_y (PuzzleView* self,
                                       gdouble event_y,
                                       guint8* tile_y);
static gboolean puzzle_view_on_right_half (PuzzleView* self,
                                    gdouble x);
static void puzzle_view_drop_tile (PuzzleView* self,
                            gdouble x,
                            gdouble y);
VALA_EXTERN gboolean puzzle_can_switch (Puzzle* self,
                            guint8 x0,
                            guint8 y0,
                            guint8 x1,
                            guint8 y1);
VALA_EXTERN void puzzle_switch_tiles (Puzzle* self,
                          guint8 x0,
                          guint8 y0,
                          guint8 x1,
                          guint8 y1,
                          guint delay_if_finished);
static void puzzle_view_move_tile_to_right_half (PuzzleView* self,
                                          Tile* tile);
static void puzzle_view_init_mouse (PuzzleView* self);
static inline void puzzle_view_on_motion (PuzzleView* self,
                            GtkEventControllerMotion* _motion_controller,
                            gdouble event_x,
                            gdouble event_y);
static void _puzzle_view_on_motion_gtk_event_controller_motion_motion (GtkEventControllerMotion* _sender,
                                                                gdouble x,
                                                                gdouble y,
                                                                gpointer self);
static inline void puzzle_view_on_click (PuzzleView* self,
                           GtkGestureMultiPress* _click_controller,
                           gint n_press,
                           gdouble event_x,
                           gdouble event_y);
static void _puzzle_view_on_click_gtk_gesture_multi_press_pressed (GtkGestureMultiPress* _sender,
                                                            gint n_press,
                                                            gdouble x,
                                                            gdouble y,
                                                            gpointer self);
static inline void puzzle_view_on_release (PuzzleView* self,
                             GtkGestureMultiPress* _click_controller,
                             gint n_press,
                             gdouble event_x,
                             gdouble event_y);
static void _puzzle_view_on_release_gtk_gesture_multi_press_released (GtkGestureMultiPress* _sender,
                                                               gint n_press,
                                                               gdouble x,
                                                               gdouble y,
                                                               gpointer self);
static void puzzle_view_clear_keyboard_highlight (PuzzleView* self,
                                           gboolean only_selection);
static inline void puzzle_view_main_button_pressed (PuzzleView* self,
                                      gint n_press,
                                      gdouble event_x,
                                      gdouble event_y);
static gboolean puzzle_view_get_mouse_use_extra_buttons (PuzzleView* self);
static gint puzzle_view_get_mouse_back_button (PuzzleView* self);
VALA_EXTERN void puzzle_view_undo (PuzzleView* self);
static gint puzzle_view_get_mouse_forward_button (PuzzleView* self);
VALA_EXTERN void puzzle_view_redo (PuzzleView* self);
VALA_EXTERN gboolean puzzle_only_one_remaining_tile (Puzzle* self,
                                         guint8* empty_x,
                                         guint8* empty_y);
static gboolean puzzle_view_real_leave_notify_event (GtkWidget* base,
                                              GdkEventCrossing* event);
static gboolean puzzle_view_real_enter_notify_event (GtkWidget* base,
                                              GdkEventCrossing* event);
VALA_EXTERN void puzzle_view_finish (PuzzleView* self);
VALA_EXTERN void puzzle_finish (Puzzle* self,
                    guint duration);
VALA_EXTERN void puzzle_view_release_selected_tile (PuzzleView* self);
VALA_EXTERN void puzzle_undo (Puzzle* self);
VALA_EXTERN void puzzle_redo (Puzzle* self);
VALA_EXTERN void puzzle_view_reload (PuzzleView* self);
VALA_EXTERN void puzzle_reload (Puzzle* self);
VALA_EXTERN void puzzle_view_hide_right_sockets (PuzzleView* self);
static gboolean __lambda6_ (PuzzleView* self);
static gboolean ___lambda6__gsource_func (gpointer self);
static inline void puzzle_view_show_right_sockets (PuzzleView* self);
static void puzzle_view_init_keyboard (PuzzleView* self);
static inline gboolean puzzle_view_on_key_pressed (PuzzleView* self,
                                     GtkEventControllerKey* _key_controller,
                                     guint keyval,
                                     guint keycode,
                                     GdkModifierType state);
static gboolean _puzzle_view_on_key_pressed_gtk_event_controller_key_key_pressed (GtkEventControllerKey* _sender,
                                                                           guint keyval,
                                                                           guint keycode,
                                                                           GdkModifierType state,
                                                                           gpointer self);
static void puzzle_view_set_highlight_position_if_needed (PuzzleView* self);
static void puzzle_view_set_highlight_position (PuzzleView* self);
VALA_EXTERN void puzzle_view_disable_highlight (PuzzleView* self);
VALA_EXTERN void puzzle_view_move_up (PuzzleView* self,
                          gboolean left_board);
VALA_EXTERN gboolean puzzle_move_up (Puzzle* self,
                         gboolean left_board);
VALA_EXTERN void puzzle_view_move_down (PuzzleView* self,
                            gboolean left_board);
VALA_EXTERN gboolean puzzle_move_down (Puzzle* self,
                           gboolean left_board);
VALA_EXTERN void puzzle_view_move_left (PuzzleView* self,
                            gboolean left_board);
VALA_EXTERN gboolean puzzle_move_left (Puzzle* self,
                           gboolean left_board);
VALA_EXTERN void puzzle_view_move_right (PuzzleView* self,
                             gboolean left_board);
VALA_EXTERN gboolean puzzle_move_right (Puzzle* self,
                            gboolean left_board);
VALA_EXTERN PuzzleView* puzzle_view_new (void);
VALA_EXTERN PuzzleView* puzzle_view_construct (GType object_type);
VALA_EXTERN void puzzle_view_set_puzzle (PuzzleView* self,
                             Puzzle* value);
static PuzzleViewTileImage* puzzle_view_tile_image_new (Tile* tile);
static PuzzleViewTileImage* puzzle_view_tile_image_construct (GType object_type,
                                                       Tile* tile);
static void _puzzle_view_puzzle___lambda5_ (PuzzleView* self);
static void __puzzle_view_puzzle___lambda5__puzzle_solved (Puzzle* _sender,
                                                    gpointer self);
static void _puzzle_view_tile_moved_cb_puzzle_tile_moved (Puzzle* _sender,
                                                   Tile* tile,
                                                   guint8 x,
                                                   guint8 y,
                                                   gpointer self);
static void _gtk_widget_queue_draw_g_object_notify (GObject* _sender,
                                             GParamSpec* pspec,
                                             gpointer self);
VALA_EXTERN void puzzle_view_set_theme_id (PuzzleView* self,
                               const gchar* value);
VALA_EXTERN NeoRetroTheme* neo_retro_theme_new (void);
VALA_EXTERN NeoRetroTheme* neo_retro_theme_construct (GType object_type);
VALA_EXTERN GType neo_retro_theme_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (NeoRetroTheme, g_object_unref)
VALA_EXTERN NostalgiaTheme* nostalgia_theme_new (void);
VALA_EXTERN NostalgiaTheme* nostalgia_theme_construct (GType object_type);
VALA_EXTERN GType nostalgia_theme_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (NostalgiaTheme, g_object_unref)
VALA_EXTERN SynesthesiaTheme* synesthesia_theme_new (void);
VALA_EXTERN SynesthesiaTheme* synesthesia_theme_construct (GType object_type);
VALA_EXTERN GType synesthesia_theme_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (SynesthesiaTheme, g_object_unref)
VALA_EXTERN ExtrusionTheme* extrusion_theme_new (void);
VALA_EXTERN ExtrusionTheme* extrusion_theme_construct (GType object_type);
VALA_EXTERN GType extrusion_theme_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (ExtrusionTheme, g_object_unref)
VALA_EXTERN gdouble puzzle_view_get_right_margin (PuzzleView* self);
VALA_EXTERN void puzzle_view_set_mouse_use_extra_buttons (PuzzleView* self,
                                              gboolean value);
VALA_EXTERN void puzzle_view_set_mouse_back_button (PuzzleView* self,
                                        gint value);
VALA_EXTERN void puzzle_view_set_mouse_forward_button (PuzzleView* self,
                                           gint value);
static void puzzle_view_tile_image_finalize (GObject * obj);
static GType puzzle_view_tile_image_get_type_once (void);
static GObject * puzzle_view_constructor (GType type,
                                   guint n_construct_properties,
                                   GObjectConstructParam * construct_properties);
static void puzzle_view_finalize (GObject * obj);
static GType puzzle_view_get_type_once (void);
static void _vala_puzzle_view_get_property (GObject * object,
                                     guint property_id,
                                     GValue * value,
                                     GParamSpec * pspec);
static void _vala_puzzle_view_set_property (GObject * object,
                                     guint property_id,
                                     const GValue * value,
                                     GParamSpec * pspec);

static inline gpointer
theme_get_instance_private (Theme* self)
{
	return G_STRUCT_MEMBER_P (self, Theme_private_offset);
}

static void
theme_real_configure (Theme* self,
                      guint size)
{
#line 30 "../src/puzzle-view.vala"
	g_critical ("Type `%s' does not implement abstract method `theme_configure'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 30 "../src/puzzle-view.vala"
	return;
#line 623 "puzzle-view.c"
}

void
theme_configure (Theme* self,
                 guint size)
{
	ThemeClass* _klass_;
#line 30 "../src/puzzle-view.vala"
	g_return_if_fail (self != NULL);
#line 30 "../src/puzzle-view.vala"
	_klass_ = THEME_GET_CLASS (self);
#line 30 "../src/puzzle-view.vala"
	if (_klass_->configure) {
#line 30 "../src/puzzle-view.vala"
		_klass_->configure (self, size);
#line 639 "puzzle-view.c"
	}
}

static void
theme_real_draw_arrow (Theme* self,
                       cairo_t* context)
{
#line 31 "../src/puzzle-view.vala"
	g_critical ("Type `%s' does not implement abstract method `theme_draw_arrow'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 31 "../src/puzzle-view.vala"
	return;
#line 651 "puzzle-view.c"
}

void
theme_draw_arrow (Theme* self,
                  cairo_t* context)
{
	ThemeClass* _klass_;
#line 31 "../src/puzzle-view.vala"
	g_return_if_fail (self != NULL);
#line 31 "../src/puzzle-view.vala"
	_klass_ = THEME_GET_CLASS (self);
#line 31 "../src/puzzle-view.vala"
	if (_klass_->draw_arrow) {
#line 31 "../src/puzzle-view.vala"
		_klass_->draw_arrow (self, context);
#line 667 "puzzle-view.c"
	}
}

static void
theme_real_draw_socket (Theme* self,
                        cairo_t* context)
{
#line 32 "../src/puzzle-view.vala"
	g_critical ("Type `%s' does not implement abstract method `theme_draw_socket'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 32 "../src/puzzle-view.vala"
	return;
#line 679 "puzzle-view.c"
}

void
theme_draw_socket (Theme* self,
                   cairo_t* context)
{
	ThemeClass* _klass_;
#line 32 "../src/puzzle-view.vala"
	g_return_if_fail (self != NULL);
#line 32 "../src/puzzle-view.vala"
	_klass_ = THEME_GET_CLASS (self);
#line 32 "../src/puzzle-view.vala"
	if (_klass_->draw_socket) {
#line 32 "../src/puzzle-view.vala"
		_klass_->draw_socket (self, context);
#line 695 "puzzle-view.c"
	}
}

static void
theme_real_draw_highlight (Theme* self,
                           cairo_t* context,
                           gboolean has_tile)
{
#line 33 "../src/puzzle-view.vala"
	g_critical ("Type `%s' does not implement abstract method `theme_draw_highlight'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 33 "../src/puzzle-view.vala"
	return;
#line 708 "puzzle-view.c"
}

void
theme_draw_highlight (Theme* self,
                      cairo_t* context,
                      gboolean has_tile)
{
	ThemeClass* _klass_;
#line 33 "../src/puzzle-view.vala"
	g_return_if_fail (self != NULL);
#line 33 "../src/puzzle-view.vala"
	_klass_ = THEME_GET_CLASS (self);
#line 33 "../src/puzzle-view.vala"
	if (_klass_->draw_highlight) {
#line 33 "../src/puzzle-view.vala"
		_klass_->draw_highlight (self, context, has_tile);
#line 725 "puzzle-view.c"
	}
}

static void
theme_real_draw_paused_tile (Theme* self,
                             cairo_t* context)
{
#line 34 "../src/puzzle-view.vala"
	g_critical ("Type `%s' does not implement abstract method `theme_draw_paused_tile'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 34 "../src/puzzle-view.vala"
	return;
#line 737 "puzzle-view.c"
}

void
theme_draw_paused_tile (Theme* self,
                        cairo_t* context)
{
	ThemeClass* _klass_;
#line 34 "../src/puzzle-view.vala"
	g_return_if_fail (self != NULL);
#line 34 "../src/puzzle-view.vala"
	_klass_ = THEME_GET_CLASS (self);
#line 34 "../src/puzzle-view.vala"
	if (_klass_->draw_paused_tile) {
#line 34 "../src/puzzle-view.vala"
		_klass_->draw_paused_tile (self, context);
#line 753 "puzzle-view.c"
	}
}

static void
theme_real_draw_tile (Theme* self,
                      cairo_t* context,
                      Tile* tile,
                      gboolean highlight)
{
#line 35 "../src/puzzle-view.vala"
	g_critical ("Type `%s' does not implement abstract method `theme_draw_tile'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 35 "../src/puzzle-view.vala"
	return;
#line 767 "puzzle-view.c"
}

void
theme_draw_tile (Theme* self,
                 cairo_t* context,
                 Tile* tile,
                 gboolean highlight)
{
	ThemeClass* _klass_;
#line 35 "../src/puzzle-view.vala"
	g_return_if_fail (self != NULL);
#line 35 "../src/puzzle-view.vala"
	_klass_ = THEME_GET_CLASS (self);
#line 35 "../src/puzzle-view.vala"
	if (_klass_->draw_tile) {
#line 35 "../src/puzzle-view.vala"
		_klass_->draw_tile (self, context, tile, highlight);
#line 785 "puzzle-view.c"
	}
}

static void
theme_real_set_animation_level (Theme* self,
                                guint8 animation_level)
{
#line 36 "../src/puzzle-view.vala"
	g_critical ("Type `%s' does not implement abstract method `theme_set_animation_level'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 36 "../src/puzzle-view.vala"
	return;
#line 797 "puzzle-view.c"
}

void
theme_set_animation_level (Theme* self,
                           guint8 animation_level)
{
	ThemeClass* _klass_;
#line 36 "../src/puzzle-view.vala"
	g_return_if_fail (self != NULL);
#line 36 "../src/puzzle-view.vala"
	_klass_ = THEME_GET_CLASS (self);
#line 36 "../src/puzzle-view.vala"
	if (_klass_->set_animation_level) {
#line 36 "../src/puzzle-view.vala"
		_klass_->set_animation_level (self, animation_level);
#line 813 "puzzle-view.c"
	}
}

Theme*
theme_construct (GType object_type)
{
	Theme * self = NULL;
#line 22 "../src/puzzle-view.vala"
	self = (Theme*) g_object_new (object_type, NULL);
#line 22 "../src/puzzle-view.vala"
	return self;
#line 825 "puzzle-view.c"
}

gint
theme_get_overdraw_top (Theme* self)
{
	gint result;
#line 25 "../src/puzzle-view.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 25 "../src/puzzle-view.vala"
	result = self->priv->_overdraw_top;
#line 25 "../src/puzzle-view.vala"
	return result;
#line 838 "puzzle-view.c"
}

void
theme_set_overdraw_top (Theme* self,
                        gint value)
{
	gint old_value;
#line 25 "../src/puzzle-view.vala"
	g_return_if_fail (self != NULL);
#line 25 "../src/puzzle-view.vala"
	old_value = theme_get_overdraw_top (self);
#line 25 "../src/puzzle-view.vala"
	if (old_value != value) {
#line 25 "../src/puzzle-view.vala"
		self->priv->_overdraw_top = value;
#line 25 "../src/puzzle-view.vala"
		g_object_notify_by_pspec ((GObject *) self, theme_properties[THEME_OVERDRAW_TOP_PROPERTY]);
#line 856 "puzzle-view.c"
	}
}

gint
theme_get_overdraw_left (Theme* self)
{
	gint result;
#line 26 "../src/puzzle-view.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 26 "../src/puzzle-view.vala"
	result = self->priv->_overdraw_left;
#line 26 "../src/puzzle-view.vala"
	return result;
#line 870 "puzzle-view.c"
}

void
theme_set_overdraw_left (Theme* self,
                         gint value)
{
	gint old_value;
#line 26 "../src/puzzle-view.vala"
	g_return_if_fail (self != NULL);
#line 26 "../src/puzzle-view.vala"
	old_value = theme_get_overdraw_left (self);
#line 26 "../src/puzzle-view.vala"
	if (old_value != value) {
#line 26 "../src/puzzle-view.vala"
		self->priv->_overdraw_left = value;
#line 26 "../src/puzzle-view.vala"
		g_object_notify_by_pspec ((GObject *) self, theme_properties[THEME_OVERDRAW_LEFT_PROPERTY]);
#line 888 "puzzle-view.c"
	}
}

gint
theme_get_overdraw_right (Theme* self)
{
	gint result;
#line 27 "../src/puzzle-view.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 27 "../src/puzzle-view.vala"
	result = self->priv->_overdraw_right;
#line 27 "../src/puzzle-view.vala"
	return result;
#line 902 "puzzle-view.c"
}

void
theme_set_overdraw_right (Theme* self,
                          gint value)
{
	gint old_value;
#line 27 "../src/puzzle-view.vala"
	g_return_if_fail (self != NULL);
#line 27 "../src/puzzle-view.vala"
	old_value = theme_get_overdraw_right (self);
#line 27 "../src/puzzle-view.vala"
	if (old_value != value) {
#line 27 "../src/puzzle-view.vala"
		self->priv->_overdraw_right = value;
#line 27 "../src/puzzle-view.vala"
		g_object_notify_by_pspec ((GObject *) self, theme_properties[THEME_OVERDRAW_RIGHT_PROPERTY]);
#line 920 "puzzle-view.c"
	}
}

gint
theme_get_overdraw_bottom (Theme* self)
{
	gint result;
#line 28 "../src/puzzle-view.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 28 "../src/puzzle-view.vala"
	result = self->priv->_overdraw_bottom;
#line 28 "../src/puzzle-view.vala"
	return result;
#line 934 "puzzle-view.c"
}

void
theme_set_overdraw_bottom (Theme* self,
                           gint value)
{
	gint old_value;
#line 28 "../src/puzzle-view.vala"
	g_return_if_fail (self != NULL);
#line 28 "../src/puzzle-view.vala"
	old_value = theme_get_overdraw_bottom (self);
#line 28 "../src/puzzle-view.vala"
	if (old_value != value) {
#line 28 "../src/puzzle-view.vala"
		self->priv->_overdraw_bottom = value;
#line 28 "../src/puzzle-view.vala"
		g_object_notify_by_pspec ((GObject *) self, theme_properties[THEME_OVERDRAW_BOTTOM_PROPERTY]);
#line 952 "puzzle-view.c"
	}
}

static void
theme_class_init (ThemeClass * klass,
                  gpointer klass_data)
{
#line 22 "../src/puzzle-view.vala"
	theme_parent_class = g_type_class_peek_parent (klass);
#line 22 "../src/puzzle-view.vala"
	g_type_class_adjust_private_offset (klass, &Theme_private_offset);
#line 22 "../src/puzzle-view.vala"
	((ThemeClass *) klass)->configure = (void (*) (Theme*, guint)) theme_real_configure;
#line 22 "../src/puzzle-view.vala"
	((ThemeClass *) klass)->draw_arrow = (void (*) (Theme*, cairo_t*)) theme_real_draw_arrow;
#line 22 "../src/puzzle-view.vala"
	((ThemeClass *) klass)->draw_socket = (void (*) (Theme*, cairo_t*)) theme_real_draw_socket;
#line 22 "../src/puzzle-view.vala"
	((ThemeClass *) klass)->draw_highlight = (void (*) (Theme*, cairo_t*, gboolean)) theme_real_draw_highlight;
#line 22 "../src/puzzle-view.vala"
	((ThemeClass *) klass)->draw_paused_tile = (void (*) (Theme*, cairo_t*)) theme_real_draw_paused_tile;
#line 22 "../src/puzzle-view.vala"
	((ThemeClass *) klass)->draw_tile = (void (*) (Theme*, cairo_t*, Tile*, gboolean)) theme_real_draw_tile;
#line 22 "../src/puzzle-view.vala"
	((ThemeClass *) klass)->set_animation_level = (void (*) (Theme*, guint8)) theme_real_set_animation_level;
#line 22 "../src/puzzle-view.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_theme_get_property;
#line 22 "../src/puzzle-view.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_theme_set_property;
#line 22 "../src/puzzle-view.vala"
	G_OBJECT_CLASS (klass)->finalize = theme_finalize;
#line 22 "../src/puzzle-view.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), THEME_OVERDRAW_TOP_PROPERTY, theme_properties[THEME_OVERDRAW_TOP_PROPERTY] = g_param_spec_int ("overdraw-top", "overdraw-top", "overdraw-top", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 22 "../src/puzzle-view.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), THEME_OVERDRAW_LEFT_PROPERTY, theme_properties[THEME_OVERDRAW_LEFT_PROPERTY] = g_param_spec_int ("overdraw-left", "overdraw-left", "overdraw-left", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 22 "../src/puzzle-view.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), THEME_OVERDRAW_RIGHT_PROPERTY, theme_properties[THEME_OVERDRAW_RIGHT_PROPERTY] = g_param_spec_int ("overdraw-right", "overdraw-right", "overdraw-right", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 22 "../src/puzzle-view.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), THEME_OVERDRAW_BOTTOM_PROPERTY, theme_properties[THEME_OVERDRAW_BOTTOM_PROPERTY] = g_param_spec_int ("overdraw-bottom", "overdraw-bottom", "overdraw-bottom", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 992 "puzzle-view.c"
}

static void
theme_instance_init (Theme * self,
                     gpointer klass)
{
#line 22 "../src/puzzle-view.vala"
	self->priv = theme_get_instance_private (self);
#line 25 "../src/puzzle-view.vala"
	self->priv->_overdraw_top = 0;
#line 26 "../src/puzzle-view.vala"
	self->priv->_overdraw_left = 0;
#line 27 "../src/puzzle-view.vala"
	self->priv->_overdraw_right = 0;
#line 28 "../src/puzzle-view.vala"
	self->priv->_overdraw_bottom = 0;
#line 1009 "puzzle-view.c"
}

static void
theme_finalize (GObject * obj)
{
	Theme * self;
#line 22 "../src/puzzle-view.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_THEME, Theme);
#line 22 "../src/puzzle-view.vala"
	G_OBJECT_CLASS (theme_parent_class)->finalize (obj);
#line 1020 "puzzle-view.c"
}

static GType
theme_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (ThemeClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) theme_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Theme), 0, (GInstanceInitFunc) theme_instance_init, NULL };
	GType theme_type_id;
	theme_type_id = g_type_register_static (G_TYPE_OBJECT, "Theme", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
	Theme_private_offset = g_type_add_instance_private (theme_type_id, sizeof (ThemePrivate));
	return theme_type_id;
}

GType
theme_get_type (void)
{
	static volatile gsize theme_type_id__once = 0;
	if (g_once_init_enter (&theme_type_id__once)) {
		GType theme_type_id;
		theme_type_id = theme_get_type_once ();
		g_once_init_leave (&theme_type_id__once, theme_type_id);
	}
	return theme_type_id__once;
}

static void
_vala_theme_get_property (GObject * object,
                          guint property_id,
                          GValue * value,
                          GParamSpec * pspec)
{
	Theme * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_THEME, Theme);
#line 22 "../src/puzzle-view.vala"
	switch (property_id) {
#line 22 "../src/puzzle-view.vala"
		case THEME_OVERDRAW_TOP_PROPERTY:
#line 22 "../src/puzzle-view.vala"
		g_value_set_int (value, theme_get_overdraw_top (self));
#line 22 "../src/puzzle-view.vala"
		break;
#line 22 "../src/puzzle-view.vala"
		case THEME_OVERDRAW_LEFT_PROPERTY:
#line 22 "../src/puzzle-view.vala"
		g_value_set_int (value, theme_get_overdraw_left (self));
#line 22 "../src/puzzle-view.vala"
		break;
#line 22 "../src/puzzle-view.vala"
		case THEME_OVERDRAW_RIGHT_PROPERTY:
#line 22 "../src/puzzle-view.vala"
		g_value_set_int (value, theme_get_overdraw_right (self));
#line 22 "../src/puzzle-view.vala"
		break;
#line 22 "../src/puzzle-view.vala"
		case THEME_OVERDRAW_BOTTOM_PROPERTY:
#line 22 "../src/puzzle-view.vala"
		g_value_set_int (value, theme_get_overdraw_bottom (self));
#line 22 "../src/puzzle-view.vala"
		break;
#line 1079 "puzzle-view.c"
		default:
#line 22 "../src/puzzle-view.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 22 "../src/puzzle-view.vala"
		break;
#line 1085 "puzzle-view.c"
	}
}

static void
_vala_theme_set_property (GObject * object,
                          guint property_id,
                          const GValue * value,
                          GParamSpec * pspec)
{
	Theme * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_THEME, Theme);
#line 22 "../src/puzzle-view.vala"
	switch (property_id) {
#line 22 "../src/puzzle-view.vala"
		case THEME_OVERDRAW_TOP_PROPERTY:
#line 22 "../src/puzzle-view.vala"
		theme_set_overdraw_top (self, g_value_get_int (value));
#line 22 "../src/puzzle-view.vala"
		break;
#line 22 "../src/puzzle-view.vala"
		case THEME_OVERDRAW_LEFT_PROPERTY:
#line 22 "../src/puzzle-view.vala"
		theme_set_overdraw_left (self, g_value_get_int (value));
#line 22 "../src/puzzle-view.vala"
		break;
#line 22 "../src/puzzle-view.vala"
		case THEME_OVERDRAW_RIGHT_PROPERTY:
#line 22 "../src/puzzle-view.vala"
		theme_set_overdraw_right (self, g_value_get_int (value));
#line 22 "../src/puzzle-view.vala"
		break;
#line 22 "../src/puzzle-view.vala"
		case THEME_OVERDRAW_BOTTOM_PROPERTY:
#line 22 "../src/puzzle-view.vala"
		theme_set_overdraw_bottom (self, g_value_get_int (value));
#line 22 "../src/puzzle-view.vala"
		break;
#line 1123 "puzzle-view.c"
		default:
#line 22 "../src/puzzle-view.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 22 "../src/puzzle-view.vala"
		break;
#line 1129 "puzzle-view.c"
	}
}

static inline gpointer
puzzle_view_get_instance_private (PuzzleView* self)
{
	return G_STRUCT_MEMBER_P (self, PuzzleView_private_offset);
}

static void
_g_object_unref0_ (gpointer var)
{
#line 167 "../src/puzzle-view.vala"
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
#line 1144 "puzzle-view.c"
}

static void
puzzle_view_redraw_tile (PuzzleView* self,
                         PuzzleViewTileImage* image)
{
	Theme* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	Theme* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	Theme* _tmp6_;
	gint _tmp7_;
	gint _tmp8_;
	Theme* _tmp9_;
	gint _tmp10_;
	gint _tmp11_;
	Theme* _tmp12_;
	gint _tmp13_;
	gint _tmp14_;
	Theme* _tmp15_;
	gint _tmp16_;
	gint _tmp17_;
#line 209 "../src/puzzle-view.vala"
	g_return_if_fail (self != NULL);
#line 209 "../src/puzzle-view.vala"
	g_return_if_fail (image != NULL);
#line 211 "../src/puzzle-view.vala"
	_tmp0_ = self->priv->theme;
#line 211 "../src/puzzle-view.vala"
	_tmp1_ = theme_get_overdraw_left (_tmp0_);
#line 211 "../src/puzzle-view.vala"
	_tmp2_ = _tmp1_;
#line 211 "../src/puzzle-view.vala"
	_tmp3_ = self->priv->theme;
#line 211 "../src/puzzle-view.vala"
	_tmp4_ = theme_get_overdraw_top (_tmp3_);
#line 211 "../src/puzzle-view.vala"
	_tmp5_ = _tmp4_;
#line 211 "../src/puzzle-view.vala"
	_tmp6_ = self->priv->theme;
#line 211 "../src/puzzle-view.vala"
	_tmp7_ = theme_get_overdraw_left (_tmp6_);
#line 211 "../src/puzzle-view.vala"
	_tmp8_ = _tmp7_;
#line 211 "../src/puzzle-view.vala"
	_tmp9_ = self->priv->theme;
#line 211 "../src/puzzle-view.vala"
	_tmp10_ = theme_get_overdraw_right (_tmp9_);
#line 211 "../src/puzzle-view.vala"
	_tmp11_ = _tmp10_;
#line 211 "../src/puzzle-view.vala"
	_tmp12_ = self->priv->theme;
#line 211 "../src/puzzle-view.vala"
	_tmp13_ = theme_get_overdraw_top (_tmp12_);
#line 211 "../src/puzzle-view.vala"
	_tmp14_ = _tmp13_;
#line 211 "../src/puzzle-view.vala"
	_tmp15_ = self->priv->theme;
#line 211 "../src/puzzle-view.vala"
	_tmp16_ = theme_get_overdraw_bottom (_tmp15_);
#line 211 "../src/puzzle-view.vala"
	_tmp17_ = _tmp16_;
#line 211 "../src/puzzle-view.vala"
	gtk_widget_queue_draw_area ((GtkWidget*) self, ((gint) image->x) - _tmp2_, ((gint) image->y) - _tmp5_, (((gint) self->priv->tilesize) + _tmp8_) + _tmp11_, (((gint) self->priv->tilesize) + _tmp14_) + _tmp17_);
#line 1211 "puzzle-view.c"
}

static void
puzzle_view_queue_draw_tile (PuzzleView* self,
                             guint8 x,
                             guint8 y)
{
	gdouble* _tmp0_;
	gint _tmp0__length1;
	gint _tmp0__length2;
	gdouble _tmp1_;
	Theme* _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
	gdouble* _tmp5_;
	gint _tmp5__length1;
	gint _tmp5__length2;
	gdouble _tmp6_;
	Theme* _tmp7_;
	gint _tmp8_;
	gint _tmp9_;
	Theme* _tmp10_;
	gint _tmp11_;
	gint _tmp12_;
	Theme* _tmp13_;
	gint _tmp14_;
	gint _tmp15_;
	Theme* _tmp16_;
	gint _tmp17_;
	gint _tmp18_;
	Theme* _tmp19_;
	gint _tmp20_;
	gint _tmp21_;
#line 217 "../src/puzzle-view.vala"
	g_return_if_fail (self != NULL);
#line 219 "../src/puzzle-view.vala"
	_tmp0_ = self->priv->sockets_xs;
#line 219 "../src/puzzle-view.vala"
	_tmp0__length1 = self->priv->sockets_xs_length1;
#line 219 "../src/puzzle-view.vala"
	_tmp0__length2 = self->priv->sockets_xs_length2;
#line 219 "../src/puzzle-view.vala"
	_tmp1_ = _tmp0_[(x * _tmp0__length2) + y];
#line 219 "../src/puzzle-view.vala"
	_tmp2_ = self->priv->theme;
#line 219 "../src/puzzle-view.vala"
	_tmp3_ = theme_get_overdraw_left (_tmp2_);
#line 219 "../src/puzzle-view.vala"
	_tmp4_ = _tmp3_;
#line 219 "../src/puzzle-view.vala"
	_tmp5_ = self->priv->sockets_ys;
#line 219 "../src/puzzle-view.vala"
	_tmp5__length1 = self->priv->sockets_ys_length1;
#line 219 "../src/puzzle-view.vala"
	_tmp5__length2 = self->priv->sockets_ys_length2;
#line 219 "../src/puzzle-view.vala"
	_tmp6_ = _tmp5_[(x * _tmp5__length2) + y];
#line 219 "../src/puzzle-view.vala"
	_tmp7_ = self->priv->theme;
#line 219 "../src/puzzle-view.vala"
	_tmp8_ = theme_get_overdraw_top (_tmp7_);
#line 219 "../src/puzzle-view.vala"
	_tmp9_ = _tmp8_;
#line 219 "../src/puzzle-view.vala"
	_tmp10_ = self->priv->theme;
#line 219 "../src/puzzle-view.vala"
	_tmp11_ = theme_get_overdraw_left (_tmp10_);
#line 219 "../src/puzzle-view.vala"
	_tmp12_ = _tmp11_;
#line 219 "../src/puzzle-view.vala"
	_tmp13_ = self->priv->theme;
#line 219 "../src/puzzle-view.vala"
	_tmp14_ = theme_get_overdraw_right (_tmp13_);
#line 219 "../src/puzzle-view.vala"
	_tmp15_ = _tmp14_;
#line 219 "../src/puzzle-view.vala"
	_tmp16_ = self->priv->theme;
#line 219 "../src/puzzle-view.vala"
	_tmp17_ = theme_get_overdraw_top (_tmp16_);
#line 219 "../src/puzzle-view.vala"
	_tmp18_ = _tmp17_;
#line 219 "../src/puzzle-view.vala"
	_tmp19_ = self->priv->theme;
#line 219 "../src/puzzle-view.vala"
	_tmp20_ = theme_get_overdraw_bottom (_tmp19_);
#line 219 "../src/puzzle-view.vala"
	_tmp21_ = _tmp20_;
#line 219 "../src/puzzle-view.vala"
	gtk_widget_queue_draw_area ((GtkWidget*) self, ((gint) _tmp1_) - _tmp4_, ((gint) _tmp6_) - _tmp9_, (((gint) self->priv->tilesize) + _tmp12_) + _tmp15_, (((gint) self->priv->tilesize) + _tmp18_) + _tmp21_);
#line 1301 "puzzle-view.c"
}

static void
puzzle_view_move_tile_to_location (PuzzleView* self,
                                   PuzzleViewTileImage* image,
                                   guint x,
                                   guint y,
                                   gdouble duration)
{
	gdouble target_x = 0.0;
	Puzzle* _tmp0_;
	Puzzle* _tmp1_;
	guint8 _tmp2_;
	guint8 _tmp3_;
	gdouble target_y = 0.0;
	gdouble _tmp4_;
#line 225 "../src/puzzle-view.vala"
	g_return_if_fail (self != NULL);
#line 225 "../src/puzzle-view.vala"
	g_return_if_fail (image != NULL);
#line 227 "../src/puzzle-view.vala"
	target_x = self->priv->x_offset + ((gdouble) (x * self->priv->tilesize));
#line 228 "../src/puzzle-view.vala"
	_tmp0_ = puzzle_view_get_puzzle (self);
#line 228 "../src/puzzle-view.vala"
	_tmp1_ = _tmp0_;
#line 228 "../src/puzzle-view.vala"
	_tmp2_ = puzzle_get_size (_tmp1_);
#line 228 "../src/puzzle-view.vala"
	_tmp3_ = _tmp2_;
#line 228 "../src/puzzle-view.vala"
	if (x >= ((guint) _tmp3_)) {
#line 229 "../src/puzzle-view.vala"
		target_x += (gdouble) self->priv->gap;
#line 1336 "puzzle-view.c"
	}
#line 230 "../src/puzzle-view.vala"
	_tmp4_ = self->priv->_y_offset;
#line 230 "../src/puzzle-view.vala"
	target_y = _tmp4_ + ((gdouble) (y * self->priv->tilesize));
#line 231 "../src/puzzle-view.vala"
	puzzle_view_move_tile (self, image, target_x, target_y, duration);
#line 1344 "puzzle-view.c"
}

static gboolean
_puzzle_view_animate_cb_gsource_func (gpointer self)
{
	gboolean result;
	result = puzzle_view_animate_cb ((PuzzleView*) self);
#line 259 "../src/puzzle-view.vala"
	return result;
#line 1354 "puzzle-view.c"
}

static void
puzzle_view_move_tile (PuzzleView* self,
                       PuzzleViewTileImage* image,
                       gdouble x,
                       gdouble y,
                       gdouble duration)
{
	gboolean _tmp0_ = FALSE;
	GTimer* _tmp1_;
#line 234 "../src/puzzle-view.vala"
	g_return_if_fail (self != NULL);
#line 234 "../src/puzzle-view.vala"
	g_return_if_fail (image != NULL);
#line 236 "../src/puzzle-view.vala"
	if (image->x == x) {
#line 236 "../src/puzzle-view.vala"
		_tmp0_ = image->y == y;
#line 1374 "puzzle-view.c"
	} else {
#line 236 "../src/puzzle-view.vala"
		_tmp0_ = FALSE;
#line 1378 "puzzle-view.c"
	}
#line 236 "../src/puzzle-view.vala"
	if (_tmp0_) {
#line 237 "../src/puzzle-view.vala"
		return;
#line 1384 "puzzle-view.c"
	}
#line 239 "../src/puzzle-view.vala"
	image->source_x = image->x;
#line 240 "../src/puzzle-view.vala"
	image->source_y = image->y;
#line 241 "../src/puzzle-view.vala"
	_tmp1_ = self->priv->animation_timer;
#line 241 "../src/puzzle-view.vala"
	image->source_time = g_timer_elapsed (_tmp1_, NULL);
#line 242 "../src/puzzle-view.vala"
	image->target_x = x;
#line 243 "../src/puzzle-view.vala"
	image->target_y = y;
#line 244 "../src/puzzle-view.vala"
	image->duration = duration;
#line 247 "../src/puzzle-view.vala"
	if (duration == ((gdouble) 0)) {
#line 249 "../src/puzzle-view.vala"
		puzzle_view_redraw_tile (self, image);
#line 250 "../src/puzzle-view.vala"
		image->x = image->target_x;
#line 251 "../src/puzzle-view.vala"
		image->y = image->target_y;
#line 252 "../src/puzzle-view.vala"
		image->snap_to_cursor = TRUE;
#line 253 "../src/puzzle-view.vala"
		puzzle_view_redraw_tile (self, image);
#line 254 "../src/puzzle-view.vala"
		return;
#line 1414 "puzzle-view.c"
	}
#line 258 "../src/puzzle-view.vala"
	if (self->priv->animation_timeout == ((guint) 0)) {
#line 259 "../src/puzzle-view.vala"
		self->priv->animation_timeout = g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) 10, _puzzle_view_animate_cb_gsource_func, g_object_ref (self), g_object_unref);
#line 1420 "puzzle-view.c"
	}
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 272 "../src/puzzle-view.vala"
	return self ? g_object_ref (self) : NULL;
#line 1429 "puzzle-view.c"
}

static gboolean
puzzle_view_animate_cb (PuzzleView* self)
{
	gdouble t = 0.0;
	GTimer* _tmp0_;
	gboolean animating = FALSE;
	GHashTableIter iter = {0};
	GHashTable* _tmp1_;
	gboolean result;
#line 262 "../src/puzzle-view.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 264 "../src/puzzle-view.vala"
	_tmp0_ = self->priv->animation_timer;
#line 264 "../src/puzzle-view.vala"
	t = g_timer_elapsed (_tmp0_, NULL);
#line 266 "../src/puzzle-view.vala"
	animating = FALSE;
#line 267 "../src/puzzle-view.vala"
	_tmp1_ = self->priv->tiles;
#line 267 "../src/puzzle-view.vala"
	g_hash_table_iter_init (&iter, _tmp1_);
#line 268 "../src/puzzle-view.vala"
	while (TRUE) {
#line 1455 "puzzle-view.c"
		Tile* tile = NULL;
		PuzzleViewTileImage* image = NULL;
		gconstpointer _tmp2_ = NULL;
		gconstpointer _tmp3_ = NULL;
		gboolean _tmp4_;
		Tile* _tmp5_;
		PuzzleViewTileImage* _tmp6_;
		gboolean _tmp7_ = FALSE;
		PuzzleViewTileImage* _tmp8_;
		PuzzleViewTileImage* _tmp9_;
		PuzzleViewTileImage* _tmp12_;
		PuzzleViewTileImage* _tmp13_;
		PuzzleViewTileImage* _tmp14_;
		PuzzleViewTileImage* _tmp29_;
		PuzzleViewTileImage* _tmp35_;
#line 272 "../src/puzzle-view.vala"
		_tmp4_ = g_hash_table_iter_next (&iter, (gpointer*) (&_tmp2_), (gpointer*) (&_tmp3_));
#line 272 "../src/puzzle-view.vala"
		_g_object_unref0 (tile);
#line 272 "../src/puzzle-view.vala"
		_tmp5_ = _g_object_ref0 ((Tile*) _tmp2_);
#line 272 "../src/puzzle-view.vala"
		tile = _tmp5_;
#line 272 "../src/puzzle-view.vala"
		_g_object_unref0 (image);
#line 272 "../src/puzzle-view.vala"
		_tmp6_ = _g_object_ref0 ((PuzzleViewTileImage*) _tmp3_);
#line 272 "../src/puzzle-view.vala"
		image = _tmp6_;
#line 272 "../src/puzzle-view.vala"
		if (!_tmp4_) {
#line 273 "../src/puzzle-view.vala"
			_g_object_unref0 (image);
#line 273 "../src/puzzle-view.vala"
			_g_object_unref0 (tile);
#line 273 "../src/puzzle-view.vala"
			break;
#line 1493 "puzzle-view.c"
		}
#line 275 "../src/puzzle-view.vala"
		_tmp8_ = image;
#line 275 "../src/puzzle-view.vala"
		_tmp9_ = image;
#line 275 "../src/puzzle-view.vala"
		if (_tmp8_->x == _tmp9_->target_x) {
#line 1501 "puzzle-view.c"
			PuzzleViewTileImage* _tmp10_;
			PuzzleViewTileImage* _tmp11_;
#line 276 "../src/puzzle-view.vala"
			_tmp10_ = image;
#line 276 "../src/puzzle-view.vala"
			_tmp11_ = image;
#line 276 "../src/puzzle-view.vala"
			_tmp7_ = _tmp10_->y == _tmp11_->target_y;
#line 1510 "puzzle-view.c"
		} else {
#line 275 "../src/puzzle-view.vala"
			_tmp7_ = FALSE;
#line 1514 "puzzle-view.c"
		}
#line 275 "../src/puzzle-view.vala"
		if (_tmp7_) {
#line 277 "../src/puzzle-view.vala"
			_g_object_unref0 (image);
#line 277 "../src/puzzle-view.vala"
			_g_object_unref0 (tile);
#line 277 "../src/puzzle-view.vala"
			continue;
#line 1524 "puzzle-view.c"
		}
#line 280 "../src/puzzle-view.vala"
		_tmp12_ = image;
#line 280 "../src/puzzle-view.vala"
		puzzle_view_redraw_tile (self, _tmp12_);
#line 283 "../src/puzzle-view.vala"
		_tmp13_ = image;
#line 283 "../src/puzzle-view.vala"
		_tmp14_ = image;
#line 283 "../src/puzzle-view.vala"
		if (t >= (_tmp13_->source_time + _tmp14_->duration)) {
#line 1536 "puzzle-view.c"
			PuzzleViewTileImage* _tmp15_;
			PuzzleViewTileImage* _tmp16_;
			PuzzleViewTileImage* _tmp17_;
			PuzzleViewTileImage* _tmp18_;
#line 285 "../src/puzzle-view.vala"
			_tmp15_ = image;
#line 285 "../src/puzzle-view.vala"
			_tmp16_ = image;
#line 285 "../src/puzzle-view.vala"
			_tmp15_->x = _tmp16_->target_x;
#line 286 "../src/puzzle-view.vala"
			_tmp17_ = image;
#line 286 "../src/puzzle-view.vala"
			_tmp18_ = image;
#line 286 "../src/puzzle-view.vala"
			_tmp17_->y = _tmp18_->target_y;
#line 1553 "puzzle-view.c"
		} else {
			gdouble d = 0.0;
			PuzzleViewTileImage* _tmp19_;
			PuzzleViewTileImage* _tmp20_;
			PuzzleViewTileImage* _tmp21_;
			PuzzleViewTileImage* _tmp22_;
			PuzzleViewTileImage* _tmp23_;
			PuzzleViewTileImage* _tmp24_;
			PuzzleViewTileImage* _tmp25_;
			PuzzleViewTileImage* _tmp26_;
			PuzzleViewTileImage* _tmp27_;
			PuzzleViewTileImage* _tmp28_;
#line 290 "../src/puzzle-view.vala"
			_tmp19_ = image;
#line 290 "../src/puzzle-view.vala"
			_tmp20_ = image;
#line 290 "../src/puzzle-view.vala"
			d = (t - _tmp19_->source_time) / _tmp20_->duration;
#line 291 "../src/puzzle-view.vala"
			_tmp21_ = image;
#line 291 "../src/puzzle-view.vala"
			_tmp22_ = image;
#line 291 "../src/puzzle-view.vala"
			_tmp23_ = image;
#line 291 "../src/puzzle-view.vala"
			_tmp24_ = image;
#line 291 "../src/puzzle-view.vala"
			_tmp21_->x = _tmp22_->source_x + ((_tmp23_->target_x - _tmp24_->source_x) * d);
#line 292 "../src/puzzle-view.vala"
			_tmp25_ = image;
#line 292 "../src/puzzle-view.vala"
			_tmp26_ = image;
#line 292 "../src/puzzle-view.vala"
			_tmp27_ = image;
#line 292 "../src/puzzle-view.vala"
			_tmp28_ = image;
#line 292 "../src/puzzle-view.vala"
			_tmp25_->y = _tmp26_->source_y + ((_tmp27_->target_y - _tmp28_->source_y) * d);
#line 293 "../src/puzzle-view.vala"
			animating = TRUE;
#line 1594 "puzzle-view.c"
		}
#line 296 "../src/puzzle-view.vala"
		_tmp29_ = image;
#line 296 "../src/puzzle-view.vala"
		if (!_tmp29_->snap_to_cursor) {
#line 1600 "puzzle-view.c"
			gdouble distance = 0.0;
			PuzzleViewTileImage* _tmp30_;
			PuzzleViewTileImage* _tmp31_;
			PuzzleViewTileImage* _tmp32_;
			PuzzleViewTileImage* _tmp33_;
#line 298 "../src/puzzle-view.vala"
			_tmp30_ = image;
#line 298 "../src/puzzle-view.vala"
			_tmp31_ = image;
#line 298 "../src/puzzle-view.vala"
			_tmp32_ = image;
#line 298 "../src/puzzle-view.vala"
			_tmp33_ = image;
#line 298 "../src/puzzle-view.vala"
			distance = sqrt (pow (_tmp30_->x - _tmp31_->target_x, (gdouble) 2) + pow (_tmp32_->y - _tmp33_->target_y, (gdouble) 2));
#line 300 "../src/puzzle-view.vala"
			if (distance < self->priv->snap_distance) {
#line 1618 "puzzle-view.c"
				PuzzleViewTileImage* _tmp34_;
#line 301 "../src/puzzle-view.vala"
				_tmp34_ = image;
#line 301 "../src/puzzle-view.vala"
				_tmp34_->snap_to_cursor = TRUE;
#line 1624 "puzzle-view.c"
			}
		}
#line 305 "../src/puzzle-view.vala"
		_tmp35_ = image;
#line 305 "../src/puzzle-view.vala"
		puzzle_view_redraw_tile (self, _tmp35_);
#line 268 "../src/puzzle-view.vala"
		_g_object_unref0 (image);
#line 268 "../src/puzzle-view.vala"
		_g_object_unref0 (tile);
#line 1635 "puzzle-view.c"
	}
#line 309 "../src/puzzle-view.vala"
	if (animating) {
#line 310 "../src/puzzle-view.vala"
		result = TRUE;
#line 310 "../src/puzzle-view.vala"
		return result;
#line 1643 "puzzle-view.c"
	}
#line 312 "../src/puzzle-view.vala"
	self->priv->animation_timeout = (guint) 0;
#line 313 "../src/puzzle-view.vala"
	result = FALSE;
#line 313 "../src/puzzle-view.vala"
	return result;
#line 1651 "puzzle-view.c"
}

static void
puzzle_view_real_get_preferred_width (GtkWidget* base,
                                      gint* minimum,
                                      gint* natural)
{
	PuzzleView * self;
	gint _vala_minimum = 0;
	gint _vala_natural = 0;
	gint size = 0;
#line 316 "../src/puzzle-view.vala"
	self = (PuzzleView*) base;
#line 318 "../src/puzzle-view.vala"
	size = 0;
#line 319 "../src/puzzle-view.vala"
	if (self->priv->puzzle_init_done) {
#line 1669 "puzzle-view.c"
		Puzzle* _tmp0_;
		Puzzle* _tmp1_;
		guint8 _tmp2_;
		guint8 _tmp3_;
#line 320 "../src/puzzle-view.vala"
		_tmp0_ = puzzle_view_get_puzzle (self);
#line 320 "../src/puzzle-view.vala"
		_tmp1_ = _tmp0_;
#line 320 "../src/puzzle-view.vala"
		_tmp2_ = puzzle_get_size (_tmp1_);
#line 320 "../src/puzzle-view.vala"
		_tmp3_ = _tmp2_;
#line 320 "../src/puzzle-view.vala"
		size = (gint) ((((_tmp3_ * 2) + 1.0) + PUZZLE_VIEW_gap_factor) * PUZZLE_VIEW_minimum_size);
#line 1684 "puzzle-view.c"
	}
#line 321 "../src/puzzle-view.vala"
	_vala_natural = MAX (size, 500);
#line 321 "../src/puzzle-view.vala"
	_vala_minimum = _vala_natural;
#line 316 "../src/puzzle-view.vala"
	if (minimum) {
#line 316 "../src/puzzle-view.vala"
		*minimum = _vala_minimum;
#line 1694 "puzzle-view.c"
	}
#line 316 "../src/puzzle-view.vala"
	if (natural) {
#line 316 "../src/puzzle-view.vala"
		*natural = _vala_natural;
#line 1700 "puzzle-view.c"
	}
}

static void
puzzle_view_real_get_preferred_height (GtkWidget* base,
                                       gint* minimum,
                                       gint* natural)
{
	PuzzleView * self;
	gint _vala_minimum = 0;
	gint _vala_natural = 0;
	gint size = 0;
#line 324 "../src/puzzle-view.vala"
	self = (PuzzleView*) base;
#line 326 "../src/puzzle-view.vala"
	size = 0;
#line 327 "../src/puzzle-view.vala"
	if (self->priv->puzzle_init_done) {
#line 1719 "puzzle-view.c"
		Puzzle* _tmp0_;
		Puzzle* _tmp1_;
		guint8 _tmp2_;
		guint8 _tmp3_;
#line 328 "../src/puzzle-view.vala"
		_tmp0_ = puzzle_view_get_puzzle (self);
#line 328 "../src/puzzle-view.vala"
		_tmp1_ = _tmp0_;
#line 328 "../src/puzzle-view.vala"
		_tmp2_ = puzzle_get_size (_tmp1_);
#line 328 "../src/puzzle-view.vala"
		_tmp3_ = _tmp2_;
#line 328 "../src/puzzle-view.vala"
		size = (gint) ((_tmp3_ + 1.0) * PUZZLE_VIEW_minimum_size);
#line 1734 "puzzle-view.c"
	}
#line 329 "../src/puzzle-view.vala"
	_vala_natural = MAX (size, 300);
#line 329 "../src/puzzle-view.vala"
	_vala_minimum = _vala_natural;
#line 324 "../src/puzzle-view.vala"
	if (minimum) {
#line 324 "../src/puzzle-view.vala"
		*minimum = _vala_minimum;
#line 1744 "puzzle-view.c"
	}
#line 324 "../src/puzzle-view.vala"
	if (natural) {
#line 324 "../src/puzzle-view.vala"
		*natural = _vala_natural;
#line 1750 "puzzle-view.c"
	}
}

static void
puzzle_view_tile_moved_cb (PuzzleView* self,
                           Puzzle* puzzle,
                           Tile* tile,
                           guint8 x,
                           guint8 y)
{
	GHashTable* _tmp0_;
	gconstpointer _tmp1_;
#line 332 "../src/puzzle-view.vala"
	g_return_if_fail (self != NULL);
#line 332 "../src/puzzle-view.vala"
	g_return_if_fail (puzzle != NULL);
#line 332 "../src/puzzle-view.vala"
	g_return_if_fail (tile != NULL);
#line 334 "../src/puzzle-view.vala"
	_tmp0_ = self->priv->tiles;
#line 334 "../src/puzzle-view.vala"
	_tmp1_ = g_hash_table_lookup (_tmp0_, tile);
#line 334 "../src/puzzle-view.vala"
	puzzle_view_move_tile_to_location (self, (PuzzleViewTileImage*) _tmp1_, (guint) x, (guint) y, PUZZLE_VIEW_animation_duration);
#line 1775 "puzzle-view.c"
}

static gboolean
puzzle_view_real_configure_event (GtkWidget* base,
                                  GdkEventConfigure* event)
{
	PuzzleView * self;
	GHashTableIter iter = {0};
	GHashTable* _tmp40_;
	PuzzleViewTileImage* _tmp52_;
	gboolean result;
#line 338 "../src/puzzle-view.vala"
	self = (PuzzleView*) base;
#line 338 "../src/puzzle-view.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 340 "../src/puzzle-view.vala"
	if (self->priv->puzzle_init_done) {
#line 1793 "puzzle-view.c"
		gint allocated_width = 0;
		gint allocated_height = 0;
		guint width = 0U;
		Puzzle* _tmp0_;
		Puzzle* _tmp1_;
		guint8 _tmp2_;
		guint8 _tmp3_;
		guint height = 0U;
		Puzzle* _tmp4_;
		Puzzle* _tmp5_;
		guint8 _tmp6_;
		guint8 _tmp7_;
		Puzzle* _tmp8_;
		Puzzle* _tmp9_;
		guint8 _tmp10_;
		guint8 _tmp11_;
		Theme* _tmp12_;
		guint _tmp13_;
		guint _tmp14_;
		guint _tmp15_;
		guint _tmp16_;
		guint _tmp17_;
		gdouble _tmp18_;
		guint _tmp19_;
#line 342 "../src/puzzle-view.vala"
		allocated_width = gtk_widget_get_allocated_width ((GtkWidget*) self);
#line 343 "../src/puzzle-view.vala"
		allocated_height = gtk_widget_get_allocated_height ((GtkWidget*) self);
#line 345 "../src/puzzle-view.vala"
		_tmp0_ = puzzle_view_get_puzzle (self);
#line 345 "../src/puzzle-view.vala"
		_tmp1_ = _tmp0_;
#line 345 "../src/puzzle-view.vala"
		_tmp2_ = puzzle_get_size (_tmp1_);
#line 345 "../src/puzzle-view.vala"
		_tmp3_ = _tmp2_;
#line 345 "../src/puzzle-view.vala"
		width = (guint) (allocated_width / (((2 * _tmp3_) + 1.0) + PUZZLE_VIEW_gap_factor));
#line 346 "../src/puzzle-view.vala"
		_tmp4_ = puzzle_view_get_puzzle (self);
#line 346 "../src/puzzle-view.vala"
		_tmp5_ = _tmp4_;
#line 346 "../src/puzzle-view.vala"
		_tmp6_ = puzzle_get_size (_tmp5_);
#line 346 "../src/puzzle-view.vala"
		_tmp7_ = _tmp6_;
#line 346 "../src/puzzle-view.vala"
		height = (guint) (allocated_height / (_tmp7_ + 1.0));
#line 347 "../src/puzzle-view.vala"
		self->priv->tilesize = MIN (width, height);
#line 348 "../src/puzzle-view.vala"
		_tmp8_ = puzzle_view_get_puzzle (self);
#line 348 "../src/puzzle-view.vala"
		_tmp9_ = _tmp8_;
#line 348 "../src/puzzle-view.vala"
		_tmp10_ = puzzle_get_size (_tmp9_);
#line 348 "../src/puzzle-view.vala"
		_tmp11_ = _tmp10_;
#line 348 "../src/puzzle-view.vala"
		puzzle_view_set_boardsize (self, (guint) ((gint) (self->priv->tilesize * _tmp11_)));
#line 349 "../src/puzzle-view.vala"
		self->priv->gap = (guint) (self->priv->tilesize * PUZZLE_VIEW_gap_factor);
#line 350 "../src/puzzle-view.vala"
		_tmp12_ = self->priv->theme;
#line 350 "../src/puzzle-view.vala"
		theme_configure (_tmp12_, self->priv->tilesize);
#line 351 "../src/puzzle-view.vala"
		_tmp13_ = self->priv->_boardsize;
#line 351 "../src/puzzle-view.vala"
		self->priv->x_offset = ((gdouble) ((allocated_width - (2 * _tmp13_)) - self->priv->gap)) / 2.0;
#line 352 "../src/puzzle-view.vala"
		_tmp14_ = self->priv->_boardsize;
#line 352 "../src/puzzle-view.vala"
		puzzle_view_set_y_offset (self, ((gdouble) (allocated_height - _tmp14_)) / 2.0);
#line 354 "../src/puzzle-view.vala"
		self->priv->board_x_maxi = allocated_width - ((gint) self->priv->tilesize);
#line 355 "../src/puzzle-view.vala"
		self->priv->board_y_maxi = allocated_height - ((gint) self->priv->tilesize);
#line 357 "../src/puzzle-view.vala"
		_tmp15_ = self->priv->_boardsize;
#line 357 "../src/puzzle-view.vala"
		self->priv->snap_distance = _tmp15_ / 40.0;
#line 359 "../src/puzzle-view.vala"
		_tmp16_ = self->priv->_boardsize;
#line 359 "../src/puzzle-view.vala"
		self->priv->arrow_x = self->priv->x_offset + _tmp16_;
#line 360 "../src/puzzle-view.vala"
		_tmp17_ = self->priv->_boardsize;
#line 360 "../src/puzzle-view.vala"
		self->priv->arrow_local_y = _tmp17_ * 0.5;
#line 362 "../src/puzzle-view.vala"
		puzzle_view_set_x_offset_right (self, self->priv->arrow_x + self->priv->gap);
#line 363 "../src/puzzle-view.vala"
		_tmp18_ = self->priv->_x_offset_right;
#line 363 "../src/puzzle-view.vala"
		_tmp19_ = self->priv->_boardsize;
#line 363 "../src/puzzle-view.vala"
		puzzle_view_set_right_margin (self, (allocated_width - _tmp18_) - _tmp19_);
#line 1892 "puzzle-view.c"
		{
			guint8 y = 0U;
#line 366 "../src/puzzle-view.vala"
			y = (guint8) 0;
#line 1897 "puzzle-view.c"
			{
				gboolean _tmp20_ = FALSE;
#line 366 "../src/puzzle-view.vala"
				_tmp20_ = TRUE;
#line 366 "../src/puzzle-view.vala"
				while (TRUE) {
#line 1904 "puzzle-view.c"
					Puzzle* _tmp22_;
					Puzzle* _tmp23_;
					guint8 _tmp24_;
					guint8 _tmp25_;
#line 366 "../src/puzzle-view.vala"
					if (!_tmp20_) {
#line 1911 "puzzle-view.c"
						guint8 _tmp21_;
#line 366 "../src/puzzle-view.vala"
						_tmp21_ = y;
#line 366 "../src/puzzle-view.vala"
						y = _tmp21_ + 1;
#line 1917 "puzzle-view.c"
					}
#line 366 "../src/puzzle-view.vala"
					_tmp20_ = FALSE;
#line 366 "../src/puzzle-view.vala"
					_tmp22_ = puzzle_view_get_puzzle (self);
#line 366 "../src/puzzle-view.vala"
					_tmp23_ = _tmp22_;
#line 366 "../src/puzzle-view.vala"
					_tmp24_ = puzzle_get_size (_tmp23_);
#line 366 "../src/puzzle-view.vala"
					_tmp25_ = _tmp24_;
#line 366 "../src/puzzle-view.vala"
					if (!(y < _tmp25_)) {
#line 366 "../src/puzzle-view.vala"
						break;
#line 1933 "puzzle-view.c"
					}
					{
						guint8 x = 0U;
#line 367 "../src/puzzle-view.vala"
						x = (guint8) 0;
#line 1939 "puzzle-view.c"
						{
							gboolean _tmp26_ = FALSE;
#line 367 "../src/puzzle-view.vala"
							_tmp26_ = TRUE;
#line 367 "../src/puzzle-view.vala"
							while (TRUE) {
#line 1946 "puzzle-view.c"
								Puzzle* _tmp28_;
								Puzzle* _tmp29_;
								guint8 _tmp30_;
								guint8 _tmp31_;
								Puzzle* _tmp32_;
								Puzzle* _tmp33_;
								guint8 _tmp34_;
								guint8 _tmp35_;
								gdouble* _tmp38_;
								gint _tmp38__length1;
								gint _tmp38__length2;
								gdouble _tmp39_;
#line 367 "../src/puzzle-view.vala"
								if (!_tmp26_) {
#line 1961 "puzzle-view.c"
									guint8 _tmp27_;
#line 367 "../src/puzzle-view.vala"
									_tmp27_ = x;
#line 367 "../src/puzzle-view.vala"
									x = _tmp27_ + 1;
#line 1967 "puzzle-view.c"
								}
#line 367 "../src/puzzle-view.vala"
								_tmp26_ = FALSE;
#line 367 "../src/puzzle-view.vala"
								_tmp28_ = puzzle_view_get_puzzle (self);
#line 367 "../src/puzzle-view.vala"
								_tmp29_ = _tmp28_;
#line 367 "../src/puzzle-view.vala"
								_tmp30_ = puzzle_get_size (_tmp29_);
#line 367 "../src/puzzle-view.vala"
								_tmp31_ = _tmp30_;
#line 367 "../src/puzzle-view.vala"
								if (!(((gint) x) < (_tmp31_ * 2))) {
#line 367 "../src/puzzle-view.vala"
									break;
#line 1983 "puzzle-view.c"
								}
#line 369 "../src/puzzle-view.vala"
								_tmp32_ = puzzle_view_get_puzzle (self);
#line 369 "../src/puzzle-view.vala"
								_tmp33_ = _tmp32_;
#line 369 "../src/puzzle-view.vala"
								_tmp34_ = puzzle_get_size (_tmp33_);
#line 369 "../src/puzzle-view.vala"
								_tmp35_ = _tmp34_;
#line 369 "../src/puzzle-view.vala"
								if (x >= _tmp35_) {
#line 1995 "puzzle-view.c"
									gdouble* _tmp36_;
									gint _tmp36__length1;
									gint _tmp36__length2;
#line 370 "../src/puzzle-view.vala"
									_tmp36_ = self->priv->sockets_xs;
#line 370 "../src/puzzle-view.vala"
									_tmp36__length1 = self->priv->sockets_xs_length1;
#line 370 "../src/puzzle-view.vala"
									_tmp36__length2 = self->priv->sockets_xs_length2;
#line 370 "../src/puzzle-view.vala"
									_tmp36_[(x * _tmp36__length2) + y] = (self->priv->x_offset + (x * self->priv->tilesize)) + self->priv->gap;
#line 2007 "puzzle-view.c"
								} else {
									gdouble* _tmp37_;
									gint _tmp37__length1;
									gint _tmp37__length2;
#line 372 "../src/puzzle-view.vala"
									_tmp37_ = self->priv->sockets_xs;
#line 372 "../src/puzzle-view.vala"
									_tmp37__length1 = self->priv->sockets_xs_length1;
#line 372 "../src/puzzle-view.vala"
									_tmp37__length2 = self->priv->sockets_xs_length2;
#line 372 "../src/puzzle-view.vala"
									_tmp37_[(x * _tmp37__length2) + y] = self->priv->x_offset + (x * self->priv->tilesize);
#line 2020 "puzzle-view.c"
								}
#line 373 "../src/puzzle-view.vala"
								_tmp38_ = self->priv->sockets_ys;
#line 373 "../src/puzzle-view.vala"
								_tmp38__length1 = self->priv->sockets_ys_length1;
#line 373 "../src/puzzle-view.vala"
								_tmp38__length2 = self->priv->sockets_ys_length2;
#line 373 "../src/puzzle-view.vala"
								_tmp39_ = self->priv->_y_offset;
#line 373 "../src/puzzle-view.vala"
								_tmp38_[(x * _tmp38__length2) + y] = _tmp39_ + (y * self->priv->tilesize);
#line 2032 "puzzle-view.c"
							}
						}
					}
				}
			}
		}
	}
#line 378 "../src/puzzle-view.vala"
	_tmp40_ = self->priv->tiles;
#line 378 "../src/puzzle-view.vala"
	g_hash_table_iter_init (&iter, _tmp40_);
#line 379 "../src/puzzle-view.vala"
	while (TRUE) {
#line 2046 "puzzle-view.c"
		Tile* tile = NULL;
		PuzzleViewTileImage* image = NULL;
		gconstpointer _tmp41_ = NULL;
		gconstpointer _tmp42_ = NULL;
		gboolean _tmp43_;
		Tile* _tmp44_;
		PuzzleViewTileImage* _tmp45_;
		guint8 x = 0U;
		guint8 y = 0U;
		Puzzle* _tmp46_;
		Puzzle* _tmp47_;
		Tile* _tmp48_;
		guint8 _tmp49_ = 0U;
		guint8 _tmp50_ = 0U;
		PuzzleViewTileImage* _tmp51_;
#line 383 "../src/puzzle-view.vala"
		_tmp43_ = g_hash_table_iter_next (&iter, (gpointer*) (&_tmp41_), (gpointer*) (&_tmp42_));
#line 383 "../src/puzzle-view.vala"
		_g_object_unref0 (tile);
#line 383 "../src/puzzle-view.vala"
		_tmp44_ = _g_object_ref0 ((Tile*) _tmp41_);
#line 383 "../src/puzzle-view.vala"
		tile = _tmp44_;
#line 383 "../src/puzzle-view.vala"
		_g_object_unref0 (image);
#line 383 "../src/puzzle-view.vala"
		_tmp45_ = _g_object_ref0 ((PuzzleViewTileImage*) _tmp42_);
#line 383 "../src/puzzle-view.vala"
		image = _tmp45_;
#line 383 "../src/puzzle-view.vala"
		if (!_tmp43_) {
#line 384 "../src/puzzle-view.vala"
			_g_object_unref0 (image);
#line 384 "../src/puzzle-view.vala"
			_g_object_unref0 (tile);
#line 384 "../src/puzzle-view.vala"
			break;
#line 2084 "puzzle-view.c"
		}
#line 386 "../src/puzzle-view.vala"
		_tmp46_ = puzzle_view_get_puzzle (self);
#line 386 "../src/puzzle-view.vala"
		_tmp47_ = _tmp46_;
#line 386 "../src/puzzle-view.vala"
		_tmp48_ = tile;
#line 386 "../src/puzzle-view.vala"
		puzzle_get_tile_location (_tmp47_, _tmp48_, &_tmp49_, &_tmp50_);
#line 386 "../src/puzzle-view.vala"
		x = _tmp49_;
#line 386 "../src/puzzle-view.vala"
		y = _tmp50_;
#line 387 "../src/puzzle-view.vala"
		_tmp51_ = image;
#line 387 "../src/puzzle-view.vala"
		puzzle_view_move_tile_to_location (self, _tmp51_, (guint) x, (guint) y, (gdouble) 0);
#line 379 "../src/puzzle-view.vala"
		_g_object_unref0 (image);
#line 379 "../src/puzzle-view.vala"
		_g_object_unref0 (tile);
#line 2106 "puzzle-view.c"
	}
#line 389 "../src/puzzle-view.vala"
	_tmp52_ = self->priv->selected_tile;
#line 389 "../src/puzzle-view.vala"
	if (_tmp52_ != NULL) {
#line 2112 "puzzle-view.c"
		PuzzleViewTileImage* _tmp53_;
#line 390 "../src/puzzle-view.vala"
		_tmp53_ = self->priv->selected_tile;
#line 390 "../src/puzzle-view.vala"
		G_TYPE_CHECK_INSTANCE_CAST (_tmp53_, PUZZLE_VIEW_TYPE_TILE_IMAGE, PuzzleViewTileImage)->snap_to_cursor = TRUE;
#line 2118 "puzzle-view.c"
	}
#line 391 "../src/puzzle-view.vala"
	_g_object_unref0 (self->priv->selected_tile);
#line 391 "../src/puzzle-view.vala"
	self->priv->selected_tile = NULL;
#line 392 "../src/puzzle-view.vala"
	puzzle_view_set_tile_selected (self, FALSE);
#line 394 "../src/puzzle-view.vala"
	result = FALSE;
#line 394 "../src/puzzle-view.vala"
	return result;
#line 2130 "puzzle-view.c"
}

static inline void
puzzle_view_init_patterns (PuzzleView* self,
                           cairo_t* context)
{
	cairo_surface_t* tmp_surface = NULL;
	cairo_t* tmp_context = NULL;
	cairo_surface_t* _tmp0_;
	guint _tmp1_;
	cairo_surface_t* _tmp2_;
	cairo_surface_t* _tmp3_;
	cairo_t* _tmp4_;
	cairo_t* _tmp5_;
	cairo_t* _tmp6_;
	Theme* _tmp7_;
	cairo_t* _tmp8_;
	cairo_t* _tmp9_;
	cairo_surface_t* _tmp10_;
	cairo_pattern_t* _tmp11_;
	cairo_surface_t* _tmp12_;
	cairo_surface_t* _tmp13_;
	cairo_surface_t* _tmp14_;
	cairo_t* _tmp15_;
	Theme* _tmp16_;
	cairo_t* _tmp17_;
	cairo_surface_t* _tmp18_;
	cairo_pattern_t* _tmp19_;
#line 397 "../src/puzzle-view.vala"
	g_return_if_fail (self != NULL);
#line 397 "../src/puzzle-view.vala"
	g_return_if_fail (context != NULL);
#line 399 "../src/puzzle-view.vala"
	self->priv->render_size = self->priv->tilesize;
#line 405 "../src/puzzle-view.vala"
	_tmp0_ = cairo_get_target (context);
#line 405 "../src/puzzle-view.vala"
	_tmp1_ = self->priv->_boardsize;
#line 405 "../src/puzzle-view.vala"
	_tmp2_ = cairo_surface_create_similar (_tmp0_, CAIRO_CONTENT_COLOR_ALPHA, (gint) self->priv->gap, (gint) _tmp1_);
#line 405 "../src/puzzle-view.vala"
	_cairo_surface_destroy0 (tmp_surface);
#line 405 "../src/puzzle-view.vala"
	tmp_surface = _tmp2_;
#line 407 "../src/puzzle-view.vala"
	_tmp3_ = tmp_surface;
#line 407 "../src/puzzle-view.vala"
	_tmp4_ = cairo_create (_tmp3_);
#line 407 "../src/puzzle-view.vala"
	_cairo_destroy0 (tmp_context);
#line 407 "../src/puzzle-view.vala"
	tmp_context = _tmp4_;
#line 409 "../src/puzzle-view.vala"
	_tmp5_ = tmp_context;
#line 409 "../src/puzzle-view.vala"
	cairo_save (_tmp5_);
#line 410 "../src/puzzle-view.vala"
	_tmp6_ = tmp_context;
#line 410 "../src/puzzle-view.vala"
	cairo_translate (_tmp6_, 0.0, self->priv->arrow_local_y);
#line 411 "../src/puzzle-view.vala"
	_tmp7_ = self->priv->theme;
#line 411 "../src/puzzle-view.vala"
	_tmp8_ = tmp_context;
#line 411 "../src/puzzle-view.vala"
	theme_draw_arrow (_tmp7_, _tmp8_);
#line 412 "../src/puzzle-view.vala"
	_tmp9_ = tmp_context;
#line 412 "../src/puzzle-view.vala"
	cairo_restore (_tmp9_);
#line 414 "../src/puzzle-view.vala"
	_tmp10_ = tmp_surface;
#line 414 "../src/puzzle-view.vala"
	_tmp11_ = cairo_pattern_create_for_surface (_tmp10_);
#line 414 "../src/puzzle-view.vala"
	_cairo_pattern_destroy0 (self->priv->arrow_pattern);
#line 414 "../src/puzzle-view.vala"
	self->priv->arrow_pattern = _tmp11_;
#line 417 "../src/puzzle-view.vala"
	_tmp12_ = cairo_get_target (context);
#line 417 "../src/puzzle-view.vala"
	_tmp13_ = cairo_surface_create_similar (_tmp12_, CAIRO_CONTENT_COLOR_ALPHA, (gint) self->priv->tilesize, (gint) self->priv->tilesize);
#line 417 "../src/puzzle-view.vala"
	_cairo_surface_destroy0 (tmp_surface);
#line 417 "../src/puzzle-view.vala"
	tmp_surface = _tmp13_;
#line 419 "../src/puzzle-view.vala"
	_tmp14_ = tmp_surface;
#line 419 "../src/puzzle-view.vala"
	_tmp15_ = cairo_create (_tmp14_);
#line 419 "../src/puzzle-view.vala"
	_cairo_destroy0 (tmp_context);
#line 419 "../src/puzzle-view.vala"
	tmp_context = _tmp15_;
#line 421 "../src/puzzle-view.vala"
	_tmp16_ = self->priv->theme;
#line 421 "../src/puzzle-view.vala"
	_tmp17_ = tmp_context;
#line 421 "../src/puzzle-view.vala"
	theme_draw_socket (_tmp16_, _tmp17_);
#line 423 "../src/puzzle-view.vala"
	_tmp18_ = tmp_surface;
#line 423 "../src/puzzle-view.vala"
	_tmp19_ = cairo_pattern_create_for_surface (_tmp18_);
#line 423 "../src/puzzle-view.vala"
	_cairo_pattern_destroy0 (self->priv->socket_pattern);
#line 423 "../src/puzzle-view.vala"
	self->priv->socket_pattern = _tmp19_;
#line 397 "../src/puzzle-view.vala"
	_cairo_destroy0 (tmp_context);
#line 397 "../src/puzzle-view.vala"
	_cairo_surface_destroy0 (tmp_surface);
#line 2243 "puzzle-view.c"
}

static inline void
_g_slist_free__g_object_unref0_ (GSList* self)
{
#line 506 "../src/puzzle-view.vala"
	g_slist_free_full (self, (GDestroyNotify) _g_object_unref0_);
#line 2251 "puzzle-view.c"
}

static gboolean
puzzle_view_real_draw (GtkWidget* base,
                       cairo_t* context)
{
	PuzzleView * self;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	cairo_pattern_t* _tmp2_;
	gdouble _tmp4_;
	cairo_pattern_t* _tmp5_;
	guint _tmp6_;
	GSList* moving_tiles = NULL;
	GHashTableIter iter = {0};
	GHashTable* _tmp24_;
	GSList* _tmp48_;
	PuzzleViewTileImage* _tmp50_;
	gboolean _tmp54_ = FALSE;
	Puzzle* _tmp68_;
	Puzzle* _tmp69_;
	gboolean _tmp70_;
	gboolean _tmp71_;
	gboolean result;
#line 426 "../src/puzzle-view.vala"
	self = (PuzzleView*) base;
#line 426 "../src/puzzle-view.vala"
	g_return_val_if_fail (context != NULL, FALSE);
#line 428 "../src/puzzle-view.vala"
	if (!self->priv->puzzle_init_done) {
#line 429 "../src/puzzle-view.vala"
		result = FALSE;
#line 429 "../src/puzzle-view.vala"
		return result;
#line 2286 "puzzle-view.c"
	}
#line 431 "../src/puzzle-view.vala"
	_tmp2_ = self->priv->arrow_pattern;
#line 431 "../src/puzzle-view.vala"
	if (_tmp2_ == NULL) {
#line 431 "../src/puzzle-view.vala"
		_tmp1_ = TRUE;
#line 2294 "puzzle-view.c"
	} else {
		cairo_pattern_t* _tmp3_;
#line 431 "../src/puzzle-view.vala"
		_tmp3_ = self->priv->socket_pattern;
#line 431 "../src/puzzle-view.vala"
		_tmp1_ = _tmp3_ == NULL;
#line 2301 "puzzle-view.c"
	}
#line 431 "../src/puzzle-view.vala"
	if (_tmp1_) {
#line 431 "../src/puzzle-view.vala"
		_tmp0_ = TRUE;
#line 2307 "puzzle-view.c"
	} else {
#line 431 "../src/puzzle-view.vala"
		_tmp0_ = self->priv->render_size != self->priv->tilesize;
#line 2311 "puzzle-view.c"
	}
#line 431 "../src/puzzle-view.vala"
	if (_tmp0_) {
#line 432 "../src/puzzle-view.vala"
		puzzle_view_init_patterns (self, context);
#line 2317 "puzzle-view.c"
	}
#line 435 "../src/puzzle-view.vala"
	cairo_save (context);
#line 436 "../src/puzzle-view.vala"
	_tmp4_ = self->priv->_y_offset;
#line 436 "../src/puzzle-view.vala"
	cairo_translate (context, self->priv->arrow_x, _tmp4_);
#line 437 "../src/puzzle-view.vala"
	_tmp5_ = self->priv->arrow_pattern;
#line 437 "../src/puzzle-view.vala"
	cairo_set_source (context, (cairo_pattern_t*) _tmp5_);
#line 438 "../src/puzzle-view.vala"
	_tmp6_ = self->priv->_boardsize;
#line 438 "../src/puzzle-view.vala"
	cairo_rectangle (context, 0.0, 0.0, (gdouble) self->priv->gap, (gdouble) _tmp6_);
#line 439 "../src/puzzle-view.vala"
	cairo_fill (context);
#line 440 "../src/puzzle-view.vala"
	cairo_restore (context);
#line 2337 "puzzle-view.c"
	{
		guint8 y = 0U;
#line 443 "../src/puzzle-view.vala"
		y = (guint8) 0;
#line 2342 "puzzle-view.c"
		{
			gboolean _tmp7_ = FALSE;
#line 443 "../src/puzzle-view.vala"
			_tmp7_ = TRUE;
#line 443 "../src/puzzle-view.vala"
			while (TRUE) {
#line 2349 "puzzle-view.c"
				Puzzle* _tmp9_;
				Puzzle* _tmp10_;
				guint8 _tmp11_;
				guint8 _tmp12_;
#line 443 "../src/puzzle-view.vala"
				if (!_tmp7_) {
#line 2356 "puzzle-view.c"
					guint8 _tmp8_;
#line 443 "../src/puzzle-view.vala"
					_tmp8_ = y;
#line 443 "../src/puzzle-view.vala"
					y = _tmp8_ + 1;
#line 2362 "puzzle-view.c"
				}
#line 443 "../src/puzzle-view.vala"
				_tmp7_ = FALSE;
#line 443 "../src/puzzle-view.vala"
				_tmp9_ = puzzle_view_get_puzzle (self);
#line 443 "../src/puzzle-view.vala"
				_tmp10_ = _tmp9_;
#line 443 "../src/puzzle-view.vala"
				_tmp11_ = puzzle_get_size (_tmp10_);
#line 443 "../src/puzzle-view.vala"
				_tmp12_ = _tmp11_;
#line 443 "../src/puzzle-view.vala"
				if (!(y < _tmp12_)) {
#line 443 "../src/puzzle-view.vala"
					break;
#line 2378 "puzzle-view.c"
				}
				{
					guint8 x = 0U;
#line 444 "../src/puzzle-view.vala"
					x = (guint8) 0;
#line 2384 "puzzle-view.c"
					{
						gboolean _tmp13_ = FALSE;
#line 444 "../src/puzzle-view.vala"
						_tmp13_ = TRUE;
#line 444 "../src/puzzle-view.vala"
						while (TRUE) {
#line 2391 "puzzle-view.c"
							Puzzle* _tmp15_;
							Puzzle* _tmp16_;
							guint8 _tmp17_;
							guint8 _tmp18_;
							gdouble* _tmp19_;
							gint _tmp19__length1;
							gint _tmp19__length2;
							gdouble _tmp20_;
							gdouble* _tmp21_;
							gint _tmp21__length1;
							gint _tmp21__length2;
							gdouble _tmp22_;
							cairo_pattern_t* _tmp23_;
#line 444 "../src/puzzle-view.vala"
							if (!_tmp13_) {
#line 2407 "puzzle-view.c"
								guint8 _tmp14_;
#line 444 "../src/puzzle-view.vala"
								_tmp14_ = x;
#line 444 "../src/puzzle-view.vala"
								x = _tmp14_ + 1;
#line 2413 "puzzle-view.c"
							}
#line 444 "../src/puzzle-view.vala"
							_tmp13_ = FALSE;
#line 444 "../src/puzzle-view.vala"
							_tmp15_ = puzzle_view_get_puzzle (self);
#line 444 "../src/puzzle-view.vala"
							_tmp16_ = _tmp15_;
#line 444 "../src/puzzle-view.vala"
							_tmp17_ = puzzle_get_size (_tmp16_);
#line 444 "../src/puzzle-view.vala"
							_tmp18_ = _tmp17_;
#line 444 "../src/puzzle-view.vala"
							if (!(((gint) x) < (_tmp18_ * 2))) {
#line 444 "../src/puzzle-view.vala"
								break;
#line 2429 "puzzle-view.c"
							}
#line 446 "../src/puzzle-view.vala"
							cairo_save (context);
#line 447 "../src/puzzle-view.vala"
							_tmp19_ = self->priv->sockets_xs;
#line 447 "../src/puzzle-view.vala"
							_tmp19__length1 = self->priv->sockets_xs_length1;
#line 447 "../src/puzzle-view.vala"
							_tmp19__length2 = self->priv->sockets_xs_length2;
#line 447 "../src/puzzle-view.vala"
							_tmp20_ = _tmp19_[(x * _tmp19__length2) + y];
#line 447 "../src/puzzle-view.vala"
							_tmp21_ = self->priv->sockets_ys;
#line 447 "../src/puzzle-view.vala"
							_tmp21__length1 = self->priv->sockets_ys_length1;
#line 447 "../src/puzzle-view.vala"
							_tmp21__length2 = self->priv->sockets_ys_length2;
#line 447 "../src/puzzle-view.vala"
							_tmp22_ = _tmp21_[(x * _tmp21__length2) + y];
#line 447 "../src/puzzle-view.vala"
							cairo_translate (context, _tmp20_, _tmp22_);
#line 449 "../src/puzzle-view.vala"
							_tmp23_ = self->priv->socket_pattern;
#line 449 "../src/puzzle-view.vala"
							cairo_set_source (context, (cairo_pattern_t*) _tmp23_);
#line 450 "../src/puzzle-view.vala"
							cairo_rectangle (context, 0.0, 0.0, (gdouble) self->priv->tilesize, (gdouble) self->priv->tilesize);
#line 451 "../src/puzzle-view.vala"
							cairo_fill (context);
#line 453 "../src/puzzle-view.vala"
							cairo_restore (context);
#line 2461 "puzzle-view.c"
						}
					}
				}
			}
		}
	}
#line 457 "../src/puzzle-view.vala"
	moving_tiles = NULL;
#line 458 "../src/puzzle-view.vala"
	_tmp24_ = self->priv->tiles;
#line 458 "../src/puzzle-view.vala"
	g_hash_table_iter_init (&iter, _tmp24_);
#line 459 "../src/puzzle-view.vala"
	while (TRUE) {
#line 2476 "puzzle-view.c"
		Tile* tile = NULL;
		PuzzleViewTileImage* image = NULL;
		gconstpointer _tmp25_ = NULL;
		gconstpointer _tmp26_ = NULL;
		gboolean _tmp27_;
		Tile* _tmp28_;
		PuzzleViewTileImage* _tmp29_;
		gboolean _tmp30_ = FALSE;
		PuzzleViewTileImage* _tmp31_;
		gboolean _tmp34_ = FALSE;
		gboolean _tmp35_ = FALSE;
		PuzzleViewTileImage* _tmp36_;
		gboolean _tmp40_ = FALSE;
		PuzzleViewTileImage* _tmp41_;
		PuzzleViewTileImage* _tmp42_;
		PuzzleViewTileImage* _tmp47_;
#line 463 "../src/puzzle-view.vala"
		_tmp27_ = g_hash_table_iter_next (&iter, (gpointer*) (&_tmp25_), (gpointer*) (&_tmp26_));
#line 463 "../src/puzzle-view.vala"
		_g_object_unref0 (tile);
#line 463 "../src/puzzle-view.vala"
		_tmp28_ = _g_object_ref0 ((Tile*) _tmp25_);
#line 463 "../src/puzzle-view.vala"
		tile = _tmp28_;
#line 463 "../src/puzzle-view.vala"
		_g_object_unref0 (image);
#line 463 "../src/puzzle-view.vala"
		_tmp29_ = _g_object_ref0 ((PuzzleViewTileImage*) _tmp26_);
#line 463 "../src/puzzle-view.vala"
		image = _tmp29_;
#line 463 "../src/puzzle-view.vala"
		if (!_tmp27_) {
#line 464 "../src/puzzle-view.vala"
			_g_object_unref0 (image);
#line 464 "../src/puzzle-view.vala"
			_g_object_unref0 (tile);
#line 464 "../src/puzzle-view.vala"
			break;
#line 2515 "puzzle-view.c"
		}
#line 466 "../src/puzzle-view.vala"
		_tmp31_ = self->priv->selected_tile;
#line 466 "../src/puzzle-view.vala"
		if (_tmp31_ != NULL) {
#line 2521 "puzzle-view.c"
			PuzzleViewTileImage* _tmp32_;
			PuzzleViewTileImage* _tmp33_;
#line 466 "../src/puzzle-view.vala"
			_tmp32_ = image;
#line 466 "../src/puzzle-view.vala"
			_tmp33_ = self->priv->selected_tile;
#line 466 "../src/puzzle-view.vala"
			_tmp30_ = _tmp32_ == G_TYPE_CHECK_INSTANCE_CAST (_tmp33_, PUZZLE_VIEW_TYPE_TILE_IMAGE, PuzzleViewTileImage);
#line 2530 "puzzle-view.c"
		} else {
#line 466 "../src/puzzle-view.vala"
			_tmp30_ = FALSE;
#line 2534 "puzzle-view.c"
		}
#line 466 "../src/puzzle-view.vala"
		if (_tmp30_) {
#line 467 "../src/puzzle-view.vala"
			_g_object_unref0 (image);
#line 467 "../src/puzzle-view.vala"
			_g_object_unref0 (tile);
#line 467 "../src/puzzle-view.vala"
			continue;
#line 2544 "puzzle-view.c"
		}
#line 468 "../src/puzzle-view.vala"
		_tmp36_ = self->priv->selected_tile;
#line 468 "../src/puzzle-view.vala"
		if (_tmp36_ == NULL) {
#line 2550 "puzzle-view.c"
			PuzzleViewTileImage* _tmp37_;
#line 468 "../src/puzzle-view.vala"
			_tmp37_ = self->priv->last_selected_tile;
#line 468 "../src/puzzle-view.vala"
			_tmp35_ = _tmp37_ != NULL;
#line 2556 "puzzle-view.c"
		} else {
#line 468 "../src/puzzle-view.vala"
			_tmp35_ = FALSE;
#line 2560 "puzzle-view.c"
		}
#line 468 "../src/puzzle-view.vala"
		if (_tmp35_) {
#line 2564 "puzzle-view.c"
			PuzzleViewTileImage* _tmp38_;
			PuzzleViewTileImage* _tmp39_;
#line 468 "../src/puzzle-view.vala"
			_tmp38_ = image;
#line 468 "../src/puzzle-view.vala"
			_tmp39_ = self->priv->last_selected_tile;
#line 468 "../src/puzzle-view.vala"
			_tmp34_ = _tmp38_ == G_TYPE_CHECK_INSTANCE_CAST (_tmp39_, PUZZLE_VIEW_TYPE_TILE_IMAGE, PuzzleViewTileImage);
#line 2573 "puzzle-view.c"
		} else {
#line 468 "../src/puzzle-view.vala"
			_tmp34_ = FALSE;
#line 2577 "puzzle-view.c"
		}
#line 468 "../src/puzzle-view.vala"
		if (_tmp34_) {
#line 469 "../src/puzzle-view.vala"
			_g_object_unref0 (image);
#line 469 "../src/puzzle-view.vala"
			_g_object_unref0 (tile);
#line 469 "../src/puzzle-view.vala"
			continue;
#line 2587 "puzzle-view.c"
		}
#line 471 "../src/puzzle-view.vala"
		_tmp41_ = image;
#line 471 "../src/puzzle-view.vala"
		_tmp42_ = image;
#line 471 "../src/puzzle-view.vala"
		if (_tmp41_->x != _tmp42_->target_x) {
#line 471 "../src/puzzle-view.vala"
			_tmp40_ = TRUE;
#line 2597 "puzzle-view.c"
		} else {
			PuzzleViewTileImage* _tmp43_;
			PuzzleViewTileImage* _tmp44_;
#line 472 "../src/puzzle-view.vala"
			_tmp43_ = image;
#line 472 "../src/puzzle-view.vala"
			_tmp44_ = image;
#line 472 "../src/puzzle-view.vala"
			_tmp40_ = _tmp43_->y != _tmp44_->target_y;
#line 2607 "puzzle-view.c"
		}
#line 471 "../src/puzzle-view.vala"
		if (_tmp40_) {
#line 2611 "puzzle-view.c"
			PuzzleViewTileImage* _tmp45_;
			PuzzleViewTileImage* _tmp46_;
#line 474 "../src/puzzle-view.vala"
			_tmp45_ = image;
#line 474 "../src/puzzle-view.vala"
			_tmp46_ = _g_object_ref0 (_tmp45_);
#line 474 "../src/puzzle-view.vala"
			moving_tiles = g_slist_prepend (moving_tiles, _tmp46_);
#line 475 "../src/puzzle-view.vala"
			_g_object_unref0 (image);
#line 475 "../src/puzzle-view.vala"
			_g_object_unref0 (tile);
#line 475 "../src/puzzle-view.vala"
			continue;
#line 2626 "puzzle-view.c"
		}
#line 478 "../src/puzzle-view.vala"
		_tmp47_ = image;
#line 478 "../src/puzzle-view.vala"
		puzzle_view_draw_image (self, context, _tmp47_);
#line 459 "../src/puzzle-view.vala"
		_g_object_unref0 (image);
#line 459 "../src/puzzle-view.vala"
		_g_object_unref0 (tile);
#line 2636 "puzzle-view.c"
	}
#line 482 "../src/puzzle-view.vala"
	_tmp48_ = moving_tiles;
#line 2640 "puzzle-view.c"
	{
		GSList* image_collection = NULL;
		GSList* image_it = NULL;
#line 482 "../src/puzzle-view.vala"
		image_collection = _tmp48_;
#line 482 "../src/puzzle-view.vala"
		for (image_it = image_collection; image_it != NULL; image_it = image_it->next) {
#line 2648 "puzzle-view.c"
			PuzzleViewTileImage* image = NULL;
#line 482 "../src/puzzle-view.vala"
			image = (PuzzleViewTileImage*) image_it->data;
#line 2652 "puzzle-view.c"
			{
				PuzzleViewTileImage* _tmp49_;
#line 483 "../src/puzzle-view.vala"
				_tmp49_ = image;
#line 483 "../src/puzzle-view.vala"
				puzzle_view_draw_image (self, context, _tmp49_);
#line 2659 "puzzle-view.c"
			}
		}
	}
#line 486 "../src/puzzle-view.vala"
	_tmp50_ = self->priv->selected_tile;
#line 486 "../src/puzzle-view.vala"
	if (_tmp50_ != NULL) {
#line 2667 "puzzle-view.c"
		PuzzleViewTileImage* _tmp51_;
#line 487 "../src/puzzle-view.vala"
		_tmp51_ = self->priv->selected_tile;
#line 487 "../src/puzzle-view.vala"
		puzzle_view_draw_image (self, context, G_TYPE_CHECK_INSTANCE_CAST (_tmp51_, PUZZLE_VIEW_TYPE_TILE_IMAGE, PuzzleViewTileImage));
#line 2673 "puzzle-view.c"
	} else {
		PuzzleViewTileImage* _tmp52_;
#line 490 "../src/puzzle-view.vala"
		_tmp52_ = self->priv->last_selected_tile;
#line 490 "../src/puzzle-view.vala"
		if (_tmp52_ != NULL) {
#line 2680 "puzzle-view.c"
			PuzzleViewTileImage* _tmp53_;
#line 491 "../src/puzzle-view.vala"
			_tmp53_ = self->priv->last_selected_tile;
#line 491 "../src/puzzle-view.vala"
			puzzle_view_draw_image (self, context, G_TYPE_CHECK_INSTANCE_CAST (_tmp53_, PUZZLE_VIEW_TYPE_TILE_IMAGE, PuzzleViewTileImage));
#line 2686 "puzzle-view.c"
		}
	}
#line 494 "../src/puzzle-view.vala"
	if (self->priv->show_highlight) {
#line 2691 "puzzle-view.c"
		Puzzle* _tmp55_;
		Puzzle* _tmp56_;
		gboolean _tmp57_;
		gboolean _tmp58_;
#line 494 "../src/puzzle-view.vala"
		_tmp55_ = puzzle_view_get_puzzle (self);
#line 494 "../src/puzzle-view.vala"
		_tmp56_ = _tmp55_;
#line 494 "../src/puzzle-view.vala"
		_tmp57_ = puzzle_get_is_solved (_tmp56_);
#line 494 "../src/puzzle-view.vala"
		_tmp58_ = _tmp57_;
#line 494 "../src/puzzle-view.vala"
		_tmp54_ = !_tmp58_;
#line 2706 "puzzle-view.c"
	} else {
#line 494 "../src/puzzle-view.vala"
		_tmp54_ = FALSE;
#line 2710 "puzzle-view.c"
	}
#line 494 "../src/puzzle-view.vala"
	if (_tmp54_) {
#line 2714 "puzzle-view.c"
		gdouble* _tmp59_;
		gint _tmp59__length1;
		gint _tmp59__length2;
		gdouble _tmp60_;
		gdouble* _tmp61_;
		gint _tmp61__length1;
		gint _tmp61__length2;
		gdouble _tmp62_;
		Theme* _tmp63_;
		Puzzle* _tmp64_;
		Puzzle* _tmp65_;
		Tile* _tmp66_;
		Tile* _tmp67_;
#line 496 "../src/puzzle-view.vala"
		cairo_save (context);
#line 497 "../src/puzzle-view.vala"
		_tmp59_ = self->priv->sockets_xs;
#line 497 "../src/puzzle-view.vala"
		_tmp59__length1 = self->priv->sockets_xs_length1;
#line 497 "../src/puzzle-view.vala"
		_tmp59__length2 = self->priv->sockets_xs_length2;
#line 497 "../src/puzzle-view.vala"
		_tmp60_ = _tmp59_[(self->priv->highlight_x * _tmp59__length2) + self->priv->highlight_y];
#line 497 "../src/puzzle-view.vala"
		_tmp61_ = self->priv->sockets_ys;
#line 497 "../src/puzzle-view.vala"
		_tmp61__length1 = self->priv->sockets_ys_length1;
#line 497 "../src/puzzle-view.vala"
		_tmp61__length2 = self->priv->sockets_ys_length2;
#line 497 "../src/puzzle-view.vala"
		_tmp62_ = _tmp61_[(self->priv->highlight_x * _tmp61__length2) + self->priv->highlight_y];
#line 497 "../src/puzzle-view.vala"
		cairo_translate (context, _tmp60_, _tmp62_);
#line 498 "../src/puzzle-view.vala"
		_tmp63_ = self->priv->theme;
#line 498 "../src/puzzle-view.vala"
		_tmp64_ = puzzle_view_get_puzzle (self);
#line 498 "../src/puzzle-view.vala"
		_tmp65_ = _tmp64_;
#line 498 "../src/puzzle-view.vala"
		_tmp66_ = puzzle_get_tile (_tmp65_, self->priv->highlight_x, self->priv->highlight_y);
#line 498 "../src/puzzle-view.vala"
		_tmp67_ = _tmp66_;
#line 498 "../src/puzzle-view.vala"
		theme_draw_highlight (_tmp63_, context, _tmp67_ != NULL);
#line 498 "../src/puzzle-view.vala"
		_g_object_unref0 (_tmp67_);
#line 499 "../src/puzzle-view.vala"
		cairo_restore (context);
#line 2764 "puzzle-view.c"
	}
#line 503 "../src/puzzle-view.vala"
	_tmp68_ = puzzle_view_get_puzzle (self);
#line 503 "../src/puzzle-view.vala"
	_tmp69_ = _tmp68_;
#line 503 "../src/puzzle-view.vala"
	_tmp70_ = puzzle_get_paused (_tmp69_);
#line 503 "../src/puzzle-view.vala"
	_tmp71_ = _tmp70_;
#line 503 "../src/puzzle-view.vala"
	if (_tmp71_) {
#line 504 "../src/puzzle-view.vala"
		puzzle_view_draw_pause_overlay (self, context);
#line 2778 "puzzle-view.c"
	}
#line 506 "../src/puzzle-view.vala"
	result = FALSE;
#line 506 "../src/puzzle-view.vala"
	(moving_tiles == NULL) ? NULL : (moving_tiles = (_g_slist_free__g_object_unref0_ (moving_tiles), NULL));
#line 506 "../src/puzzle-view.vala"
	return result;
#line 2786 "puzzle-view.c"
}

static void
puzzle_view_draw_image (PuzzleView* self,
                        cairo_t* context,
                        PuzzleViewTileImage* image)
{
	Puzzle* _tmp0_;
	Puzzle* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
#line 508 "../src/puzzle-view.vala"
	g_return_if_fail (self != NULL);
#line 508 "../src/puzzle-view.vala"
	g_return_if_fail (context != NULL);
#line 508 "../src/puzzle-view.vala"
	g_return_if_fail (image != NULL);
#line 510 "../src/puzzle-view.vala"
	cairo_save (context);
#line 511 "../src/puzzle-view.vala"
	cairo_translate (context, (gdouble) ((gint) image->x), (gdouble) ((gint) image->y));
#line 512 "../src/puzzle-view.vala"
	_tmp0_ = puzzle_view_get_puzzle (self);
#line 512 "../src/puzzle-view.vala"
	_tmp1_ = _tmp0_;
#line 512 "../src/puzzle-view.vala"
	_tmp2_ = puzzle_get_paused (_tmp1_);
#line 512 "../src/puzzle-view.vala"
	_tmp3_ = _tmp2_;
#line 512 "../src/puzzle-view.vala"
	if (_tmp3_) {
#line 2818 "puzzle-view.c"
		Theme* _tmp4_;
#line 513 "../src/puzzle-view.vala"
		_tmp4_ = self->priv->theme;
#line 513 "../src/puzzle-view.vala"
		theme_draw_paused_tile (_tmp4_, context);
#line 2824 "puzzle-view.c"
	} else {
		guint8 tile_x = 0U;
		guint8 tile_y = 0U;
		Puzzle* _tmp5_;
		Puzzle* _tmp6_;
		Tile* _tmp7_;
		guint8 _tmp8_ = 0U;
		guint8 _tmp9_ = 0U;
		gboolean _tmp10_ = FALSE;
		gboolean _tmp11_ = FALSE;
		gboolean _tmp12_ = FALSE;
		gboolean highlight = FALSE;
		Theme* _tmp13_;
		Tile* _tmp14_;
#line 518 "../src/puzzle-view.vala"
		_tmp5_ = puzzle_view_get_puzzle (self);
#line 518 "../src/puzzle-view.vala"
		_tmp6_ = _tmp5_;
#line 518 "../src/puzzle-view.vala"
		_tmp7_ = image->tile;
#line 518 "../src/puzzle-view.vala"
		puzzle_get_tile_location (_tmp6_, _tmp7_, &_tmp8_, &_tmp9_);
#line 518 "../src/puzzle-view.vala"
		tile_x = _tmp8_;
#line 518 "../src/puzzle-view.vala"
		tile_y = _tmp9_;
#line 519 "../src/puzzle-view.vala"
		if (self->priv->show_highlight) {
#line 519 "../src/puzzle-view.vala"
			_tmp12_ = self->priv->tile_selection;
#line 2855 "puzzle-view.c"
		} else {
#line 519 "../src/puzzle-view.vala"
			_tmp12_ = FALSE;
#line 2859 "puzzle-view.c"
		}
#line 519 "../src/puzzle-view.vala"
		if (_tmp12_) {
#line 520 "../src/puzzle-view.vala"
			_tmp11_ = self->priv->kbd_selected_x == tile_x;
#line 2865 "puzzle-view.c"
		} else {
#line 519 "../src/puzzle-view.vala"
			_tmp11_ = FALSE;
#line 2869 "puzzle-view.c"
		}
#line 519 "../src/puzzle-view.vala"
		if (_tmp11_) {
#line 521 "../src/puzzle-view.vala"
			_tmp10_ = self->priv->kbd_selected_y == tile_y;
#line 2875 "puzzle-view.c"
		} else {
#line 519 "../src/puzzle-view.vala"
			_tmp10_ = FALSE;
#line 2879 "puzzle-view.c"
		}
#line 519 "../src/puzzle-view.vala"
		highlight = _tmp10_;
#line 522 "../src/puzzle-view.vala"
		_tmp13_ = self->priv->theme;
#line 522 "../src/puzzle-view.vala"
		_tmp14_ = image->tile;
#line 522 "../src/puzzle-view.vala"
		theme_draw_tile (_tmp13_, context, _tmp14_, highlight);
#line 2889 "puzzle-view.c"
	}
#line 524 "../src/puzzle-view.vala"
	cairo_restore (context);
#line 2893 "puzzle-view.c"
}

static inline void
puzzle_view_draw_pause_overlay (PuzzleView* self,
                                cairo_t* context)
{
	gchar* text = NULL;
	gchar* _tmp0_;
	cairo_text_extents_t extents = {0};
	cairo_text_extents_t _tmp1_ = {0};
	cairo_text_extents_t _tmp2_;
	cairo_text_extents_t _tmp3_;
#line 526 "../src/puzzle-view.vala"
	g_return_if_fail (self != NULL);
#line 526 "../src/puzzle-view.vala"
	g_return_if_fail (context != NULL);
#line 528 "../src/puzzle-view.vala"
	cairo_set_source_rgba (context, (gdouble) 0, (gdouble) 0, (gdouble) 0, 0.75);
#line 529 "../src/puzzle-view.vala"
	cairo_paint (context);
#line 531 "../src/puzzle-view.vala"
	cairo_select_font_face (context, "Sans", CAIRO_FONT_SLANT_NORMAL, CAIRO_FONT_WEIGHT_BOLD);
#line 532 "../src/puzzle-view.vala"
	cairo_set_font_size (context, gtk_widget_get_allocated_width ((GtkWidget*) self) * 0.125);
#line 535 "../src/puzzle-view.vala"
	_tmp0_ = g_strdup (_ ("Paused"));
#line 535 "../src/puzzle-view.vala"
	text = _tmp0_;
#line 537 "../src/puzzle-view.vala"
	cairo_text_extents (context, text, &_tmp1_);
#line 537 "../src/puzzle-view.vala"
	extents = _tmp1_;
#line 538 "../src/puzzle-view.vala"
	_tmp2_ = extents;
#line 538 "../src/puzzle-view.vala"
	_tmp3_ = extents;
#line 538 "../src/puzzle-view.vala"
	cairo_move_to (context, (gtk_widget_get_allocated_width ((GtkWidget*) self) - _tmp2_.width) / 2.0, (gtk_widget_get_allocated_height ((GtkWidget*) self) + _tmp3_.height) / 2.0);
#line 539 "../src/puzzle-view.vala"
	cairo_set_source_rgb (context, (gdouble) 1, (gdouble) 1, (gdouble) 1);
#line 540 "../src/puzzle-view.vala"
	cairo_show_text (context, text);
#line 526 "../src/puzzle-view.vala"
	_g_free0 (text);
#line 2938 "puzzle-view.c"
}

static gboolean
_puzzle_view_selection_timeout_cb_gsource_func (gpointer self)
{
	gboolean result;
	result = puzzle_view_selection_timeout_cb ((PuzzleView*) self);
#line 570 "../src/puzzle-view.vala"
	return result;
#line 2948 "puzzle-view.c"
}

static void
puzzle_view_pick_tile (PuzzleView* self,
                       gdouble x,
                       gdouble y)
{
	PuzzleViewTileImage* _tmp0_;
	Puzzle* _tmp1_;
	Puzzle* _tmp2_;
	gboolean _tmp3_;
	gboolean _tmp4_;
	GHashTableIter iter = {0};
	GHashTable* _tmp5_;
	gboolean _tmp24_;
#line 543 "../src/puzzle-view.vala"
	g_return_if_fail (self != NULL);
#line 545 "../src/puzzle-view.vala"
	_tmp0_ = self->priv->selected_tile;
#line 545 "../src/puzzle-view.vala"
	if (_tmp0_ != NULL) {
#line 546 "../src/puzzle-view.vala"
		return;
#line 2972 "puzzle-view.c"
	}
#line 548 "../src/puzzle-view.vala"
	_tmp1_ = puzzle_view_get_puzzle (self);
#line 548 "../src/puzzle-view.vala"
	_tmp2_ = _tmp1_;
#line 548 "../src/puzzle-view.vala"
	_tmp3_ = puzzle_get_is_solved (_tmp2_);
#line 548 "../src/puzzle-view.vala"
	_tmp4_ = _tmp3_;
#line 548 "../src/puzzle-view.vala"
	if (_tmp4_) {
#line 549 "../src/puzzle-view.vala"
		return;
#line 2986 "puzzle-view.c"
	}
#line 551 "../src/puzzle-view.vala"
	_tmp5_ = self->priv->tiles;
#line 551 "../src/puzzle-view.vala"
	g_hash_table_iter_init (&iter, _tmp5_);
#line 552 "../src/puzzle-view.vala"
	while (TRUE) {
#line 2994 "puzzle-view.c"
		Tile* tile = NULL;
		PuzzleViewTileImage* image = NULL;
		gconstpointer _tmp6_ = NULL;
		gconstpointer _tmp7_ = NULL;
		gboolean _tmp8_;
		Tile* _tmp9_;
		PuzzleViewTileImage* _tmp10_;
		gboolean _tmp11_ = FALSE;
		gboolean _tmp12_ = FALSE;
		gboolean _tmp13_ = FALSE;
		PuzzleViewTileImage* _tmp14_;
#line 556 "../src/puzzle-view.vala"
		_tmp8_ = g_hash_table_iter_next (&iter, (gpointer*) (&_tmp6_), (gpointer*) (&_tmp7_));
#line 556 "../src/puzzle-view.vala"
		_g_object_unref0 (tile);
#line 556 "../src/puzzle-view.vala"
		_tmp9_ = _g_object_ref0 ((Tile*) _tmp6_);
#line 556 "../src/puzzle-view.vala"
		tile = _tmp9_;
#line 556 "../src/puzzle-view.vala"
		_g_object_unref0 (image);
#line 556 "../src/puzzle-view.vala"
		_tmp10_ = _g_object_ref0 ((PuzzleViewTileImage*) _tmp7_);
#line 556 "../src/puzzle-view.vala"
		image = _tmp10_;
#line 556 "../src/puzzle-view.vala"
		if (!_tmp8_) {
#line 557 "../src/puzzle-view.vala"
			_g_object_unref0 (image);
#line 557 "../src/puzzle-view.vala"
			_g_object_unref0 (tile);
#line 557 "../src/puzzle-view.vala"
			break;
#line 3028 "puzzle-view.c"
		}
#line 559 "../src/puzzle-view.vala"
		_tmp14_ = image;
#line 559 "../src/puzzle-view.vala"
		if (x >= _tmp14_->x) {
#line 3034 "puzzle-view.c"
			PuzzleViewTileImage* _tmp15_;
#line 559 "../src/puzzle-view.vala"
			_tmp15_ = image;
#line 559 "../src/puzzle-view.vala"
			_tmp13_ = x <= (_tmp15_->x + self->priv->tilesize);
#line 3040 "puzzle-view.c"
		} else {
#line 559 "../src/puzzle-view.vala"
			_tmp13_ = FALSE;
#line 3044 "puzzle-view.c"
		}
#line 559 "../src/puzzle-view.vala"
		if (_tmp13_) {
#line 3048 "puzzle-view.c"
			PuzzleViewTileImage* _tmp16_;
#line 560 "../src/puzzle-view.vala"
			_tmp16_ = image;
#line 560 "../src/puzzle-view.vala"
			_tmp12_ = y >= _tmp16_->y;
#line 3054 "puzzle-view.c"
		} else {
#line 559 "../src/puzzle-view.vala"
			_tmp12_ = FALSE;
#line 3058 "puzzle-view.c"
		}
#line 559 "../src/puzzle-view.vala"
		if (_tmp12_) {
#line 3062 "puzzle-view.c"
			PuzzleViewTileImage* _tmp17_;
#line 560 "../src/puzzle-view.vala"
			_tmp17_ = image;
#line 560 "../src/puzzle-view.vala"
			_tmp11_ = y <= (_tmp17_->y + self->priv->tilesize);
#line 3068 "puzzle-view.c"
		} else {
#line 559 "../src/puzzle-view.vala"
			_tmp11_ = FALSE;
#line 3072 "puzzle-view.c"
		}
#line 559 "../src/puzzle-view.vala"
		if (_tmp11_) {
#line 3076 "puzzle-view.c"
			PuzzleViewTileImage* _tmp18_;
			PuzzleViewTileImage* _tmp19_;
			PuzzleViewTileImage* _tmp20_;
			PuzzleViewTileImage* _tmp21_;
			PuzzleViewTileImage* _tmp22_;
			PuzzleViewTileImage* _tmp23_;
#line 562 "../src/puzzle-view.vala"
			_tmp18_ = image;
#line 562 "../src/puzzle-view.vala"
			_tmp19_ = _g_object_ref0 (_tmp18_);
#line 562 "../src/puzzle-view.vala"
			_g_object_unref0 (self->priv->selected_tile);
#line 562 "../src/puzzle-view.vala"
			self->priv->selected_tile = _tmp19_;
#line 563 "../src/puzzle-view.vala"
			_tmp20_ = image;
#line 563 "../src/puzzle-view.vala"
			_tmp21_ = _g_object_ref0 (_tmp20_);
#line 563 "../src/puzzle-view.vala"
			_g_object_unref0 (self->priv->last_selected_tile);
#line 563 "../src/puzzle-view.vala"
			self->priv->last_selected_tile = _tmp21_;
#line 564 "../src/puzzle-view.vala"
			puzzle_view_set_tile_selected (self, TRUE);
#line 565 "../src/puzzle-view.vala"
			_tmp22_ = image;
#line 565 "../src/puzzle-view.vala"
			self->priv->selected_x_offset = x - _tmp22_->x;
#line 566 "../src/puzzle-view.vala"
			_tmp23_ = image;
#line 566 "../src/puzzle-view.vala"
			self->priv->selected_y_offset = y - _tmp23_->y;
#line 568 "../src/puzzle-view.vala"
			if (self->priv->selection_timeout != ((guint) 0)) {
#line 569 "../src/puzzle-view.vala"
				g_source_remove (self->priv->selection_timeout);
#line 3113 "puzzle-view.c"
			}
#line 570 "../src/puzzle-view.vala"
			self->priv->selection_timeout = g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) 200, _puzzle_view_selection_timeout_cb_gsource_func, g_object_ref (self), g_object_unref);
#line 3117 "puzzle-view.c"
		}
#line 552 "../src/puzzle-view.vala"
		_g_object_unref0 (image);
#line 552 "../src/puzzle-view.vala"
		_g_object_unref0 (tile);
#line 3123 "puzzle-view.c"
	}
#line 574 "../src/puzzle-view.vala"
	_tmp24_ = self->priv->_tile_selected;
#line 574 "../src/puzzle-view.vala"
	if (!_tmp24_) {
#line 3129 "puzzle-view.c"
		guint8 tile_x = 0U;
		guint8 tile_y = 0U;
		guint8 _tmp25_ = 0U;
		guint8 _tmp26_ = 0U;
		gboolean _tmp27_;
#line 578 "../src/puzzle-view.vala"
		_tmp27_ = puzzle_view_get_tile_coords (self, x, y, &_tmp25_, &_tmp26_);
#line 578 "../src/puzzle-view.vala"
		tile_x = _tmp25_;
#line 578 "../src/puzzle-view.vala"
		tile_y = _tmp26_;
#line 578 "../src/puzzle-view.vala"
		if (_tmp27_) {
#line 3143 "puzzle-view.c"
			Puzzle* _tmp28_;
			Puzzle* _tmp29_;
#line 579 "../src/puzzle-view.vala"
			_tmp28_ = puzzle_view_get_puzzle (self);
#line 579 "../src/puzzle-view.vala"
			_tmp29_ = _tmp28_;
#line 579 "../src/puzzle-view.vala"
			puzzle_try_move (_tmp29_, tile_x, tile_y);
#line 3152 "puzzle-view.c"
		}
	}
}

static inline gboolean
puzzle_view_get_tile_coords (PuzzleView* self,
                             gdouble event_x,
                             gdouble event_y,
                             guint8* tile_x,
                             guint8* tile_y)
{
	guint8 _vala_tile_x = 0U;
	guint8 _vala_tile_y = 0U;
	guint8 _tmp0_ = 0U;
	gboolean _tmp1_;
	guint8 _tmp2_ = 0U;
	gboolean _tmp3_;
	gboolean result;
#line 582 "../src/puzzle-view.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 584 "../src/puzzle-view.vala"
	_tmp1_ = puzzle_view_get_tile_coord_x (self, event_x, &_tmp0_);
#line 584 "../src/puzzle-view.vala"
	_vala_tile_x = _tmp0_;
#line 584 "../src/puzzle-view.vala"
	if (!_tmp1_) {
#line 586 "../src/puzzle-view.vala"
		_vala_tile_y = (guint8) 0;
#line 587 "../src/puzzle-view.vala"
		result = FALSE;
#line 587 "../src/puzzle-view.vala"
		if (tile_x) {
#line 587 "../src/puzzle-view.vala"
			*tile_x = _vala_tile_x;
#line 3187 "puzzle-view.c"
		}
#line 587 "../src/puzzle-view.vala"
		if (tile_y) {
#line 587 "../src/puzzle-view.vala"
			*tile_y = _vala_tile_y;
#line 3193 "puzzle-view.c"
		}
#line 587 "../src/puzzle-view.vala"
		return result;
#line 3197 "puzzle-view.c"
	}
#line 589 "../src/puzzle-view.vala"
	_tmp3_ = puzzle_view_get_tile_coord_y (self, event_y, &_tmp2_);
#line 589 "../src/puzzle-view.vala"
	_vala_tile_y = _tmp2_;
#line 589 "../src/puzzle-view.vala"
	if (!_tmp3_) {
#line 590 "../src/puzzle-view.vala"
		result = FALSE;
#line 590 "../src/puzzle-view.vala"
		if (tile_x) {
#line 590 "../src/puzzle-view.vala"
			*tile_x = _vala_tile_x;
#line 3211 "puzzle-view.c"
		}
#line 590 "../src/puzzle-view.vala"
		if (tile_y) {
#line 590 "../src/puzzle-view.vala"
			*tile_y = _vala_tile_y;
#line 3217 "puzzle-view.c"
		}
#line 590 "../src/puzzle-view.vala"
		return result;
#line 3221 "puzzle-view.c"
	}
#line 591 "../src/puzzle-view.vala"
	result = TRUE;
#line 591 "../src/puzzle-view.vala"
	if (tile_x) {
#line 591 "../src/puzzle-view.vala"
		*tile_x = _vala_tile_x;
#line 3229 "puzzle-view.c"
	}
#line 591 "../src/puzzle-view.vala"
	if (tile_y) {
#line 591 "../src/puzzle-view.vala"
		*tile_y = _vala_tile_y;
#line 3235 "puzzle-view.c"
	}
#line 591 "../src/puzzle-view.vala"
	return result;
#line 3239 "puzzle-view.c"
}

static inline gboolean
puzzle_view_get_tile_coord_x (PuzzleView* self,
                              gdouble event_x,
                              guint8* tile_x)
{
	guint8 _vala_tile_x = 0U;
	gboolean result;
#line 593 "../src/puzzle-view.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 3251 "puzzle-view.c"
	{
		gboolean _tmp0_ = FALSE;
#line 595 "../src/puzzle-view.vala"
		_vala_tile_x = (guint8) 0;
#line 595 "../src/puzzle-view.vala"
		_tmp0_ = TRUE;
#line 595 "../src/puzzle-view.vala"
		while (TRUE) {
#line 3260 "puzzle-view.c"
			Puzzle* _tmp2_;
			Puzzle* _tmp3_;
			guint8 _tmp4_;
			guint8 _tmp5_;
			gboolean _tmp6_ = FALSE;
			gdouble* _tmp7_;
			gint _tmp7__length1;
			gint _tmp7__length2;
			gdouble _tmp8_;
#line 595 "../src/puzzle-view.vala"
			if (!_tmp0_) {
#line 3272 "puzzle-view.c"
				guint8 _tmp1_;
#line 595 "../src/puzzle-view.vala"
				_tmp1_ = _vala_tile_x;
#line 595 "../src/puzzle-view.vala"
				_vala_tile_x = _tmp1_ + 1;
#line 3278 "puzzle-view.c"
			}
#line 595 "../src/puzzle-view.vala"
			_tmp0_ = FALSE;
#line 595 "../src/puzzle-view.vala"
			_tmp2_ = puzzle_view_get_puzzle (self);
#line 595 "../src/puzzle-view.vala"
			_tmp3_ = _tmp2_;
#line 595 "../src/puzzle-view.vala"
			_tmp4_ = puzzle_get_size (_tmp3_);
#line 595 "../src/puzzle-view.vala"
			_tmp5_ = _tmp4_;
#line 595 "../src/puzzle-view.vala"
			if (!(((gint) _vala_tile_x) < (2 * _tmp5_))) {
#line 595 "../src/puzzle-view.vala"
				break;
#line 3294 "puzzle-view.c"
			}
#line 596 "../src/puzzle-view.vala"
			_tmp7_ = self->priv->sockets_xs;
#line 596 "../src/puzzle-view.vala"
			_tmp7__length1 = self->priv->sockets_xs_length1;
#line 596 "../src/puzzle-view.vala"
			_tmp7__length2 = self->priv->sockets_xs_length2;
#line 596 "../src/puzzle-view.vala"
			_tmp8_ = _tmp7_[(_vala_tile_x * _tmp7__length2) + 0];
#line 596 "../src/puzzle-view.vala"
			if (event_x > _tmp8_) {
#line 3306 "puzzle-view.c"
				gdouble* _tmp9_;
				gint _tmp9__length1;
				gint _tmp9__length2;
				gdouble _tmp10_;
#line 596 "../src/puzzle-view.vala"
				_tmp9_ = self->priv->sockets_xs;
#line 596 "../src/puzzle-view.vala"
				_tmp9__length1 = self->priv->sockets_xs_length1;
#line 596 "../src/puzzle-view.vala"
				_tmp9__length2 = self->priv->sockets_xs_length2;
#line 596 "../src/puzzle-view.vala"
				_tmp10_ = _tmp9_[(_vala_tile_x * _tmp9__length2) + 0];
#line 596 "../src/puzzle-view.vala"
				_tmp6_ = event_x < (_tmp10_ + self->priv->tilesize);
#line 3321 "puzzle-view.c"
			} else {
#line 596 "../src/puzzle-view.vala"
				_tmp6_ = FALSE;
#line 3325 "puzzle-view.c"
			}
#line 596 "../src/puzzle-view.vala"
			if (_tmp6_) {
#line 597 "../src/puzzle-view.vala"
				result = TRUE;
#line 597 "../src/puzzle-view.vala"
				if (tile_x) {
#line 597 "../src/puzzle-view.vala"
					*tile_x = _vala_tile_x;
#line 3335 "puzzle-view.c"
				}
#line 597 "../src/puzzle-view.vala"
				return result;
#line 3339 "puzzle-view.c"
			}
		}
	}
#line 598 "../src/puzzle-view.vala"
	result = FALSE;
#line 598 "../src/puzzle-view.vala"
	if (tile_x) {
#line 598 "../src/puzzle-view.vala"
		*tile_x = _vala_tile_x;
#line 3349 "puzzle-view.c"
	}
#line 598 "../src/puzzle-view.vala"
	return result;
#line 3353 "puzzle-view.c"
}

static inline gboolean
puzzle_view_get_tile_coord_y (PuzzleView* self,
                              gdouble event_y,
                              guint8* tile_y)
{
	guint8 _vala_tile_y = 0U;
	gboolean result;
#line 600 "../src/puzzle-view.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 3365 "puzzle-view.c"
	{
		gboolean _tmp0_ = FALSE;
#line 602 "../src/puzzle-view.vala"
		_vala_tile_y = (guint8) 0;
#line 602 "../src/puzzle-view.vala"
		_tmp0_ = TRUE;
#line 602 "../src/puzzle-view.vala"
		while (TRUE) {
#line 3374 "puzzle-view.c"
			Puzzle* _tmp2_;
			Puzzle* _tmp3_;
			guint8 _tmp4_;
			guint8 _tmp5_;
			gboolean _tmp6_ = FALSE;
			gdouble* _tmp7_;
			gint _tmp7__length1;
			gint _tmp7__length2;
			gdouble _tmp8_;
#line 602 "../src/puzzle-view.vala"
			if (!_tmp0_) {
#line 3386 "puzzle-view.c"
				guint8 _tmp1_;
#line 602 "../src/puzzle-view.vala"
				_tmp1_ = _vala_tile_y;
#line 602 "../src/puzzle-view.vala"
				_vala_tile_y = _tmp1_ + 1;
#line 3392 "puzzle-view.c"
			}
#line 602 "../src/puzzle-view.vala"
			_tmp0_ = FALSE;
#line 602 "../src/puzzle-view.vala"
			_tmp2_ = puzzle_view_get_puzzle (self);
#line 602 "../src/puzzle-view.vala"
			_tmp3_ = _tmp2_;
#line 602 "../src/puzzle-view.vala"
			_tmp4_ = puzzle_get_size (_tmp3_);
#line 602 "../src/puzzle-view.vala"
			_tmp5_ = _tmp4_;
#line 602 "../src/puzzle-view.vala"
			if (!(_vala_tile_y < _tmp5_)) {
#line 602 "../src/puzzle-view.vala"
				break;
#line 3408 "puzzle-view.c"
			}
#line 603 "../src/puzzle-view.vala"
			_tmp7_ = self->priv->sockets_ys;
#line 603 "../src/puzzle-view.vala"
			_tmp7__length1 = self->priv->sockets_ys_length1;
#line 603 "../src/puzzle-view.vala"
			_tmp7__length2 = self->priv->sockets_ys_length2;
#line 603 "../src/puzzle-view.vala"
			_tmp8_ = _tmp7_[(0 * _tmp7__length2) + _vala_tile_y];
#line 603 "../src/puzzle-view.vala"
			if (event_y > _tmp8_) {
#line 3420 "puzzle-view.c"
				gdouble* _tmp9_;
				gint _tmp9__length1;
				gint _tmp9__length2;
				gdouble _tmp10_;
#line 603 "../src/puzzle-view.vala"
				_tmp9_ = self->priv->sockets_ys;
#line 603 "../src/puzzle-view.vala"
				_tmp9__length1 = self->priv->sockets_ys_length1;
#line 603 "../src/puzzle-view.vala"
				_tmp9__length2 = self->priv->sockets_ys_length2;
#line 603 "../src/puzzle-view.vala"
				_tmp10_ = _tmp9_[(0 * _tmp9__length2) + _vala_tile_y];
#line 603 "../src/puzzle-view.vala"
				_tmp6_ = event_y < (_tmp10_ + self->priv->tilesize);
#line 3435 "puzzle-view.c"
			} else {
#line 603 "../src/puzzle-view.vala"
				_tmp6_ = FALSE;
#line 3439 "puzzle-view.c"
			}
#line 603 "../src/puzzle-view.vala"
			if (_tmp6_) {
#line 604 "../src/puzzle-view.vala"
				result = TRUE;
#line 604 "../src/puzzle-view.vala"
				if (tile_y) {
#line 604 "../src/puzzle-view.vala"
					*tile_y = _vala_tile_y;
#line 3449 "puzzle-view.c"
				}
#line 604 "../src/puzzle-view.vala"
				return result;
#line 3453 "puzzle-view.c"
			}
		}
	}
#line 605 "../src/puzzle-view.vala"
	result = FALSE;
#line 605 "../src/puzzle-view.vala"
	if (tile_y) {
#line 605 "../src/puzzle-view.vala"
		*tile_y = _vala_tile_y;
#line 3463 "puzzle-view.c"
	}
#line 605 "../src/puzzle-view.vala"
	return result;
#line 3467 "puzzle-view.c"
}

static gboolean
puzzle_view_selection_timeout_cb (PuzzleView* self)
{
	gboolean result;
#line 608 "../src/puzzle-view.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 610 "../src/puzzle-view.vala"
	self->priv->selection_timeout = (guint) 0;
#line 611 "../src/puzzle-view.vala"
	result = FALSE;
#line 611 "../src/puzzle-view.vala"
	return result;
#line 3482 "puzzle-view.c"
}

static gboolean
puzzle_view_on_right_half (PuzzleView* self,
                           gdouble x)
{
	gdouble _tmp0_;
	gboolean result;
#line 614 "../src/puzzle-view.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 616 "../src/puzzle-view.vala"
	_tmp0_ = self->priv->_x_offset_right;
#line 616 "../src/puzzle-view.vala"
	result = x > (_tmp0_ - (self->priv->gap * 0.5));
#line 616 "../src/puzzle-view.vala"
	return result;
#line 3499 "puzzle-view.c"
}

static void
puzzle_view_drop_tile (PuzzleView* self,
                       gdouble x,
                       gdouble y)
{
	PuzzleViewTileImage* _tmp0_;
	gint16 tile_y = 0;
	gdouble _tmp1_;
	Puzzle* _tmp2_;
	Puzzle* _tmp3_;
	guint8 _tmp4_;
	guint8 _tmp5_;
	gint16 tile_x = 0;
	guint8 selected_x = 0U;
	guint8 selected_y = 0U;
	Puzzle* _tmp23_;
	Puzzle* _tmp24_;
	PuzzleViewTileImage* _tmp25_;
	Tile* _tmp26_;
	guint8 _tmp27_ = 0U;
	guint8 _tmp28_ = 0U;
	Puzzle* _tmp29_;
	Puzzle* _tmp30_;
	PuzzleViewTileImage* _tmp34_;
#line 619 "../src/puzzle-view.vala"
	g_return_if_fail (self != NULL);
#line 621 "../src/puzzle-view.vala"
	_tmp0_ = self->priv->selected_tile;
#line 621 "../src/puzzle-view.vala"
	if (_tmp0_ == NULL) {
#line 622 "../src/puzzle-view.vala"
		return;
#line 3534 "puzzle-view.c"
	}
#line 625 "../src/puzzle-view.vala"
	x = x + ((self->priv->tilesize * 0.5) - self->priv->selected_x_offset);
#line 626 "../src/puzzle-view.vala"
	y = y + ((self->priv->tilesize * 0.5) - self->priv->selected_y_offset);
#line 628 "../src/puzzle-view.vala"
	_tmp1_ = self->priv->_y_offset;
#line 628 "../src/puzzle-view.vala"
	tile_y = (gint16) floor ((y - _tmp1_) / self->priv->tilesize);
#line 629 "../src/puzzle-view.vala"
	_tmp2_ = puzzle_view_get_puzzle (self);
#line 629 "../src/puzzle-view.vala"
	_tmp3_ = _tmp2_;
#line 629 "../src/puzzle-view.vala"
	_tmp4_ = puzzle_get_size (_tmp3_);
#line 629 "../src/puzzle-view.vala"
	_tmp5_ = _tmp4_;
#line 629 "../src/puzzle-view.vala"
	tile_y = CLAMP (tile_y, (gint16) 0, (gint16) (((gint16) _tmp5_) - 1));
#line 633 "../src/puzzle-view.vala"
	if (puzzle_view_on_right_half (self, x)) {
#line 3556 "puzzle-view.c"
		Puzzle* _tmp6_;
		Puzzle* _tmp7_;
		guint8 _tmp8_;
		guint8 _tmp9_;
		gdouble _tmp10_;
		Puzzle* _tmp11_;
		Puzzle* _tmp12_;
		guint8 _tmp13_;
		guint8 _tmp14_;
		Puzzle* _tmp15_;
		Puzzle* _tmp16_;
		guint8 _tmp17_;
		guint8 _tmp18_;
#line 635 "../src/puzzle-view.vala"
		_tmp6_ = puzzle_view_get_puzzle (self);
#line 635 "../src/puzzle-view.vala"
		_tmp7_ = _tmp6_;
#line 635 "../src/puzzle-view.vala"
		_tmp8_ = puzzle_get_size (_tmp7_);
#line 635 "../src/puzzle-view.vala"
		_tmp9_ = _tmp8_;
#line 635 "../src/puzzle-view.vala"
		_tmp10_ = self->priv->_x_offset_right;
#line 635 "../src/puzzle-view.vala"
		tile_x = ((gint16) _tmp9_) + ((gint16) floor ((x - _tmp10_) / self->priv->tilesize));
#line 636 "../src/puzzle-view.vala"
		_tmp11_ = puzzle_view_get_puzzle (self);
#line 636 "../src/puzzle-view.vala"
		_tmp12_ = _tmp11_;
#line 636 "../src/puzzle-view.vala"
		_tmp13_ = puzzle_get_size (_tmp12_);
#line 636 "../src/puzzle-view.vala"
		_tmp14_ = _tmp13_;
#line 636 "../src/puzzle-view.vala"
		_tmp15_ = puzzle_view_get_puzzle (self);
#line 636 "../src/puzzle-view.vala"
		_tmp16_ = _tmp15_;
#line 636 "../src/puzzle-view.vala"
		_tmp17_ = puzzle_get_size (_tmp16_);
#line 636 "../src/puzzle-view.vala"
		_tmp18_ = _tmp17_;
#line 636 "../src/puzzle-view.vala"
		tile_x = CLAMP (tile_x, (gint16) _tmp14_, (gint16) ((2 * ((gint16) _tmp18_)) - 1));
#line 3600 "puzzle-view.c"
	} else {
		Puzzle* _tmp19_;
		Puzzle* _tmp20_;
		guint8 _tmp21_;
		guint8 _tmp22_;
#line 640 "../src/puzzle-view.vala"
		tile_x = (gint16) floor ((x - self->priv->x_offset) / self->priv->tilesize);
#line 641 "../src/puzzle-view.vala"
		_tmp19_ = puzzle_view_get_puzzle (self);
#line 641 "../src/puzzle-view.vala"
		_tmp20_ = _tmp19_;
#line 641 "../src/puzzle-view.vala"
		_tmp21_ = puzzle_get_size (_tmp20_);
#line 641 "../src/puzzle-view.vala"
		_tmp22_ = _tmp21_;
#line 641 "../src/puzzle-view.vala"
		tile_x = CLAMP (tile_x, (gint16) 0, (gint16) (((gint16) _tmp22_) - 1));
#line 3618 "puzzle-view.c"
	}
#line 646 "../src/puzzle-view.vala"
	_tmp23_ = puzzle_view_get_puzzle (self);
#line 646 "../src/puzzle-view.vala"
	_tmp24_ = _tmp23_;
#line 646 "../src/puzzle-view.vala"
	_tmp25_ = self->priv->selected_tile;
#line 646 "../src/puzzle-view.vala"
	_tmp26_ = G_TYPE_CHECK_INSTANCE_CAST (_tmp25_, PUZZLE_VIEW_TYPE_TILE_IMAGE, PuzzleViewTileImage)->tile;
#line 646 "../src/puzzle-view.vala"
	puzzle_get_tile_location (_tmp24_, _tmp26_, &_tmp27_, &_tmp28_);
#line 646 "../src/puzzle-view.vala"
	selected_x = _tmp27_;
#line 646 "../src/puzzle-view.vala"
	selected_y = _tmp28_;
#line 647 "../src/puzzle-view.vala"
	_tmp29_ = puzzle_view_get_puzzle (self);
#line 647 "../src/puzzle-view.vala"
	_tmp30_ = _tmp29_;
#line 647 "../src/puzzle-view.vala"
	if (puzzle_can_switch (_tmp30_, selected_x, selected_y, (guint8) tile_x, (guint8) tile_y)) {
#line 3640 "puzzle-view.c"
		Puzzle* _tmp31_;
		Puzzle* _tmp32_;
#line 648 "../src/puzzle-view.vala"
		_tmp31_ = puzzle_view_get_puzzle (self);
#line 648 "../src/puzzle-view.vala"
		_tmp32_ = _tmp31_;
#line 648 "../src/puzzle-view.vala"
		puzzle_switch_tiles (_tmp32_, selected_x, selected_y, (guint8) tile_x, (guint8) tile_y, (guint) 0);
#line 3649 "puzzle-view.c"
	} else {
		PuzzleViewTileImage* _tmp33_;
#line 650 "../src/puzzle-view.vala"
		_tmp33_ = self->priv->selected_tile;
#line 650 "../src/puzzle-view.vala"
		puzzle_view_move_tile_to_location (self, G_TYPE_CHECK_INSTANCE_CAST (_tmp33_, PUZZLE_VIEW_TYPE_TILE_IMAGE, PuzzleViewTileImage), (guint) selected_x, (guint) selected_y, PUZZLE_VIEW_animation_duration);
#line 3656 "puzzle-view.c"
	}
#line 651 "../src/puzzle-view.vala"
	_tmp34_ = self->priv->selected_tile;
#line 651 "../src/puzzle-view.vala"
	G_TYPE_CHECK_INSTANCE_CAST (_tmp34_, PUZZLE_VIEW_TYPE_TILE_IMAGE, PuzzleViewTileImage)->snap_to_cursor = TRUE;
#line 652 "../src/puzzle-view.vala"
	_g_object_unref0 (self->priv->selected_tile);
#line 652 "../src/puzzle-view.vala"
	self->priv->selected_tile = NULL;
#line 653 "../src/puzzle-view.vala"
	puzzle_view_set_tile_selected (self, FALSE);
#line 3668 "puzzle-view.c"
}

static void
puzzle_view_move_tile_to_right_half (PuzzleView* self,
                                     Tile* tile)
{
#line 656 "../src/puzzle-view.vala"
	g_return_if_fail (self != NULL);
#line 656 "../src/puzzle-view.vala"
	g_return_if_fail (tile != NULL);
#line 3679 "puzzle-view.c"
	{
		guint8 y = 0U;
#line 659 "../src/puzzle-view.vala"
		y = (guint8) 0;
#line 3684 "puzzle-view.c"
		{
			gboolean _tmp0_ = FALSE;
#line 659 "../src/puzzle-view.vala"
			_tmp0_ = TRUE;
#line 659 "../src/puzzle-view.vala"
			while (TRUE) {
#line 3691 "puzzle-view.c"
				Puzzle* _tmp2_;
				Puzzle* _tmp3_;
				guint8 _tmp4_;
				guint8 _tmp5_;
#line 659 "../src/puzzle-view.vala"
				if (!_tmp0_) {
#line 3698 "puzzle-view.c"
					guint8 _tmp1_;
#line 659 "../src/puzzle-view.vala"
					_tmp1_ = y;
#line 659 "../src/puzzle-view.vala"
					y = _tmp1_ + 1;
#line 3704 "puzzle-view.c"
				}
#line 659 "../src/puzzle-view.vala"
				_tmp0_ = FALSE;
#line 659 "../src/puzzle-view.vala"
				_tmp2_ = puzzle_view_get_puzzle (self);
#line 659 "../src/puzzle-view.vala"
				_tmp3_ = _tmp2_;
#line 659 "../src/puzzle-view.vala"
				_tmp4_ = puzzle_get_size (_tmp3_);
#line 659 "../src/puzzle-view.vala"
				_tmp5_ = _tmp4_;
#line 659 "../src/puzzle-view.vala"
				if (!(y < _tmp5_)) {
#line 659 "../src/puzzle-view.vala"
					break;
#line 3720 "puzzle-view.c"
				}
				{
					guint8 x = 0U;
					Puzzle* _tmp6_;
					Puzzle* _tmp7_;
					guint8 _tmp8_;
					guint8 _tmp9_;
#line 661 "../src/puzzle-view.vala"
					_tmp6_ = puzzle_view_get_puzzle (self);
#line 661 "../src/puzzle-view.vala"
					_tmp7_ = _tmp6_;
#line 661 "../src/puzzle-view.vala"
					_tmp8_ = puzzle_get_size (_tmp7_);
#line 661 "../src/puzzle-view.vala"
					_tmp9_ = _tmp8_;
#line 661 "../src/puzzle-view.vala"
					x = _tmp9_;
#line 3738 "puzzle-view.c"
					{
						gboolean _tmp10_ = FALSE;
#line 661 "../src/puzzle-view.vala"
						_tmp10_ = TRUE;
#line 661 "../src/puzzle-view.vala"
						while (TRUE) {
#line 3745 "puzzle-view.c"
							Puzzle* _tmp12_;
							Puzzle* _tmp13_;
							guint8 _tmp14_;
							guint8 _tmp15_;
							Puzzle* _tmp16_;
							Puzzle* _tmp17_;
							Tile* _tmp18_;
							Tile* _tmp19_;
							gboolean _tmp20_;
#line 661 "../src/puzzle-view.vala"
							if (!_tmp10_) {
#line 3757 "puzzle-view.c"
								guint8 _tmp11_;
#line 661 "../src/puzzle-view.vala"
								_tmp11_ = x;
#line 661 "../src/puzzle-view.vala"
								x = _tmp11_ + 1;
#line 3763 "puzzle-view.c"
							}
#line 661 "../src/puzzle-view.vala"
							_tmp10_ = FALSE;
#line 661 "../src/puzzle-view.vala"
							_tmp12_ = puzzle_view_get_puzzle (self);
#line 661 "../src/puzzle-view.vala"
							_tmp13_ = _tmp12_;
#line 661 "../src/puzzle-view.vala"
							_tmp14_ = puzzle_get_size (_tmp13_);
#line 661 "../src/puzzle-view.vala"
							_tmp15_ = _tmp14_;
#line 661 "../src/puzzle-view.vala"
							if (!(((gint) x) < (_tmp15_ * 2))) {
#line 661 "../src/puzzle-view.vala"
								break;
#line 3779 "puzzle-view.c"
							}
#line 663 "../src/puzzle-view.vala"
							_tmp16_ = puzzle_view_get_puzzle (self);
#line 663 "../src/puzzle-view.vala"
							_tmp17_ = _tmp16_;
#line 663 "../src/puzzle-view.vala"
							_tmp18_ = puzzle_get_tile (_tmp17_, x, y);
#line 663 "../src/puzzle-view.vala"
							_tmp19_ = _tmp18_;
#line 663 "../src/puzzle-view.vala"
							_tmp20_ = _tmp19_ == NULL;
#line 663 "../src/puzzle-view.vala"
							_g_object_unref0 (_tmp19_);
#line 663 "../src/puzzle-view.vala"
							if (_tmp20_) {
#line 3795 "puzzle-view.c"
								guint8 source_x = 0U;
								guint8 source_y = 0U;
								Puzzle* _tmp21_;
								Puzzle* _tmp22_;
								guint8 _tmp23_ = 0U;
								guint8 _tmp24_ = 0U;
								Puzzle* _tmp25_;
								Puzzle* _tmp26_;
#line 666 "../src/puzzle-view.vala"
								_tmp21_ = puzzle_view_get_puzzle (self);
#line 666 "../src/puzzle-view.vala"
								_tmp22_ = _tmp21_;
#line 666 "../src/puzzle-view.vala"
								puzzle_get_tile_location (_tmp22_, tile, &_tmp23_, &_tmp24_);
#line 666 "../src/puzzle-view.vala"
								source_x = _tmp23_;
#line 666 "../src/puzzle-view.vala"
								source_y = _tmp24_;
#line 667 "../src/puzzle-view.vala"
								_tmp25_ = puzzle_view_get_puzzle (self);
#line 667 "../src/puzzle-view.vala"
								_tmp26_ = _tmp25_;
#line 667 "../src/puzzle-view.vala"
								puzzle_switch_tiles (_tmp26_, source_x, source_y, x, y, (guint) 0);
#line 668 "../src/puzzle-view.vala"
								return;
#line 3822 "puzzle-view.c"
							}
						}
					}
				}
			}
		}
	}
#line 672 "../src/puzzle-view.vala"
	g_assert_not_reached ();
#line 3832 "puzzle-view.c"
}

static void
_puzzle_view_on_motion_gtk_event_controller_motion_motion (GtkEventControllerMotion* _sender,
                                                           gdouble x,
                                                           gdouble y,
                                                           gpointer self)
{
#line 685 "../src/puzzle-view.vala"
	puzzle_view_on_motion ((PuzzleView*) self, _sender, x, y);
#line 3843 "puzzle-view.c"
}

static void
_puzzle_view_on_click_gtk_gesture_multi_press_pressed (GtkGestureMultiPress* _sender,
                                                       gint n_press,
                                                       gdouble x,
                                                       gdouble y,
                                                       gpointer self)
{
#line 691 "../src/puzzle-view.vala"
	puzzle_view_on_click ((PuzzleView*) self, _sender, n_press, x, y);
#line 3855 "puzzle-view.c"
}

static void
_puzzle_view_on_release_gtk_gesture_multi_press_released (GtkGestureMultiPress* _sender,
                                                          gint n_press,
                                                          gdouble x,
                                                          gdouble y,
                                                          gpointer self)
{
#line 692 "../src/puzzle-view.vala"
	puzzle_view_on_release ((PuzzleView*) self, _sender, n_press, x, y);
#line 3867 "puzzle-view.c"
}

static void
puzzle_view_init_mouse (PuzzleView* self)
{
	GtkEventControllerMotion* _tmp0_;
	GtkEventControllerMotion* _tmp1_;
	GtkGestureMultiPress* _tmp2_;
	GtkGestureMultiPress* _tmp3_;
	GtkGestureMultiPress* _tmp4_;
	GtkGestureMultiPress* _tmp5_;
#line 682 "../src/puzzle-view.vala"
	g_return_if_fail (self != NULL);
#line 684 "../src/puzzle-view.vala"
	_tmp0_ = (GtkEventControllerMotion*) gtk_event_controller_motion_new ((GtkWidget*) self);
#line 684 "../src/puzzle-view.vala"
	_g_object_unref0 (self->priv->motion_controller);
#line 684 "../src/puzzle-view.vala"
	self->priv->motion_controller = _tmp0_;
#line 685 "../src/puzzle-view.vala"
	_tmp1_ = self->priv->motion_controller;
#line 685 "../src/puzzle-view.vala"
	g_signal_connect_object (_tmp1_, "motion", (GCallback) _puzzle_view_on_motion_gtk_event_controller_motion_motion, self, 0);
#line 689 "../src/puzzle-view.vala"
	_tmp2_ = (GtkGestureMultiPress*) gtk_gesture_multi_press_new ((GtkWidget*) self);
#line 689 "../src/puzzle-view.vala"
	_g_object_unref0 (self->priv->click_controller);
#line 689 "../src/puzzle-view.vala"
	self->priv->click_controller = _tmp2_;
#line 690 "../src/puzzle-view.vala"
	_tmp3_ = self->priv->click_controller;
#line 690 "../src/puzzle-view.vala"
	gtk_gesture_single_set_button ((GtkGestureSingle*) _tmp3_, (guint) 0);
#line 691 "../src/puzzle-view.vala"
	_tmp4_ = self->priv->click_controller;
#line 691 "../src/puzzle-view.vala"
	g_signal_connect_object (_tmp4_, "pressed", (GCallback) _puzzle_view_on_click_gtk_gesture_multi_press_pressed, self, 0);
#line 692 "../src/puzzle-view.vala"
	_tmp5_ = self->priv->click_controller;
#line 692 "../src/puzzle-view.vala"
	g_signal_connect_object (_tmp5_, "released", (GCallback) _puzzle_view_on_release_gtk_gesture_multi_press_released, self, 0);
#line 3909 "puzzle-view.c"
}

static inline void
puzzle_view_on_click (PuzzleView* self,
                      GtkGestureMultiPress* _click_controller,
                      gint n_press,
                      gdouble event_x,
                      gdouble event_y)
{
	gboolean _tmp0_ = FALSE;
	Puzzle* _tmp1_;
	Puzzle* _tmp2_;
	gboolean _tmp3_;
	gboolean _tmp4_;
	guint button = 0U;
	gboolean _tmp9_ = FALSE;
	gboolean _tmp10_;
	gint _tmp11_;
#line 699 "../src/puzzle-view.vala"
	g_return_if_fail (self != NULL);
#line 699 "../src/puzzle-view.vala"
	g_return_if_fail (_click_controller != NULL);
#line 701 "../src/puzzle-view.vala"
	_tmp1_ = puzzle_view_get_puzzle (self);
#line 701 "../src/puzzle-view.vala"
	_tmp2_ = _tmp1_;
#line 701 "../src/puzzle-view.vala"
	_tmp3_ = puzzle_get_paused (_tmp2_);
#line 701 "../src/puzzle-view.vala"
	_tmp4_ = _tmp3_;
#line 701 "../src/puzzle-view.vala"
	if (_tmp4_) {
#line 701 "../src/puzzle-view.vala"
		_tmp0_ = TRUE;
#line 3944 "puzzle-view.c"
	} else {
		Puzzle* _tmp5_;
		Puzzle* _tmp6_;
		gboolean _tmp7_;
		gboolean _tmp8_;
#line 701 "../src/puzzle-view.vala"
		_tmp5_ = puzzle_view_get_puzzle (self);
#line 701 "../src/puzzle-view.vala"
		_tmp6_ = _tmp5_;
#line 701 "../src/puzzle-view.vala"
		_tmp7_ = puzzle_get_is_solved (_tmp6_);
#line 701 "../src/puzzle-view.vala"
		_tmp8_ = _tmp7_;
#line 701 "../src/puzzle-view.vala"
		_tmp0_ = _tmp8_;
#line 3960 "puzzle-view.c"
	}
#line 701 "../src/puzzle-view.vala"
	if (_tmp0_) {
#line 702 "../src/puzzle-view.vala"
		return;
#line 3966 "puzzle-view.c"
	}
#line 703 "../src/puzzle-view.vala"
	puzzle_view_clear_keyboard_highlight (self, FALSE);
#line 705 "../src/puzzle-view.vala"
	button = gtk_gesture_single_get_current_button ((GtkGestureSingle*) _click_controller);
#line 706 "../src/puzzle-view.vala"
	if (button == ((guint) GDK_BUTTON_PRIMARY)) {
#line 706 "../src/puzzle-view.vala"
		_tmp9_ = TRUE;
#line 3976 "puzzle-view.c"
	} else {
#line 706 "../src/puzzle-view.vala"
		_tmp9_ = button == ((guint) GDK_BUTTON_SECONDARY);
#line 3980 "puzzle-view.c"
	}
#line 706 "../src/puzzle-view.vala"
	if (_tmp9_) {
#line 708 "../src/puzzle-view.vala"
		puzzle_view_main_button_pressed (self, n_press, event_x, event_y);
#line 709 "../src/puzzle-view.vala"
		return;
#line 3988 "puzzle-view.c"
	}
#line 712 "../src/puzzle-view.vala"
	_tmp10_ = self->priv->_mouse_use_extra_buttons;
#line 712 "../src/puzzle-view.vala"
	if (!_tmp10_) {
#line 713 "../src/puzzle-view.vala"
		return;
#line 3996 "puzzle-view.c"
	}
#line 714 "../src/puzzle-view.vala"
	_tmp11_ = self->priv->_mouse_back_button;
#line 714 "../src/puzzle-view.vala"
	if (button == ((guint) _tmp11_)) {
#line 715 "../src/puzzle-view.vala"
		puzzle_view_undo (self);
#line 4004 "puzzle-view.c"
	} else {
		gint _tmp12_;
#line 716 "../src/puzzle-view.vala"
		_tmp12_ = self->priv->_mouse_forward_button;
#line 716 "../src/puzzle-view.vala"
		if (button == ((guint) _tmp12_)) {
#line 717 "../src/puzzle-view.vala"
			puzzle_view_redo (self);
#line 4013 "puzzle-view.c"
		}
	}
}

static inline void
puzzle_view_main_button_pressed (PuzzleView* self,
                                 gint n_press,
                                 gdouble event_x,
                                 gdouble event_y)
{
	Puzzle* _tmp0_;
	Puzzle* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
#line 720 "../src/puzzle-view.vala"
	g_return_if_fail (self != NULL);
#line 722 "../src/puzzle-view.vala"
	_tmp0_ = puzzle_view_get_puzzle (self);
#line 722 "../src/puzzle-view.vala"
	_tmp1_ = _tmp0_;
#line 722 "../src/puzzle-view.vala"
	_tmp2_ = puzzle_get_is_solved (_tmp1_);
#line 722 "../src/puzzle-view.vala"
	_tmp3_ = _tmp2_;
#line 722 "../src/puzzle-view.vala"
	if (_tmp3_) {
#line 723 "../src/puzzle-view.vala"
		return;
#line 4042 "puzzle-view.c"
	}
#line 725 "../src/puzzle-view.vala"
	if (n_press == 1) {
#line 4046 "puzzle-view.c"
		PuzzleViewTileImage* _tmp4_;
#line 727 "../src/puzzle-view.vala"
		_tmp4_ = self->priv->selected_tile;
#line 727 "../src/puzzle-view.vala"
		if (_tmp4_ == NULL) {
#line 728 "../src/puzzle-view.vala"
			puzzle_view_pick_tile (self, event_x, event_y);
#line 4054 "puzzle-view.c"
		} else {
#line 730 "../src/puzzle-view.vala"
			puzzle_view_drop_tile (self, event_x, event_y);
#line 4058 "puzzle-view.c"
		}
	} else {
		gboolean had_selected_tile = FALSE;
		PuzzleViewTileImage* _tmp5_;
		PuzzleViewTileImage* _tmp6_;
		PuzzleViewTileImage* _tmp7_;
		PuzzleViewTileImage* _tmp25_;
#line 734 "../src/puzzle-view.vala"
		_tmp5_ = self->priv->selected_tile;
#line 734 "../src/puzzle-view.vala"
		had_selected_tile = _tmp5_ != NULL;
#line 737 "../src/puzzle-view.vala"
		puzzle_view_pick_tile (self, event_x, event_y);
#line 738 "../src/puzzle-view.vala"
		_tmp6_ = self->priv->selected_tile;
#line 738 "../src/puzzle-view.vala"
		if (_tmp6_ == NULL) {
#line 739 "../src/puzzle-view.vala"
			return;
#line 4078 "puzzle-view.c"
		}
#line 741 "../src/puzzle-view.vala"
		_tmp7_ = self->priv->selected_tile;
#line 741 "../src/puzzle-view.vala"
		if (puzzle_view_on_right_half (self, G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, PUZZLE_VIEW_TYPE_TILE_IMAGE, PuzzleViewTileImage)->x)) {
#line 4084 "puzzle-view.c"
			guint8 x = 0U;
			guint8 y = 0U;
			Puzzle* _tmp8_;
			Puzzle* _tmp9_;
			guint8 _tmp10_ = 0U;
			guint8 _tmp11_ = 0U;
			gboolean _tmp12_;
#line 745 "../src/puzzle-view.vala"
			_tmp8_ = puzzle_view_get_puzzle (self);
#line 745 "../src/puzzle-view.vala"
			_tmp9_ = _tmp8_;
#line 745 "../src/puzzle-view.vala"
			_tmp12_ = puzzle_only_one_remaining_tile (_tmp9_, &_tmp10_, &_tmp11_);
#line 745 "../src/puzzle-view.vala"
			x = _tmp10_;
#line 745 "../src/puzzle-view.vala"
			y = _tmp11_;
#line 745 "../src/puzzle-view.vala"
			if (_tmp12_) {
#line 4104 "puzzle-view.c"
				guint8 selected_x = 0U;
				guint8 selected_y = 0U;
				Puzzle* _tmp13_;
				Puzzle* _tmp14_;
				PuzzleViewTileImage* _tmp15_;
				Tile* _tmp16_;
				guint8 _tmp17_ = 0U;
				guint8 _tmp18_ = 0U;
				Puzzle* _tmp19_;
				Puzzle* _tmp20_;
#line 748 "../src/puzzle-view.vala"
				_tmp13_ = puzzle_view_get_puzzle (self);
#line 748 "../src/puzzle-view.vala"
				_tmp14_ = _tmp13_;
#line 748 "../src/puzzle-view.vala"
				_tmp15_ = self->priv->selected_tile;
#line 748 "../src/puzzle-view.vala"
				_tmp16_ = G_TYPE_CHECK_INSTANCE_CAST (_tmp15_, PUZZLE_VIEW_TYPE_TILE_IMAGE, PuzzleViewTileImage)->tile;
#line 748 "../src/puzzle-view.vala"
				puzzle_get_tile_location (_tmp14_, _tmp16_, &_tmp17_, &_tmp18_);
#line 748 "../src/puzzle-view.vala"
				selected_x = _tmp17_;
#line 748 "../src/puzzle-view.vala"
				selected_y = _tmp18_;
#line 749 "../src/puzzle-view.vala"
				_tmp19_ = puzzle_view_get_puzzle (self);
#line 749 "../src/puzzle-view.vala"
				_tmp20_ = _tmp19_;
#line 749 "../src/puzzle-view.vala"
				if (puzzle_can_switch (_tmp20_, selected_x, selected_y, x, y)) {
#line 4135 "puzzle-view.c"
					Puzzle* _tmp21_;
					Puzzle* _tmp22_;
#line 750 "../src/puzzle-view.vala"
					_tmp21_ = puzzle_view_get_puzzle (self);
#line 750 "../src/puzzle-view.vala"
					_tmp22_ = _tmp21_;
#line 750 "../src/puzzle-view.vala"
					puzzle_switch_tiles (_tmp22_, selected_x, selected_y, x, y, PUZZLE_VIEW_final_animation_duration);
#line 4144 "puzzle-view.c"
				} else {
#line 753 "../src/puzzle-view.vala"
					if (had_selected_tile) {
#line 754 "../src/puzzle-view.vala"
						puzzle_view_drop_tile (self, event_x, event_y);
#line 4150 "puzzle-view.c"
					}
#line 755 "../src/puzzle-view.vala"
					return;
#line 4154 "puzzle-view.c"
				}
			} else {
#line 760 "../src/puzzle-view.vala"
				if (had_selected_tile) {
#line 761 "../src/puzzle-view.vala"
					puzzle_view_drop_tile (self, event_x, event_y);
#line 4161 "puzzle-view.c"
				}
#line 762 "../src/puzzle-view.vala"
				return;
#line 4165 "puzzle-view.c"
			}
		} else {
#line 765 "../src/puzzle-view.vala"
			if (!had_selected_tile) {
#line 4170 "puzzle-view.c"
				PuzzleViewTileImage* _tmp23_;
				Tile* _tmp24_;
#line 766 "../src/puzzle-view.vala"
				_tmp23_ = self->priv->selected_tile;
#line 766 "../src/puzzle-view.vala"
				_tmp24_ = G_TYPE_CHECK_INSTANCE_CAST (_tmp23_, PUZZLE_VIEW_TYPE_TILE_IMAGE, PuzzleViewTileImage)->tile;
#line 766 "../src/puzzle-view.vala"
				puzzle_view_move_tile_to_right_half (self, _tmp24_);
#line 4179 "puzzle-view.c"
			}
		}
#line 767 "../src/puzzle-view.vala"
		_tmp25_ = self->priv->selected_tile;
#line 767 "../src/puzzle-view.vala"
		G_TYPE_CHECK_INSTANCE_CAST (_tmp25_, PUZZLE_VIEW_TYPE_TILE_IMAGE, PuzzleViewTileImage)->snap_to_cursor = TRUE;
#line 768 "../src/puzzle-view.vala"
		_g_object_unref0 (self->priv->selected_tile);
#line 768 "../src/puzzle-view.vala"
		self->priv->selected_tile = NULL;
#line 769 "../src/puzzle-view.vala"
		puzzle_view_set_tile_selected (self, FALSE);
#line 4192 "puzzle-view.c"
	}
}

static inline void
puzzle_view_on_release (PuzzleView* self,
                        GtkGestureMultiPress* _click_controller,
                        gint n_press,
                        gdouble event_x,
                        gdouble event_y)
{
	gboolean _tmp0_ = FALSE;
	Puzzle* _tmp1_;
	Puzzle* _tmp2_;
	gboolean _tmp3_;
	gboolean _tmp4_;
	guint button = 0U;
	gboolean _tmp9_ = FALSE;
	gboolean _tmp10_ = FALSE;
	gboolean _tmp11_ = FALSE;
#line 773 "../src/puzzle-view.vala"
	g_return_if_fail (self != NULL);
#line 773 "../src/puzzle-view.vala"
	g_return_if_fail (_click_controller != NULL);
#line 775 "../src/puzzle-view.vala"
	_tmp1_ = puzzle_view_get_puzzle (self);
#line 775 "../src/puzzle-view.vala"
	_tmp2_ = _tmp1_;
#line 775 "../src/puzzle-view.vala"
	_tmp3_ = puzzle_get_paused (_tmp2_);
#line 775 "../src/puzzle-view.vala"
	_tmp4_ = _tmp3_;
#line 775 "../src/puzzle-view.vala"
	if (_tmp4_) {
#line 775 "../src/puzzle-view.vala"
		_tmp0_ = TRUE;
#line 4228 "puzzle-view.c"
	} else {
		Puzzle* _tmp5_;
		Puzzle* _tmp6_;
		gboolean _tmp7_;
		gboolean _tmp8_;
#line 775 "../src/puzzle-view.vala"
		_tmp5_ = puzzle_view_get_puzzle (self);
#line 775 "../src/puzzle-view.vala"
		_tmp6_ = _tmp5_;
#line 775 "../src/puzzle-view.vala"
		_tmp7_ = puzzle_get_is_solved (_tmp6_);
#line 775 "../src/puzzle-view.vala"
		_tmp8_ = _tmp7_;
#line 775 "../src/puzzle-view.vala"
		_tmp0_ = _tmp8_;
#line 4244 "puzzle-view.c"
	}
#line 775 "../src/puzzle-view.vala"
	if (_tmp0_) {
#line 776 "../src/puzzle-view.vala"
		return;
#line 4250 "puzzle-view.c"
	}
#line 777 "../src/puzzle-view.vala"
	puzzle_view_clear_keyboard_highlight (self, FALSE);
#line 779 "../src/puzzle-view.vala"
	button = gtk_gesture_single_get_button ((GtkGestureSingle*) _click_controller);
#line 780 "../src/puzzle-view.vala"
	if (button == ((guint) GDK_BUTTON_PRIMARY)) {
#line 780 "../src/puzzle-view.vala"
		_tmp11_ = TRUE;
#line 4260 "puzzle-view.c"
	} else {
#line 780 "../src/puzzle-view.vala"
		_tmp11_ = button == ((guint) GDK_BUTTON_SECONDARY);
#line 4264 "puzzle-view.c"
	}
#line 780 "../src/puzzle-view.vala"
	if (_tmp11_) {
#line 4268 "puzzle-view.c"
		PuzzleViewTileImage* _tmp12_;
#line 781 "../src/puzzle-view.vala"
		_tmp12_ = self->priv->selected_tile;
#line 781 "../src/puzzle-view.vala"
		_tmp10_ = _tmp12_ != NULL;
#line 4274 "puzzle-view.c"
	} else {
#line 780 "../src/puzzle-view.vala"
		_tmp10_ = FALSE;
#line 4278 "puzzle-view.c"
	}
#line 780 "../src/puzzle-view.vala"
	if (_tmp10_) {
#line 781 "../src/puzzle-view.vala"
		_tmp9_ = self->priv->selection_timeout == ((guint) 0);
#line 4284 "puzzle-view.c"
	} else {
#line 780 "../src/puzzle-view.vala"
		_tmp9_ = FALSE;
#line 4288 "puzzle-view.c"
	}
#line 780 "../src/puzzle-view.vala"
	if (_tmp9_) {
#line 782 "../src/puzzle-view.vala"
		puzzle_view_drop_tile (self, event_x, event_y);
#line 4294 "puzzle-view.c"
	}
#line 784 "../src/puzzle-view.vala"
	if (self->priv->selection_timeout != ((guint) 0)) {
#line 785 "../src/puzzle-view.vala"
		g_source_remove (self->priv->selection_timeout);
#line 4300 "puzzle-view.c"
	}
#line 786 "../src/puzzle-view.vala"
	self->priv->selection_timeout = (guint) 0;
#line 4304 "puzzle-view.c"
}

static inline void
puzzle_view_on_motion (PuzzleView* self,
                       GtkEventControllerMotion* _motion_controller,
                       gdouble event_x,
                       gdouble event_y)
{
	PuzzleViewTileImage* _tmp0_;
#line 789 "../src/puzzle-view.vala"
	g_return_if_fail (self != NULL);
#line 789 "../src/puzzle-view.vala"
	g_return_if_fail (_motion_controller != NULL);
#line 791 "../src/puzzle-view.vala"
	_tmp0_ = self->priv->selected_tile;
#line 791 "../src/puzzle-view.vala"
	if (_tmp0_ != NULL) {
#line 4322 "puzzle-view.c"
		gint new_x = 0;
		gint new_y = 0;
		gdouble duration = 0.0;
		PuzzleViewTileImage* _tmp1_;
		PuzzleViewTileImage* _tmp3_;
#line 793 "../src/puzzle-view.vala"
		new_x = CLAMP ((gint) (event_x - self->priv->selected_x_offset), 0, self->priv->board_x_maxi);
#line 794 "../src/puzzle-view.vala"
		new_y = CLAMP ((gint) (event_y - self->priv->selected_y_offset), 0, self->priv->board_y_maxi);
#line 797 "../src/puzzle-view.vala"
		_tmp1_ = self->priv->selected_tile;
#line 797 "../src/puzzle-view.vala"
		if (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, PUZZLE_VIEW_TYPE_TILE_IMAGE, PuzzleViewTileImage)->snap_to_cursor) {
#line 798 "../src/puzzle-view.vala"
			duration = 0.0;
#line 4338 "puzzle-view.c"
		} else {
			PuzzleViewTileImage* _tmp2_;
#line 800 "../src/puzzle-view.vala"
			_tmp2_ = self->priv->selected_tile;
#line 800 "../src/puzzle-view.vala"
			duration = G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, PUZZLE_VIEW_TYPE_TILE_IMAGE, PuzzleViewTileImage)->duration;
#line 4345 "puzzle-view.c"
		}
#line 802 "../src/puzzle-view.vala"
		_tmp3_ = self->priv->selected_tile;
#line 802 "../src/puzzle-view.vala"
		puzzle_view_move_tile (self, G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, PUZZLE_VIEW_TYPE_TILE_IMAGE, PuzzleViewTileImage), (gdouble) new_x, (gdouble) new_y, duration);
#line 4351 "puzzle-view.c"
	}
}

static gboolean
puzzle_view_real_leave_notify_event (GtkWidget* base,
                                     GdkEventCrossing* event)
{
	PuzzleView * self;
	PuzzleViewTileImage* _tmp0_;
	gboolean result;
#line 807 "../src/puzzle-view.vala"
	self = (PuzzleView*) base;
#line 807 "../src/puzzle-view.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 809 "../src/puzzle-view.vala"
	_tmp0_ = self->priv->selected_tile;
#line 809 "../src/puzzle-view.vala"
	if (_tmp0_ != NULL) {
#line 4370 "puzzle-view.c"
		PuzzleViewTileImage* _tmp1_;
#line 810 "../src/puzzle-view.vala"
		_tmp1_ = self->priv->selected_tile;
#line 810 "../src/puzzle-view.vala"
		G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, PUZZLE_VIEW_TYPE_TILE_IMAGE, PuzzleViewTileImage)->snap_to_cursor = FALSE;
#line 4376 "puzzle-view.c"
	}
#line 812 "../src/puzzle-view.vala"
	result = FALSE;
#line 812 "../src/puzzle-view.vala"
	return result;
#line 4382 "puzzle-view.c"
}

static gboolean
puzzle_view_real_enter_notify_event (GtkWidget* base,
                                     GdkEventCrossing* event)
{
	PuzzleView * self;
	PuzzleViewTileImage* _tmp0_;
	gboolean result;
#line 816 "../src/puzzle-view.vala"
	self = (PuzzleView*) base;
#line 816 "../src/puzzle-view.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 818 "../src/puzzle-view.vala"
	_tmp0_ = self->priv->selected_tile;
#line 818 "../src/puzzle-view.vala"
	if (_tmp0_ != NULL) {
#line 4400 "puzzle-view.c"
		PuzzleViewTileImage* _tmp1_;
		PuzzleViewTileImage* _tmp2_;
#line 820 "../src/puzzle-view.vala"
		_tmp1_ = self->priv->selected_tile;
#line 820 "../src/puzzle-view.vala"
		G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, PUZZLE_VIEW_TYPE_TILE_IMAGE, PuzzleViewTileImage)->snap_to_cursor = FALSE;
#line 821 "../src/puzzle-view.vala"
		_tmp2_ = self->priv->selected_tile;
#line 821 "../src/puzzle-view.vala"
		G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, PUZZLE_VIEW_TYPE_TILE_IMAGE, PuzzleViewTileImage)->duration = PUZZLE_VIEW_half_animation_duration;
#line 4411 "puzzle-view.c"
	}
#line 824 "../src/puzzle-view.vala"
	result = FALSE;
#line 824 "../src/puzzle-view.vala"
	return result;
#line 4417 "puzzle-view.c"
}

void
puzzle_view_finish (PuzzleView* self)
{
	Puzzle* _tmp0_;
	Puzzle* _tmp1_;
#line 827 "../src/puzzle-view.vala"
	g_return_if_fail (self != NULL);
#line 829 "../src/puzzle-view.vala"
	_tmp0_ = puzzle_view_get_puzzle (self);
#line 829 "../src/puzzle-view.vala"
	_tmp1_ = _tmp0_;
#line 829 "../src/puzzle-view.vala"
	puzzle_finish (_tmp1_, PUZZLE_VIEW_final_animation_duration);
#line 4433 "puzzle-view.c"
}

void
puzzle_view_release_selected_tile (PuzzleView* self)
{
	PuzzleViewTileImage* _tmp0_;
	guint8 selected_x = 0U;
	guint8 selected_y = 0U;
	Puzzle* _tmp1_;
	Puzzle* _tmp2_;
	PuzzleViewTileImage* _tmp3_;
	Tile* _tmp4_;
	guint8 _tmp5_ = 0U;
	guint8 _tmp6_ = 0U;
	PuzzleViewTileImage* _tmp7_;
	PuzzleViewTileImage* _tmp8_;
#line 832 "../src/puzzle-view.vala"
	g_return_if_fail (self != NULL);
#line 834 "../src/puzzle-view.vala"
	_tmp0_ = self->priv->selected_tile;
#line 834 "../src/puzzle-view.vala"
	if (_tmp0_ == NULL) {
#line 835 "../src/puzzle-view.vala"
		return;
#line 4458 "puzzle-view.c"
	}
#line 838 "../src/puzzle-view.vala"
	_tmp1_ = puzzle_view_get_puzzle (self);
#line 838 "../src/puzzle-view.vala"
	_tmp2_ = _tmp1_;
#line 838 "../src/puzzle-view.vala"
	_tmp3_ = self->priv->selected_tile;
#line 838 "../src/puzzle-view.vala"
	_tmp4_ = G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, PUZZLE_VIEW_TYPE_TILE_IMAGE, PuzzleViewTileImage)->tile;
#line 838 "../src/puzzle-view.vala"
	puzzle_get_tile_location (_tmp2_, _tmp4_, &_tmp5_, &_tmp6_);
#line 838 "../src/puzzle-view.vala"
	selected_x = _tmp5_;
#line 838 "../src/puzzle-view.vala"
	selected_y = _tmp6_;
#line 839 "../src/puzzle-view.vala"
	_tmp7_ = self->priv->selected_tile;
#line 839 "../src/puzzle-view.vala"
	puzzle_view_move_tile_to_location (self, G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, PUZZLE_VIEW_TYPE_TILE_IMAGE, PuzzleViewTileImage), (guint) selected_x, (guint) selected_y, PUZZLE_VIEW_animation_duration);
#line 840 "../src/puzzle-view.vala"
	_tmp8_ = self->priv->selected_tile;
#line 840 "../src/puzzle-view.vala"
	G_TYPE_CHECK_INSTANCE_CAST (_tmp8_, PUZZLE_VIEW_TYPE_TILE_IMAGE, PuzzleViewTileImage)->snap_to_cursor = TRUE;
#line 841 "../src/puzzle-view.vala"
	_g_object_unref0 (self->priv->selected_tile);
#line 841 "../src/puzzle-view.vala"
	self->priv->selected_tile = NULL;
#line 842 "../src/puzzle-view.vala"
	puzzle_view_set_tile_selected (self, FALSE);
#line 4488 "puzzle-view.c"
}

void
puzzle_view_undo (PuzzleView* self)
{
	Puzzle* _tmp0_;
	Puzzle* _tmp1_;
#line 849 "../src/puzzle-view.vala"
	g_return_if_fail (self != NULL);
#line 851 "../src/puzzle-view.vala"
	_g_object_unref0 (self->priv->last_selected_tile);
#line 851 "../src/puzzle-view.vala"
	self->priv->last_selected_tile = NULL;
#line 852 "../src/puzzle-view.vala"
	_tmp0_ = puzzle_view_get_puzzle (self);
#line 852 "../src/puzzle-view.vala"
	_tmp1_ = _tmp0_;
#line 852 "../src/puzzle-view.vala"
	puzzle_undo (_tmp1_);
#line 4508 "puzzle-view.c"
}

void
puzzle_view_redo (PuzzleView* self)
{
	Puzzle* _tmp0_;
	Puzzle* _tmp1_;
#line 855 "../src/puzzle-view.vala"
	g_return_if_fail (self != NULL);
#line 857 "../src/puzzle-view.vala"
	_g_object_unref0 (self->priv->last_selected_tile);
#line 857 "../src/puzzle-view.vala"
	self->priv->last_selected_tile = NULL;
#line 858 "../src/puzzle-view.vala"
	_tmp0_ = puzzle_view_get_puzzle (self);
#line 858 "../src/puzzle-view.vala"
	_tmp1_ = _tmp0_;
#line 858 "../src/puzzle-view.vala"
	puzzle_redo (_tmp1_);
#line 4528 "puzzle-view.c"
}

void
puzzle_view_reload (PuzzleView* self)
{
	Puzzle* _tmp0_;
	Puzzle* _tmp1_;
#line 861 "../src/puzzle-view.vala"
	g_return_if_fail (self != NULL);
#line 863 "../src/puzzle-view.vala"
	_g_object_unref0 (self->priv->last_selected_tile);
#line 863 "../src/puzzle-view.vala"
	self->priv->last_selected_tile = NULL;
#line 864 "../src/puzzle-view.vala"
	_tmp0_ = puzzle_view_get_puzzle (self);
#line 864 "../src/puzzle-view.vala"
	_tmp1_ = _tmp0_;
#line 864 "../src/puzzle-view.vala"
	puzzle_reload (_tmp1_);
#line 4548 "puzzle-view.c"
}

static gboolean
__lambda6_ (PuzzleView* self)
{
	guint8 _tmp0_;
	Theme* _tmp1_;
	gboolean result;
#line 877 "../src/puzzle-view.vala"
	_tmp0_ = self->priv->socket_animation_level;
#line 877 "../src/puzzle-view.vala"
	self->priv->socket_animation_level = _tmp0_ + 1;
#line 878 "../src/puzzle-view.vala"
	_tmp1_ = self->priv->theme;
#line 878 "../src/puzzle-view.vala"
	theme_set_animation_level (_tmp1_, self->priv->socket_animation_level);
#line 879 "../src/puzzle-view.vala"
	_cairo_pattern_destroy0 (self->priv->arrow_pattern);
#line 879 "../src/puzzle-view.vala"
	self->priv->arrow_pattern = NULL;
#line 880 "../src/puzzle-view.vala"
	_cairo_pattern_destroy0 (self->priv->socket_pattern);
#line 880 "../src/puzzle-view.vala"
	self->priv->socket_pattern = NULL;
#line 881 "../src/puzzle-view.vala"
	gtk_widget_queue_draw ((GtkWidget*) self);
#line 883 "../src/puzzle-view.vala"
	if (((gint) self->priv->socket_animation_level) < 17) {
#line 884 "../src/puzzle-view.vala"
		result = G_SOURCE_CONTINUE;
#line 884 "../src/puzzle-view.vala"
		return result;
#line 4581 "puzzle-view.c"
	} else {
#line 887 "../src/puzzle-view.vala"
		self->priv->socket_timeout_id = (guint) 0;
#line 888 "../src/puzzle-view.vala"
		result = G_SOURCE_REMOVE;
#line 888 "../src/puzzle-view.vala"
		return result;
#line 4589 "puzzle-view.c"
	}
}

static gboolean
___lambda6__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda6_ ((PuzzleView*) self);
#line 876 "../src/puzzle-view.vala"
	return result;
#line 4600 "puzzle-view.c"
}

void
puzzle_view_hide_right_sockets (PuzzleView* self)
{
#line 874 "../src/puzzle-view.vala"
	g_return_if_fail (self != NULL);
#line 876 "../src/puzzle-view.vala"
	self->priv->socket_timeout_id = g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) 75, ___lambda6__gsource_func, g_object_ref (self), g_object_unref);
#line 4610 "puzzle-view.c"
}

static inline void
puzzle_view_show_right_sockets (PuzzleView* self)
{
	Theme* _tmp0_;
#line 893 "../src/puzzle-view.vala"
	g_return_if_fail (self != NULL);
#line 895 "../src/puzzle-view.vala"
	if (self->priv->socket_timeout_id != ((guint) 0)) {
#line 897 "../src/puzzle-view.vala"
		g_source_remove (self->priv->socket_timeout_id);
#line 898 "../src/puzzle-view.vala"
		self->priv->socket_timeout_id = (guint) 0;
#line 4625 "puzzle-view.c"
	}
#line 900 "../src/puzzle-view.vala"
	self->priv->socket_animation_level = (guint8) 0;
#line 901 "../src/puzzle-view.vala"
	_tmp0_ = self->priv->theme;
#line 901 "../src/puzzle-view.vala"
	theme_set_animation_level (_tmp0_, (guint8) 0);
#line 902 "../src/puzzle-view.vala"
	_cairo_pattern_destroy0 (self->priv->arrow_pattern);
#line 902 "../src/puzzle-view.vala"
	self->priv->arrow_pattern = NULL;
#line 903 "../src/puzzle-view.vala"
	_cairo_pattern_destroy0 (self->priv->socket_pattern);
#line 903 "../src/puzzle-view.vala"
	self->priv->socket_pattern = NULL;
#line 4641 "puzzle-view.c"
}

static gboolean
_puzzle_view_on_key_pressed_gtk_event_controller_key_key_pressed (GtkEventControllerKey* _sender,
                                                                  guint keyval,
                                                                  guint keycode,
                                                                  GdkModifierType state,
                                                                  gpointer self)
{
	gboolean result;
	result = puzzle_view_on_key_pressed ((PuzzleView*) self, _sender, keyval, keycode, state);
#line 927 "../src/puzzle-view.vala"
	return result;
#line 4655 "puzzle-view.c"
}

static void
puzzle_view_init_keyboard (PuzzleView* self)
{
	GtkEventControllerKey* _tmp0_;
	GtkEventControllerKey* _tmp1_;
#line 924 "../src/puzzle-view.vala"
	g_return_if_fail (self != NULL);
#line 926 "../src/puzzle-view.vala"
	_tmp0_ = (GtkEventControllerKey*) gtk_event_controller_key_new ((GtkWidget*) self);
#line 926 "../src/puzzle-view.vala"
	_g_object_unref0 (self->priv->key_controller);
#line 926 "../src/puzzle-view.vala"
	self->priv->key_controller = _tmp0_;
#line 927 "../src/puzzle-view.vala"
	_tmp1_ = self->priv->key_controller;
#line 927 "../src/puzzle-view.vala"
	g_signal_connect_object (_tmp1_, "key-pressed", (GCallback) _puzzle_view_on_key_pressed_gtk_event_controller_key_key_pressed, self, 0);
#line 4675 "puzzle-view.c"
}

static inline gboolean
puzzle_view_on_key_pressed (PuzzleView* self,
                            GtkEventControllerKey* _key_controller,
                            guint keyval,
                            guint keycode,
                            GdkModifierType state)
{
	gboolean _tmp0_ = FALSE;
	Puzzle* _tmp1_;
	Puzzle* _tmp2_;
	gboolean _tmp3_;
	gboolean _tmp4_;
	gboolean _tmp9_;
	const gchar* _tmp10_ = NULL;
	const gchar* _tmp11_;
	gchar* key = NULL;
	gchar* _tmp12_;
	const gchar* _tmp13_;
	gboolean _tmp14_ = FALSE;
	gboolean _tmp15_ = FALSE;
	gboolean _tmp55_ = FALSE;
	gboolean _tmp56_ = FALSE;
	gboolean _tmp57_ = FALSE;
	gboolean _tmp58_ = FALSE;
	gboolean _tmp59_ = FALSE;
	gboolean _tmp60_ = FALSE;
	gboolean _tmp61_ = FALSE;
	gboolean _tmp62_ = FALSE;
	Puzzle* _tmp63_;
	Puzzle* _tmp64_;
	guint8 _tmp65_;
	guint8 _tmp66_;
	const gchar* _tmp158_;
	const gchar* _tmp159_;
	GQuark _tmp161_ = 0U;
#line 1015 "../src/puzzle-view.vala"
	static GQuark _tmp160_label0 = 0;
#line 1015 "../src/puzzle-view.vala"
	static GQuark _tmp160_label1 = 0;
#line 1015 "../src/puzzle-view.vala"
	static GQuark _tmp160_label2 = 0;
#line 1015 "../src/puzzle-view.vala"
	static GQuark _tmp160_label3 = 0;
#line 1015 "../src/puzzle-view.vala"
	static GQuark _tmp160_label4 = 0;
#line 1015 "../src/puzzle-view.vala"
	static GQuark _tmp160_label5 = 0;
#line 1015 "../src/puzzle-view.vala"
	static GQuark _tmp160_label6 = 0;
#line 1015 "../src/puzzle-view.vala"
	static GQuark _tmp160_label7 = 0;
#line 1015 "../src/puzzle-view.vala"
	static GQuark _tmp160_label8 = 0;
#line 1015 "../src/puzzle-view.vala"
	static GQuark _tmp160_label9 = 0;
#line 1015 "../src/puzzle-view.vala"
	static GQuark _tmp160_label10 = 0;
#line 1015 "../src/puzzle-view.vala"
	static GQuark _tmp160_label11 = 0;
#line 1015 "../src/puzzle-view.vala"
	static GQuark _tmp160_label12 = 0;
#line 1015 "../src/puzzle-view.vala"
	static GQuark _tmp160_label13 = 0;
#line 1015 "../src/puzzle-view.vala"
	static GQuark _tmp160_label14 = 0;
#line 1015 "../src/puzzle-view.vala"
	static GQuark _tmp160_label15 = 0;
#line 1015 "../src/puzzle-view.vala"
	static GQuark _tmp160_label16 = 0;
#line 1015 "../src/puzzle-view.vala"
	static GQuark _tmp160_label17 = 0;
#line 1015 "../src/puzzle-view.vala"
	static GQuark _tmp160_label18 = 0;
#line 1015 "../src/puzzle-view.vala"
	static GQuark _tmp160_label19 = 0;
#line 1015 "../src/puzzle-view.vala"
	static GQuark _tmp160_label20 = 0;
#line 1015 "../src/puzzle-view.vala"
	static GQuark _tmp160_label21 = 0;
#line 1015 "../src/puzzle-view.vala"
	static GQuark _tmp160_label22 = 0;
#line 1015 "../src/puzzle-view.vala"
	static GQuark _tmp160_label23 = 0;
#line 1015 "../src/puzzle-view.vala"
	static GQuark _tmp160_label24 = 0;
#line 1015 "../src/puzzle-view.vala"
	static GQuark _tmp160_label25 = 0;
#line 1015 "../src/puzzle-view.vala"
	static GQuark _tmp160_label26 = 0;
#line 1015 "../src/puzzle-view.vala"
	static GQuark _tmp160_label27 = 0;
#line 1015 "../src/puzzle-view.vala"
	static GQuark _tmp160_label28 = 0;
#line 1015 "../src/puzzle-view.vala"
	static GQuark _tmp160_label29 = 0;
#line 1015 "../src/puzzle-view.vala"
	static GQuark _tmp160_label30 = 0;
#line 1015 "../src/puzzle-view.vala"
	static GQuark _tmp160_label31 = 0;
#line 1015 "../src/puzzle-view.vala"
	static GQuark _tmp160_label32 = 0;
#line 1015 "../src/puzzle-view.vala"
	static GQuark _tmp160_label33 = 0;
#line 1015 "../src/puzzle-view.vala"
	static GQuark _tmp160_label34 = 0;
#line 1015 "../src/puzzle-view.vala"
	static GQuark _tmp160_label35 = 0;
#line 1015 "../src/puzzle-view.vala"
	static GQuark _tmp160_label36 = 0;
#line 1015 "../src/puzzle-view.vala"
	static GQuark _tmp160_label37 = 0;
#line 1015 "../src/puzzle-view.vala"
	static GQuark _tmp160_label38 = 0;
#line 1015 "../src/puzzle-view.vala"
	static GQuark _tmp160_label39 = 0;
#line 1015 "../src/puzzle-view.vala"
	static GQuark _tmp160_label40 = 0;
#line 1015 "../src/puzzle-view.vala"
	static GQuark _tmp160_label41 = 0;
#line 1015 "../src/puzzle-view.vala"
	static GQuark _tmp160_label42 = 0;
#line 1015 "../src/puzzle-view.vala"
	static GQuark _tmp160_label43 = 0;
#line 4801 "puzzle-view.c"
	const gchar* _tmp206_;
	gboolean _tmp207_ = FALSE;
	gboolean result;
#line 930 "../src/puzzle-view.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 930 "../src/puzzle-view.vala"
	g_return_val_if_fail (_key_controller != NULL, FALSE);
#line 932 "../src/puzzle-view.vala"
	if (!self->priv->puzzle_init_done) {
#line 933 "../src/puzzle-view.vala"
		result = FALSE;
#line 933 "../src/puzzle-view.vala"
		return result;
#line 4815 "puzzle-view.c"
	}
#line 935 "../src/puzzle-view.vala"
	_tmp1_ = puzzle_view_get_puzzle (self);
#line 935 "../src/puzzle-view.vala"
	_tmp2_ = _tmp1_;
#line 935 "../src/puzzle-view.vala"
	_tmp3_ = puzzle_get_is_solved (_tmp2_);
#line 935 "../src/puzzle-view.vala"
	_tmp4_ = _tmp3_;
#line 935 "../src/puzzle-view.vala"
	if (_tmp4_) {
#line 935 "../src/puzzle-view.vala"
		_tmp0_ = TRUE;
#line 4829 "puzzle-view.c"
	} else {
		Puzzle* _tmp5_;
		Puzzle* _tmp6_;
		gboolean _tmp7_;
		gboolean _tmp8_;
#line 935 "../src/puzzle-view.vala"
		_tmp5_ = puzzle_view_get_puzzle (self);
#line 935 "../src/puzzle-view.vala"
		_tmp6_ = _tmp5_;
#line 935 "../src/puzzle-view.vala"
		_tmp7_ = puzzle_get_paused (_tmp6_);
#line 935 "../src/puzzle-view.vala"
		_tmp8_ = _tmp7_;
#line 935 "../src/puzzle-view.vala"
		_tmp0_ = _tmp8_;
#line 4845 "puzzle-view.c"
	}
#line 935 "../src/puzzle-view.vala"
	if (_tmp0_) {
#line 936 "../src/puzzle-view.vala"
		result = FALSE;
#line 936 "../src/puzzle-view.vala"
		return result;
#line 4853 "puzzle-view.c"
	}
#line 938 "../src/puzzle-view.vala"
	_tmp9_ = self->priv->_tile_selected;
#line 938 "../src/puzzle-view.vala"
	if (_tmp9_) {
#line 939 "../src/puzzle-view.vala"
		result = FALSE;
#line 939 "../src/puzzle-view.vala"
		return result;
#line 4863 "puzzle-view.c"
	}
#line 941 "../src/puzzle-view.vala"
	_tmp11_ = gdk_keyval_name (keyval);
#line 941 "../src/puzzle-view.vala"
	_tmp10_ = _tmp11_;
#line 941 "../src/puzzle-view.vala"
	if (_tmp10_ == NULL) {
#line 941 "../src/puzzle-view.vala"
		_tmp10_ = "";
#line 4873 "puzzle-view.c"
	}
#line 941 "../src/puzzle-view.vala"
	_tmp12_ = g_strdup ((const gchar*) _tmp10_);
#line 941 "../src/puzzle-view.vala"
	key = _tmp12_;
#line 942 "../src/puzzle-view.vala"
	_tmp13_ = key;
#line 942 "../src/puzzle-view.vala"
	if (g_strcmp0 (_tmp13_, "") == 0) {
#line 943 "../src/puzzle-view.vala"
		result = FALSE;
#line 943 "../src/puzzle-view.vala"
		_g_free0 (key);
#line 943 "../src/puzzle-view.vala"
		return result;
#line 4889 "puzzle-view.c"
	}
#line 945 "../src/puzzle-view.vala"
	if (self->priv->highlight_set) {
#line 945 "../src/puzzle-view.vala"
		_tmp15_ = self->priv->show_highlight;
#line 4895 "puzzle-view.c"
	} else {
#line 945 "../src/puzzle-view.vala"
		_tmp15_ = FALSE;
#line 4899 "puzzle-view.c"
	}
#line 945 "../src/puzzle-view.vala"
	if (_tmp15_) {
#line 4903 "puzzle-view.c"
		gboolean _tmp16_ = FALSE;
		gboolean _tmp17_ = FALSE;
		const gchar* _tmp18_;
#line 945 "../src/puzzle-view.vala"
		_tmp18_ = key;
#line 945 "../src/puzzle-view.vala"
		if (g_strcmp0 (_tmp18_, "space") == 0) {
#line 945 "../src/puzzle-view.vala"
			_tmp17_ = TRUE;
#line 4913 "puzzle-view.c"
		} else {
			const gchar* _tmp19_;
#line 945 "../src/puzzle-view.vala"
			_tmp19_ = key;
#line 945 "../src/puzzle-view.vala"
			_tmp17_ = g_strcmp0 (_tmp19_, "Return") == 0;
#line 4920 "puzzle-view.c"
		}
#line 945 "../src/puzzle-view.vala"
		if (_tmp17_) {
#line 945 "../src/puzzle-view.vala"
			_tmp16_ = TRUE;
#line 4926 "puzzle-view.c"
		} else {
			const gchar* _tmp20_;
#line 945 "../src/puzzle-view.vala"
			_tmp20_ = key;
#line 945 "../src/puzzle-view.vala"
			_tmp16_ = g_strcmp0 (_tmp20_, "KP_Enter") == 0;
#line 4933 "puzzle-view.c"
		}
#line 945 "../src/puzzle-view.vala"
		_tmp14_ = _tmp16_;
#line 4937 "puzzle-view.c"
	} else {
#line 945 "../src/puzzle-view.vala"
		_tmp14_ = FALSE;
#line 4941 "puzzle-view.c"
	}
#line 945 "../src/puzzle-view.vala"
	if (_tmp14_) {
#line 947 "../src/puzzle-view.vala"
		if (self->priv->tile_selection) {
#line 4947 "puzzle-view.c"
			gboolean _tmp21_ = FALSE;
			Puzzle* _tmp22_;
			Puzzle* _tmp23_;
			Puzzle* _tmp26_;
			Puzzle* _tmp27_;
			Tile* _tmp28_;
			Tile* _tmp29_;
			gboolean _tmp30_;
#line 949 "../src/puzzle-view.vala"
			if (self->priv->highlight_x == self->priv->kbd_selected_x) {
#line 949 "../src/puzzle-view.vala"
				_tmp21_ = self->priv->highlight_y == self->priv->kbd_selected_y;
#line 4960 "puzzle-view.c"
			} else {
#line 949 "../src/puzzle-view.vala"
				_tmp21_ = FALSE;
#line 4964 "puzzle-view.c"
			}
#line 949 "../src/puzzle-view.vala"
			if (_tmp21_) {
#line 951 "../src/puzzle-view.vala"
				puzzle_view_clear_keyboard_highlight (self, TRUE);
#line 952 "../src/puzzle-view.vala"
				result = TRUE;
#line 952 "../src/puzzle-view.vala"
				_g_free0 (key);
#line 952 "../src/puzzle-view.vala"
				return result;
#line 4976 "puzzle-view.c"
			}
#line 954 "../src/puzzle-view.vala"
			_tmp22_ = puzzle_view_get_puzzle (self);
#line 954 "../src/puzzle-view.vala"
			_tmp23_ = _tmp22_;
#line 954 "../src/puzzle-view.vala"
			if (puzzle_can_switch (_tmp23_, self->priv->highlight_x, self->priv->highlight_y, self->priv->kbd_selected_x, self->priv->kbd_selected_y)) {
#line 4984 "puzzle-view.c"
				Puzzle* _tmp24_;
				Puzzle* _tmp25_;
#line 956 "../src/puzzle-view.vala"
				_tmp24_ = puzzle_view_get_puzzle (self);
#line 956 "../src/puzzle-view.vala"
				_tmp25_ = _tmp24_;
#line 956 "../src/puzzle-view.vala"
				puzzle_switch_tiles (_tmp25_, self->priv->highlight_x, self->priv->highlight_y, self->priv->kbd_selected_x, self->priv->kbd_selected_y, (guint) 0);
#line 957 "../src/puzzle-view.vala"
				puzzle_view_clear_keyboard_highlight (self, TRUE);
#line 958 "../src/puzzle-view.vala"
				result = TRUE;
#line 958 "../src/puzzle-view.vala"
				_g_free0 (key);
#line 958 "../src/puzzle-view.vala"
				return result;
#line 5001 "puzzle-view.c"
			}
#line 960 "../src/puzzle-view.vala"
			_tmp26_ = puzzle_view_get_puzzle (self);
#line 960 "../src/puzzle-view.vala"
			_tmp27_ = _tmp26_;
#line 960 "../src/puzzle-view.vala"
			_tmp28_ = puzzle_get_tile (_tmp27_, self->priv->highlight_x, self->priv->highlight_y);
#line 960 "../src/puzzle-view.vala"
			_tmp29_ = _tmp28_;
#line 960 "../src/puzzle-view.vala"
			_tmp30_ = _tmp29_ != NULL;
#line 960 "../src/puzzle-view.vala"
			_g_object_unref0 (_tmp29_);
#line 960 "../src/puzzle-view.vala"
			if (_tmp30_) {
#line 962 "../src/puzzle-view.vala"
				self->priv->tile_selection = FALSE;
#line 963 "../src/puzzle-view.vala"
				puzzle_view_queue_draw_tile (self, self->priv->kbd_selected_x, self->priv->kbd_selected_y);
#line 964 "../src/puzzle-view.vala"
				self->priv->kbd_selected_x = self->priv->highlight_x;
#line 965 "../src/puzzle-view.vala"
				self->priv->kbd_selected_y = self->priv->highlight_y;
#line 966 "../src/puzzle-view.vala"
				self->priv->tile_selection = TRUE;
#line 967 "../src/puzzle-view.vala"
				puzzle_view_queue_draw_tile (self, self->priv->highlight_x, self->priv->highlight_y);
#line 968 "../src/puzzle-view.vala"
				result = TRUE;
#line 968 "../src/puzzle-view.vala"
				_g_free0 (key);
#line 968 "../src/puzzle-view.vala"
				return result;
#line 5035 "puzzle-view.c"
			}
		} else {
			Tile* tile = NULL;
			Puzzle* _tmp31_;
			Puzzle* _tmp32_;
			Tile* _tmp33_;
			Tile* _tmp34_;
			Puzzle* _tmp37_;
			Puzzle* _tmp38_;
			guint8 _tmp39_;
			guint8 _tmp40_;
#line 973 "../src/puzzle-view.vala"
			_tmp31_ = puzzle_view_get_puzzle (self);
#line 973 "../src/puzzle-view.vala"
			_tmp32_ = _tmp31_;
#line 973 "../src/puzzle-view.vala"
			_tmp33_ = puzzle_get_tile (_tmp32_, self->priv->highlight_x, self->priv->highlight_y);
#line 973 "../src/puzzle-view.vala"
			tile = _tmp33_;
#line 974 "../src/puzzle-view.vala"
			_tmp34_ = tile;
#line 974 "../src/puzzle-view.vala"
			if (_tmp34_ == NULL) {
#line 5059 "puzzle-view.c"
				Puzzle* _tmp35_;
				Puzzle* _tmp36_;
#line 976 "../src/puzzle-view.vala"
				_tmp35_ = puzzle_view_get_puzzle (self);
#line 976 "../src/puzzle-view.vala"
				_tmp36_ = _tmp35_;
#line 976 "../src/puzzle-view.vala"
				puzzle_try_move (_tmp36_, self->priv->highlight_x, self->priv->highlight_y);
#line 977 "../src/puzzle-view.vala"
				result = TRUE;
#line 977 "../src/puzzle-view.vala"
				_g_object_unref0 (tile);
#line 977 "../src/puzzle-view.vala"
				_g_free0 (key);
#line 977 "../src/puzzle-view.vala"
				return result;
#line 5076 "puzzle-view.c"
			}
#line 980 "../src/puzzle-view.vala"
			_tmp37_ = puzzle_view_get_puzzle (self);
#line 980 "../src/puzzle-view.vala"
			_tmp38_ = _tmp37_;
#line 980 "../src/puzzle-view.vala"
			_tmp39_ = puzzle_get_size (_tmp38_);
#line 980 "../src/puzzle-view.vala"
			_tmp40_ = _tmp39_;
#line 980 "../src/puzzle-view.vala"
			if (self->priv->highlight_x >= _tmp40_) {
#line 5088 "puzzle-view.c"
				guint8 x = 0U;
				guint8 y = 0U;
				Puzzle* _tmp41_;
				Puzzle* _tmp42_;
				guint8 _tmp43_ = 0U;
				guint8 _tmp44_ = 0U;
				gboolean _tmp45_;
#line 984 "../src/puzzle-view.vala"
				_tmp41_ = puzzle_view_get_puzzle (self);
#line 984 "../src/puzzle-view.vala"
				_tmp42_ = _tmp41_;
#line 984 "../src/puzzle-view.vala"
				_tmp45_ = puzzle_only_one_remaining_tile (_tmp42_, &_tmp43_, &_tmp44_);
#line 984 "../src/puzzle-view.vala"
				x = _tmp43_;
#line 984 "../src/puzzle-view.vala"
				y = _tmp44_;
#line 984 "../src/puzzle-view.vala"
				if (_tmp45_) {
#line 5108 "puzzle-view.c"
					guint8 selected_x = 0U;
					guint8 selected_y = 0U;
					Puzzle* _tmp46_;
					Puzzle* _tmp47_;
					Tile* _tmp48_;
					guint8 _tmp49_ = 0U;
					guint8 _tmp50_ = 0U;
					Puzzle* _tmp51_;
					Puzzle* _tmp52_;
#line 987 "../src/puzzle-view.vala"
					_tmp46_ = puzzle_view_get_puzzle (self);
#line 987 "../src/puzzle-view.vala"
					_tmp47_ = _tmp46_;
#line 987 "../src/puzzle-view.vala"
					_tmp48_ = tile;
#line 987 "../src/puzzle-view.vala"
					puzzle_get_tile_location (_tmp47_, G_TYPE_CHECK_INSTANCE_CAST (_tmp48_, TYPE_TILE, Tile), &_tmp49_, &_tmp50_);
#line 987 "../src/puzzle-view.vala"
					selected_x = _tmp49_;
#line 987 "../src/puzzle-view.vala"
					selected_y = _tmp50_;
#line 988 "../src/puzzle-view.vala"
					_tmp51_ = puzzle_view_get_puzzle (self);
#line 988 "../src/puzzle-view.vala"
					_tmp52_ = _tmp51_;
#line 988 "../src/puzzle-view.vala"
					if (puzzle_can_switch (_tmp52_, selected_x, selected_y, x, y)) {
#line 5136 "puzzle-view.c"
						Puzzle* _tmp53_;
						Puzzle* _tmp54_;
#line 990 "../src/puzzle-view.vala"
						_tmp53_ = puzzle_view_get_puzzle (self);
#line 990 "../src/puzzle-view.vala"
						_tmp54_ = _tmp53_;
#line 990 "../src/puzzle-view.vala"
						puzzle_switch_tiles (_tmp54_, selected_x, selected_y, x, y, PUZZLE_VIEW_final_animation_duration);
#line 991 "../src/puzzle-view.vala"
						result = TRUE;
#line 991 "../src/puzzle-view.vala"
						_g_object_unref0 (tile);
#line 991 "../src/puzzle-view.vala"
						_g_free0 (key);
#line 991 "../src/puzzle-view.vala"
						return result;
#line 5153 "puzzle-view.c"
					}
				}
			}
#line 995 "../src/puzzle-view.vala"
			self->priv->tile_selection = TRUE;
#line 996 "../src/puzzle-view.vala"
			self->priv->kbd_selected_x = self->priv->highlight_x;
#line 997 "../src/puzzle-view.vala"
			self->priv->kbd_selected_y = self->priv->highlight_y;
#line 998 "../src/puzzle-view.vala"
			puzzle_view_queue_draw_tile (self, self->priv->highlight_x, self->priv->highlight_y);
#line 947 "../src/puzzle-view.vala"
			_g_object_unref0 (tile);
#line 5167 "puzzle-view.c"
		}
#line 1000 "../src/puzzle-view.vala"
		result = TRUE;
#line 1000 "../src/puzzle-view.vala"
		_g_free0 (key);
#line 1000 "../src/puzzle-view.vala"
		return result;
#line 5175 "puzzle-view.c"
	}
#line 1003 "../src/puzzle-view.vala"
	_tmp63_ = puzzle_view_get_puzzle (self);
#line 1003 "../src/puzzle-view.vala"
	_tmp64_ = _tmp63_;
#line 1003 "../src/puzzle-view.vala"
	_tmp65_ = puzzle_get_size (_tmp64_);
#line 1003 "../src/puzzle-view.vala"
	_tmp66_ = _tmp65_;
#line 1003 "../src/puzzle-view.vala"
	if (((gint) _tmp66_) <= 2) {
#line 5187 "puzzle-view.c"
		gboolean _tmp67_ = FALSE;
		gboolean _tmp68_ = FALSE;
		gboolean _tmp69_ = FALSE;
		const gchar* _tmp70_;
#line 1003 "../src/puzzle-view.vala"
		_tmp70_ = key;
#line 1003 "../src/puzzle-view.vala"
		if (g_strcmp0 (_tmp70_, "c") == 0) {
#line 1003 "../src/puzzle-view.vala"
			_tmp69_ = TRUE;
#line 5198 "puzzle-view.c"
		} else {
			const gchar* _tmp71_;
#line 1003 "../src/puzzle-view.vala"
			_tmp71_ = key;
#line 1003 "../src/puzzle-view.vala"
			_tmp69_ = g_strcmp0 (_tmp71_, "C") == 0;
#line 5205 "puzzle-view.c"
		}
#line 1003 "../src/puzzle-view.vala"
		if (_tmp69_) {
#line 1003 "../src/puzzle-view.vala"
			_tmp68_ = TRUE;
#line 5211 "puzzle-view.c"
		} else {
			const gchar* _tmp72_;
#line 1003 "../src/puzzle-view.vala"
			_tmp72_ = key;
#line 1003 "../src/puzzle-view.vala"
			_tmp68_ = g_strcmp0 (_tmp72_, "3") == 0;
#line 5218 "puzzle-view.c"
		}
#line 1003 "../src/puzzle-view.vala"
		if (_tmp68_) {
#line 1003 "../src/puzzle-view.vala"
			_tmp67_ = TRUE;
#line 5224 "puzzle-view.c"
		} else {
			const gchar* _tmp73_;
#line 1003 "../src/puzzle-view.vala"
			_tmp73_ = key;
#line 1003 "../src/puzzle-view.vala"
			_tmp67_ = g_strcmp0 (_tmp73_, "KP_3") == 0;
#line 5231 "puzzle-view.c"
		}
#line 1003 "../src/puzzle-view.vala"
		_tmp62_ = _tmp67_;
#line 5235 "puzzle-view.c"
	} else {
#line 1003 "../src/puzzle-view.vala"
		_tmp62_ = FALSE;
#line 5239 "puzzle-view.c"
	}
#line 1003 "../src/puzzle-view.vala"
	if (_tmp62_) {
#line 1003 "../src/puzzle-view.vala"
		_tmp61_ = TRUE;
#line 5245 "puzzle-view.c"
	} else {
		gboolean _tmp74_ = FALSE;
		Puzzle* _tmp75_;
		Puzzle* _tmp76_;
		guint8 _tmp77_;
		guint8 _tmp78_;
#line 1004 "../src/puzzle-view.vala"
		_tmp75_ = puzzle_view_get_puzzle (self);
#line 1004 "../src/puzzle-view.vala"
		_tmp76_ = _tmp75_;
#line 1004 "../src/puzzle-view.vala"
		_tmp77_ = puzzle_get_size (_tmp76_);
#line 1004 "../src/puzzle-view.vala"
		_tmp78_ = _tmp77_;
#line 1004 "../src/puzzle-view.vala"
		if (((gint) _tmp78_) <= 3) {
#line 5262 "puzzle-view.c"
			gboolean _tmp79_ = FALSE;
			gboolean _tmp80_ = FALSE;
			gboolean _tmp81_ = FALSE;
			const gchar* _tmp82_;
#line 1004 "../src/puzzle-view.vala"
			_tmp82_ = key;
#line 1004 "../src/puzzle-view.vala"
			if (g_strcmp0 (_tmp82_, "d") == 0) {
#line 1004 "../src/puzzle-view.vala"
				_tmp81_ = TRUE;
#line 5273 "puzzle-view.c"
			} else {
				const gchar* _tmp83_;
#line 1004 "../src/puzzle-view.vala"
				_tmp83_ = key;
#line 1004 "../src/puzzle-view.vala"
				_tmp81_ = g_strcmp0 (_tmp83_, "D") == 0;
#line 5280 "puzzle-view.c"
			}
#line 1004 "../src/puzzle-view.vala"
			if (_tmp81_) {
#line 1004 "../src/puzzle-view.vala"
				_tmp80_ = TRUE;
#line 5286 "puzzle-view.c"
			} else {
				const gchar* _tmp84_;
#line 1004 "../src/puzzle-view.vala"
				_tmp84_ = key;
#line 1004 "../src/puzzle-view.vala"
				_tmp80_ = g_strcmp0 (_tmp84_, "4") == 0;
#line 5293 "puzzle-view.c"
			}
#line 1004 "../src/puzzle-view.vala"
			if (_tmp80_) {
#line 1004 "../src/puzzle-view.vala"
				_tmp79_ = TRUE;
#line 5299 "puzzle-view.c"
			} else {
				const gchar* _tmp85_;
#line 1004 "../src/puzzle-view.vala"
				_tmp85_ = key;
#line 1004 "../src/puzzle-view.vala"
				_tmp79_ = g_strcmp0 (_tmp85_, "KP_4") == 0;
#line 5306 "puzzle-view.c"
			}
#line 1004 "../src/puzzle-view.vala"
			_tmp74_ = _tmp79_;
#line 5310 "puzzle-view.c"
		} else {
#line 1004 "../src/puzzle-view.vala"
			_tmp74_ = FALSE;
#line 5314 "puzzle-view.c"
		}
#line 1004 "../src/puzzle-view.vala"
		_tmp61_ = _tmp74_;
#line 5318 "puzzle-view.c"
	}
#line 1003 "../src/puzzle-view.vala"
	if (_tmp61_) {
#line 1003 "../src/puzzle-view.vala"
		_tmp60_ = TRUE;
#line 5324 "puzzle-view.c"
	} else {
		gboolean _tmp86_ = FALSE;
		Puzzle* _tmp87_;
		Puzzle* _tmp88_;
		guint8 _tmp89_;
		guint8 _tmp90_;
#line 1005 "../src/puzzle-view.vala"
		_tmp87_ = puzzle_view_get_puzzle (self);
#line 1005 "../src/puzzle-view.vala"
		_tmp88_ = _tmp87_;
#line 1005 "../src/puzzle-view.vala"
		_tmp89_ = puzzle_get_size (_tmp88_);
#line 1005 "../src/puzzle-view.vala"
		_tmp90_ = _tmp89_;
#line 1005 "../src/puzzle-view.vala"
		if (((gint) _tmp90_) <= 4) {
#line 5341 "puzzle-view.c"
			gboolean _tmp91_ = FALSE;
			gboolean _tmp92_ = FALSE;
			gboolean _tmp93_ = FALSE;
			const gchar* _tmp94_;
#line 1005 "../src/puzzle-view.vala"
			_tmp94_ = key;
#line 1005 "../src/puzzle-view.vala"
			if (g_strcmp0 (_tmp94_, "e") == 0) {
#line 1005 "../src/puzzle-view.vala"
				_tmp93_ = TRUE;
#line 5352 "puzzle-view.c"
			} else {
				const gchar* _tmp95_;
#line 1005 "../src/puzzle-view.vala"
				_tmp95_ = key;
#line 1005 "../src/puzzle-view.vala"
				_tmp93_ = g_strcmp0 (_tmp95_, "E") == 0;
#line 5359 "puzzle-view.c"
			}
#line 1005 "../src/puzzle-view.vala"
			if (_tmp93_) {
#line 1005 "../src/puzzle-view.vala"
				_tmp92_ = TRUE;
#line 5365 "puzzle-view.c"
			} else {
				const gchar* _tmp96_;
#line 1005 "../src/puzzle-view.vala"
				_tmp96_ = key;
#line 1005 "../src/puzzle-view.vala"
				_tmp92_ = g_strcmp0 (_tmp96_, "5") == 0;
#line 5372 "puzzle-view.c"
			}
#line 1005 "../src/puzzle-view.vala"
			if (_tmp92_) {
#line 1005 "../src/puzzle-view.vala"
				_tmp91_ = TRUE;
#line 5378 "puzzle-view.c"
			} else {
				const gchar* _tmp97_;
#line 1005 "../src/puzzle-view.vala"
				_tmp97_ = key;
#line 1005 "../src/puzzle-view.vala"
				_tmp91_ = g_strcmp0 (_tmp97_, "KP_5") == 0;
#line 5385 "puzzle-view.c"
			}
#line 1005 "../src/puzzle-view.vala"
			_tmp86_ = _tmp91_;
#line 5389 "puzzle-view.c"
		} else {
#line 1005 "../src/puzzle-view.vala"
			_tmp86_ = FALSE;
#line 5393 "puzzle-view.c"
		}
#line 1005 "../src/puzzle-view.vala"
		_tmp60_ = _tmp86_;
#line 5397 "puzzle-view.c"
	}
#line 1003 "../src/puzzle-view.vala"
	if (_tmp60_) {
#line 1003 "../src/puzzle-view.vala"
		_tmp59_ = TRUE;
#line 5403 "puzzle-view.c"
	} else {
		gboolean _tmp98_ = FALSE;
		Puzzle* _tmp99_;
		Puzzle* _tmp100_;
		guint8 _tmp101_;
		guint8 _tmp102_;
#line 1006 "../src/puzzle-view.vala"
		_tmp99_ = puzzle_view_get_puzzle (self);
#line 1006 "../src/puzzle-view.vala"
		_tmp100_ = _tmp99_;
#line 1006 "../src/puzzle-view.vala"
		_tmp101_ = puzzle_get_size (_tmp100_);
#line 1006 "../src/puzzle-view.vala"
		_tmp102_ = _tmp101_;
#line 1006 "../src/puzzle-view.vala"
		if (((gint) _tmp102_) <= 5) {
#line 5420 "puzzle-view.c"
			gboolean _tmp103_ = FALSE;
			gboolean _tmp104_ = FALSE;
			gboolean _tmp105_ = FALSE;
			const gchar* _tmp106_;
#line 1006 "../src/puzzle-view.vala"
			_tmp106_ = key;
#line 1006 "../src/puzzle-view.vala"
			if (g_strcmp0 (_tmp106_, "f") == 0) {
#line 1006 "../src/puzzle-view.vala"
				_tmp105_ = TRUE;
#line 5431 "puzzle-view.c"
			} else {
				const gchar* _tmp107_;
#line 1006 "../src/puzzle-view.vala"
				_tmp107_ = key;
#line 1006 "../src/puzzle-view.vala"
				_tmp105_ = g_strcmp0 (_tmp107_, "F") == 0;
#line 5438 "puzzle-view.c"
			}
#line 1006 "../src/puzzle-view.vala"
			if (_tmp105_) {
#line 1006 "../src/puzzle-view.vala"
				_tmp104_ = TRUE;
#line 5444 "puzzle-view.c"
			} else {
				const gchar* _tmp108_;
#line 1006 "../src/puzzle-view.vala"
				_tmp108_ = key;
#line 1006 "../src/puzzle-view.vala"
				_tmp104_ = g_strcmp0 (_tmp108_, "6") == 0;
#line 5451 "puzzle-view.c"
			}
#line 1006 "../src/puzzle-view.vala"
			if (_tmp104_) {
#line 1006 "../src/puzzle-view.vala"
				_tmp103_ = TRUE;
#line 5457 "puzzle-view.c"
			} else {
				const gchar* _tmp109_;
#line 1006 "../src/puzzle-view.vala"
				_tmp109_ = key;
#line 1006 "../src/puzzle-view.vala"
				_tmp103_ = g_strcmp0 (_tmp109_, "KP_6") == 0;
#line 5464 "puzzle-view.c"
			}
#line 1006 "../src/puzzle-view.vala"
			_tmp98_ = _tmp103_;
#line 5468 "puzzle-view.c"
		} else {
#line 1006 "../src/puzzle-view.vala"
			_tmp98_ = FALSE;
#line 5472 "puzzle-view.c"
		}
#line 1006 "../src/puzzle-view.vala"
		_tmp59_ = _tmp98_;
#line 5476 "puzzle-view.c"
	}
#line 1003 "../src/puzzle-view.vala"
	if (_tmp59_) {
#line 1003 "../src/puzzle-view.vala"
		_tmp58_ = TRUE;
#line 5482 "puzzle-view.c"
	} else {
		gboolean _tmp110_ = FALSE;
		Puzzle* _tmp111_;
		Puzzle* _tmp112_;
		guint8 _tmp113_;
		guint8 _tmp114_;
#line 1007 "../src/puzzle-view.vala"
		_tmp111_ = puzzle_view_get_puzzle (self);
#line 1007 "../src/puzzle-view.vala"
		_tmp112_ = _tmp111_;
#line 1007 "../src/puzzle-view.vala"
		_tmp113_ = puzzle_get_size (_tmp112_);
#line 1007 "../src/puzzle-view.vala"
		_tmp114_ = _tmp113_;
#line 1007 "../src/puzzle-view.vala"
		if (((gint) _tmp114_) <= 6) {
#line 5499 "puzzle-view.c"
			gboolean _tmp115_ = FALSE;
			gboolean _tmp116_ = FALSE;
			gboolean _tmp117_ = FALSE;
			const gchar* _tmp118_;
#line 1007 "../src/puzzle-view.vala"
			_tmp118_ = key;
#line 1007 "../src/puzzle-view.vala"
			if (g_strcmp0 (_tmp118_, "g") == 0) {
#line 1007 "../src/puzzle-view.vala"
				_tmp117_ = TRUE;
#line 5510 "puzzle-view.c"
			} else {
				const gchar* _tmp119_;
#line 1007 "../src/puzzle-view.vala"
				_tmp119_ = key;
#line 1007 "../src/puzzle-view.vala"
				_tmp117_ = g_strcmp0 (_tmp119_, "G") == 0;
#line 5517 "puzzle-view.c"
			}
#line 1007 "../src/puzzle-view.vala"
			if (_tmp117_) {
#line 1007 "../src/puzzle-view.vala"
				_tmp116_ = TRUE;
#line 5523 "puzzle-view.c"
			} else {
				const gchar* _tmp120_;
#line 1007 "../src/puzzle-view.vala"
				_tmp120_ = key;
#line 1007 "../src/puzzle-view.vala"
				_tmp116_ = g_strcmp0 (_tmp120_, "7") == 0;
#line 5530 "puzzle-view.c"
			}
#line 1007 "../src/puzzle-view.vala"
			if (_tmp116_) {
#line 1007 "../src/puzzle-view.vala"
				_tmp115_ = TRUE;
#line 5536 "puzzle-view.c"
			} else {
				const gchar* _tmp121_;
#line 1007 "../src/puzzle-view.vala"
				_tmp121_ = key;
#line 1007 "../src/puzzle-view.vala"
				_tmp115_ = g_strcmp0 (_tmp121_, "KP_7") == 0;
#line 5543 "puzzle-view.c"
			}
#line 1007 "../src/puzzle-view.vala"
			_tmp110_ = _tmp115_;
#line 5547 "puzzle-view.c"
		} else {
#line 1007 "../src/puzzle-view.vala"
			_tmp110_ = FALSE;
#line 5551 "puzzle-view.c"
		}
#line 1007 "../src/puzzle-view.vala"
		_tmp58_ = _tmp110_;
#line 5555 "puzzle-view.c"
	}
#line 1003 "../src/puzzle-view.vala"
	if (_tmp58_) {
#line 1003 "../src/puzzle-view.vala"
		_tmp57_ = TRUE;
#line 5561 "puzzle-view.c"
	} else {
		gboolean _tmp122_ = FALSE;
		Puzzle* _tmp123_;
		Puzzle* _tmp124_;
		guint8 _tmp125_;
		guint8 _tmp126_;
#line 1008 "../src/puzzle-view.vala"
		_tmp123_ = puzzle_view_get_puzzle (self);
#line 1008 "../src/puzzle-view.vala"
		_tmp124_ = _tmp123_;
#line 1008 "../src/puzzle-view.vala"
		_tmp125_ = puzzle_get_size (_tmp124_);
#line 1008 "../src/puzzle-view.vala"
		_tmp126_ = _tmp125_;
#line 1008 "../src/puzzle-view.vala"
		if (((gint) _tmp126_) <= 7) {
#line 5578 "puzzle-view.c"
			gboolean _tmp127_ = FALSE;
			gboolean _tmp128_ = FALSE;
			gboolean _tmp129_ = FALSE;
			const gchar* _tmp130_;
#line 1008 "../src/puzzle-view.vala"
			_tmp130_ = key;
#line 1008 "../src/puzzle-view.vala"
			if (g_strcmp0 (_tmp130_, "h") == 0) {
#line 1008 "../src/puzzle-view.vala"
				_tmp129_ = TRUE;
#line 5589 "puzzle-view.c"
			} else {
				const gchar* _tmp131_;
#line 1008 "../src/puzzle-view.vala"
				_tmp131_ = key;
#line 1008 "../src/puzzle-view.vala"
				_tmp129_ = g_strcmp0 (_tmp131_, "H") == 0;
#line 5596 "puzzle-view.c"
			}
#line 1008 "../src/puzzle-view.vala"
			if (_tmp129_) {
#line 1008 "../src/puzzle-view.vala"
				_tmp128_ = TRUE;
#line 5602 "puzzle-view.c"
			} else {
				const gchar* _tmp132_;
#line 1008 "../src/puzzle-view.vala"
				_tmp132_ = key;
#line 1008 "../src/puzzle-view.vala"
				_tmp128_ = g_strcmp0 (_tmp132_, "8") == 0;
#line 5609 "puzzle-view.c"
			}
#line 1008 "../src/puzzle-view.vala"
			if (_tmp128_) {
#line 1008 "../src/puzzle-view.vala"
				_tmp127_ = TRUE;
#line 5615 "puzzle-view.c"
			} else {
				const gchar* _tmp133_;
#line 1008 "../src/puzzle-view.vala"
				_tmp133_ = key;
#line 1008 "../src/puzzle-view.vala"
				_tmp127_ = g_strcmp0 (_tmp133_, "KP_8") == 0;
#line 5622 "puzzle-view.c"
			}
#line 1008 "../src/puzzle-view.vala"
			_tmp122_ = _tmp127_;
#line 5626 "puzzle-view.c"
		} else {
#line 1008 "../src/puzzle-view.vala"
			_tmp122_ = FALSE;
#line 5630 "puzzle-view.c"
		}
#line 1008 "../src/puzzle-view.vala"
		_tmp57_ = _tmp122_;
#line 5634 "puzzle-view.c"
	}
#line 1003 "../src/puzzle-view.vala"
	if (_tmp57_) {
#line 1003 "../src/puzzle-view.vala"
		_tmp56_ = TRUE;
#line 5640 "puzzle-view.c"
	} else {
		gboolean _tmp134_ = FALSE;
		Puzzle* _tmp135_;
		Puzzle* _tmp136_;
		guint8 _tmp137_;
		guint8 _tmp138_;
#line 1009 "../src/puzzle-view.vala"
		_tmp135_ = puzzle_view_get_puzzle (self);
#line 1009 "../src/puzzle-view.vala"
		_tmp136_ = _tmp135_;
#line 1009 "../src/puzzle-view.vala"
		_tmp137_ = puzzle_get_size (_tmp136_);
#line 1009 "../src/puzzle-view.vala"
		_tmp138_ = _tmp137_;
#line 1009 "../src/puzzle-view.vala"
		if (((gint) _tmp138_) <= 8) {
#line 5657 "puzzle-view.c"
			gboolean _tmp139_ = FALSE;
			gboolean _tmp140_ = FALSE;
			gboolean _tmp141_ = FALSE;
			const gchar* _tmp142_;
#line 1009 "../src/puzzle-view.vala"
			_tmp142_ = key;
#line 1009 "../src/puzzle-view.vala"
			if (g_strcmp0 (_tmp142_, "i") == 0) {
#line 1009 "../src/puzzle-view.vala"
				_tmp141_ = TRUE;
#line 5668 "puzzle-view.c"
			} else {
				const gchar* _tmp143_;
#line 1009 "../src/puzzle-view.vala"
				_tmp143_ = key;
#line 1009 "../src/puzzle-view.vala"
				_tmp141_ = g_strcmp0 (_tmp143_, "I") == 0;
#line 5675 "puzzle-view.c"
			}
#line 1009 "../src/puzzle-view.vala"
			if (_tmp141_) {
#line 1009 "../src/puzzle-view.vala"
				_tmp140_ = TRUE;
#line 5681 "puzzle-view.c"
			} else {
				const gchar* _tmp144_;
#line 1009 "../src/puzzle-view.vala"
				_tmp144_ = key;
#line 1009 "../src/puzzle-view.vala"
				_tmp140_ = g_strcmp0 (_tmp144_, "9") == 0;
#line 5688 "puzzle-view.c"
			}
#line 1009 "../src/puzzle-view.vala"
			if (_tmp140_) {
#line 1009 "../src/puzzle-view.vala"
				_tmp139_ = TRUE;
#line 5694 "puzzle-view.c"
			} else {
				const gchar* _tmp145_;
#line 1009 "../src/puzzle-view.vala"
				_tmp145_ = key;
#line 1009 "../src/puzzle-view.vala"
				_tmp139_ = g_strcmp0 (_tmp145_, "KP_9") == 0;
#line 5701 "puzzle-view.c"
			}
#line 1009 "../src/puzzle-view.vala"
			_tmp134_ = _tmp139_;
#line 5705 "puzzle-view.c"
		} else {
#line 1009 "../src/puzzle-view.vala"
			_tmp134_ = FALSE;
#line 5709 "puzzle-view.c"
		}
#line 1009 "../src/puzzle-view.vala"
		_tmp56_ = _tmp134_;
#line 5713 "puzzle-view.c"
	}
#line 1003 "../src/puzzle-view.vala"
	if (_tmp56_) {
#line 1003 "../src/puzzle-view.vala"
		_tmp55_ = TRUE;
#line 5719 "puzzle-view.c"
	} else {
		gboolean _tmp146_ = FALSE;
		Puzzle* _tmp147_;
		Puzzle* _tmp148_;
		guint8 _tmp149_;
		guint8 _tmp150_;
#line 1010 "../src/puzzle-view.vala"
		_tmp147_ = puzzle_view_get_puzzle (self);
#line 1010 "../src/puzzle-view.vala"
		_tmp148_ = _tmp147_;
#line 1010 "../src/puzzle-view.vala"
		_tmp149_ = puzzle_get_size (_tmp148_);
#line 1010 "../src/puzzle-view.vala"
		_tmp150_ = _tmp149_;
#line 1010 "../src/puzzle-view.vala"
		if (((gint) _tmp150_) <= 9) {
#line 5736 "puzzle-view.c"
			gboolean _tmp151_ = FALSE;
			gboolean _tmp152_ = FALSE;
			gboolean _tmp153_ = FALSE;
			const gchar* _tmp154_;
#line 1010 "../src/puzzle-view.vala"
			_tmp154_ = key;
#line 1010 "../src/puzzle-view.vala"
			if (g_strcmp0 (_tmp154_, "j") == 0) {
#line 1010 "../src/puzzle-view.vala"
				_tmp153_ = TRUE;
#line 5747 "puzzle-view.c"
			} else {
				const gchar* _tmp155_;
#line 1010 "../src/puzzle-view.vala"
				_tmp155_ = key;
#line 1010 "../src/puzzle-view.vala"
				_tmp153_ = g_strcmp0 (_tmp155_, "J") == 0;
#line 5754 "puzzle-view.c"
			}
#line 1010 "../src/puzzle-view.vala"
			if (_tmp153_) {
#line 1010 "../src/puzzle-view.vala"
				_tmp152_ = TRUE;
#line 5760 "puzzle-view.c"
			} else {
				const gchar* _tmp156_;
#line 1010 "../src/puzzle-view.vala"
				_tmp156_ = key;
#line 1010 "../src/puzzle-view.vala"
				_tmp152_ = g_strcmp0 (_tmp156_, "0") == 0;
#line 5767 "puzzle-view.c"
			}
#line 1010 "../src/puzzle-view.vala"
			if (_tmp152_) {
#line 1010 "../src/puzzle-view.vala"
				_tmp151_ = TRUE;
#line 5773 "puzzle-view.c"
			} else {
				const gchar* _tmp157_;
#line 1010 "../src/puzzle-view.vala"
				_tmp157_ = key;
#line 1010 "../src/puzzle-view.vala"
				_tmp151_ = g_strcmp0 (_tmp157_, "KP_0") == 0;
#line 5780 "puzzle-view.c"
			}
#line 1010 "../src/puzzle-view.vala"
			_tmp146_ = _tmp151_;
#line 5784 "puzzle-view.c"
		} else {
#line 1010 "../src/puzzle-view.vala"
			_tmp146_ = FALSE;
#line 5788 "puzzle-view.c"
		}
#line 1010 "../src/puzzle-view.vala"
		_tmp55_ = _tmp146_;
#line 5792 "puzzle-view.c"
	}
#line 1003 "../src/puzzle-view.vala"
	if (_tmp55_) {
#line 1011 "../src/puzzle-view.vala"
		result = FALSE;
#line 1011 "../src/puzzle-view.vala"
		_g_free0 (key);
#line 1011 "../src/puzzle-view.vala"
		return result;
#line 5802 "puzzle-view.c"
	}
#line 1013 "../src/puzzle-view.vala"
	self->priv->old_highlight_x = self->priv->highlight_x;
#line 1014 "../src/puzzle-view.vala"
	self->priv->old_highlight_y = self->priv->highlight_y;
#line 1015 "../src/puzzle-view.vala"
	_tmp158_ = key;
#line 1015 "../src/puzzle-view.vala"
	_tmp159_ = _tmp158_;
#line 1015 "../src/puzzle-view.vala"
	_tmp161_ = (NULL == _tmp159_) ? 0 : g_quark_from_string (_tmp159_);
#line 1015 "../src/puzzle-view.vala"
	if ((_tmp161_ == ((0 != _tmp160_label0) ? _tmp160_label0 : (_tmp160_label0 = g_quark_from_static_string ("Up")))) || (_tmp161_ == ((0 != _tmp160_label1) ? _tmp160_label1 : (_tmp160_label1 = g_quark_from_static_string ("KP_Up"))))) {
#line 1015 "../src/puzzle-view.vala"
		switch (0) {
#line 5818 "puzzle-view.c"
			default:
			{
#line 1019 "../src/puzzle-view.vala"
				puzzle_view_set_highlight_position_if_needed (self);
#line 1020 "../src/puzzle-view.vala"
				if (((gint) self->priv->highlight_y) > 0) {
#line 5825 "puzzle-view.c"
					guint8 _tmp162_;
#line 1020 "../src/puzzle-view.vala"
					_tmp162_ = self->priv->highlight_y;
#line 1020 "../src/puzzle-view.vala"
					self->priv->highlight_y = _tmp162_ - 1;
#line 5831 "puzzle-view.c"
				}
#line 1021 "../src/puzzle-view.vala"
				break;
#line 5835 "puzzle-view.c"
			}
		}
	} else if ((_tmp161_ == ((0 != _tmp160_label2) ? _tmp160_label2 : (_tmp160_label2 = g_quark_from_static_string ("Left")))) || (_tmp161_ == ((0 != _tmp160_label3) ? _tmp160_label3 : (_tmp160_label3 = g_quark_from_static_string ("KP_Left"))))) {
#line 1015 "../src/puzzle-view.vala"
		switch (0) {
#line 5841 "puzzle-view.c"
			default:
			{
#line 1024 "../src/puzzle-view.vala"
				puzzle_view_set_highlight_position_if_needed (self);
#line 1025 "../src/puzzle-view.vala"
				if (((gint) self->priv->highlight_x) > 0) {
#line 5848 "puzzle-view.c"
					guint8 _tmp163_;
#line 1025 "../src/puzzle-view.vala"
					_tmp163_ = self->priv->highlight_x;
#line 1025 "../src/puzzle-view.vala"
					self->priv->highlight_x = _tmp163_ - 1;
#line 5854 "puzzle-view.c"
				}
#line 1026 "../src/puzzle-view.vala"
				break;
#line 5858 "puzzle-view.c"
			}
		}
	} else if ((_tmp161_ == ((0 != _tmp160_label4) ? _tmp160_label4 : (_tmp160_label4 = g_quark_from_static_string ("Right")))) || (_tmp161_ == ((0 != _tmp160_label5) ? _tmp160_label5 : (_tmp160_label5 = g_quark_from_static_string ("KP_Right"))))) {
#line 1015 "../src/puzzle-view.vala"
		switch (0) {
#line 5864 "puzzle-view.c"
			default:
			{
				Puzzle* _tmp164_;
				Puzzle* _tmp165_;
				guint8 _tmp166_;
				guint8 _tmp167_;
#line 1029 "../src/puzzle-view.vala"
				puzzle_view_set_highlight_position_if_needed (self);
#line 1030 "../src/puzzle-view.vala"
				_tmp164_ = puzzle_view_get_puzzle (self);
#line 1030 "../src/puzzle-view.vala"
				_tmp165_ = _tmp164_;
#line 1030 "../src/puzzle-view.vala"
				_tmp166_ = puzzle_get_size (_tmp165_);
#line 1030 "../src/puzzle-view.vala"
				_tmp167_ = _tmp166_;
#line 1030 "../src/puzzle-view.vala"
				if (((gint) self->priv->highlight_x) < ((_tmp167_ * 2) - 1)) {
#line 5883 "puzzle-view.c"
					guint8 _tmp168_;
#line 1030 "../src/puzzle-view.vala"
					_tmp168_ = self->priv->highlight_x;
#line 1030 "../src/puzzle-view.vala"
					self->priv->highlight_x = _tmp168_ + 1;
#line 5889 "puzzle-view.c"
				}
#line 1031 "../src/puzzle-view.vala"
				break;
#line 5893 "puzzle-view.c"
			}
		}
	} else if ((_tmp161_ == ((0 != _tmp160_label6) ? _tmp160_label6 : (_tmp160_label6 = g_quark_from_static_string ("Down")))) || (_tmp161_ == ((0 != _tmp160_label7) ? _tmp160_label7 : (_tmp160_label7 = g_quark_from_static_string ("KP_Down"))))) {
#line 1015 "../src/puzzle-view.vala"
		switch (0) {
#line 5899 "puzzle-view.c"
			default:
			{
				Puzzle* _tmp169_;
				Puzzle* _tmp170_;
				guint8 _tmp171_;
				guint8 _tmp172_;
#line 1034 "../src/puzzle-view.vala"
				puzzle_view_set_highlight_position_if_needed (self);
#line 1035 "../src/puzzle-view.vala"
				_tmp169_ = puzzle_view_get_puzzle (self);
#line 1035 "../src/puzzle-view.vala"
				_tmp170_ = _tmp169_;
#line 1035 "../src/puzzle-view.vala"
				_tmp171_ = puzzle_get_size (_tmp170_);
#line 1035 "../src/puzzle-view.vala"
				_tmp172_ = _tmp171_;
#line 1035 "../src/puzzle-view.vala"
				if (((gint) self->priv->highlight_y) < (_tmp172_ - 1)) {
#line 5918 "puzzle-view.c"
					guint8 _tmp173_;
#line 1035 "../src/puzzle-view.vala"
					_tmp173_ = self->priv->highlight_y;
#line 1035 "../src/puzzle-view.vala"
					self->priv->highlight_y = _tmp173_ + 1;
#line 5924 "puzzle-view.c"
				}
#line 1036 "../src/puzzle-view.vala"
				break;
#line 5928 "puzzle-view.c"
			}
		}
	} else if (((_tmp161_ == ((0 != _tmp160_label8) ? _tmp160_label8 : (_tmp160_label8 = g_quark_from_static_string ("space")))) || (_tmp161_ == ((0 != _tmp160_label9) ? _tmp160_label9 : (_tmp160_label9 = g_quark_from_static_string ("Return"))))) || (_tmp161_ == ((0 != _tmp160_label10) ? _tmp160_label10 : (_tmp160_label10 = g_quark_from_static_string ("KP_Enter"))))) {
#line 1015 "../src/puzzle-view.vala"
		switch (0) {
#line 5934 "puzzle-view.c"
			default:
			{
#line 1041 "../src/puzzle-view.vala"
				puzzle_view_set_highlight_position_if_needed (self);
#line 1042 "../src/puzzle-view.vala"
				break;
#line 5941 "puzzle-view.c"
			}
		}
	} else if (_tmp161_ == ((0 != _tmp160_label11) ? _tmp160_label11 : (_tmp160_label11 = g_quark_from_static_string ("Escape")))) {
#line 1015 "../src/puzzle-view.vala"
		switch (0) {
#line 5947 "puzzle-view.c"
			default:
			{
#line 1044 "../src/puzzle-view.vala"
				break;
#line 5952 "puzzle-view.c"
			}
		}
	} else if (_tmp161_ == ((0 != _tmp160_label12) ? _tmp160_label12 : (_tmp160_label12 = g_quark_from_static_string ("a")))) {
#line 1015 "../src/puzzle-view.vala"
		switch (0) {
#line 5958 "puzzle-view.c"
			default:
			{
#line 1046 "../src/puzzle-view.vala"
				puzzle_view_set_highlight_position_if_needed (self);
#line 1046 "../src/puzzle-view.vala"
				self->priv->highlight_x = (guint8) 0;
#line 1046 "../src/puzzle-view.vala"
				break;
#line 5967 "puzzle-view.c"
			}
		}
	} else if (_tmp161_ == ((0 != _tmp160_label13) ? _tmp160_label13 : (_tmp160_label13 = g_quark_from_static_string ("b")))) {
#line 1015 "../src/puzzle-view.vala"
		switch (0) {
#line 5973 "puzzle-view.c"
			default:
			{
#line 1047 "../src/puzzle-view.vala"
				puzzle_view_set_highlight_position_if_needed (self);
#line 1047 "../src/puzzle-view.vala"
				self->priv->highlight_x = (guint8) 1;
#line 1047 "../src/puzzle-view.vala"
				break;
#line 5982 "puzzle-view.c"
			}
		}
	} else if (_tmp161_ == ((0 != _tmp160_label14) ? _tmp160_label14 : (_tmp160_label14 = g_quark_from_static_string ("c")))) {
#line 1015 "../src/puzzle-view.vala"
		switch (0) {
#line 5988 "puzzle-view.c"
			default:
			{
#line 1048 "../src/puzzle-view.vala"
				puzzle_view_set_highlight_position_if_needed (self);
#line 1048 "../src/puzzle-view.vala"
				self->priv->highlight_x = (guint8) 2;
#line 1048 "../src/puzzle-view.vala"
				break;
#line 5997 "puzzle-view.c"
			}
		}
	} else if (_tmp161_ == ((0 != _tmp160_label15) ? _tmp160_label15 : (_tmp160_label15 = g_quark_from_static_string ("d")))) {
#line 1015 "../src/puzzle-view.vala"
		switch (0) {
#line 6003 "puzzle-view.c"
			default:
			{
#line 1049 "../src/puzzle-view.vala"
				puzzle_view_set_highlight_position_if_needed (self);
#line 1049 "../src/puzzle-view.vala"
				self->priv->highlight_x = (guint8) 3;
#line 1049 "../src/puzzle-view.vala"
				break;
#line 6012 "puzzle-view.c"
			}
		}
	} else if (_tmp161_ == ((0 != _tmp160_label16) ? _tmp160_label16 : (_tmp160_label16 = g_quark_from_static_string ("e")))) {
#line 1015 "../src/puzzle-view.vala"
		switch (0) {
#line 6018 "puzzle-view.c"
			default:
			{
#line 1050 "../src/puzzle-view.vala"
				puzzle_view_set_highlight_position_if_needed (self);
#line 1050 "../src/puzzle-view.vala"
				self->priv->highlight_x = (guint8) 4;
#line 1050 "../src/puzzle-view.vala"
				break;
#line 6027 "puzzle-view.c"
			}
		}
	} else if (_tmp161_ == ((0 != _tmp160_label17) ? _tmp160_label17 : (_tmp160_label17 = g_quark_from_static_string ("f")))) {
#line 1015 "../src/puzzle-view.vala"
		switch (0) {
#line 6033 "puzzle-view.c"
			default:
			{
#line 1051 "../src/puzzle-view.vala"
				puzzle_view_set_highlight_position_if_needed (self);
#line 1051 "../src/puzzle-view.vala"
				self->priv->highlight_x = (guint8) 5;
#line 1051 "../src/puzzle-view.vala"
				break;
#line 6042 "puzzle-view.c"
			}
		}
	} else if (_tmp161_ == ((0 != _tmp160_label18) ? _tmp160_label18 : (_tmp160_label18 = g_quark_from_static_string ("A")))) {
#line 1015 "../src/puzzle-view.vala"
		switch (0) {
#line 6048 "puzzle-view.c"
			default:
			{
				Puzzle* _tmp174_;
				Puzzle* _tmp175_;
				guint8 _tmp176_;
				guint8 _tmp177_;
#line 1053 "../src/puzzle-view.vala"
				puzzle_view_set_highlight_position_if_needed (self);
#line 1053 "../src/puzzle-view.vala"
				_tmp174_ = puzzle_view_get_puzzle (self);
#line 1053 "../src/puzzle-view.vala"
				_tmp175_ = _tmp174_;
#line 1053 "../src/puzzle-view.vala"
				_tmp176_ = puzzle_get_size (_tmp175_);
#line 1053 "../src/puzzle-view.vala"
				_tmp177_ = _tmp176_;
#line 1053 "../src/puzzle-view.vala"
				self->priv->highlight_x = _tmp177_;
#line 1053 "../src/puzzle-view.vala"
				break;
#line 6069 "puzzle-view.c"
			}
		}
	} else if (_tmp161_ == ((0 != _tmp160_label19) ? _tmp160_label19 : (_tmp160_label19 = g_quark_from_static_string ("B")))) {
#line 1015 "../src/puzzle-view.vala"
		switch (0) {
#line 6075 "puzzle-view.c"
			default:
			{
				Puzzle* _tmp178_;
				Puzzle* _tmp179_;
				guint8 _tmp180_;
				guint8 _tmp181_;
#line 1054 "../src/puzzle-view.vala"
				puzzle_view_set_highlight_position_if_needed (self);
#line 1054 "../src/puzzle-view.vala"
				_tmp178_ = puzzle_view_get_puzzle (self);
#line 1054 "../src/puzzle-view.vala"
				_tmp179_ = _tmp178_;
#line 1054 "../src/puzzle-view.vala"
				_tmp180_ = puzzle_get_size (_tmp179_);
#line 1054 "../src/puzzle-view.vala"
				_tmp181_ = _tmp180_;
#line 1054 "../src/puzzle-view.vala"
				self->priv->highlight_x = (guint8) (_tmp181_ + 1);
#line 1054 "../src/puzzle-view.vala"
				break;
#line 6096 "puzzle-view.c"
			}
		}
	} else if (_tmp161_ == ((0 != _tmp160_label20) ? _tmp160_label20 : (_tmp160_label20 = g_quark_from_static_string ("C")))) {
#line 1015 "../src/puzzle-view.vala"
		switch (0) {
#line 6102 "puzzle-view.c"
			default:
			{
				Puzzle* _tmp182_;
				Puzzle* _tmp183_;
				guint8 _tmp184_;
				guint8 _tmp185_;
#line 1055 "../src/puzzle-view.vala"
				puzzle_view_set_highlight_position_if_needed (self);
#line 1055 "../src/puzzle-view.vala"
				_tmp182_ = puzzle_view_get_puzzle (self);
#line 1055 "../src/puzzle-view.vala"
				_tmp183_ = _tmp182_;
#line 1055 "../src/puzzle-view.vala"
				_tmp184_ = puzzle_get_size (_tmp183_);
#line 1055 "../src/puzzle-view.vala"
				_tmp185_ = _tmp184_;
#line 1055 "../src/puzzle-view.vala"
				self->priv->highlight_x = (guint8) (_tmp185_ + 2);
#line 1055 "../src/puzzle-view.vala"
				break;
#line 6123 "puzzle-view.c"
			}
		}
	} else if (_tmp161_ == ((0 != _tmp160_label21) ? _tmp160_label21 : (_tmp160_label21 = g_quark_from_static_string ("D")))) {
#line 1015 "../src/puzzle-view.vala"
		switch (0) {
#line 6129 "puzzle-view.c"
			default:
			{
				Puzzle* _tmp186_;
				Puzzle* _tmp187_;
				guint8 _tmp188_;
				guint8 _tmp189_;
#line 1056 "../src/puzzle-view.vala"
				puzzle_view_set_highlight_position_if_needed (self);
#line 1056 "../src/puzzle-view.vala"
				_tmp186_ = puzzle_view_get_puzzle (self);
#line 1056 "../src/puzzle-view.vala"
				_tmp187_ = _tmp186_;
#line 1056 "../src/puzzle-view.vala"
				_tmp188_ = puzzle_get_size (_tmp187_);
#line 1056 "../src/puzzle-view.vala"
				_tmp189_ = _tmp188_;
#line 1056 "../src/puzzle-view.vala"
				self->priv->highlight_x = (guint8) (_tmp189_ + 3);
#line 1056 "../src/puzzle-view.vala"
				break;
#line 6150 "puzzle-view.c"
			}
		}
	} else if (_tmp161_ == ((0 != _tmp160_label22) ? _tmp160_label22 : (_tmp160_label22 = g_quark_from_static_string ("E")))) {
#line 1015 "../src/puzzle-view.vala"
		switch (0) {
#line 6156 "puzzle-view.c"
			default:
			{
				Puzzle* _tmp190_;
				Puzzle* _tmp191_;
				guint8 _tmp192_;
				guint8 _tmp193_;
#line 1057 "../src/puzzle-view.vala"
				puzzle_view_set_highlight_position_if_needed (self);
#line 1057 "../src/puzzle-view.vala"
				_tmp190_ = puzzle_view_get_puzzle (self);
#line 1057 "../src/puzzle-view.vala"
				_tmp191_ = _tmp190_;
#line 1057 "../src/puzzle-view.vala"
				_tmp192_ = puzzle_get_size (_tmp191_);
#line 1057 "../src/puzzle-view.vala"
				_tmp193_ = _tmp192_;
#line 1057 "../src/puzzle-view.vala"
				self->priv->highlight_x = (guint8) (_tmp193_ + 4);
#line 1057 "../src/puzzle-view.vala"
				break;
#line 6177 "puzzle-view.c"
			}
		}
	} else if (_tmp161_ == ((0 != _tmp160_label23) ? _tmp160_label23 : (_tmp160_label23 = g_quark_from_static_string ("F")))) {
#line 1015 "../src/puzzle-view.vala"
		switch (0) {
#line 6183 "puzzle-view.c"
			default:
			{
				Puzzle* _tmp194_;
				Puzzle* _tmp195_;
				guint8 _tmp196_;
				guint8 _tmp197_;
#line 1058 "../src/puzzle-view.vala"
				puzzle_view_set_highlight_position_if_needed (self);
#line 1058 "../src/puzzle-view.vala"
				_tmp194_ = puzzle_view_get_puzzle (self);
#line 1058 "../src/puzzle-view.vala"
				_tmp195_ = _tmp194_;
#line 1058 "../src/puzzle-view.vala"
				_tmp196_ = puzzle_get_size (_tmp195_);
#line 1058 "../src/puzzle-view.vala"
				_tmp197_ = _tmp196_;
#line 1058 "../src/puzzle-view.vala"
				self->priv->highlight_x = (guint8) (_tmp197_ + 5);
#line 1058 "../src/puzzle-view.vala"
				break;
#line 6204 "puzzle-view.c"
			}
		}
	} else if ((_tmp161_ == ((0 != _tmp160_label24) ? _tmp160_label24 : (_tmp160_label24 = g_quark_from_static_string ("1")))) || (_tmp161_ == ((0 != _tmp160_label25) ? _tmp160_label25 : (_tmp160_label25 = g_quark_from_static_string ("KP_1"))))) {
#line 1015 "../src/puzzle-view.vala"
		switch (0) {
#line 6210 "puzzle-view.c"
			default:
			{
#line 1060 "../src/puzzle-view.vala"
				puzzle_view_set_highlight_position_if_needed (self);
#line 1060 "../src/puzzle-view.vala"
				self->priv->highlight_y = (guint8) 0;
#line 1060 "../src/puzzle-view.vala"
				break;
#line 6219 "puzzle-view.c"
			}
		}
	} else if ((_tmp161_ == ((0 != _tmp160_label26) ? _tmp160_label26 : (_tmp160_label26 = g_quark_from_static_string ("2")))) || (_tmp161_ == ((0 != _tmp160_label27) ? _tmp160_label27 : (_tmp160_label27 = g_quark_from_static_string ("KP_2"))))) {
#line 1015 "../src/puzzle-view.vala"
		switch (0) {
#line 6225 "puzzle-view.c"
			default:
			{
#line 1061 "../src/puzzle-view.vala"
				puzzle_view_set_highlight_position_if_needed (self);
#line 1061 "../src/puzzle-view.vala"
				self->priv->highlight_y = (guint8) 1;
#line 1061 "../src/puzzle-view.vala"
				break;
#line 6234 "puzzle-view.c"
			}
		}
	} else if ((_tmp161_ == ((0 != _tmp160_label28) ? _tmp160_label28 : (_tmp160_label28 = g_quark_from_static_string ("3")))) || (_tmp161_ == ((0 != _tmp160_label29) ? _tmp160_label29 : (_tmp160_label29 = g_quark_from_static_string ("KP_3"))))) {
#line 1015 "../src/puzzle-view.vala"
		switch (0) {
#line 6240 "puzzle-view.c"
			default:
			{
#line 1062 "../src/puzzle-view.vala"
				puzzle_view_set_highlight_position_if_needed (self);
#line 1062 "../src/puzzle-view.vala"
				self->priv->highlight_y = (guint8) 2;
#line 1062 "../src/puzzle-view.vala"
				break;
#line 6249 "puzzle-view.c"
			}
		}
	} else if ((_tmp161_ == ((0 != _tmp160_label30) ? _tmp160_label30 : (_tmp160_label30 = g_quark_from_static_string ("4")))) || (_tmp161_ == ((0 != _tmp160_label31) ? _tmp160_label31 : (_tmp160_label31 = g_quark_from_static_string ("KP_4"))))) {
#line 1015 "../src/puzzle-view.vala"
		switch (0) {
#line 6255 "puzzle-view.c"
			default:
			{
#line 1063 "../src/puzzle-view.vala"
				puzzle_view_set_highlight_position_if_needed (self);
#line 1063 "../src/puzzle-view.vala"
				self->priv->highlight_y = (guint8) 3;
#line 1063 "../src/puzzle-view.vala"
				break;
#line 6264 "puzzle-view.c"
			}
		}
	} else if ((_tmp161_ == ((0 != _tmp160_label32) ? _tmp160_label32 : (_tmp160_label32 = g_quark_from_static_string ("5")))) || (_tmp161_ == ((0 != _tmp160_label33) ? _tmp160_label33 : (_tmp160_label33 = g_quark_from_static_string ("KP_5"))))) {
#line 1015 "../src/puzzle-view.vala"
		switch (0) {
#line 6270 "puzzle-view.c"
			default:
			{
#line 1064 "../src/puzzle-view.vala"
				puzzle_view_set_highlight_position_if_needed (self);
#line 1064 "../src/puzzle-view.vala"
				self->priv->highlight_y = (guint8) 4;
#line 1064 "../src/puzzle-view.vala"
				break;
#line 6279 "puzzle-view.c"
			}
		}
	} else if ((_tmp161_ == ((0 != _tmp160_label34) ? _tmp160_label34 : (_tmp160_label34 = g_quark_from_static_string ("6")))) || (_tmp161_ == ((0 != _tmp160_label35) ? _tmp160_label35 : (_tmp160_label35 = g_quark_from_static_string ("KP_6"))))) {
#line 1015 "../src/puzzle-view.vala"
		switch (0) {
#line 6285 "puzzle-view.c"
			default:
			{
#line 1065 "../src/puzzle-view.vala"
				puzzle_view_set_highlight_position_if_needed (self);
#line 1065 "../src/puzzle-view.vala"
				self->priv->highlight_y = (guint8) 5;
#line 1065 "../src/puzzle-view.vala"
				break;
#line 6294 "puzzle-view.c"
			}
		}
	} else if ((_tmp161_ == ((0 != _tmp160_label36) ? _tmp160_label36 : (_tmp160_label36 = g_quark_from_static_string ("Home")))) || (_tmp161_ == ((0 != _tmp160_label37) ? _tmp160_label37 : (_tmp160_label37 = g_quark_from_static_string ("KP_Home"))))) {
#line 1015 "../src/puzzle-view.vala"
		switch (0) {
#line 6300 "puzzle-view.c"
			default:
			{
#line 1069 "../src/puzzle-view.vala"
				puzzle_view_set_highlight_position_if_needed (self);
#line 1070 "../src/puzzle-view.vala"
				self->priv->highlight_x = (guint8) 0;
#line 1071 "../src/puzzle-view.vala"
				break;
#line 6309 "puzzle-view.c"
			}
		}
	} else if ((_tmp161_ == ((0 != _tmp160_label38) ? _tmp160_label38 : (_tmp160_label38 = g_quark_from_static_string ("End")))) || (_tmp161_ == ((0 != _tmp160_label39) ? _tmp160_label39 : (_tmp160_label39 = g_quark_from_static_string ("KP_End"))))) {
#line 1015 "../src/puzzle-view.vala"
		switch (0) {
#line 6315 "puzzle-view.c"
			default:
			{
				Puzzle* _tmp198_;
				Puzzle* _tmp199_;
				guint8 _tmp200_;
				guint8 _tmp201_;
#line 1074 "../src/puzzle-view.vala"
				puzzle_view_set_highlight_position_if_needed (self);
#line 1075 "../src/puzzle-view.vala"
				_tmp198_ = puzzle_view_get_puzzle (self);
#line 1075 "../src/puzzle-view.vala"
				_tmp199_ = _tmp198_;
#line 1075 "../src/puzzle-view.vala"
				_tmp200_ = puzzle_get_size (_tmp199_);
#line 1075 "../src/puzzle-view.vala"
				_tmp201_ = _tmp200_;
#line 1075 "../src/puzzle-view.vala"
				self->priv->highlight_x = (guint8) ((_tmp201_ * 2) - 1);
#line 1076 "../src/puzzle-view.vala"
				break;
#line 6336 "puzzle-view.c"
			}
		}
	} else if ((_tmp161_ == ((0 != _tmp160_label40) ? _tmp160_label40 : (_tmp160_label40 = g_quark_from_static_string ("Page_Up")))) || (_tmp161_ == ((0 != _tmp160_label41) ? _tmp160_label41 : (_tmp160_label41 = g_quark_from_static_string ("KP_Page_Up"))))) {
#line 1015 "../src/puzzle-view.vala"
		switch (0) {
#line 6342 "puzzle-view.c"
			default:
			{
#line 1079 "../src/puzzle-view.vala"
				puzzle_view_set_highlight_position_if_needed (self);
#line 1080 "../src/puzzle-view.vala"
				self->priv->highlight_y = (guint8) 0;
#line 1081 "../src/puzzle-view.vala"
				break;
#line 6351 "puzzle-view.c"
			}
		}
	} else if ((_tmp161_ == ((0 != _tmp160_label42) ? _tmp160_label42 : (_tmp160_label42 = g_quark_from_static_string ("Page_Down")))) || (_tmp161_ == ((0 != _tmp160_label43) ? _tmp160_label43 : (_tmp160_label43 = g_quark_from_static_string ("KP_Next"))))) {
#line 1015 "../src/puzzle-view.vala"
		switch (0) {
#line 6357 "puzzle-view.c"
			default:
			{
				Puzzle* _tmp202_;
				Puzzle* _tmp203_;
				guint8 _tmp204_;
				guint8 _tmp205_;
#line 1084 "../src/puzzle-view.vala"
				puzzle_view_set_highlight_position_if_needed (self);
#line 1085 "../src/puzzle-view.vala"
				_tmp202_ = puzzle_view_get_puzzle (self);
#line 1085 "../src/puzzle-view.vala"
				_tmp203_ = _tmp202_;
#line 1085 "../src/puzzle-view.vala"
				_tmp204_ = puzzle_get_size (_tmp203_);
#line 1085 "../src/puzzle-view.vala"
				_tmp205_ = _tmp204_;
#line 1085 "../src/puzzle-view.vala"
				self->priv->highlight_y = (guint8) (_tmp205_ - 1);
#line 1086 "../src/puzzle-view.vala"
				break;
#line 6378 "puzzle-view.c"
			}
		}
	} else {
#line 1015 "../src/puzzle-view.vala"
		switch (0) {
#line 6384 "puzzle-view.c"
			default:
			{
#line 1090 "../src/puzzle-view.vala"
				result = FALSE;
#line 1090 "../src/puzzle-view.vala"
				_g_free0 (key);
#line 1090 "../src/puzzle-view.vala"
				return result;
#line 6393 "puzzle-view.c"
			}
		}
	}
#line 1093 "../src/puzzle-view.vala"
	self->priv->highlight_set = TRUE;
#line 1095 "../src/puzzle-view.vala"
	_tmp206_ = key;
#line 1095 "../src/puzzle-view.vala"
	if (g_strcmp0 (_tmp206_, "Escape") == 0) {
#line 1097 "../src/puzzle-view.vala"
		if (self->priv->tile_selection) {
#line 1098 "../src/puzzle-view.vala"
			puzzle_view_clear_keyboard_highlight (self, TRUE);
#line 6407 "puzzle-view.c"
		} else {
#line 1100 "../src/puzzle-view.vala"
			puzzle_view_clear_keyboard_highlight (self, FALSE);
#line 6411 "puzzle-view.c"
		}
	} else {
#line 1103 "../src/puzzle-view.vala"
		self->priv->show_highlight = TRUE;
#line 6416 "puzzle-view.c"
	}
#line 1105 "../src/puzzle-view.vala"
	puzzle_view_queue_draw_tile (self, self->priv->old_highlight_x, self->priv->old_highlight_y);
#line 1106 "../src/puzzle-view.vala"
	if (self->priv->old_highlight_x != self->priv->highlight_x) {
#line 1106 "../src/puzzle-view.vala"
		_tmp207_ = TRUE;
#line 6424 "puzzle-view.c"
	} else {
#line 1107 "../src/puzzle-view.vala"
		_tmp207_ = self->priv->old_highlight_y != self->priv->highlight_y;
#line 6428 "puzzle-view.c"
	}
#line 1106 "../src/puzzle-view.vala"
	if (_tmp207_) {
#line 1108 "../src/puzzle-view.vala"
		puzzle_view_queue_draw_tile (self, self->priv->highlight_x, self->priv->highlight_y);
#line 6434 "puzzle-view.c"
	}
#line 1109 "../src/puzzle-view.vala"
	result = TRUE;
#line 1109 "../src/puzzle-view.vala"
	_g_free0 (key);
#line 1109 "../src/puzzle-view.vala"
	return result;
#line 6442 "puzzle-view.c"
}

static void
puzzle_view_set_highlight_position_if_needed (PuzzleView* self)
{
#line 1112 "../src/puzzle-view.vala"
	g_return_if_fail (self != NULL);
#line 1114 "../src/puzzle-view.vala"
	if (self->priv->highlight_set) {
#line 1116 "../src/puzzle-view.vala"
		return;
#line 6454 "puzzle-view.c"
	}
#line 1117 "../src/puzzle-view.vala"
	puzzle_view_set_highlight_position (self);
#line 6458 "puzzle-view.c"
}

static void
puzzle_view_set_highlight_position (PuzzleView* self)
{
	Puzzle* _tmp0_;
	Puzzle* _tmp1_;
	guint8 _tmp2_;
	guint8 _tmp3_;
#line 1119 "../src/puzzle-view.vala"
	g_return_if_fail (self != NULL);
#line 1122 "../src/puzzle-view.vala"
	_tmp0_ = puzzle_view_get_puzzle (self);
#line 1122 "../src/puzzle-view.vala"
	_tmp1_ = _tmp0_;
#line 1122 "../src/puzzle-view.vala"
	_tmp2_ = puzzle_get_size (_tmp1_);
#line 1122 "../src/puzzle-view.vala"
	_tmp3_ = _tmp2_;
#line 1122 "../src/puzzle-view.vala"
	self->priv->highlight_x = _tmp3_;
#line 1123 "../src/puzzle-view.vala"
	self->priv->highlight_y = (guint8) 0;
#line 6482 "puzzle-view.c"
}

static void
puzzle_view_clear_keyboard_highlight (PuzzleView* self,
                                      gboolean only_selection)
{
#line 1126 "../src/puzzle-view.vala"
	g_return_if_fail (self != NULL);
#line 1128 "../src/puzzle-view.vala"
	if (!only_selection) {
#line 1130 "../src/puzzle-view.vala"
		self->priv->show_highlight = FALSE;
#line 1131 "../src/puzzle-view.vala"
		puzzle_view_queue_draw_tile (self, self->priv->highlight_x, self->priv->highlight_y);
#line 1132 "../src/puzzle-view.vala"
		self->priv->highlight_set = FALSE;
#line 1133 "../src/puzzle-view.vala"
		self->priv->highlight_x = G_MAXUINT8;
#line 1134 "../src/puzzle-view.vala"
		self->priv->highlight_y = G_MAXUINT8;
#line 1135 "../src/puzzle-view.vala"
		self->priv->old_highlight_x = G_MAXUINT8;
#line 1136 "../src/puzzle-view.vala"
		self->priv->old_highlight_y = G_MAXUINT8;
#line 6507 "puzzle-view.c"
	}
#line 1138 "../src/puzzle-view.vala"
	if (self->priv->tile_selection) {
#line 1140 "../src/puzzle-view.vala"
		self->priv->tile_selection = FALSE;
#line 1141 "../src/puzzle-view.vala"
		puzzle_view_queue_draw_tile (self, self->priv->kbd_selected_x, self->priv->kbd_selected_y);
#line 1142 "../src/puzzle-view.vala"
		self->priv->kbd_selected_x = G_MAXUINT8;
#line 1143 "../src/puzzle-view.vala"
		self->priv->kbd_selected_y = G_MAXUINT8;
#line 6519 "puzzle-view.c"
	}
}

void
puzzle_view_disable_highlight (PuzzleView* self)
{
#line 1147 "../src/puzzle-view.vala"
	g_return_if_fail (self != NULL);
#line 1149 "../src/puzzle-view.vala"
	puzzle_view_clear_keyboard_highlight (self, FALSE);
#line 6530 "puzzle-view.c"
}

void
puzzle_view_move_up (PuzzleView* self,
                     gboolean left_board)
{
	PuzzleViewTileImage* _tmp0_;
#line 1156 "../src/puzzle-view.vala"
	g_return_if_fail (self != NULL);
#line 1158 "../src/puzzle-view.vala"
	_tmp0_ = self->priv->selected_tile;
#line 1158 "../src/puzzle-view.vala"
	if (_tmp0_ == NULL) {
#line 6544 "puzzle-view.c"
		Puzzle* _tmp1_;
		Puzzle* _tmp2_;
#line 1159 "../src/puzzle-view.vala"
		_tmp1_ = puzzle_view_get_puzzle (self);
#line 1159 "../src/puzzle-view.vala"
		_tmp2_ = _tmp1_;
#line 1159 "../src/puzzle-view.vala"
		puzzle_move_up (_tmp2_, left_board);
#line 6553 "puzzle-view.c"
	}
}

void
puzzle_view_move_down (PuzzleView* self,
                       gboolean left_board)
{
	PuzzleViewTileImage* _tmp0_;
#line 1162 "../src/puzzle-view.vala"
	g_return_if_fail (self != NULL);
#line 1164 "../src/puzzle-view.vala"
	_tmp0_ = self->priv->selected_tile;
#line 1164 "../src/puzzle-view.vala"
	if (_tmp0_ == NULL) {
#line 6568 "puzzle-view.c"
		Puzzle* _tmp1_;
		Puzzle* _tmp2_;
#line 1165 "../src/puzzle-view.vala"
		_tmp1_ = puzzle_view_get_puzzle (self);
#line 1165 "../src/puzzle-view.vala"
		_tmp2_ = _tmp1_;
#line 1165 "../src/puzzle-view.vala"
		puzzle_move_down (_tmp2_, left_board);
#line 6577 "puzzle-view.c"
	}
}

void
puzzle_view_move_left (PuzzleView* self,
                       gboolean left_board)
{
	PuzzleViewTileImage* _tmp0_;
#line 1168 "../src/puzzle-view.vala"
	g_return_if_fail (self != NULL);
#line 1170 "../src/puzzle-view.vala"
	_tmp0_ = self->priv->selected_tile;
#line 1170 "../src/puzzle-view.vala"
	if (_tmp0_ == NULL) {
#line 6592 "puzzle-view.c"
		Puzzle* _tmp1_;
		Puzzle* _tmp2_;
#line 1171 "../src/puzzle-view.vala"
		_tmp1_ = puzzle_view_get_puzzle (self);
#line 1171 "../src/puzzle-view.vala"
		_tmp2_ = _tmp1_;
#line 1171 "../src/puzzle-view.vala"
		puzzle_move_left (_tmp2_, left_board);
#line 6601 "puzzle-view.c"
	}
}

void
puzzle_view_move_right (PuzzleView* self,
                        gboolean left_board)
{
	PuzzleViewTileImage* _tmp0_;
#line 1174 "../src/puzzle-view.vala"
	g_return_if_fail (self != NULL);
#line 1176 "../src/puzzle-view.vala"
	_tmp0_ = self->priv->selected_tile;
#line 1176 "../src/puzzle-view.vala"
	if (_tmp0_ == NULL) {
#line 6616 "puzzle-view.c"
		Puzzle* _tmp1_;
		Puzzle* _tmp2_;
#line 1177 "../src/puzzle-view.vala"
		_tmp1_ = puzzle_view_get_puzzle (self);
#line 1177 "../src/puzzle-view.vala"
		_tmp2_ = _tmp1_;
#line 1177 "../src/puzzle-view.vala"
		puzzle_move_right (_tmp2_, left_board);
#line 6625 "puzzle-view.c"
	}
}

PuzzleView*
puzzle_view_construct (GType object_type)
{
	PuzzleView * self = NULL;
#line 39 "../src/puzzle-view.vala"
	self = (PuzzleView*) g_object_new (object_type, NULL);
#line 39 "../src/puzzle-view.vala"
	return self;
#line 6637 "puzzle-view.c"
}

PuzzleView*
puzzle_view_new (void)
{
#line 39 "../src/puzzle-view.vala"
	return puzzle_view_construct (TYPE_PUZZLE_VIEW);
#line 6645 "puzzle-view.c"
}

static Puzzle*
puzzle_view_get_puzzle (PuzzleView* self)
{
	Puzzle* result;
	Puzzle* _tmp0_;
#line 86 "../src/puzzle-view.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 86 "../src/puzzle-view.vala"
	if (!self->priv->puzzle_init_done) {
#line 86 "../src/puzzle-view.vala"
		g_assert_not_reached ();
#line 6659 "puzzle-view.c"
	}
#line 86 "../src/puzzle-view.vala"
	_tmp0_ = self->priv->_puzzle;
#line 86 "../src/puzzle-view.vala"
	result = _tmp0_;
#line 86 "../src/puzzle-view.vala"
	return result;
#line 6667 "puzzle-view.c"
}

static void
_puzzle_view_puzzle___lambda5_ (PuzzleView* self)
{
#line 123 "../src/puzzle-view.vala"
	puzzle_view_clear_keyboard_highlight (self, TRUE);
#line 6675 "puzzle-view.c"
}

static void
__puzzle_view_puzzle___lambda5__puzzle_solved (Puzzle* _sender,
                                               gpointer self)
{
#line 123 "../src/puzzle-view.vala"
	_puzzle_view_puzzle___lambda5_ ((PuzzleView*) self);
#line 6684 "puzzle-view.c"
}

static void
_puzzle_view_tile_moved_cb_puzzle_tile_moved (Puzzle* _sender,
                                              Tile* tile,
                                              guint8 x,
                                              guint8 y,
                                              gpointer self)
{
#line 124 "../src/puzzle-view.vala"
	puzzle_view_tile_moved_cb ((PuzzleView*) self, _sender, tile, x, y);
#line 6696 "puzzle-view.c"
}

static void
_gtk_widget_queue_draw_g_object_notify (GObject* _sender,
                                        GParamSpec* pspec,
                                        gpointer self)
{
#line 125 "../src/puzzle-view.vala"
	gtk_widget_queue_draw ((GtkWidget*) self);
#line 6706 "puzzle-view.c"
}

void
puzzle_view_set_puzzle (PuzzleView* self,
                        Puzzle* value)
{
	guint8 old_puzzle_size = 0U;
	Puzzle* _tmp4_;
	GHashTable* _tmp5_;
	Puzzle* _tmp27_;
	guint8 _tmp28_;
	guint8 _tmp29_;
	Puzzle* _tmp44_;
	Puzzle* _tmp45_;
	Puzzle* _tmp46_;
#line 87 "../src/puzzle-view.vala"
	g_return_if_fail (self != NULL);
#line 89 "../src/puzzle-view.vala"
	puzzle_view_show_right_sockets (self);
#line 90 "../src/puzzle-view.vala"
	old_puzzle_size = (guint8) 0;
#line 91 "../src/puzzle-view.vala"
	if (self->priv->puzzle_init_done) {
#line 6730 "puzzle-view.c"
		Puzzle* _tmp0_;
		guint8 _tmp1_;
		guint8 _tmp2_;
		Puzzle* _tmp3_;
#line 93 "../src/puzzle-view.vala"
		_tmp0_ = self->priv->_puzzle;
#line 93 "../src/puzzle-view.vala"
		_tmp1_ = puzzle_get_size (_tmp0_);
#line 93 "../src/puzzle-view.vala"
		_tmp2_ = _tmp1_;
#line 93 "../src/puzzle-view.vala"
		old_puzzle_size = _tmp2_;
#line 94 "../src/puzzle-view.vala"
		_tmp3_ = self->priv->_puzzle;
#line 94 "../src/puzzle-view.vala"
		g_signal_handlers_disconnect_by_func (_tmp3_, NULL, self);
#line 6747 "puzzle-view.c"
	}
#line 97 "../src/puzzle-view.vala"
	_tmp4_ = _g_object_ref0 (value);
#line 97 "../src/puzzle-view.vala"
	_g_object_unref0 (self->priv->_puzzle);
#line 97 "../src/puzzle-view.vala"
	self->priv->_puzzle = _tmp4_;
#line 98 "../src/puzzle-view.vala"
	self->priv->puzzle_init_done = TRUE;
#line 99 "../src/puzzle-view.vala"
	_g_object_unref0 (self->priv->last_selected_tile);
#line 99 "../src/puzzle-view.vala"
	self->priv->last_selected_tile = NULL;
#line 100 "../src/puzzle-view.vala"
	_tmp5_ = self->priv->tiles;
#line 100 "../src/puzzle-view.vala"
	g_hash_table_remove_all (_tmp5_);
#line 6765 "puzzle-view.c"
	{
		guint8 y = 0U;
#line 101 "../src/puzzle-view.vala"
		y = (guint8) 0;
#line 6770 "puzzle-view.c"
		{
			gboolean _tmp6_ = FALSE;
#line 101 "../src/puzzle-view.vala"
			_tmp6_ = TRUE;
#line 101 "../src/puzzle-view.vala"
			while (TRUE) {
#line 6777 "puzzle-view.c"
				Puzzle* _tmp8_;
				guint8 _tmp9_;
				guint8 _tmp10_;
#line 101 "../src/puzzle-view.vala"
				if (!_tmp6_) {
#line 6783 "puzzle-view.c"
					guint8 _tmp7_;
#line 101 "../src/puzzle-view.vala"
					_tmp7_ = y;
#line 101 "../src/puzzle-view.vala"
					y = _tmp7_ + 1;
#line 6789 "puzzle-view.c"
				}
#line 101 "../src/puzzle-view.vala"
				_tmp6_ = FALSE;
#line 101 "../src/puzzle-view.vala"
				_tmp8_ = self->priv->_puzzle;
#line 101 "../src/puzzle-view.vala"
				_tmp9_ = puzzle_get_size (_tmp8_);
#line 101 "../src/puzzle-view.vala"
				_tmp10_ = _tmp9_;
#line 101 "../src/puzzle-view.vala"
				if (!(y < _tmp10_)) {
#line 101 "../src/puzzle-view.vala"
					break;
#line 6803 "puzzle-view.c"
				}
				{
					guint8 x = 0U;
#line 103 "../src/puzzle-view.vala"
					x = (guint8) 0;
#line 6809 "puzzle-view.c"
					{
						gboolean _tmp11_ = FALSE;
#line 103 "../src/puzzle-view.vala"
						_tmp11_ = TRUE;
#line 103 "../src/puzzle-view.vala"
						while (TRUE) {
#line 6816 "puzzle-view.c"
							Puzzle* _tmp13_;
							guint8 _tmp14_;
							guint8 _tmp15_;
							Tile* tile = NULL;
							Puzzle* _tmp16_;
							Tile* _tmp17_;
							Tile* _tmp18_;
							PuzzleViewTileImage* image = NULL;
							Tile* _tmp19_;
							PuzzleViewTileImage* _tmp20_;
							PuzzleViewTileImage* _tmp21_;
							GHashTable* _tmp22_;
							Tile* _tmp23_;
							Tile* _tmp24_;
							PuzzleViewTileImage* _tmp25_;
							PuzzleViewTileImage* _tmp26_;
#line 103 "../src/puzzle-view.vala"
							if (!_tmp11_) {
#line 6835 "puzzle-view.c"
								guint8 _tmp12_;
#line 103 "../src/puzzle-view.vala"
								_tmp12_ = x;
#line 103 "../src/puzzle-view.vala"
								x = _tmp12_ + 1;
#line 6841 "puzzle-view.c"
							}
#line 103 "../src/puzzle-view.vala"
							_tmp11_ = FALSE;
#line 103 "../src/puzzle-view.vala"
							_tmp13_ = self->priv->_puzzle;
#line 103 "../src/puzzle-view.vala"
							_tmp14_ = puzzle_get_size (_tmp13_);
#line 103 "../src/puzzle-view.vala"
							_tmp15_ = _tmp14_;
#line 103 "../src/puzzle-view.vala"
							if (!(((gint) x) < (_tmp15_ * 2))) {
#line 103 "../src/puzzle-view.vala"
								break;
#line 6855 "puzzle-view.c"
							}
#line 105 "../src/puzzle-view.vala"
							_tmp16_ = self->priv->_puzzle;
#line 105 "../src/puzzle-view.vala"
							_tmp17_ = puzzle_get_tile (_tmp16_, x, y);
#line 105 "../src/puzzle-view.vala"
							tile = _tmp17_;
#line 106 "../src/puzzle-view.vala"
							_tmp18_ = tile;
#line 106 "../src/puzzle-view.vala"
							if (_tmp18_ == NULL) {
#line 107 "../src/puzzle-view.vala"
								_g_object_unref0 (tile);
#line 107 "../src/puzzle-view.vala"
								continue;
#line 6871 "puzzle-view.c"
							}
#line 109 "../src/puzzle-view.vala"
							_tmp19_ = tile;
#line 109 "../src/puzzle-view.vala"
							_tmp20_ = puzzle_view_tile_image_new (G_TYPE_CHECK_INSTANCE_CAST (_tmp19_, TYPE_TILE, Tile));
#line 109 "../src/puzzle-view.vala"
							image = _tmp20_;
#line 110 "../src/puzzle-view.vala"
							_tmp21_ = image;
#line 110 "../src/puzzle-view.vala"
							puzzle_view_move_tile_to_location (self, _tmp21_, (guint) x, (guint) y, (gdouble) 0);
#line 111 "../src/puzzle-view.vala"
							_tmp22_ = self->priv->tiles;
#line 111 "../src/puzzle-view.vala"
							_tmp23_ = tile;
#line 111 "../src/puzzle-view.vala"
							_tmp24_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp23_, TYPE_TILE, Tile));
#line 111 "../src/puzzle-view.vala"
							_tmp25_ = image;
#line 111 "../src/puzzle-view.vala"
							_tmp26_ = _g_object_ref0 (_tmp25_);
#line 111 "../src/puzzle-view.vala"
							g_hash_table_insert (_tmp22_, _tmp24_, _tmp26_);
#line 103 "../src/puzzle-view.vala"
							_g_object_unref0 (image);
#line 103 "../src/puzzle-view.vala"
							_g_object_unref0 (tile);
#line 6899 "puzzle-view.c"
						}
					}
				}
			}
		}
	}
#line 114 "../src/puzzle-view.vala"
	_tmp27_ = self->priv->_puzzle;
#line 114 "../src/puzzle-view.vala"
	_tmp28_ = puzzle_get_size (_tmp27_);
#line 114 "../src/puzzle-view.vala"
	_tmp29_ = _tmp28_;
#line 114 "../src/puzzle-view.vala"
	if (old_puzzle_size != _tmp29_) {
#line 6914 "puzzle-view.c"
		Puzzle* _tmp30_;
		guint8 _tmp31_;
		guint8 _tmp32_;
		Puzzle* _tmp33_;
		guint8 _tmp34_;
		guint8 _tmp35_;
		gdouble* _tmp36_;
		Puzzle* _tmp37_;
		guint8 _tmp38_;
		guint8 _tmp39_;
		Puzzle* _tmp40_;
		guint8 _tmp41_;
		guint8 _tmp42_;
		gdouble* _tmp43_;
#line 116 "../src/puzzle-view.vala"
		_cairo_pattern_destroy0 (self->priv->arrow_pattern);
#line 116 "../src/puzzle-view.vala"
		self->priv->arrow_pattern = NULL;
#line 117 "../src/puzzle-view.vala"
		_cairo_pattern_destroy0 (self->priv->socket_pattern);
#line 117 "../src/puzzle-view.vala"
		self->priv->socket_pattern = NULL;
#line 118 "../src/puzzle-view.vala"
		_tmp30_ = self->priv->_puzzle;
#line 118 "../src/puzzle-view.vala"
		_tmp31_ = puzzle_get_size (_tmp30_);
#line 118 "../src/puzzle-view.vala"
		_tmp32_ = _tmp31_;
#line 118 "../src/puzzle-view.vala"
		_tmp33_ = self->priv->_puzzle;
#line 118 "../src/puzzle-view.vala"
		_tmp34_ = puzzle_get_size (_tmp33_);
#line 118 "../src/puzzle-view.vala"
		_tmp35_ = _tmp34_;
#line 118 "../src/puzzle-view.vala"
		_tmp36_ = g_new0 (gdouble, (2 * _tmp32_) * _tmp35_);
#line 118 "../src/puzzle-view.vala"
		self->priv->sockets_xs = (g_free (self->priv->sockets_xs), NULL);
#line 118 "../src/puzzle-view.vala"
		self->priv->sockets_xs = _tmp36_;
#line 118 "../src/puzzle-view.vala"
		self->priv->sockets_xs_length1 = 2 * _tmp32_;
#line 118 "../src/puzzle-view.vala"
		self->priv->sockets_xs_length2 = _tmp35_;
#line 119 "../src/puzzle-view.vala"
		_tmp37_ = self->priv->_puzzle;
#line 119 "../src/puzzle-view.vala"
		_tmp38_ = puzzle_get_size (_tmp37_);
#line 119 "../src/puzzle-view.vala"
		_tmp39_ = _tmp38_;
#line 119 "../src/puzzle-view.vala"
		_tmp40_ = self->priv->_puzzle;
#line 119 "../src/puzzle-view.vala"
		_tmp41_ = puzzle_get_size (_tmp40_);
#line 119 "../src/puzzle-view.vala"
		_tmp42_ = _tmp41_;
#line 119 "../src/puzzle-view.vala"
		_tmp43_ = g_new0 (gdouble, (2 * _tmp39_) * _tmp42_);
#line 119 "../src/puzzle-view.vala"
		self->priv->sockets_ys = (g_free (self->priv->sockets_ys), NULL);
#line 119 "../src/puzzle-view.vala"
		self->priv->sockets_ys = _tmp43_;
#line 119 "../src/puzzle-view.vala"
		self->priv->sockets_ys_length1 = 2 * _tmp39_;
#line 119 "../src/puzzle-view.vala"
		self->priv->sockets_ys_length2 = _tmp42_;
#line 6981 "puzzle-view.c"
	}
#line 122 "../src/puzzle-view.vala"
	puzzle_view_set_highlight_position (self);
#line 123 "../src/puzzle-view.vala"
	_tmp44_ = self->priv->_puzzle;
#line 123 "../src/puzzle-view.vala"
	g_signal_connect_object (_tmp44_, "solved", (GCallback) __puzzle_view_puzzle___lambda5__puzzle_solved, self, 0);
#line 124 "../src/puzzle-view.vala"
	_tmp45_ = self->priv->_puzzle;
#line 124 "../src/puzzle-view.vala"
	g_signal_connect_object (_tmp45_, "tile-moved", (GCallback) _puzzle_view_tile_moved_cb_puzzle_tile_moved, self, 0);
#line 125 "../src/puzzle-view.vala"
	_tmp46_ = self->priv->_puzzle;
#line 125 "../src/puzzle-view.vala"
	g_signal_connect_object ((GObject*) _tmp46_, "notify::paused", (GCallback) _gtk_widget_queue_draw_g_object_notify, (GtkWidget*) self, 0);
#line 126 "../src/puzzle-view.vala"
	gtk_widget_queue_resize ((GtkWidget*) self);
#line 6999 "puzzle-view.c"
}

void
puzzle_view_set_theme_id (PuzzleView* self,
                          const gchar* value)
{
	const gchar* _tmp0_;
	GQuark _tmp2_ = 0U;
#line 136 "../src/puzzle-view.vala"
	static GQuark _tmp1_label0 = 0;
#line 136 "../src/puzzle-view.vala"
	static GQuark _tmp1_label1 = 0;
#line 136 "../src/puzzle-view.vala"
	static GQuark _tmp1_label2 = 0;
#line 7014 "puzzle-view.c"
	Theme* _tmp8_;
#line 134 "../src/puzzle-view.vala"
	g_return_if_fail (self != NULL);
#line 136 "../src/puzzle-view.vala"
	_tmp0_ = value;
#line 136 "../src/puzzle-view.vala"
	_tmp2_ = (NULL == _tmp0_) ? 0 : g_quark_from_string (_tmp0_);
#line 136 "../src/puzzle-view.vala"
	if (_tmp2_ == ((0 != _tmp1_label0) ? _tmp1_label0 : (_tmp1_label0 = g_quark_from_static_string ("neoretro")))) {
#line 136 "../src/puzzle-view.vala"
		switch (0) {
#line 7026 "puzzle-view.c"
			default:
			{
				NeoRetroTheme* _tmp3_;
#line 140 "../src/puzzle-view.vala"
				_tmp3_ = neo_retro_theme_new ();
#line 140 "../src/puzzle-view.vala"
				_g_object_unref0 (self->priv->theme);
#line 140 "../src/puzzle-view.vala"
				self->priv->theme = (Theme*) _tmp3_;
#line 140 "../src/puzzle-view.vala"
				break;
#line 7038 "puzzle-view.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label1) ? _tmp1_label1 : (_tmp1_label1 = g_quark_from_static_string ("nostalgia")))) {
#line 136 "../src/puzzle-view.vala"
		switch (0) {
#line 7044 "puzzle-view.c"
			default:
			{
				NostalgiaTheme* _tmp4_;
#line 141 "../src/puzzle-view.vala"
				_tmp4_ = nostalgia_theme_new ();
#line 141 "../src/puzzle-view.vala"
				_g_object_unref0 (self->priv->theme);
#line 141 "../src/puzzle-view.vala"
				self->priv->theme = (Theme*) _tmp4_;
#line 141 "../src/puzzle-view.vala"
				break;
#line 7056 "puzzle-view.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label2) ? _tmp1_label2 : (_tmp1_label2 = g_quark_from_static_string ("synesthesia")))) {
#line 136 "../src/puzzle-view.vala"
		switch (0) {
#line 7062 "puzzle-view.c"
			default:
			{
				SynesthesiaTheme* _tmp5_;
#line 142 "../src/puzzle-view.vala"
				_tmp5_ = synesthesia_theme_new ();
#line 142 "../src/puzzle-view.vala"
				_g_object_unref0 (self->priv->theme);
#line 142 "../src/puzzle-view.vala"
				self->priv->theme = (Theme*) _tmp5_;
#line 142 "../src/puzzle-view.vala"
				break;
#line 7074 "puzzle-view.c"
			}
		}
	} else {
#line 136 "../src/puzzle-view.vala"
		switch (0) {
#line 7080 "puzzle-view.c"
			default:
			{
				ExtrusionTheme* _tmp6_;
#line 139 "../src/puzzle-view.vala"
				_tmp6_ = extrusion_theme_new ();
#line 139 "../src/puzzle-view.vala"
				_g_object_unref0 (self->priv->theme);
#line 139 "../src/puzzle-view.vala"
				self->priv->theme = (Theme*) _tmp6_;
#line 139 "../src/puzzle-view.vala"
				break;
#line 7092 "puzzle-view.c"
			}
		}
	}
#line 145 "../src/puzzle-view.vala"
	if (self->priv->tilesize != ((guint) 0)) {
#line 7098 "puzzle-view.c"
		Theme* _tmp7_;
#line 146 "../src/puzzle-view.vala"
		_tmp7_ = self->priv->theme;
#line 146 "../src/puzzle-view.vala"
		theme_configure (_tmp7_, self->priv->tilesize);
#line 7104 "puzzle-view.c"
	}
#line 147 "../src/puzzle-view.vala"
	_cairo_pattern_destroy0 (self->priv->arrow_pattern);
#line 147 "../src/puzzle-view.vala"
	self->priv->arrow_pattern = NULL;
#line 148 "../src/puzzle-view.vala"
	_cairo_pattern_destroy0 (self->priv->socket_pattern);
#line 148 "../src/puzzle-view.vala"
	self->priv->socket_pattern = NULL;
#line 149 "../src/puzzle-view.vala"
	_tmp8_ = self->priv->theme;
#line 149 "../src/puzzle-view.vala"
	theme_set_animation_level (_tmp8_, self->priv->socket_animation_level);
#line 150 "../src/puzzle-view.vala"
	gtk_widget_queue_draw ((GtkWidget*) self);
#line 134 "../src/puzzle-view.vala"
	g_object_notify_by_pspec ((GObject *) self, puzzle_view_properties[PUZZLE_VIEW_THEME_ID_PROPERTY]);
#line 7122 "puzzle-view.c"
}

gboolean
puzzle_view_get_tile_selected (PuzzleView* self)
{
	gboolean result;
#line 157 "../src/puzzle-view.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 157 "../src/puzzle-view.vala"
	result = self->priv->_tile_selected;
#line 157 "../src/puzzle-view.vala"
	return result;
#line 7135 "puzzle-view.c"
}

static void
puzzle_view_set_tile_selected (PuzzleView* self,
                               gboolean value)
{
	gboolean old_value;
#line 157 "../src/puzzle-view.vala"
	g_return_if_fail (self != NULL);
#line 157 "../src/puzzle-view.vala"
	old_value = puzzle_view_get_tile_selected (self);
#line 157 "../src/puzzle-view.vala"
	if (old_value != value) {
#line 157 "../src/puzzle-view.vala"
		self->priv->_tile_selected = value;
#line 157 "../src/puzzle-view.vala"
		g_object_notify_by_pspec ((GObject *) self, puzzle_view_properties[PUZZLE_VIEW_TILE_SELECTED_PROPERTY]);
#line 7153 "puzzle-view.c"
	}
}

guint
puzzle_view_get_boardsize (PuzzleView* self)
{
	guint result;
#line 174 "../src/puzzle-view.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 174 "../src/puzzle-view.vala"
	result = self->priv->_boardsize;
#line 174 "../src/puzzle-view.vala"
	return result;
#line 7167 "puzzle-view.c"
}

static void
puzzle_view_set_boardsize (PuzzleView* self,
                           guint value)
{
	guint old_value;
#line 174 "../src/puzzle-view.vala"
	g_return_if_fail (self != NULL);
#line 174 "../src/puzzle-view.vala"
	old_value = puzzle_view_get_boardsize (self);
#line 174 "../src/puzzle-view.vala"
	if (old_value != value) {
#line 174 "../src/puzzle-view.vala"
		self->priv->_boardsize = value;
#line 174 "../src/puzzle-view.vala"
		g_object_notify_by_pspec ((GObject *) self, puzzle_view_properties[PUZZLE_VIEW_BOARDSIZE_PROPERTY]);
#line 7185 "puzzle-view.c"
	}
}

gdouble
puzzle_view_get_x_offset_right (PuzzleView* self)
{
	gdouble result;
#line 175 "../src/puzzle-view.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 175 "../src/puzzle-view.vala"
	result = self->priv->_x_offset_right;
#line 175 "../src/puzzle-view.vala"
	return result;
#line 7199 "puzzle-view.c"
}

static void
puzzle_view_set_x_offset_right (PuzzleView* self,
                                gdouble value)
{
	gdouble old_value;
#line 175 "../src/puzzle-view.vala"
	g_return_if_fail (self != NULL);
#line 175 "../src/puzzle-view.vala"
	old_value = puzzle_view_get_x_offset_right (self);
#line 175 "../src/puzzle-view.vala"
	if (old_value != value) {
#line 175 "../src/puzzle-view.vala"
		self->priv->_x_offset_right = value;
#line 175 "../src/puzzle-view.vala"
		g_object_notify_by_pspec ((GObject *) self, puzzle_view_properties[PUZZLE_VIEW_X_OFFSET_RIGHT_PROPERTY]);
#line 7217 "puzzle-view.c"
	}
}

gdouble
puzzle_view_get_y_offset (PuzzleView* self)
{
	gdouble result;
#line 176 "../src/puzzle-view.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 176 "../src/puzzle-view.vala"
	result = self->priv->_y_offset;
#line 176 "../src/puzzle-view.vala"
	return result;
#line 7231 "puzzle-view.c"
}

static void
puzzle_view_set_y_offset (PuzzleView* self,
                          gdouble value)
{
	gdouble old_value;
#line 176 "../src/puzzle-view.vala"
	g_return_if_fail (self != NULL);
#line 176 "../src/puzzle-view.vala"
	old_value = puzzle_view_get_y_offset (self);
#line 176 "../src/puzzle-view.vala"
	if (old_value != value) {
#line 176 "../src/puzzle-view.vala"
		self->priv->_y_offset = value;
#line 176 "../src/puzzle-view.vala"
		g_object_notify_by_pspec ((GObject *) self, puzzle_view_properties[PUZZLE_VIEW_Y_OFFSET_PROPERTY]);
#line 7249 "puzzle-view.c"
	}
}

gdouble
puzzle_view_get_right_margin (PuzzleView* self)
{
	gdouble result;
#line 177 "../src/puzzle-view.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 177 "../src/puzzle-view.vala"
	result = self->priv->_right_margin;
#line 177 "../src/puzzle-view.vala"
	return result;
#line 7263 "puzzle-view.c"
}

static void
puzzle_view_set_right_margin (PuzzleView* self,
                              gdouble value)
{
	gdouble old_value;
#line 177 "../src/puzzle-view.vala"
	g_return_if_fail (self != NULL);
#line 177 "../src/puzzle-view.vala"
	old_value = puzzle_view_get_right_margin (self);
#line 177 "../src/puzzle-view.vala"
	if (old_value != value) {
#line 177 "../src/puzzle-view.vala"
		self->priv->_right_margin = value;
#line 177 "../src/puzzle-view.vala"
		g_object_notify_by_pspec ((GObject *) self, puzzle_view_properties[PUZZLE_VIEW_RIGHT_MARGIN_PROPERTY]);
#line 7281 "puzzle-view.c"
	}
}

static gboolean
puzzle_view_get_mouse_use_extra_buttons (PuzzleView* self)
{
	gboolean result;
#line 695 "../src/puzzle-view.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 695 "../src/puzzle-view.vala"
	result = self->priv->_mouse_use_extra_buttons;
#line 695 "../src/puzzle-view.vala"
	return result;
#line 7295 "puzzle-view.c"
}

void
puzzle_view_set_mouse_use_extra_buttons (PuzzleView* self,
                                         gboolean value)
{
#line 695 "../src/puzzle-view.vala"
	g_return_if_fail (self != NULL);
#line 695 "../src/puzzle-view.vala"
	self->priv->_mouse_use_extra_buttons = value;
#line 7306 "puzzle-view.c"
}

static gint
puzzle_view_get_mouse_back_button (PuzzleView* self)
{
	gint result;
#line 696 "../src/puzzle-view.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 696 "../src/puzzle-view.vala"
	result = self->priv->_mouse_back_button;
#line 696 "../src/puzzle-view.vala"
	return result;
#line 7319 "puzzle-view.c"
}

void
puzzle_view_set_mouse_back_button (PuzzleView* self,
                                   gint value)
{
#line 696 "../src/puzzle-view.vala"
	g_return_if_fail (self != NULL);
#line 696 "../src/puzzle-view.vala"
	self->priv->_mouse_back_button = value;
#line 7330 "puzzle-view.c"
}

static gint
puzzle_view_get_mouse_forward_button (PuzzleView* self)
{
	gint result;
#line 697 "../src/puzzle-view.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 697 "../src/puzzle-view.vala"
	result = self->priv->_mouse_forward_button;
#line 697 "../src/puzzle-view.vala"
	return result;
#line 7343 "puzzle-view.c"
}

void
puzzle_view_set_mouse_forward_button (PuzzleView* self,
                                      gint value)
{
#line 697 "../src/puzzle-view.vala"
	g_return_if_fail (self != NULL);
#line 697 "../src/puzzle-view.vala"
	self->priv->_mouse_forward_button = value;
#line 7354 "puzzle-view.c"
}

static PuzzleViewTileImage*
puzzle_view_tile_image_construct (GType object_type,
                                  Tile* tile)
{
	PuzzleViewTileImage * self = NULL;
	Tile* _tmp0_;
#line 67 "../src/puzzle-view.vala"
	g_return_val_if_fail (tile != NULL, NULL);
#line 67 "../src/puzzle-view.vala"
	self = (PuzzleViewTileImage*) g_object_new (object_type, NULL);
#line 69 "../src/puzzle-view.vala"
	_tmp0_ = _g_object_ref0 (tile);
#line 69 "../src/puzzle-view.vala"
	_g_object_unref0 (self->tile);
#line 69 "../src/puzzle-view.vala"
	self->tile = _tmp0_;
#line 67 "../src/puzzle-view.vala"
	return self;
#line 7375 "puzzle-view.c"
}

static PuzzleViewTileImage*
puzzle_view_tile_image_new (Tile* tile)
{
#line 67 "../src/puzzle-view.vala"
	return puzzle_view_tile_image_construct (PUZZLE_VIEW_TYPE_TILE_IMAGE, tile);
#line 7383 "puzzle-view.c"
}

static void
puzzle_view_tile_image_class_init (PuzzleViewTileImageClass * klass,
                                   gpointer klass_data)
{
#line 41 "../src/puzzle-view.vala"
	puzzle_view_tile_image_parent_class = g_type_class_peek_parent (klass);
#line 41 "../src/puzzle-view.vala"
	G_OBJECT_CLASS (klass)->finalize = puzzle_view_tile_image_finalize;
#line 7394 "puzzle-view.c"
}

static void
puzzle_view_tile_image_instance_init (PuzzleViewTileImage * self,
                                      gpointer klass)
{
#line 47 "../src/puzzle-view.vala"
	self->x = 0.0;
#line 48 "../src/puzzle-view.vala"
	self->y = 0.0;
#line 51 "../src/puzzle-view.vala"
	self->source_x = 0.0;
#line 52 "../src/puzzle-view.vala"
	self->source_y = 0.0;
#line 55 "../src/puzzle-view.vala"
	self->source_time = 0.0;
#line 58 "../src/puzzle-view.vala"
	self->target_x = 0.0;
#line 59 "../src/puzzle-view.vala"
	self->target_y = 0.0;
#line 62 "../src/puzzle-view.vala"
	self->duration = 0.0;
#line 65 "../src/puzzle-view.vala"
	self->snap_to_cursor = TRUE;
#line 7419 "puzzle-view.c"
}

static void
puzzle_view_tile_image_finalize (GObject * obj)
{
	PuzzleViewTileImage * self;
#line 41 "../src/puzzle-view.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PUZZLE_VIEW_TYPE_TILE_IMAGE, PuzzleViewTileImage);
#line 44 "../src/puzzle-view.vala"
	_g_object_unref0 (self->tile);
#line 41 "../src/puzzle-view.vala"
	G_OBJECT_CLASS (puzzle_view_tile_image_parent_class)->finalize (obj);
#line 7432 "puzzle-view.c"
}

static GType
puzzle_view_tile_image_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (PuzzleViewTileImageClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) puzzle_view_tile_image_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PuzzleViewTileImage), 0, (GInstanceInitFunc) puzzle_view_tile_image_instance_init, NULL };
	GType puzzle_view_tile_image_type_id;
	puzzle_view_tile_image_type_id = g_type_register_static (G_TYPE_OBJECT, "PuzzleViewTileImage", &g_define_type_info, 0);
	return puzzle_view_tile_image_type_id;
}

static GType
puzzle_view_tile_image_get_type (void)
{
	static volatile gsize puzzle_view_tile_image_type_id__once = 0;
	if (g_once_init_enter (&puzzle_view_tile_image_type_id__once)) {
		GType puzzle_view_tile_image_type_id;
		puzzle_view_tile_image_type_id = puzzle_view_tile_image_get_type_once ();
		g_once_init_leave (&puzzle_view_tile_image_type_id__once, puzzle_view_tile_image_type_id);
	}
	return puzzle_view_tile_image_type_id__once;
}

static GObject *
puzzle_view_constructor (GType type,
                         guint n_construct_properties,
                         GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	PuzzleView * self;
	GTimer* _tmp0_;
#line 194 "../src/puzzle-view.vala"
	parent_class = G_OBJECT_CLASS (puzzle_view_parent_class);
#line 194 "../src/puzzle-view.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 194 "../src/puzzle-view.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_PUZZLE_VIEW, PuzzleView);
#line 196 "../src/puzzle-view.vala"
	puzzle_view_init_mouse (self);
#line 197 "../src/puzzle-view.vala"
	puzzle_view_init_keyboard (self);
#line 199 "../src/puzzle-view.vala"
	gtk_widget_set_events ((GtkWidget*) self, (gint) (((((GDK_EXPOSURE_MASK | GDK_BUTTON_PRESS_MASK) | GDK_POINTER_MOTION_MASK) | GDK_BUTTON_RELEASE_MASK) | GDK_ENTER_NOTIFY_MASK) | GDK_LEAVE_NOTIFY_MASK));
#line 206 "../src/puzzle-view.vala"
	_tmp0_ = self->priv->animation_timer;
#line 206 "../src/puzzle-view.vala"
	g_timer_start (_tmp0_);
#line 194 "../src/puzzle-view.vala"
	return obj;
#line 7483 "puzzle-view.c"
}

static void
puzzle_view_class_init (PuzzleViewClass * klass,
                        gpointer klass_data)
{
#line 39 "../src/puzzle-view.vala"
	puzzle_view_parent_class = g_type_class_peek_parent (klass);
#line 39 "../src/puzzle-view.vala"
	g_type_class_adjust_private_offset (klass, &PuzzleView_private_offset);
#line 39 "../src/puzzle-view.vala"
	((GtkWidgetClass *) klass)->get_preferred_width = (void (*) (GtkWidget*, gint*, gint*)) puzzle_view_real_get_preferred_width;
#line 39 "../src/puzzle-view.vala"
	((GtkWidgetClass *) klass)->get_preferred_height = (void (*) (GtkWidget*, gint*, gint*)) puzzle_view_real_get_preferred_height;
#line 39 "../src/puzzle-view.vala"
	((GtkWidgetClass *) klass)->configure_event = (gboolean (*) (GtkWidget*, GdkEventConfigure*)) puzzle_view_real_configure_event;
#line 39 "../src/puzzle-view.vala"
	((GtkWidgetClass *) klass)->draw = (gboolean (*) (GtkWidget*, cairo_t*)) puzzle_view_real_draw;
#line 39 "../src/puzzle-view.vala"
	((GtkWidgetClass *) klass)->leave_notify_event = (gboolean (*) (GtkWidget*, GdkEventCrossing*)) puzzle_view_real_leave_notify_event;
#line 39 "../src/puzzle-view.vala"
	((GtkWidgetClass *) klass)->enter_notify_event = (gboolean (*) (GtkWidget*, GdkEventCrossing*)) puzzle_view_real_enter_notify_event;
#line 39 "../src/puzzle-view.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_puzzle_view_get_property;
#line 39 "../src/puzzle-view.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_puzzle_view_set_property;
#line 39 "../src/puzzle-view.vala"
	G_OBJECT_CLASS (klass)->constructor = puzzle_view_constructor;
#line 39 "../src/puzzle-view.vala"
	G_OBJECT_CLASS (klass)->finalize = puzzle_view_finalize;
#line 39 "../src/puzzle-view.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PUZZLE_VIEW_PUZZLE_PROPERTY, puzzle_view_properties[PUZZLE_VIEW_PUZZLE_PROPERTY] = g_param_spec_object ("puzzle", "puzzle", "puzzle", TYPE_PUZZLE, G_PARAM_STATIC_STRINGS | G_PARAM_WRITABLE | G_PARAM_EXPLICIT_NOTIFY));
#line 39 "../src/puzzle-view.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PUZZLE_VIEW_THEME_ID_PROPERTY, puzzle_view_properties[PUZZLE_VIEW_THEME_ID_PROPERTY] = g_param_spec_string ("theme-id", "theme-id", "theme-id", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_WRITABLE));
#line 39 "../src/puzzle-view.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PUZZLE_VIEW_TILE_SELECTED_PROPERTY, puzzle_view_properties[PUZZLE_VIEW_TILE_SELECTED_PROPERTY] = g_param_spec_boolean ("tile-selected", "tile-selected", "tile-selected", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 39 "../src/puzzle-view.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PUZZLE_VIEW_BOARDSIZE_PROPERTY, puzzle_view_properties[PUZZLE_VIEW_BOARDSIZE_PROPERTY] = g_param_spec_uint ("boardsize", "boardsize", "boardsize", 0, G_MAXUINT, (guint) 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 39 "../src/puzzle-view.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PUZZLE_VIEW_X_OFFSET_RIGHT_PROPERTY, puzzle_view_properties[PUZZLE_VIEW_X_OFFSET_RIGHT_PROPERTY] = g_param_spec_double ("x-offset-right", "x-offset-right", "x-offset-right", -G_MAXDOUBLE, G_MAXDOUBLE, (gdouble) 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 39 "../src/puzzle-view.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PUZZLE_VIEW_Y_OFFSET_PROPERTY, puzzle_view_properties[PUZZLE_VIEW_Y_OFFSET_PROPERTY] = g_param_spec_double ("y-offset", "y-offset", "y-offset", -G_MAXDOUBLE, G_MAXDOUBLE, (gdouble) 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 39 "../src/puzzle-view.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PUZZLE_VIEW_RIGHT_MARGIN_PROPERTY, puzzle_view_properties[PUZZLE_VIEW_RIGHT_MARGIN_PROPERTY] = g_param_spec_double ("right-margin", "right-margin", "right-margin", -G_MAXDOUBLE, G_MAXDOUBLE, (gdouble) 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 39 "../src/puzzle-view.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PUZZLE_VIEW_MOUSE_USE_EXTRA_BUTTONS_PROPERTY, puzzle_view_properties[PUZZLE_VIEW_MOUSE_USE_EXTRA_BUTTONS_PROPERTY] = g_param_spec_boolean ("mouse-use-extra-buttons", "mouse-use-extra-buttons", "mouse-use-extra-buttons", TRUE, G_PARAM_STATIC_STRINGS | G_PARAM_WRITABLE | G_PARAM_EXPLICIT_NOTIFY));
#line 39 "../src/puzzle-view.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PUZZLE_VIEW_MOUSE_BACK_BUTTON_PROPERTY, puzzle_view_properties[PUZZLE_VIEW_MOUSE_BACK_BUTTON_PROPERTY] = g_param_spec_int ("mouse-back-button", "mouse-back-button", "mouse-back-button", G_MININT, G_MAXINT, 8, G_PARAM_STATIC_STRINGS | G_PARAM_WRITABLE | G_PARAM_EXPLICIT_NOTIFY));
#line 39 "../src/puzzle-view.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PUZZLE_VIEW_MOUSE_FORWARD_BUTTON_PROPERTY, puzzle_view_properties[PUZZLE_VIEW_MOUSE_FORWARD_BUTTON_PROPERTY] = g_param_spec_int ("mouse-forward-button", "mouse-forward-button", "mouse-forward-button", G_MININT, G_MAXINT, 9, G_PARAM_STATIC_STRINGS | G_PARAM_WRITABLE | G_PARAM_EXPLICIT_NOTIFY));
#line 7534 "puzzle-view.c"
}

static void
puzzle_view_instance_init (PuzzleView * self,
                           gpointer klass)
{
	GHashFunc _tmp0_;
	GEqualFunc _tmp1_;
	GHashTable* _tmp2_;
	GTimer* _tmp3_;
#line 39 "../src/puzzle-view.vala"
	self->priv = puzzle_view_get_instance_private (self);
#line 83 "../src/puzzle-view.vala"
	self->priv->puzzle_init_done = FALSE;
#line 155 "../src/puzzle-view.vala"
	self->priv->selected_tile = NULL;
#line 156 "../src/puzzle-view.vala"
	self->priv->last_selected_tile = NULL;
#line 157 "../src/puzzle-view.vala"
	self->priv->_tile_selected = FALSE;
#line 160 "../src/puzzle-view.vala"
	self->priv->selection_timeout = (guint) 0;
#line 167 "../src/puzzle-view.vala"
	_tmp0_ = g_direct_hash;
#line 167 "../src/puzzle-view.vala"
	_tmp1_ = g_direct_equal;
#line 167 "../src/puzzle-view.vala"
	_tmp2_ = g_hash_table_new_full (_tmp0_, _tmp1_, _g_object_unref0_, _g_object_unref0_);
#line 167 "../src/puzzle-view.vala"
	self->priv->tiles = _tmp2_;
#line 170 "../src/puzzle-view.vala"
	_tmp3_ = g_timer_new ();
#line 170 "../src/puzzle-view.vala"
	self->priv->animation_timer = _tmp3_;
#line 171 "../src/puzzle-view.vala"
	self->priv->animation_timeout = (guint) 0;
#line 174 "../src/puzzle-view.vala"
	self->priv->_boardsize = (guint) 0;
#line 175 "../src/puzzle-view.vala"
	self->priv->_x_offset_right = (gdouble) 0;
#line 176 "../src/puzzle-view.vala"
	self->priv->_y_offset = (gdouble) 0;
#line 177 "../src/puzzle-view.vala"
	self->priv->_right_margin = (gdouble) 0;
#line 178 "../src/puzzle-view.vala"
	self->priv->x_offset = 0.0;
#line 179 "../src/puzzle-view.vala"
	self->priv->tilesize = (guint) 0;
#line 180 "../src/puzzle-view.vala"
	self->priv->gap = (guint) 0;
#line 181 "../src/puzzle-view.vala"
	self->priv->arrow_x = 0.0;
#line 182 "../src/puzzle-view.vala"
	self->priv->arrow_local_y = 0.0;
#line 185 "../src/puzzle-view.vala"
	self->priv->board_x_maxi = 0;
#line 186 "../src/puzzle-view.vala"
	self->priv->board_y_maxi = 0;
#line 187 "../src/puzzle-view.vala"
	self->priv->snap_distance = 0.0;
#line 190 "../src/puzzle-view.vala"
	self->priv->render_size = (guint) 0;
#line 191 "../src/puzzle-view.vala"
	self->priv->arrow_pattern = NULL;
#line 192 "../src/puzzle-view.vala"
	self->priv->socket_pattern = NULL;
#line 695 "../src/puzzle-view.vala"
	self->priv->_mouse_use_extra_buttons = TRUE;
#line 696 "../src/puzzle-view.vala"
	self->priv->_mouse_back_button = 8;
#line 697 "../src/puzzle-view.vala"
	self->priv->_mouse_forward_button = 9;
#line 871 "../src/puzzle-view.vala"
	self->priv->socket_animation_level = (guint8) 0;
#line 872 "../src/puzzle-view.vala"
	self->priv->socket_timeout_id = (guint) 0;
#line 912 "../src/puzzle-view.vala"
	self->priv->show_highlight = FALSE;
#line 914 "../src/puzzle-view.vala"
	self->priv->highlight_set = FALSE;
#line 915 "../src/puzzle-view.vala"
	self->priv->highlight_x = G_MAXUINT8;
#line 916 "../src/puzzle-view.vala"
	self->priv->highlight_y = G_MAXUINT8;
#line 917 "../src/puzzle-view.vala"
	self->priv->old_highlight_x = G_MAXUINT8;
#line 918 "../src/puzzle-view.vala"
	self->priv->old_highlight_y = G_MAXUINT8;
#line 920 "../src/puzzle-view.vala"
	self->priv->tile_selection = FALSE;
#line 921 "../src/puzzle-view.vala"
	self->priv->kbd_selected_x = G_MAXUINT8;
#line 922 "../src/puzzle-view.vala"
	self->priv->kbd_selected_y = G_MAXUINT8;
#line 7629 "puzzle-view.c"
}

static void
puzzle_view_finalize (GObject * obj)
{
	PuzzleView * self;
#line 39 "../src/puzzle-view.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_PUZZLE_VIEW, PuzzleView);
#line 82 "../src/puzzle-view.vala"
	_g_object_unref0 (self->priv->_puzzle);
#line 131 "../src/puzzle-view.vala"
	_g_object_unref0 (self->priv->theme);
#line 155 "../src/puzzle-view.vala"
	_g_object_unref0 (self->priv->selected_tile);
#line 156 "../src/puzzle-view.vala"
	_g_object_unref0 (self->priv->last_selected_tile);
#line 167 "../src/puzzle-view.vala"
	_g_hash_table_unref0 (self->priv->tiles);
#line 170 "../src/puzzle-view.vala"
	_g_timer_destroy0 (self->priv->animation_timer);
#line 183 "../src/puzzle-view.vala"
	self->priv->sockets_xs = (g_free (self->priv->sockets_xs), NULL);
#line 184 "../src/puzzle-view.vala"
	self->priv->sockets_ys = (g_free (self->priv->sockets_ys), NULL);
#line 191 "../src/puzzle-view.vala"
	_cairo_pattern_destroy0 (self->priv->arrow_pattern);
#line 192 "../src/puzzle-view.vala"
	_cairo_pattern_destroy0 (self->priv->socket_pattern);
#line 679 "../src/puzzle-view.vala"
	_g_object_unref0 (self->priv->motion_controller);
#line 680 "../src/puzzle-view.vala"
	_g_object_unref0 (self->priv->click_controller);
#line 910 "../src/puzzle-view.vala"
	_g_object_unref0 (self->priv->key_controller);
#line 39 "../src/puzzle-view.vala"
	G_OBJECT_CLASS (puzzle_view_parent_class)->finalize (obj);
#line 7666 "puzzle-view.c"
}

static GType
puzzle_view_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (PuzzleViewClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) puzzle_view_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PuzzleView), 0, (GInstanceInitFunc) puzzle_view_instance_init, NULL };
	GType puzzle_view_type_id;
	puzzle_view_type_id = g_type_register_static (gtk_drawing_area_get_type (), "PuzzleView", &g_define_type_info, 0);
	PuzzleView_private_offset = g_type_add_instance_private (puzzle_view_type_id, sizeof (PuzzleViewPrivate));
	return puzzle_view_type_id;
}

GType
puzzle_view_get_type (void)
{
	static volatile gsize puzzle_view_type_id__once = 0;
	if (g_once_init_enter (&puzzle_view_type_id__once)) {
		GType puzzle_view_type_id;
		puzzle_view_type_id = puzzle_view_get_type_once ();
		g_once_init_leave (&puzzle_view_type_id__once, puzzle_view_type_id);
	}
	return puzzle_view_type_id__once;
}

static void
_vala_puzzle_view_get_property (GObject * object,
                                guint property_id,
                                GValue * value,
                                GParamSpec * pspec)
{
	PuzzleView * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_PUZZLE_VIEW, PuzzleView);
#line 39 "../src/puzzle-view.vala"
	switch (property_id) {
#line 39 "../src/puzzle-view.vala"
		case PUZZLE_VIEW_PUZZLE_PROPERTY:
#line 39 "../src/puzzle-view.vala"
		g_value_set_object (value, puzzle_view_get_puzzle (self));
#line 39 "../src/puzzle-view.vala"
		break;
#line 39 "../src/puzzle-view.vala"
		case PUZZLE_VIEW_TILE_SELECTED_PROPERTY:
#line 39 "../src/puzzle-view.vala"
		g_value_set_boolean (value, puzzle_view_get_tile_selected (self));
#line 39 "../src/puzzle-view.vala"
		break;
#line 39 "../src/puzzle-view.vala"
		case PUZZLE_VIEW_BOARDSIZE_PROPERTY:
#line 39 "../src/puzzle-view.vala"
		g_value_set_uint (value, puzzle_view_get_boardsize (self));
#line 39 "../src/puzzle-view.vala"
		break;
#line 39 "../src/puzzle-view.vala"
		case PUZZLE_VIEW_X_OFFSET_RIGHT_PROPERTY:
#line 39 "../src/puzzle-view.vala"
		g_value_set_double (value, puzzle_view_get_x_offset_right (self));
#line 39 "../src/puzzle-view.vala"
		break;
#line 39 "../src/puzzle-view.vala"
		case PUZZLE_VIEW_Y_OFFSET_PROPERTY:
#line 39 "../src/puzzle-view.vala"
		g_value_set_double (value, puzzle_view_get_y_offset (self));
#line 39 "../src/puzzle-view.vala"
		break;
#line 39 "../src/puzzle-view.vala"
		case PUZZLE_VIEW_RIGHT_MARGIN_PROPERTY:
#line 39 "../src/puzzle-view.vala"
		g_value_set_double (value, puzzle_view_get_right_margin (self));
#line 39 "../src/puzzle-view.vala"
		break;
#line 39 "../src/puzzle-view.vala"
		case PUZZLE_VIEW_MOUSE_USE_EXTRA_BUTTONS_PROPERTY:
#line 39 "../src/puzzle-view.vala"
		g_value_set_boolean (value, puzzle_view_get_mouse_use_extra_buttons (self));
#line 39 "../src/puzzle-view.vala"
		break;
#line 39 "../src/puzzle-view.vala"
		case PUZZLE_VIEW_MOUSE_BACK_BUTTON_PROPERTY:
#line 39 "../src/puzzle-view.vala"
		g_value_set_int (value, puzzle_view_get_mouse_back_button (self));
#line 39 "../src/puzzle-view.vala"
		break;
#line 39 "../src/puzzle-view.vala"
		case PUZZLE_VIEW_MOUSE_FORWARD_BUTTON_PROPERTY:
#line 39 "../src/puzzle-view.vala"
		g_value_set_int (value, puzzle_view_get_mouse_forward_button (self));
#line 39 "../src/puzzle-view.vala"
		break;
#line 7755 "puzzle-view.c"
		default:
#line 39 "../src/puzzle-view.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 39 "../src/puzzle-view.vala"
		break;
#line 7761 "puzzle-view.c"
	}
}

static void
_vala_puzzle_view_set_property (GObject * object,
                                guint property_id,
                                const GValue * value,
                                GParamSpec * pspec)
{
	PuzzleView * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_PUZZLE_VIEW, PuzzleView);
#line 39 "../src/puzzle-view.vala"
	switch (property_id) {
#line 39 "../src/puzzle-view.vala"
		case PUZZLE_VIEW_PUZZLE_PROPERTY:
#line 39 "../src/puzzle-view.vala"
		puzzle_view_set_puzzle (self, g_value_get_object (value));
#line 39 "../src/puzzle-view.vala"
		break;
#line 39 "../src/puzzle-view.vala"
		case PUZZLE_VIEW_THEME_ID_PROPERTY:
#line 39 "../src/puzzle-view.vala"
		puzzle_view_set_theme_id (self, g_value_get_string (value));
#line 39 "../src/puzzle-view.vala"
		break;
#line 39 "../src/puzzle-view.vala"
		case PUZZLE_VIEW_TILE_SELECTED_PROPERTY:
#line 39 "../src/puzzle-view.vala"
		puzzle_view_set_tile_selected (self, g_value_get_boolean (value));
#line 39 "../src/puzzle-view.vala"
		break;
#line 39 "../src/puzzle-view.vala"
		case PUZZLE_VIEW_BOARDSIZE_PROPERTY:
#line 39 "../src/puzzle-view.vala"
		puzzle_view_set_boardsize (self, g_value_get_uint (value));
#line 39 "../src/puzzle-view.vala"
		break;
#line 39 "../src/puzzle-view.vala"
		case PUZZLE_VIEW_X_OFFSET_RIGHT_PROPERTY:
#line 39 "../src/puzzle-view.vala"
		puzzle_view_set_x_offset_right (self, g_value_get_double (value));
#line 39 "../src/puzzle-view.vala"
		break;
#line 39 "../src/puzzle-view.vala"
		case PUZZLE_VIEW_Y_OFFSET_PROPERTY:
#line 39 "../src/puzzle-view.vala"
		puzzle_view_set_y_offset (self, g_value_get_double (value));
#line 39 "../src/puzzle-view.vala"
		break;
#line 39 "../src/puzzle-view.vala"
		case PUZZLE_VIEW_RIGHT_MARGIN_PROPERTY:
#line 39 "../src/puzzle-view.vala"
		puzzle_view_set_right_margin (self, g_value_get_double (value));
#line 39 "../src/puzzle-view.vala"
		break;
#line 39 "../src/puzzle-view.vala"
		case PUZZLE_VIEW_MOUSE_USE_EXTRA_BUTTONS_PROPERTY:
#line 39 "../src/puzzle-view.vala"
		puzzle_view_set_mouse_use_extra_buttons (self, g_value_get_boolean (value));
#line 39 "../src/puzzle-view.vala"
		break;
#line 39 "../src/puzzle-view.vala"
		case PUZZLE_VIEW_MOUSE_BACK_BUTTON_PROPERTY:
#line 39 "../src/puzzle-view.vala"
		puzzle_view_set_mouse_back_button (self, g_value_get_int (value));
#line 39 "../src/puzzle-view.vala"
		break;
#line 39 "../src/puzzle-view.vala"
		case PUZZLE_VIEW_MOUSE_FORWARD_BUTTON_PROPERTY:
#line 39 "../src/puzzle-view.vala"
		puzzle_view_set_mouse_forward_button (self, g_value_get_int (value));
#line 39 "../src/puzzle-view.vala"
		break;
#line 7835 "puzzle-view.c"
		default:
#line 39 "../src/puzzle-view.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 39 "../src/puzzle-view.vala"
		break;
#line 7841 "puzzle-view.c"
	}
}

